SystemOrganization addCategory: #'Tweak-Costume-Aspects'!
SystemOrganization addCategory: #'Tweak-Costume-Fills'!
SystemOrganization addCategory: #'Tweak-Costume-Layouts'!
SystemOrganization addCategory: #'Tweak-Costume-Borders'!
SystemOrganization addCategory: #'Tweak-Costume-Highlights'!
SystemOrganization addCategory: #'Tweak-Costume-Transforms'!
SystemOrganization addCategory: #'Tweak-Costume-Text'!
SystemOrganization addCategory: #'Tweak-Costume-Support'!
SystemOrganization addCategory: #'Tweak-Costume-TODO'!

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:23'!
= aMorphicEvent
	super = aMorphicEvent ifFalse:[^false].
	position = aMorphicEvent position ifFalse: [^ false].
	buttons = aMorphicEvent buttons ifFalse: [^ false].
	self keyValue = aMorphicEvent keyValue ifFalse: [^ false].
	^ true! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:21'!
anyButtonPressed
	"Answer true if any mouse button is being pressed."
	^ buttons anyMask: 7! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 01:28'!
asMouseEnter
	^self clone setType: #mouseEnter! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 01:28'!
asMouseLeave
	^self clone setType: #mouseLeave! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 01:28'!
asMouseMove
	"Convert the receiver into a mouse move"
	^MouseMoveEvent new setType: #mouseMove startPoint: position endPoint: position trail: {position. position} buttons: buttons hand: source stamp: Time millisecondClockValue.! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 01:29'!
asMouseOver
	"Convert the receiver into a mouse over event"
	^MouseEvent new setType: #mouseOver position: position buttons: buttons hand: source! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:21'!
blueButtonChanged
	"Answer true if the blue mouse button has changed. This is the third mouse button or cmd+click on the Mac."
	^false! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:21'!
blueButtonPressed
	"Answer true if the blue mouse button is being pressed. This is the third mouse button or cmd+click on the Mac."
	^ buttons anyMask: 1! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:21'!
cursorPoint
	"Answer the location of the cursor's hotspot when this event occured."
	^ position! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:23'!
hash
	^ position hash + buttons hash! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:23'!
isDraggingEvent
	source ifNil:[^false].
	source hasSubmorphs ifTrue:[^true].
	self anyButtonPressed ifTrue:[^true].
	^false! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:23'!
isMouseEnter
	^self type == #mouseEnter! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:23'!
isMouseLeave
	^self type == #mouseLeave! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:21'!
keyCharacter
	^self keyValue asCharacter! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:21'!
keyValue
	^0! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:21'!
metaState
	"Answer the meta state for this event"
	^ (self buttons bitAnd: 16r78)	"cmd | opt | ctrl | shift"
		bitShift: -3! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 11/18/2004 18:42'!
mouseButtons
	"answer the mouse buttons (but not the modifiers)"
	^buttons bitAnd: 7! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 11/18/2004 18:43'!
mouseButtons: bitMask
	"set the mouse buttons (but not the modifiers)"
	buttons := (buttons bitClear: 7) bitOr: (bitMask bitAnd: 7).! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:22'!
printOn: aStream
	aStream nextPut: $[.
	aStream nextPutAll: self cursorPoint printString; space.
	aStream nextPutAll: type; space.
	aStream nextPutAll: self modifierString.
	aStream nextPutAll: self buttonString.
	aStream nextPutAll: timeStamp printString.
	aStream nextPut: $].! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:21'!
redButtonChanged
	"Answer true if the red mouse button has changed. This is the first mouse button."
	^false! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:21'!
redButtonPressed
	"Answer true if the red mouse button is being pressed. This is the first mouse button."
	^ buttons anyMask: 4! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:24'!
sentTo: anObject
	"Dispatch the receiver into anObject"
	type == #mouseOver ifTrue:[^anObject handleMouseOver: self].
	type == #mouseEnter ifTrue:[^anObject handleMouseEnter: self].
	type == #mouseLeave ifTrue:[^anObject handleMouseLeave: self].
	^super sentTo: anObject.! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:22'!
setType: aSymbol
	"For quick conversion between event types"
	type := aSymbol.! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:22'!
setType: evtType position: evtPos buttons: evtButtons hand: evtHand
	type := evtType.
	position := evtPos.
	buttons := evtButtons.
	source := evtHand.
	wasHandled := false.! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:22'!
storeOn: aStream
	aStream nextPutAll: type.
	aStream space.
	self timeStamp storeOn: aStream.
	aStream space.
	position x storeOn: aStream.
	aStream space.
	position y storeOn: aStream.
	aStream space.
	buttons storeOn: aStream.! !

!UserInputEvent methodsFor: '*Tweak-Costume-override' stamp: 'ar 1/23/2005 00:01'!
transformBy: aMorphicTransform
	"Transform the receiver into a local coordinate system."
	position :=  position transformedBy: aMorphicTransform.! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:22'!
type: eventType readFrom: aStream
	| x y |
	type := eventType.
	timeStamp := Integer readFrom: aStream.
	aStream skip: 1.
	x := Integer readFrom: aStream.
	aStream skip: 1.
	y := Integer readFrom: aStream.
	aStream skip: 1.
	buttons := Integer readFrom: aStream.
	position := x@y.! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:21'!
yellowButtonChanged
	"Answer true if the yellow mouse button has changed. This is the second mouse button or option+click on the Mac."
	^false! !

!UserInputEvent methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:22'!
yellowButtonPressed
	"Answer true if the yellow mouse button is being pressed. This is the second mouse button or option+click on the Mac."
	^ buttons anyMask: 2! !

CObject subclass: #CCostumeAspect
	instanceVariableNames: 'costume'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Aspects'!

!CCostumeAspect commentStamp: 'ar 3/27/2004 17:33' prior: 0!
CCostumeAspect is the abstract base class for all aspects manifest in primitive costumes. All aspects share some properties: They are owned by their costume, e.g., they are NEVER shared between costumes. They must be copied if a client wants to remember a particular aspect for saving/restoring it (say, remembering the fill, changing it, and restoring it) and they will notify their costume about any changes done to them.

Instance variables:
	costume		<CPrimitiveCostume>	The costume owning me.!

CCostumeAspect defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="costume" toSet="costume:">costume</field>
</fields>'!

!CCostumeAspect class methodsFor: 'instance creation' stamp: 'ar 3/23/2004 16:41'!
forCostume: aCostume
	^self new costume: aCostume! !

!CCostumeAspect methodsFor: 'initialize' stamp: 'ar 3/23/2004 15:31'!
changed
	"Notify my costume about a change in this aspect"! !

!CCostumeAspect methodsFor: 'copying' stamp: 'ar 3/23/2004 15:31'!
copy
	"Copy the receiver"
	^self shallowCopy postCopy! !

!CCostumeAspect methodsFor: 'accessing' stamp: 'ar 3/23/2004 15:30'!
costume
	^costume! !

!CCostumeAspect methodsFor: 'accessing' stamp: 'ar 3/23/2004 15:30'!
costume: aCostume
	costume := aCostume.! !

!CCostumeAspect methodsFor: 'accessing' stamp: 'ar 3/11/2005 21:09'!
hand
	^(costume ifNil:[^nil]) hand! !

!CCostumeAspect methodsFor: 'initialize' stamp: 'ar 3/23/2004 15:30'!
initialize
	"Initialize the receiver"! !

!CCostumeAspect methodsFor: 'initialize' stamp: 'ar 3/23/2004 15:35'!
invalidate
	"The receiver has become invalid. Release caches and invalidate my costume."
	self releaseCachedState.
	costume ifNotNil:[
		costume invalidate.
		self changed.
	].! !

!CCostumeAspect methodsFor: 'initialize' stamp: 'ar 3/23/2004 19:53'!
invalidateLayout
	"Invalidate my costume's layout"
	costume ifNotNil:[costume invalidateLayout].! !

!CCostumeAspect methodsFor: 'initialize' stamp: 'ar 3/25/2004 17:30'!
loadFrom: anAspect
	"Assign all my properties from anAspect"
	^self subclassResponsibility! !

!CCostumeAspect methodsFor: 'copying' stamp: 'ar 3/23/2004 15:31'!
postCopy
	"Perform post-copy operations"
	costume := nil.
	self releaseCachedState.! !

!CCostumeAspect methodsFor: 'initialize' stamp: 'ar 3/23/2004 15:32'!
releaseCachedState
	"Release any associated cache information"! !

CCostumeAspect subclass: #CCostumeBorder
	instanceVariableNames: 'style width color cachedBorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Aspects'!

!CCostumeBorder commentStamp: 'ar 3/27/2004 17:34' prior: 0!
CCostumeBorder represents the border aspect of a costume. Borders are generally described by their 'style' (the way in which the border should be drawn) their width and their color. The border aspect utilizes CBorder objects to actually perform most of the work.

Instance variables:
	style 			<Symbol>	The border's style.
	width 			<Number>	The border's width.
	color 			<Color>		The border's color.
	cachedBorder	<CBorder>	The internal border representation. !

CCostumeBorder defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="style" toSet="style:">style</field>
	<field instanceVariable="true" toGet="width" toSet="width:">width</field>
	<field instanceVariable="true" toGet="color" toSet="color:">color</field>
	<field instanceVariable="true" toGet="cachedBorder">cachedBorder</field>
</fields>'!

!CCostumeBorder class methodsFor: 'instance creation' stamp: 'ar 9/21/2003 18:37'!
style: aStyle width: aWidth color: aColor
	^self basicNew style: aStyle width: aWidth color: aColor! !

!CCostumeBorder methodsFor: 'comparing' stamp: 'ar 9/21/2003 18:47'!
= aBorder
	"Compare receiver and argument"
	self class == aBorder class ifFalse:[^false].
	^self style = aBorder style and:[self width = aBorder width and:[self color = aBorder color]]! !

!CCostumeBorder methodsFor: 'private' stamp: 'ar 9/21/2003 18:38'!
cachedBorder
	^cachedBorder ifNil:[cachedBorder := self updateBorder].! !

!CCostumeBorder methodsFor: 'initialize' stamp: 'ar 3/23/2004 15:35'!
changed
	costume signal: #borderChanged.! !

!CCostumeBorder methodsFor: 'accessing' stamp: 'ar 9/21/2003 18:38'!
color
	^color! !

!CCostumeBorder methodsFor: 'accessing' stamp: 'ar 3/23/2004 16:51'!
color: aColor
	color = aColor ifTrue:[aColor].
	color := aColor asColor.
	self invalidate.
	^aColor! !

!CCostumeBorder methodsFor: 'color tracking' stamp: 'ar 4/3/2009 11:50'!
colorsAtCorners
	^self cachedBorder colorsAtCorners! !

!CCostumeBorder methodsFor: 'drawing' stamp: 'ar 4/3/2009 11:50'!
drawLineFrom: startPoint to: stopPoint on: aCanvas
	^self cachedBorder drawLineFrom: startPoint to: stopPoint on: aCanvas! !

!CCostumeBorder methodsFor: 'operations' stamp: 'ar 1/8/2004 00:42'!
expandBounds: aRectangle
	"Answer the rectangle needed to draw this border around the argument"
	width = 0 ifTrue:[^aRectangle].
	^aRectangle expandBy: width
! !

!CCostumeBorder methodsFor: 'drawing' stamp: 'ar 4/3/2009 11:50'!
frameOval: aRectangle on: aCanvas
	^self cachedBorder frameOval: aRectangle on: aCanvas! !

!CCostumeBorder methodsFor: 'drawing' stamp: 'ar 4/3/2009 11:50'!
framePolygon: vertices on: aCanvas
	^self cachedBorder framePolygon: vertices on: aCanvas! !

!CCostumeBorder methodsFor: 'drawing' stamp: 'tk 2/4/2005 10:46'!
framePolyline: vertices on: aCanvas
	^self cachedBorder framePolyline: vertices on: aCanvas! !

!CCostumeBorder methodsFor: 'drawing' stamp: 'ar 6/5/2005 18:40'!
frameRectangle: aRectangle on: aCanvas
	^self cachedBorder frameRectangle: aRectangle on: aCanvas! !

!CCostumeBorder methodsFor: 'drawing' stamp: 'ar 4/3/2009 11:50'!
frameRoundRect: aRectangle radius: radius on: aCanvas
	^self cachedBorder frameRoundRect: aRectangle radius: radius on: aCanvas! !

!CCostumeBorder methodsFor: 'comparing' stamp: 'ar 9/21/2003 18:47'!
hash
	^(style hash bitXor: color hash) bitXor: width hash! !

!CCostumeBorder methodsFor: 'initialize' stamp: 'ar 3/23/2004 15:34'!
initialize
	super initialize.
	style := #none.
	width := 0.
	color := Color transparent.! !

!CCostumeBorder methodsFor: 'operations' stamp: 'ar 1/8/2004 00:42'!
insetBounds: aRectangle
	"Answer the inner rectangle for the argument"
	width = 0 ifTrue:[^aRectangle].
	^aRectangle insetBy: width
! !

!CCostumeBorder methodsFor: 'testing' stamp: 'ar 3/23/2004 17:48'!
isNoBorder
	^false! !

!CCostumeBorder methodsFor: 'testing' stamp: 'ar 1/8/2004 00:32'!
isTranslucent
	^color isTranslucent! !

!CCostumeBorder methodsFor: 'initialize' stamp: 'ar 3/23/2004 18:04'!
loadFrom: aBorder
	"Assign all my properties from aBorder"
	self = aBorder ifTrue:[^self].
	style := aBorder style.
	width := aBorder width.
	color := aBorder color.
	self invalidate.
! !

!CCostumeBorder methodsFor: 'serializing' stamp: 'ar 9/22/2003 01:58'!
readFieldsFrom: deSerializer
	style := deSerializer readField: #style ifAbsent:[style].
	width := deSerializer readField: #width ifAbsent:[width].
	color := deSerializer readField: #color ifAbsent:[color].
	cachedBorder := nil.! !

!CCostumeBorder methodsFor: 'initialize' stamp: 'ar 9/21/2003 19:12'!
releaseCachedState
	cachedBorder := nil.! !

!CCostumeBorder methodsFor: 'accessing' stamp: 'ar 9/21/2003 18:38'!
style
	^style! !

!CCostumeBorder methodsFor: 'accessing' stamp: 'ar 3/23/2004 16:51'!
style: newStyle
	style = newStyle ifTrue:[^newStyle].
	style := newStyle asSymbol.
	self invalidate.
	^newStyle! !

!CCostumeBorder methodsFor: 'initialize' stamp: 'ar 9/21/2003 18:44'!
style: aStyle width: aWidth color: aColor
	style := aStyle.
	width := aWidth.
	color := aColor.! !

!CCostumeBorder methodsFor: 'color tracking' stamp: 'ar 9/21/2003 18:36'!
trackColorFrom: aCostume
	^self cachedBorder trackColorFrom: aCostume! !

!CCostumeBorder methodsFor: 'private' stamp: 'ar 9/21/2003 19:18'!
updateBorder
	| newBorder |
	newBorder := CBorder perform: self style.
	newBorder width: self width.
	newBorder baseColor: self color.
	^newBorder! !

!CCostumeBorder methodsFor: 'accessing' stamp: 'ar 9/21/2003 18:38'!
width
	^width! !

!CCostumeBorder methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:33'!
width: aNumber
	width = aNumber ifTrue:[^aNumber].
	width := aNumber asNumber max: 0.
	self invalidate.
	costume ifNotNil:[costume invalidateLayout].
	^aNumber! !

!CCostumeBorder methodsFor: 'serializing' stamp: 'ar 9/22/2003 01:55'!
writeFieldsOn: aSerializer
	aSerializer writeField: #style value: style.
	aSerializer writeField: #width value: width.
	aSerializer writeField: #color value: color.! !

CCostumeAspect subclass: #CCostumeFill
	instanceVariableNames: 'style colors alpha offset angle frame cachedFill'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Aspects'!

!CCostumeFill commentStamp: 'ar 3/27/2004 17:36' prior: 0!
CCostumeFill represents the fill aspect of a costume.

Instance variables:
	style 		<Symbol>			The fill style.
	colors 		<Array of: Color>	The fill colors.
	alpha 		<Float>				The alpha value of the fill (0-1)
	offset 		<Point>				The offset of the fill.
	angle 		<Number>			The angle of the fill.
	frame 		<Rectangle>			The bounding box for the fill.
	cachedFill	<CGraphicsFill> 		The (internal) representation of the fill!

CCostumeFill defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="style" toSet="style:">style</field>
	<field instanceVariable="true" toGet="colors" toSet="colors:">colors</field>
	<field instanceVariable="true" toGet="alpha" toSet="alpha:">alpha</field>
	<field instanceVariable="true" toGet="offset" toSet="offset:">offset</field>
	<field instanceVariable="true" toGet="angle" toSet="angle:">angle</field>
	<field instanceVariable="true" toGet="frame" toSet="frame:">frame</field>
	<field instanceVariable="true" toGet="cachedFill">cachedFill</field>
</fields>'!

!CCostumeFill methodsFor: 'comparing' stamp: 'ar 9/21/2003 19:58'!
= aFill
	self class == aFill class ifFalse:[^false].
	style = aFill style ifFalse:[^false].
	colors = aFill colors ifFalse:[^false].
	alpha = aFill alpha ifFalse:[^false].
	offset = aFill offset ifFalse:[^false].
	angle = aFill angle ifFalse:[^false].
	^true! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 4/28/2005 23:55'!
alpha
	style == #none ifTrue:[^0.0] ifFalse:[^alpha]! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 16:53'!
alpha: newAlpha
	alpha = newAlpha ifTrue:[^newAlpha].
	alpha := newAlpha asFloat min: 1.0 max: 0.0.
	self invalidate.
	^newAlpha! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/12/2003 21:44'!
angle
	style == #linearGradient ifTrue:[^angle] ifFalse:[^0].! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 16:53'!
angle: newAngle
	angle = newAngle ifTrue:[^newAngle].
	angle := newAngle asNumber.
	self invalidate.
	^newAngle! !

!CCostumeFill methodsFor: 'converting' stamp: 'ar 3/12/2003 20:36'!
asColor
	^self primaryColor alpha: alpha! !

!CCostumeFill methodsFor: 'private' stamp: 'ar 3/16/2004 17:03'!
cachedFill
	cachedFill ifNil:[cachedFill := self computeFill].
	^cachedFill! !

!CCostumeFill methodsFor: 'initialize' stamp: 'ar 3/23/2004 16:52'!
changed
	costume signal: #fillChanged.! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 4/28/2005 23:57'!
color
	style == #none ifTrue:[^Color transparent].
	alpha = 0 ifTrue: [^Color transparent].	"be consistent with input"
	^self primaryColor alpha: alpha! !

!CCostumeFill methodsFor: 'accessing' stamp: 'tk 6/24/2004 15:46'!
color: aColor
	self asColor = aColor ifTrue:[^aColor].
	style := aColor alpha = 0.0 ifTrue: [#none] ifFalse: [#solid].
	self primaryColor: aColor asNontranslucentColor.
	self alpha: aColor alpha.
	^aColor! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/12/2003 19:49'!
colors
	^colors! !

!CCostumeFill methodsFor: 'accessing' stamp: 'tk 9/15/2004 12:13'!
colors: newColors
	newColors size = 0 ifTrue:[^self style: #none].
	newColors size = 1 ifTrue:[^self color: newColors first].
	colors := newColors.
	self alpha = 0.0 ifTrue: [self alpha: colors first alpha].	"need to see it"
	self invalidate.
	^newColors! !

!CCostumeFill methodsFor: 'private' stamp: 'ar 9/29/2005 14:07'!
computeFill
	"update my fill"
	| newFill radians dir |
	style == #none ifTrue:[^Color transparent].
	alpha = 0.0 ifTrue:[^Color transparent].
	style == #solid ifTrue:[^self asColor].
	newFill := CGradientFill new.
	alpha = 1.0 ifTrue:[
		newFill colors: colors.
	] ifFalse:[
		newFill colors: (colors collect:[:each| each alpha: alpha]).
	].
	style == #radialGradient ifTrue:[
		newFill origin: frame center + offset.
		newFill direction: 0@(frame width abs max: 1).
	] ifFalse:[
		radians := angle asFloat degreesToRadians.
		dir := radians cos @ radians sin.
		newFill origin: (self computeGradientOrigin: dir).
		newFill direction: dir * ((self computeGradientLength: dir) abs max: 1).
	].
	^newFill! !

!CCostumeFill methodsFor: 'private' stamp: 'ar 3/12/2003 19:55'!
computeGradientLength: dir
	| origin corner dv min max |
	origin := frame origin.
	corner := frame corner.
	dv := origin dotProduct: dir.
	min := dv. max := dv.
	dv := corner dotProduct: dir.
	dv < min ifTrue:[min := dv]. dv > max ifTrue:[max := dv].
	dv := (corner x @ origin y) dotProduct: dir.
	dv < min ifTrue:[min := dv]. dv > max ifTrue:[max := dv].
	dv := (origin x @ corner y) dotProduct: dir.
	dv < min ifTrue:[min := dv]. dv > max ifTrue:[max := dv].
	^(max - min - (offset r * 2)) truncated! !

!CCostumeFill methodsFor: 'private' stamp: 'ar 3/12/2003 19:49'!
computeGradientOrigin: dir
	dir x >= 0 ifTrue:["fill goes right"
		dir y >= 0 
			ifTrue:[^offset] "topLeft + offset"
			ifFalse:[^(0 @ frame height) + offset] "bottomLeft + offset"
	] ifFalse:["fill goes left"
		dir y >= 0 
			ifTrue:[^(frame width @ 0) + offset] "topRight + offset"
			ifFalse:[^frame extent + offset] "bottomRight + offset"
	].
! !

!CCostumeFill methodsFor: 'private' stamp: 'ar 3/12/2003 19:49'!
computePixelRampOfSize: length
	"Compute the pixel ramp in the receiver"
	| bits lastColor lastIndex nextIndex nextColor distance theta lastValue lastWord nextWord step |
	bits := Bitmap new: length.
	lastColor := colors at: 1.
	lastWord := lastColor pixelWordForDepth: 32.
	lastIndex := 0.
	1 to: colors size do:[:i|
		nextIndex := (i * length) // colors size.
		nextColor := colors at: i.
		nextWord := nextColor pixelWordForDepth: 32.
		distance := (nextIndex - lastIndex).
		distance = 0 ifTrue:[distance := 1].
		step := 1.0 / distance asFloat.
		theta := 0.0.
		lastIndex+1 to: nextIndex do:[:j|
			theta := theta + step.
			"The following is an open-coded version of:
				color := nextColor alphaMixed: theta with: lastColor.
				bits at: j put: (color scaledPixelValue32).
			"
			bits at: j put: (self scaledAlphaMix: theta of: lastWord with: nextWord).
		].
		lastIndex := nextIndex.
		lastColor := nextColor.
		lastWord := nextWord.
	].
	lastValue := lastColor scaledPixelValue32.
	lastIndex+1 to: length do:[:i| bits at: i put: lastValue].
	^bits! !

!CCostumeFill methodsFor: 'private' stamp: 'ar 3/12/2003 19:49'!
direction
	^self cachedFill direction! !

!CCostumeFill methodsFor: 'private' stamp: 'ar 4/29/2005 00:02'!
ensureCorrectColors
	| cc |
	style == #none ifTrue:[^self].
	self isGradientFill ifFalse:[
		^self colors: (Array with: self color).
	].
	colors size < 2 ifTrue:[
		cc := colors size = 1 ifTrue:[colors first] ifFalse:[Color white].
		cc brightness < 0.7
			ifTrue:[colors := Array with: cc with: (cc mixed: 0.5 with: Color white)]
			ifFalse:[colors := Array with: cc with: (cc mixed: 0.5 with: Color black)].
		self colors: colors.
	].
! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/12/2003 20:15'!
frame
	^frame! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 16:54'!
frame: aRectangle
	frame := aRectangle.
	self invalidate.
	^aRectangle! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/12/2003 20:01'!
gradientColor
	^colors last! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 16:55'!
gradientColor: aColor
	self gradientColor = aColor ifTrue:[^aColor].
	colors at: colors size put: aColor.
	self invalidate.
	^aColor! !

!CCostumeFill methodsFor: 'comparing' stamp: 'ar 9/21/2003 19:59'!
hash
	^(style hash bitXor: colors hash) bitXor: (angle hash bitXor: offset hash)! !

!CCostumeFill methodsFor: 'initialize' stamp: 'ar 3/23/2004 18:16'!
initialize
	"Initialize the receiver"
	style := #solid.
	colors := Array with: Color white.
	alpha := 1.0.
	offset := 0@0.
	angle := 0.! !

!CCostumeFill methodsFor: 'testing' stamp: 'ar 3/12/2003 19:49'!
isBitmapFill
	^false! !

!CCostumeFill methodsFor: 'testing' stamp: 'ar 3/12/2003 19:49'!
isGradientFill
	^self isSolidFill not! !

!CCostumeFill methodsFor: 'testing' stamp: 'ar 3/23/2004 17:53'!
isNoFill
	^false! !

!CCostumeFill methodsFor: 'testing' stamp: 'ar 3/12/2003 20:32'!
isOrientedFill
	^style == #linearGradient or:[style == #radialGradient]! !

!CCostumeFill methodsFor: 'testing' stamp: 'ar 3/12/2003 20:32'!
isRadialFill
	^style == #radialGradient! !

!CCostumeFill methodsFor: 'testing' stamp: 'ar 4/22/2005 11:56'!
isSolidFill
	^style == #solid or:[style == #none]! !

!CCostumeFill methodsFor: 'testing' stamp: 'ar 3/12/2003 19:49'!
isTranslucent
	^alpha < 1.0! !

!CCostumeFill methodsFor: 'testing' stamp: 'ar 3/12/2003 20:00'!
isTransparent
	^style == #none or:[alpha = 0.0]! !

!CCostumeFill methodsFor: 'initialize' stamp: 'ar 3/23/2004 18:14'!
loadFrom: aFill
	"Assign all my properties from aFill"
	self = aFill ifTrue:[^self].
	aFill isColor ifTrue:[^self color: aFill].
	self style: aFill style.
	colors := aFill colors.
	alpha := aFill alpha.
	offset := aFill offset.
	angle := aFill angle.
	self invalidate.
! !

!CCostumeFill methodsFor: 'converting' stamp: 'ar 3/12/2003 19:49'!
mixed: fraction with: aColor
	^self copy colors: (colors collect:[:each| each mixed: fraction with: aColor])! !

!CCostumeFill methodsFor: 'private' stamp: 'ar 3/12/2003 19:49'!
normal
	^self cachedFill normal! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/12/2003 19:49'!
offset
	^offset! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 16:55'!
offset: newOffset
	offset = newOffset ifTrue:[^newOffset].
	offset := newOffset asPoint.
	self invalidate.
	^newOffset! !

!CCostumeFill methodsFor: 'private' stamp: 'ar 3/12/2003 19:49'!
origin
	^self cachedFill origin! !

!CCostumeFill methodsFor: 'private' stamp: 'ar 3/12/2003 19:49'!
pixelRamp
	^self cachedFill pixelRamp! !

!CCostumeFill methodsFor: 'copying' stamp: 'ar 3/23/2004 17:00'!
postCopy
	super postCopy.
	colors := colors clone.! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 9/21/2003 19:39'!
primaryColor
	^colors at: 1! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 16:55'!
primaryColor: aColor
	self primaryColor = aColor ifTrue:[^aColor].
	colors at: 1 put: aColor.
	self invalidate.
	^aColor! !

!CCostumeFill methodsFor: 'maker' stamp: 'ar 9/22/2003 01:57'!
readFieldsFrom: deSerializer

	style := deSerializer readField: #style ifAbsent:[style].
	colors := deSerializer readField: #colors ifAbsent:[colors].
	alpha := deSerializer readField: #alpha ifAbsent:[alpha].
	offset := deSerializer readField: #offset ifAbsent:[offset].
	angle := deSerializer readField: #angle ifAbsent:[angle].
	cachedFill := nil.! !

!CCostumeFill methodsFor: 'initialize' stamp: 'ar 3/12/2003 19:49'!
releaseCachedState
	cachedFill := nil.! !

!CCostumeFill methodsFor: 'private' stamp: 'ar 4/8/2004 16:52'!
scaledAlphaMix: theta of: lastWord with: nextWord
	"Open-coded version of alpha mixing two 32bit pixel words and returning the scaled pixel value."
	| word0 word1 a0 a1 alphaPart v0 v1 vv newValue |
	word0 := lastWord.
	word1 := nextWord.
	"note: extract alpha first so we'll be in SmallInteger range afterwards"
	a0 := word0 bitShift: -24. a1 := word1 bitShift: -24.
	alphaPart := a0 + (a1 - a0 * theta) truncated.
	"Now make word0 and word1 SmallIntegers"
	word0 := word0 bitAnd: 16rFFFFFF. word1 := word1 bitAnd: 16rFFFFFF.
	"Compute first component value"
	v0 := (word0 bitAnd: 255). v1 := (word1 bitAnd: 255).
	vv := (v0 + (v1 - v0 * theta) truncated) * alphaPart // 255.
	newValue := vv.
	"Compute second component value"
	v0 := ((word0 bitShift: -8) bitAnd: 255). v1 := ((word1 bitShift: -8) bitAnd: 255).
	vv := (v0 + (v1 - v0 * theta) truncated) * alphaPart // 255.
	newValue := newValue bitOr: (vv bitShift: 8).
	"Compute third component value"
	v0 := ((word0 bitShift: -16) bitAnd: 255). v1 := ((word1 bitShift: -16) bitAnd: 255).
	vv := (v0 + (v1 - v0 * theta) truncated) * alphaPart // 255.
	newValue := newValue bitOr: (vv bitShift: 16).
	"Return result"
	^newValue bitOr: (alphaPart bitShift: 24)! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 11/14/2003 16:53'!
scaledPixelValue32
	^self cachedFill scaledPixelValue32! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 16:59'!
style
	^self verboseStyle! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:00'!
style: newStyle
	self style = newStyle ifTrue:[^newStyle].
	self verboseStyle: newStyle.
	self invalidate.
	^newStyle! !

!CCostumeFill methodsFor: 'private' stamp: 'ar 3/12/2003 19:49'!
updateFrame: aFrame
	frame = aFrame ifTrue:[^self].
	frame := aFrame.
	cachedFill := self computeFill.
! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/13/2004 22:47'!
verboseStyle
	style == #linearGradient ifTrue:[
		angle = 0 ifTrue:[^#horizontalGradient].
		angle = 45 ifTrue:[^#diagonalGradient].
		angle = 90 ifTrue:[^#verticalGradient].
	].
	^style! !

!CCostumeFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 20:50'!
verboseStyle: aStyle
	aStyle == #solid ifTrue:[
		style := #solid.
		^self ensureCorrectColors].
	aStyle == #horizontalGradient ifTrue:[
		style := #linearGradient.
		angle := 0.
		^self ensureCorrectColors].
	aStyle == #diagonalGradient ifTrue:[
		style := #linearGradient.
		angle := 45.
		^self ensureCorrectColors].
	aStyle == #verticalGradient ifTrue:[
		style := #linearGradient.
		angle := 90.
		^self ensureCorrectColors].
	(aStyle == #linearGradient and:[self verboseStyle ~~ #linearGradient]) ifTrue:[
		style := #linearGradient.
		angle := 45.
		^self ensureCorrectColors].
	aStyle == #radialGradient ifTrue:[
		style := #radialGradient.
		^self ensureCorrectColors].
	style := #none.
	^self ensureCorrectColors! !

!CCostumeFill methodsFor: 'maker' stamp: 'ar 9/22/2003 01:56'!
writeFieldsOn: aSerializer

	aSerializer writeField: #style value: style.
	aSerializer writeField: #colors value: colors.
	aSerializer writeField: #alpha value: alpha.
	aSerializer writeField: #offset value: offset.
	aSerializer writeField: #angle value: angle.! !

CCostumeAspect subclass: #CCostumeGraphic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Aspects'!

!CCostumeGraphic commentStamp: 'bf 4/2/2004 20:31' prior: 0!
CCostumeGraphic represents the (background) graphic aspect of a costume.

Instance variables:
	form			<Form>		The form to be used.
	fit 				<Symbol>	How the form should be fitted.
	opaque 			<Boolean>	Whether the form should be treated as opaque or not.
	offset 			<Point>		The offset of the graphic.
	anchorPoint		<Symbol>	Where to anchor the graphic.
	sourceRect		<Rectangle>	Which portion of the graphic to use
 !

CCostumeGraphic defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="form" toSet="form:" changeEvent="formChanged">form</field>
	<field toGet="fit" toSet="fit:" changeEvent="fitChanged">fit</field>
	<field toGet="opaque" toSet="opaque:" changeEvent="opaqueChanged">opaque</field>
	<field toGet="offset" toSet="offset:" changeEvent="offsetChanged">offset</field>
	<field toGet="anchorPoint" toSet="anchorPoint:" changeEvent="anchorPointChanged">anchorPoint</field>
	<field toGet="sourceRect" toSet="sourceRect:" changeEvent="sourceRectChanged">sourceRect</field>
</fields>'!

!CCostumeGraphic methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:58'!
anchorPoint
	"Answer the anchorPoint of the receiver"
	<bewareOf: #anchorPointChanged>
	^self propertyValueAt: #anchorPoint! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'tk 4/28/2005 17:00'!
anchorPoint: aValue
	"Modify the receiver's anchorPoint"
	^self propertyValueAt: #anchorPoint put: aValue asSymbol with: #anchorPointChanged! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'bf 4/2/2004 20:24'!
bounds
	form ifNil:[^0@0 extent: 0@0].
	^0@0 extent: self extent! !

!CCostumeGraphic methodsFor: 'initialize' stamp: 'ar 3/23/2004 19:18'!
changed
	costume signal: #graphicChanged.! !

!CCostumeGraphic methodsFor: 'drawing' stamp: 'bf 2/12/2006 17:14'!
containsPoint: aPoint
	form ifNil:[^false].
	
	"@@@: need to implement other cases!!"
	(fit == #rigid) 
		ifTrue:[^self containsPointRigid: aPoint].

	(fit == #stretch)
		ifTrue: [^self containsPointStretched: aPoint].

	^true! !

!CCostumeGraphic methodsFor: 'drawing' stamp: 'bf 2/12/2006 17:47'!
containsPointRigid: aPoint
	| ofs p |
	anchorPoint ifNil: [anchorPoint := #center].
	ofs := ((0@0 corner: costume extent) perform: anchorPoint) - 
		(self bounds perform: anchorPoint).
	p := aPoint - ofs.
	offset ifNotNil: [p := p - offset].
	sourceRect ifNotNil: [
		p := p + sourceRect origin.
		(sourceRect containsPoint: p)
			ifFalse: [^false]].
	^ (form isTransparentAt: p) not! !

!CCostumeGraphic methodsFor: 'drawing' stamp: 'bf 3/9/2005 11:58'!
containsPointStretched: aPoint
	| r p |
	r := sourceRect ifNil: [form boundingBox].
	p := (aPoint * r extent // costume extent) + r origin.
	^ (form isTransparentAt: p) not.! !

!CCostumeGraphic methodsFor: 'drawing' stamp: 'ar 5/5/2004 13:47'!
drawOn: aCanvas in: drawingBounds
	"see if we can just blt"
	| noPaint |
	form ifNil:[^self].
	form isForm 
		ifTrue:[noPaint := opaque or:[costume notNil and:[costume fill = Color black]]]
		ifFalse:[noPaint := false].

	(drawingBounds extent = self extent or:[fit == #rigid]) 
		ifTrue:[^self drawRigidOn: aCanvas in: drawingBounds opaque: noPaint].

	(fit == #scale) 
		ifTrue:[^self drawScaledOn: aCanvas in: drawingBounds opaque: noPaint].

	(fit == #stretch) 
		ifTrue:[^self drawStretchedOn: aCanvas in: drawingBounds opaque: noPaint].

	(fit == #tile)
		ifTrue:[^self drawTiledOn: aCanvas in: drawingBounds opaque: noPaint].

	(fit == #autoScale)
		ifTrue:[
			self extent < drawingBounds extent 
				ifTrue:[^self drawRigidOn: aCanvas in: drawingBounds opaque: noPaint]
				ifFalse:[^self drawScaledOn: aCanvas in: drawingBounds opaque: noPaint]].
! !

!CCostumeGraphic methodsFor: 'drawing' stamp: 'bf 4/3/2004 02:06'!
drawRigidOn: aCanvas in: drawingBounds opaque: aBool
	| ofs |
	anchorPoint ifNil:[anchorPoint := #center].
	ofs := ((0@0 extent: drawingBounds extent) perform: anchorPoint) - 
				(self bounds perform: anchorPoint).
	offset ifNotNil:[ofs := ofs + offset].
	aBool ifTrue:[^aCanvas drawImage: form at: drawingBounds origin + ofs sourceRect: (sourceRect ifNil: [form boundingBox])].
	^form drawOn: aCanvas
		in: (drawingBounds origin + ofs extent: self extent)
		sourceRect: (sourceRect ifNil: [form boundingBox])! !

!CCostumeGraphic methodsFor: 'drawing' stamp: 'bf 4/2/2004 23:31'!
drawScaledOn: aCanvas in: drawingBounds opaque: aBool
	| scale ofs box |
	drawingBounds height = 0 ifTrue:[^self].
	drawingBounds width = 0 ifTrue:[^self].
	anchorPoint ifNil:[anchorPoint := #center].
	scale := (self width / drawingBounds width)
		max: (self height / drawingBounds height).
	box := form offset extent: (self extent / scale) truncated.
	ofs := ((0@0 extent: drawingBounds extent) perform: anchorPoint) - 
				(box perform: anchorPoint).
	offset ifNotNil:[ofs := ofs + offset].
	^form drawOn: aCanvas
		in: (drawingBounds origin + ofs extent: box extent)
		sourceRect: (sourceRect ifNil: [form boundingBox])! !

!CCostumeGraphic methodsFor: 'drawing' stamp: 'bf 4/3/2004 00:59'!
drawStretchedOn: aCanvas in: drawingBounds opaque: aBool

	^form drawOn: aCanvas in: drawingBounds sourceRect: (sourceRect ifNil: [form boundingBox])
! !

!CCostumeGraphic methodsFor: 'drawing' stamp: 'bf 4/2/2004 23:34'!
drawTiledOn: aCanvas in: drawingBounds opaque: aBool
	| w h y x box ext |
	w := self width.
	h := self height.
	box := sourceRect ifNil: [form boundingBox].
	ext := box extent.
	y := drawingBounds top.
	[y < drawingBounds bottom] whileTrue:[
		x := drawingBounds left.
		[x < drawingBounds right] whileTrue:[
			aBool
				ifTrue:[aCanvas drawImage: form at: x@y sourceRect: box]
				ifFalse:[form drawOn: aCanvas in: (x@y extent: ext) sourceRect: box].
			x := x + w.
		].
		y := y + h.
	].
! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'bf 4/2/2004 20:22'!
extent
	^sourceRect
		ifNil: [form extent]
		ifNotNil: [sourceRect extent]! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:59'!
fit
	"Answer the fit of the receiver"
	<bewareOf: #fitChanged>
	^self propertyValueAt: #fit! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'tk 4/28/2005 17:01'!
fit: aValue
	"Modify the receiver's fit"
	^self propertyValueAt: #fit put: aValue asSymbol with: #fitChanged! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:59'!
form
	"Answer the form of the receiver"
	<bewareOf: #formChanged>
	^self propertyValueAt: #form! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'tk 4/28/2005 17:03'!
form: aValue
	"Modify the receiver's form"
	aValue ifNotNil:[opaque := aValue isOpaque].
	sourceRect := nil.
	^self propertyValueAt: #form put: aValue with: #formChanged! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'bf 4/2/2004 23:27'!
height
	^sourceRect
		ifNil: [form height]
		ifNotNil: [sourceRect height]! !

!CCostumeGraphic methodsFor: 'initialize' stamp: 'ar 3/23/2004 19:14'!
initialize
	fit := #rigid.
	opaque := false.
	offset := 0@0.
	anchorPoint := #center.! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:09'!
isOpaque
	^opaque! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:09'!
isOpaque: aBool
	opaque := aBool.! !

!CCostumeGraphic methodsFor: 'initialize' stamp: 'bf 4/2/2004 23:17'!
loadFrom: aGraphic
	aGraphic isForm ifTrue:[^self form: aGraphic].
	form := aGraphic form.
	fit := aGraphic fit.
	opaque := aGraphic opaque.
	offset := aGraphic offset.
	anchorPoint := aGraphic anchorPoint.
	sourceRect := aGraphic sourceRect.
	self invalidate.! !

!CCostumeGraphic methodsFor: 'initialize' stamp: 'ar 3/23/2004 19:09'!
minHeight
	^0! !

!CCostumeGraphic methodsFor: 'initialize' stamp: 'ar 3/23/2004 19:09'!
minWidth
	^0! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:58'!
offset
	"Answer the offset of the receiver"
	<bewareOf: #offsetChanged>
	^self propertyValueAt: #offset! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'tk 4/28/2005 17:04'!
offset: aValue
	"Modify the receiver's offset"
	^self propertyValueAt: #offset put: aValue asPoint with: #offsetChanged! !

!CCostumeGraphic methodsFor: 'events' stamp: 'tk 4/28/2005 17:00'!
onAnchorPointChanged
	<on: anchorPointChanged>
	self invalidate.! !

!CCostumeGraphic methodsFor: 'events' stamp: 'tk 4/28/2005 17:01'!
onFitChangedChanged
	<on: fitChanged>
	self invalidate.! !

!CCostumeGraphic methodsFor: 'events' stamp: 'tk 4/28/2005 17:02'!
onFormChanged
	<on: formChanged>
	self invalidate.! !

!CCostumeGraphic methodsFor: 'events' stamp: 'tk 4/28/2005 17:04'!
onOffsetChanged
	<on: offsetChanged>
	self invalidate.! !

!CCostumeGraphic methodsFor: 'events' stamp: 'tk 4/28/2005 17:05'!
onOpaqueChanged
	<on: opaqueChanged>
	self invalidate.! !

!CCostumeGraphic methodsFor: 'events' stamp: 'tk 4/28/2005 17:05'!
onSourceRectChanged
	<on: sourceRectChanged>
	self invalidate.! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:59'!
opaque
	"Answer the opaque of the receiver"
	<bewareOf: #opaqueChanged>
	^self propertyValueAt: #opaque! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:59'!
opaque: aValue
	"Modify the receiver's opaque"
	^self propertyValueAt: #opaque put: aValue with: #opaqueChanged! !

!CCostumeGraphic methodsFor: 'serializing' stamp: 'bf 4/2/2004 20:24'!
readFieldsFrom: deSerializer
	form := deSerializer readField: #form ifAbsent:[form].
	fit := deSerializer readField: #fit ifAbsent:[fit].
	opaque := deSerializer readField: #opaque ifAbsent:[opaque].
	offset := deSerializer readField: #offset ifAbsent:[offset].
	anchorPoint := deSerializer readField: #anchorPoint ifAbsent:[anchorPoint].
	sourceRect := deSerializer readField: #sourceRect ifAbsent:[sourceRect].! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:58'!
sourceRect
	"Answer the sourceRect of the receiver"
	<bewareOf: #sourceRectChanged>
	^self propertyValueAt: #sourceRect! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:58'!
sourceRect: aValue
	"Modify the receiver's sourceRect"
	^self propertyValueAt: #sourceRect put: aValue with: #sourceRectChanged! !

!CCostumeGraphic methodsFor: 'copying' stamp: 'ar 7/13/2007 14:55'!
veryDeepInner: deepCopier 
	"Be sure to duplicate my Form, but only if I am the graphic of the costume of a CPainterBoard.  Others do not write into their forms, so the form can be shared."

	super veryDeepInner: deepCopier.

	"Fixme: This shouldn't be done here but rather from CPainterBoard if it needs to be done.
	form ifNotNil: [
		costume ifNotNil: [
			costume player ifNotNil: [
				(costume player isKindOf: CPainterBoard) ifTrue: [
					ff := form.
					form := form deepCopy.
					deepCopier references at: ff put: form.
					deepCopier newGuys add: form]]]]."
	costume := costume.	"keep checker satisfied"! !

!CCostumeGraphic methodsFor: 'accessing' stamp: 'bf 4/2/2004 23:27'!
width
	^sourceRect
		ifNil: [form width]
		ifNotNil: [sourceRect width]! !

!CCostumeGraphic methodsFor: 'serializing' stamp: 'bf 4/2/2004 23:15'!
writeFieldsOn: aSerializer
	aSerializer writeField: #form value: form.
	aSerializer writeField: #fit value: fit.
	aSerializer writeField: #opaque value: opaque.
	aSerializer writeField: #offset value: offset.
	aSerializer writeField: #anchorPoint value: anchorPoint.
	aSerializer writeField: #sourceRect value: sourceRect.
! !

CCostumeAspect subclass: #CCostumeGrid
	instanceVariableNames: ''
	classVariableNames: 'GridCache'
	poolDictionaries: ''
	category: 'Tweak-Costume-Aspects'!

!CCostumeGrid commentStamp: 'ar 3/27/2004 17:39' prior: 0!
CCostumeGrid represents the grid aspect of a costume.

Instance variables:
	origin 		<Point>		The origin of the grid.
	extent 		<Point>		The extent (modulus) of the grid.
	enabled 	<Boolean>	Whether this grid is active or not.
	visible 		<Boolean>	Whether this grid is visible.
	color		<Color>		The color of the grid. !

CCostumeGrid defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="origin" toSet="origin:" changeEvent="originChanged">origin</field>
	<field toGet="extent" toSet="extent:" changeEvent="extentChanged">extent</field>
	<field toGet="enabled" toSet="enabled:" changeEvent="enabledChanged">enabled</field>
	<field toGet="visible" toSet="visible:" changeEvent="visibleChanged">visible</field>
	<field toGet="color" toSet="color:" changeEvent="colorChanged">color</field>
</fields>'!

!CCostumeGrid class methodsFor: 'accessing' stamp: 'ar 3/26/2004 21:15'!
gridCacheAt: aPoint
	"Answer a form to use for caching a grid with the given extent"
	| cached maxGrid gridGrid tempGrid |
	GridCache ifNil:[GridCache := Dictionary new].
	cached := GridCache at: aPoint ifAbsent:[nil].
	cached ifNotNil:[^cached].

	"We only cache up to 128x128 so no reason to do anything but that"
	maxGrid := 128@128.
	aPoint < maxGrid ifFalse:[^nil].

	gridGrid := maxGrid grid: aPoint.
	cached := ColorForm extent: gridGrid depth: 1.
	cached colors: (Array with: Color transparent with: Color black).
	tempGrid := self new.
	tempGrid extent: aPoint.
	tempGrid uncachedDrawGridOn: (CTransformCanvas on: cached) in: (0@0 extent: gridGrid).
	GridCache at: aPoint put: cached.
	^cached! !

!CCostumeGrid methodsFor: 'initialize' stamp: 'ar 3/23/2004 15:33'!
changed
	"Notify my costume about a change in this aspect"
	costume signal: #gridChanged.! !

!CCostumeGrid methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:24'!
color
	"Answer the color of the receiver"
	<bewareOf: #colorChanged>
	^self propertyValueAt: #color! !

!CCostumeGrid methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:55'!
color: aValue
	"Modify the receiver's color"
	^self propertyValueAt: #color put: aValue asColor with: #colorChanged! !

!CCostumeGrid methodsFor: 'gridding' stamp: 'ar 4/29/2004 17:02'!
drawGridOn: aCanvas in: drawingBounds
	"Draw the grid"
	| x y clip gridX gridY cached |
	visible ifFalse:[^self].
	cached := self class gridCacheAt: extent.
	cached ifNil:[^self uncachedDrawGridOn: aCanvas in: drawingBounds].

	(cached colors at: 2) = color ifFalse:[
		cached colors: (Array with: Color transparent with: color).
	].

	"Get the starting point"
	clip := drawingBounds intersect: aCanvas clipRect.
	gridX := clip left truncateTo: extent x.
	gridX < clip left ifTrue:[gridX := gridX + extent x].
	gridY := clip top truncateTo: extent y.
	gridY < clip top ifTrue:[gridY := gridY + extent y].

	"Now draw"
	aCanvas clipBy: clip during:[:cc|
		y := gridY.
		[y < clip bottom] whileTrue:[
			x := gridX.
			[x < clip right] whileTrue:[
				cc paintImage: cached at: x@y.
				x := x + cached width.
			].
			y := y + cached height.
		].
	].! !

!CCostumeGrid methodsFor: 'gridding' stamp: 'ar 3/23/2004 15:23'!
drawOn: aCanvas in: drawingBounds
	"Draw the grid"
	^self drawGridOn: aCanvas in: drawingBounds.! !

!CCostumeGrid methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:24'!
enabled
	"Answer the enabled of the receiver"
	<bewareOf: #enabledChanged>
	^self propertyValueAt: #enabled! !

!CCostumeGrid methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:54'!
enabled: aValue
	"Modify the receiver's enabled"
	^self propertyValueAt: #enabled put: aValue with: #enabledChanged! !

!CCostumeGrid methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:24'!
extent
	"Answer the extent of the receiver"
	<bewareOf: #extentChanged>
	^self propertyValueAt: #extent! !

!CCostumeGrid methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:55'!
extent: aValue
	"Modify the receiver's extent"
	^self propertyValueAt: #extent put: aValue asPoint with: #extentChanged! !

!CCostumeGrid methodsFor: 'gridding' stamp: 'ar 3/23/2004 15:22'!
gridPoint: aPoint
	enabled ifFalse:[^aPoint].
	^(aPoint - origin grid: extent) + origin! !

!CCostumeGrid methodsFor: 'initialize' stamp: 'ar 3/23/2004 15:20'!
initialize
	super initialize.
	origin := 0@0.
	extent := 8@8.
	visible := true.
	enabled := true.
	color := Color black.! !

!CCostumeGrid methodsFor: 'initialize' stamp: 'ar 3/25/2004 17:31'!
loadFrom: aGrid
	aGrid isPoint ifTrue:[^self extent: aGrid].
	origin := aGrid origin.
	extent := aGrid extent.
	enabled := aGrid enabled.
	visible := aGrid visible.
	color := aGrid color.
! !

!CCostumeGrid methodsFor: 'events' stamp: 'tk 4/28/2005 16:55'!
onColorChanged
	<on: colorChanged>
	self invalidate.		"it also sends (self changed)"! !

!CCostumeGrid methodsFor: 'events' stamp: 'tk 4/28/2005 16:50'!
onEnabledChanged
	<on: enabledChanged>
	self invalidate.! !

!CCostumeGrid methodsFor: 'events' stamp: 'tk 4/28/2005 16:50'!
onExtentChanged
	<on: extentChanged>
	self invalidate.! !

!CCostumeGrid methodsFor: 'events' stamp: 'tk 4/28/2005 16:51'!
onOriginChanged
	<on: originChanged>
	self invalidate.! !

!CCostumeGrid methodsFor: 'events' stamp: 'tk 4/28/2005 16:51'!
onVisibleChanged
	<on: visibleChanged>
	self invalidate.! !

!CCostumeGrid methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:24'!
origin
	"Answer the origin of the receiver"
	<bewareOf: #originChanged>
	^self propertyValueAt: #origin! !

!CCostumeGrid methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:56'!
origin: aValue
	"Modify the receiver's origin"
	^self propertyValueAt: #origin put: aValue asPoint with: #originChanged! !

!CCostumeGrid methodsFor: 'gridding' stamp: 'ar 3/23/2004 15:23'!
uncachedDrawGridOn: aCanvas in: drawingBounds
	"Draw an uncached grid"
	| x y clip rect gridX gridY |
	clip := (aCanvas clipRect intersect: drawingBounds).

	"Get the starting point"
	gridX := clip left truncateTo: extent x.
	gridX < clip left ifTrue:[gridX := gridX + extent x].
	gridY := clip top truncateTo: extent y.
	gridY < clip top ifTrue:[gridY := gridY + extent y].

	"Now draw"
	y := gridY.
	[y < clip bottom] whileTrue:[
		x := gridX.
		[x < clip right] whileTrue:[
			rect := x@y extent: 1@1.
			aCanvas fillRectangle: rect color: color.
			x := x + extent x.
		].
		y := y + extent y.
	].
! !

!CCostumeGrid methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:24'!
visible
	"Answer the visible of the receiver"
	<bewareOf: #visibleChanged>
	^self propertyValueAt: #visible! !

!CCostumeGrid methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:24'!
visible: aValue
	"Modify the receiver's visible"
	^self propertyValueAt: #visible put: aValue with: #visibleChanged! !

CCostumeAspect subclass: #CCostumeHighlight
	instanceVariableNames: 'name active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Highlights'!

!CCostumeHighlight commentStamp: 'ar 3/27/2004 17:44' prior: 0!
Costume highlights allow to add rendering behavior dynamically to costumes. Costume highlights are treated like other aspects but since they are dynamic they don't have an intrinsic name but must be explicitly named.

Instance variables:
	name 	<Symbol>	The name of the highlight (aspect name)
	active	<Boolean>	Whether this highlight is active. !

CCostumeHighlight subclass: #CBorderHighlight
	instanceVariableNames: 'border prior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Highlights'!

!CBorderHighlight commentStamp: 'ar 3/27/2004 17:45' prior: 0!
CBorderHighlight temporarily replaces a Costume's border with another one.

Instance variables:
	border 	<CCostumeBorder>	The border attributes to use
	prior	<CCostumeBorder>	The previous border attributes.
 !

CBorderHighlight defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="border" toSet="border:">border</field>
	<field instanceVariable="true">prior</field>
</fields>'!

!CBorderHighlight methodsFor: 'accessing' stamp: 'ar 3/23/2004 21:35'!
border
	^border! !

!CBorderHighlight methodsFor: 'accessing' stamp: 'bf 3/30/2004 10:37'!
border: aBorder
	border := aBorder.
	self invalidate.
	^ aBorder! !

!CBorderHighlight methodsFor: 'highlighting' stamp: 'ar 3/23/2004 21:41'!
highlight
	"Highlight the given costume."
	prior := nil.
	self isActive ifTrue:[
		prior := costume border copy.
		costume border: border.
	].! !

!CBorderHighlight methodsFor: 'support' stamp: ''!
priority
	"Return the priority for this particular highlight. Possible values are:
		< 0	- the highlight needs to be drawn *underneith* the target
			  Example: drop shadows.
		= 0	- the highlight does *NOT* need to be drawn 
			  but performs a state based modification of the target
			  Example: change of border style
		> 0	- the highlight needs to be drawn *on top* of the target
			  Example: framing highlights.
	"
	^0! !

!CBorderHighlight methodsFor: 'highlighting' stamp: 'ar 3/23/2004 21:41'!
unhighlight
	"Unhighlight the given costume."
	self isActive ifTrue:[costume border: prior].
	prior := nil.! !

CCostumeHighlight subclass: #CCoronaHighlight
	instanceVariableNames: 'color width'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Highlights'!

!CCoronaHighlight commentStamp: 'bf 4/2/2004 16:14' prior: 0!
CCoronaHighlight draws a 'corona' around the costume.

Instance variables:
	color 	<Color>	The color to be used for the halo.
	width 	<Number>	The extent of the halo.!

CCoronaHighlight defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="color" toSet="color:">color</field>
	<field instanceVariable="true" toGet="width" toSet="width:">width</field>
</fields>'!

!CCoronaHighlight methodsFor: 'accessing' stamp: ''!
color
	^color ifNil:[Color blue alpha: 0.5]! !

!CCoronaHighlight methodsFor: 'accessing' stamp: 'ar 3/23/2004 21:46'!
color: aColor
	color := aColor.
	self invalidate.! !

!CCoronaHighlight methodsFor: 'highlighting' stamp: 'ar 3/27/2004 17:50'!
drawOn: aCanvas
	| colorToUse offsetToUse newForm f aShadow |
	(aCanvas seesNothingOutside: costume localBounds) ifTrue:[^self].
	colorToUse := self color.
	offsetToUse := self width.
	active := false. "disable the receiver for drawing the shadow"
	aShadow := costume shadowForm.
	active := true.
	aShadow offset: 0@0.
	f := ColorForm extent: aShadow extent depth: 1.
	aShadow displayOn: f.
	f colors: {Color transparent. colorToUse}.
	newForm := Form extent: offsetToUse * 2 + aShadow extent depth: 32.
     (WarpBlt toForm: newForm)
		sourceForm: f;
		cellSize: 2; 
		combinationRule: 3;
		copyQuad: f boundingBox innerCorners toRect: newForm boundingBox.
	aCanvas 
		translateBy: offsetToUse negated
		during: [ :shadowCanvas |
			shadowCanvas shadowColor: colorToUse.
			shadowCanvas paintImage: newForm at: costume origin.
		].! !

!CCoronaHighlight methodsFor: 'support' stamp: 'ar 3/23/2004 21:21'!
expandBounds: aRectangle
	"If the highlight draws beyound the given rectangle, 
	return the bounds including the receiver."
	self isActive ifFalse:[^aRectangle].
	^aRectangle expandBy: self width! !

!CCoronaHighlight methodsFor: 'highlighting' stamp: 'ar 3/23/2004 21:46'!
highlight: aCostume
	"Highlight the given costume."
	self isActive ifTrue:[aCostume invalidateLayout; invalidate]. "trigger redraw"! !

!CCoronaHighlight methodsFor: 'support' stamp: ''!
priority
	"Return the priority for this particular highlight. Possible values are:
		< 0	- the highlight needs to be drawn *underneith* the target
			  Example: drop shadows.
		= 0	- the highlight does *NOT* need to be drawn 
			  but performs a state based modification of the target
			  Example: change of border style
		> 0	- the highlight needs to be drawn *on top* of the target
			  Example: framing highlights.
	"
	^-1! !

!CCoronaHighlight methodsFor: 'highlighting' stamp: 'ar 3/23/2004 21:46'!
unhighlight: aCostume
	"Highlight the given costume."
	self isActive ifTrue:[aCostume invalidateLayout; invalidate]. "trigger redraw"! !

!CCoronaHighlight methodsFor: 'accessing' stamp: ''!
width
	^width ifNil:[10@10]! !

!CCoronaHighlight methodsFor: 'accessing' stamp: 'bf 3/30/2004 10:45'!
width: aPoint
	width := aPoint.
	self invalidate.
	^ aPoint! !

CCostumeHighlight defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="name" toSet="name:">name</field>
	<field instanceVariable="true" toGet="active" toSet="active:">active</field>
</fields>'!

!CCostumeHighlight methodsFor: 'accessing' stamp: ''!
active
	^active! !

!CCostumeHighlight methodsFor: 'accessing' stamp: 'ar 3/26/2004 00:29'!
active: aBool
	active = aBool ifTrue:[^self].
	active ifTrue:[self unhighlight].
	active := aBool.
	active ifTrue:[self highlight].! !

!CCostumeHighlight methodsFor: 'initialize' stamp: 'bgf 1/9/2009 18:23'!
changed
	costume signal: ((name ifNil:['highlight']),'Changed') asSymbol.! !

!CCostumeHighlight methodsFor: 'highlighting' stamp: 'ar 3/23/2004 21:33'!
drawHighlightOn: aCanvas
	self isActive ifTrue:[^self drawOn: aCanvas].! !

!CCostumeHighlight methodsFor: 'highlighting' stamp: 'ar 3/23/2004 21:32'!
drawOn: aCanvas
	"If the highlight is a procedural highlight, draw it for our costume on the target canvas."! !

!CCostumeHighlight methodsFor: 'support' stamp: 'ar 4/28/2004 16:05'!
expandBounds: aRectangle
	"If the highlight draws beyound the given rectangle, 
	return the bounds including the receiver."
	self isActive ifFalse:[^aRectangle].
	costume ifNil:[^aRectangle].
	^aRectangle merge: costume highlightBounds.! !

!CCostumeHighlight methodsFor: 'highlighting' stamp: 'ar 3/23/2004 22:00'!
highlight
	"Highlight the given costume."
	(self isActive and:[costume notNil]) ifTrue:[costume invalidate]. "trigger redraw"! !

!CCostumeHighlight methodsFor: 'initialize' stamp: 'ar 3/23/2004 21:19'!
initialize
	super initialize.
	active := true.! !

!CCostumeHighlight methodsFor: 'accessing' stamp: ''!
isActive
	"Return true if this highlight is active"
	^active == true! !

!CCostumeHighlight methodsFor: 'accessing' stamp: ''!
isActive: aBool
	self active: aBool.! !

!CCostumeHighlight methodsFor: 'accessing' stamp: 'ar 3/23/2004 21:12'!
name
	^name! !

!CCostumeHighlight methodsFor: 'accessing' stamp: 'ar 3/23/2004 21:12'!
name: aSymbol
	name := aSymbol! !

!CCostumeHighlight methodsFor: 'support' stamp: 'ar 3/23/2004 21:24'!
noteInvalidationOf: aRectangle
	"This message is sent when the costume the receiver highlights invalidates any of its areas."
! !

!CCostumeHighlight methodsFor: 'support' stamp: ''!
priority
	"Return the priority for this particular highlight. Possible values are:
		< 0	- the highlight needs to be drawn *underneith* the target
			  Example: drop shadows.
		= 0	- the highlight does *NOT* need to be drawn 
			  but performs a state based modification of the target
			  Example: change of border style
		> 0	- the highlight needs to be drawn *on top* of the target
			  Example: framing highlights.
	"
	^1! !

!CCostumeHighlight methodsFor: 'highlighting' stamp: 'ar 4/28/2004 16:06'!
unhighlight
	"Unhighlight the given costume."
	self isActive ifTrue:[costume ifNotNil:[costume invalidate]]. "trigger redraw"! !

CCostumeHighlight subclass: #CCursorHighlight
	instanceVariableNames: 'cursor priorCursor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Highlights'!

!CCursorHighlight commentStamp: 'ar 3/27/2004 17:46' prior: 0!
CCursorHighlight temporarily replaces a Costume's mouse cursor with another one.

Instance variables:
	cursor 		<Cursor>		The new mouse cursor
	priorCursor	<Cursor>		The previous mouse cursor.!

CCursorHighlight defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="cursor" toSet="cursor:">cursor</field>
	<field instanceVariable="true">priorCursor</field>
</fields>'!

!CCursorHighlight methodsFor: 'accessing' stamp: ''!
cursor
	^cursor! !

!CCursorHighlight methodsFor: 'accessing' stamp: ''!
cursor: aCursor
	cursor := aCursor.! !

!CCursorHighlight methodsFor: 'highlighting' stamp: 'ar 3/23/2004 21:37'!
highlight
	priorCursor := nil.
	self isActive ifTrue:[
		priorCursor := costume mouseCursor.
		costume mouseCursor: cursor.
	].! !

!CCursorHighlight methodsFor: 'highlighting' stamp: 'ar 3/23/2004 21:38'!
unhighlight
	self isActive ifTrue:[costume mouseCursor: priorCursor].
	priorCursor := nil.! !

CCostumeHighlight subclass: #CDropShadowHighlight
	instanceVariableNames: 'color offset shadowForm dirty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Highlights'!

!CDropShadowHighlight commentStamp: 'ar 3/27/2004 17:48' prior: 0!
CDropShadowHighlight adds a drop shadow to some costume.

Instance variables:
	color	<Color>	The color of the drop shadow.
	offset 	<Point>	The offset for the drop shadow.
	shadowForm <Form> The (internal) form used to display the shadow.
	dirty 	<Boolean> Whether the shadowForm needs to be recreated.!

CDropShadowHighlight defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="color" toSet="color:">color</field>
	<field instanceVariable="true" toGet="offset" toSet="offset:">offset</field>
	<field instanceVariable="true">shadowForm</field>
	<field instanceVariable="true">dirty</field>
</fields>'!

!CDropShadowHighlight methodsFor: 'accessing' stamp: 'ar 3/23/2004 21:42'!
color
	^color! !

!CDropShadowHighlight methodsFor: 'accessing' stamp: 'ar 3/23/2004 21:41'!
color: shadowColor
	color := shadowColor.
	self invalidate.! !

!CDropShadowHighlight methodsFor: 'highlighting' stamp: 'ar 3/25/2004 21:54'!
drawOn: aCanvas
	"Fix this. Should only need to recreate shadow if aCostume changes substantially"
	| box localOffset |
	localOffset := (costume globalToLocal transformDirection: self offset) rounded.
	box := costume localBounds.
	active := false. "disable to avoid recursion"
	(shadowForm == nil or:[shadowForm extent ~= box extent]) 
		ifTrue:[shadowForm := Form extent: box extent depth: 1.
				dirty := true].
	dirty == true ifTrue:[
		shadowForm unhibernate.
		shadowForm bits atAllPut: 0. "the fastest way"
		(CTransformCanvas on: shadowForm) 
			translateBy: box origin negated during:[:cc|
				cc shadowColor: Color black.
				cc roundCornersOf: costume in: box during:[cc draw: costume].
		].
		dirty := false.
	].
	(costume localAreasRemainingToFill: (box translateBy: localOffset)) do:[:clip|
		aCanvas clipBy: clip during:[:cc| cc stencil: shadowForm at: localOffset color: self color].
	].
	active := true.! !

!CDropShadowHighlight methodsFor: 'support' stamp: 'ar 3/23/2004 21:58'!
expandBounds: aRectangle
	"If the highlight draws beyound the given rectangle, 
	return the bounds including the receiver."
	| delta box |
	self isActive ifFalse:[^aRectangle].
	costume ifNil:[^aRectangle].
	box := aRectangle.
	delta := (costume globalToLocal transformDirection: self offset) rounded.
	box := delta x >= 0 
		ifTrue:[box right: aRectangle right + delta x]
		ifFalse:[box left: aRectangle left + delta x].
	box := delta y >= 0
		ifTrue:[box bottom: aRectangle bottom + delta y]
		ifFalse:[box top: aRectangle top + delta y].
	^box! !

!CDropShadowHighlight methodsFor: 'initialize-release' stamp: 'bf 7/21/2005 12:19'!
initialize
	super initialize.
	offset := 3@3.
	color := Color black alpha: 0.3.! !

!CDropShadowHighlight methodsFor: 'support' stamp: 'ar 3/23/2004 21:27'!
noteInvalidationOf: aRectangle
	dirty := true.! !

!CDropShadowHighlight methodsFor: 'accessing' stamp: 'ar 3/23/2004 21:42'!
offset
	^offset! !

!CDropShadowHighlight methodsFor: 'accessing' stamp: 'ar 3/23/2004 21:41'!
offset: shadowOffset
	offset := shadowOffset.
	self invalidate.! !

!CDropShadowHighlight methodsFor: 'support' stamp: ''!
priority
	"Return the priority for this particular highlight. Possible values are:
		< 0	- the highlight needs to be drawn *underneith* the target
			  Example: drop shadows.
		= 0	- the highlight does *NOT* need to be drawn 
			  but performs a state based modification of the target
			  Example: change of border style
		> 0	- the highlight needs to be drawn *on top* of the target
			  Example: framing highlights.
	"
	^-1! !

!CDropShadowHighlight methodsFor: 'maker' stamp: 'ar 9/23/2003 00:17'!
readFieldsFrom: deSerializer
	active := deSerializer readField: #active ifAbsent:[active].
	color := deSerializer readField: #color ifAbsent:[color].
	offset := deSerializer readField: #offset ifAbsent:[offset].

! !

!CDropShadowHighlight methodsFor: 'initialize-release' stamp: 'ar 12/8/2002 03:42'!
releaseCachedState
	shadowForm := nil.! !

!CDropShadowHighlight methodsFor: 'maker' stamp: 'ar 9/23/2003 00:17'!
writeFieldsOn: aSerializer
	aSerializer writeField: #active value: active.
	aSerializer writeField: #color value: color.
	aSerializer writeField: #offset value: offset.
! !

CCostumeHighlight subclass: #CFillingHighlight
	instanceVariableNames: 'fill'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Highlights'!

!CFillingHighlight commentStamp: 'ar 3/27/2004 17:49' prior: 0!
CFillingHighlight fills the costume's bounding box with the specified color.

Instance variables:
	fill	<CCostumeFill>	The fill to use.!

CFillingHighlight defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="fill" toSet="fill:">fill</field>
</fields>'!

!CFillingHighlight methodsFor: 'highlighting' stamp: 'bgf 1/9/2009 18:23'!
drawOn: aCanvas
	costume ifNil:[^self].

	costume roundCorners ifTrue: [
		aCanvas roundCornersOf: costume in: costume localBounds during: [
			aCanvas 
				fillRectangle: costume innerBounds 
				fillStyle: fill 
				borderStyle: CBorder default.
		]
	] ifFalse: [
		aCanvas 
			fillRectangle: costume innerBounds 
			fillStyle: fill 
			borderStyle: CBorder default.
	].! !

!CFillingHighlight methodsFor: 'accessing' stamp: 'ar 3/23/2004 21:48'!
fill
	^fill! !

!CFillingHighlight methodsFor: 'accessing' stamp: 'ar 3/23/2004 21:48'!
fill: aFill
	fill := aFill.
	self invalidate.! !

!CFillingHighlight methodsFor: 'support' stamp: ''!
priority
	"Return the priority for this particular highlight. Possible values are:
		< 0	- the highlight needs to be drawn *underneith* the target
			  Example: drop shadows.
		= 0	- the highlight does *NOT* need to be drawn 
			  but performs a state based modification of the target
			  Example: change of border style
		> 0	- the highlight needs to be drawn *on top* of the target
			  Example: framing highlights.
	"
	^1! !

CFillingHighlight subclass: #CUnderpaintHighlight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Highlights'!

!CUnderpaintHighlight commentStamp: '<historical>' prior: 0!
A filling highlight,
drawn below the main target rather than over it.!

CUnderpaintHighlight defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CUnderpaintHighlight methodsFor: 'support' stamp: 'bgf 3/8/2009 18:21'!
priority
	"Return the priority for this particular highlight. Possible values are:
		< 0	- the highlight needs to be drawn *underneith* the target
			  Example: drop shadows.
		= 0	- the highlight does *NOT* need to be drawn 
			  but performs a state based modification of the target
			  Example: change of border style
		> 0	- the highlight needs to be drawn *on top* of the target
			  Example: framing highlights.
	"
	^-1! !

CCostumeHighlight subclass: #CFramingHighlight
	instanceVariableNames: 'border inset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Highlights'!

!CFramingHighlight commentStamp: 'ar 3/27/2004 17:50' prior: 0!
CFramingHighlight draws a border around the costume's bounding rectangle.

Instance variables:
	border 	<CBorder>	The border to use.
	inset	<Point>		Inset to apply before drawing the border.!

CFramingHighlight defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="border" toSet="border:">border</field>
	<field instanceVariable="true" toGet="inset" toSet="inset:">inset</field>
</fields>'!

!CFramingHighlight methodsFor: 'accessing' stamp: 'ar 3/23/2004 21:46'!
border
	^border! !

!CFramingHighlight methodsFor: 'accessing' stamp: 'bf 3/30/2004 10:37'!
border: aBorder
	border := aBorder.
	self invalidate.
	^ aBorder! !

!CFramingHighlight methodsFor: 'highlighting' stamp: 'ar 3/23/2004 21:59'!
drawOn: aCanvas
	aCanvas 
		fillRectangle: (costume localBounds insetBy: self inset) 
		fillStyle: Color transparent 
		borderStyle: border.! !

!CFramingHighlight methodsFor: 'support' stamp: 'ar 8/21/2007 17:24'!
expandBounds: aRectangle
	"If the highlight draws beyound the given rectangle, 
	return the bounds including the receiver."
	self isActive ifFalse:[^aRectangle].
	^aRectangle insetBy: (self inset asPoint min: 0@0)! !

!CFramingHighlight methodsFor: 'highlighting' stamp: 'ar 8/21/2007 17:24'!
highlight
	"Highlight the given costume."
	| ip |
	costume ifNil:[^self].
	self isActive ifTrue:[
		costume invalidate. "trigger redraw"
		ip := self inset asPoint.
		(ip x < 0 or:[ip y < 0]) ifTrue:[costume invalidateLayout].
	].! !

!CFramingHighlight methodsFor: 'accessing' stamp: ''!
inset
	^inset ifNil:[0]! !

!CFramingHighlight methodsFor: 'accessing' stamp: ''!
inset: aNumberOrPoint
	inset := aNumberOrPoint.! !

!CFramingHighlight methodsFor: 'support' stamp: ''!
priority
	"Return the priority for this particular highlight. Possible values are:
		< 0	- the highlight needs to be drawn *underneith* the target
			  Example: drop shadows.
		= 0	- the highlight does *NOT* need to be drawn 
			  but performs a state based modification of the target
			  Example: change of border style
		> 0	- the highlight needs to be drawn *on top* of the target
			  Example: framing highlights.
	"
	^1! !

!CFramingHighlight methodsFor: 'highlighting' stamp: 'ar 8/21/2007 17:25'!
unhighlight
	"Highlight the given costume."
	| ip |
	self isActive ifTrue:[
		costume invalidate. "trigger redraw"
		ip := self inset asPoint.
		(ip x < 0 or:[ip y < 0]) ifTrue:[costume invalidateLayout].
	].! !

CCostumeHighlight subclass: #CSoftShadowHighlight
	instanceVariableNames: 'offset'
	classVariableNames: 'GradientCache'
	poolDictionaries: ''
	category: 'Tweak-Costume-Highlights'!

CSoftShadowHighlight defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="ramp" toSet="ramp:" changeEvent="rampChanged">ramp</field>
	<field instanceVariable="true" toGet="offset" toSet="offset:">offset</field>
	<field toGet="direction" toSet="direction:" changeEvent="directionChanged">direction</field>
</fields>'!

!CSoftShadowHighlight class methodsFor: 'class initialization' stamp: 'ar 3/7/2009 14:31'!
flushGradientCache
	"Flush my gradient cache"
	GradientCache := Dictionary new.
! !

!CSoftShadowHighlight class methodsFor: 'class initialization' stamp: 'ar 3/7/2009 14:31'!
initialize
	"CSoftShadowHighlight initialize"
	self flushGradientCache.! !

!CSoftShadowHighlight methodsFor: 'accessing' stamp: 'bgf 2/24/2009 01:26'!
color
	"Psuedo-property for workalike with drop-shadow"
	^ ramp first value! !

!CSoftShadowHighlight methodsFor: 'accessing' stamp: 'bgf 2/24/2009 01:41'!
color: aColor
	"Psuedo-property for workalike with drop-shadow.
	 Actually creates the standard ramp for the soft shadow.
	 Opacity drops rapidly in the inner area and then dies out slowly to the edge."
	ramp := {
		0.0 -> aColor  .
		0.35 -> (aColor copy alpha: (aColor alpha / 2)) .
		0.7 -> (aColor copy alpha: (aColor alpha / 8)).
		1.0 -> Color transparent }.
		! !

!CSoftShadowHighlight methodsFor: 'accessing' stamp: 'ar 2/23/2009 11:48'!
direction
	"Answer the direction of the receiver"
	<bewareOf: #directionChanged>
	^self propertyValueAt: #direction! !

!CSoftShadowHighlight methodsFor: 'accessing' stamp: 'ar 2/23/2009 11:48'!
direction: aValue
	"Modify the receiver's direction"
	^self propertyValueAt: #direction put: aValue with: #directionChanged! !

!CSoftShadowHighlight methodsFor: 'highlighting' stamp: 'ar 3/7/2009 17:41'!
drawOn: aCanvas
	"Fix this. Should only need to recreate shadow if aCostume changes substantially"
	| box gradient outerBox shadowBox innerBox |
	gradient := GradientCache at: ramp first value ifAbsentPut:[CGradientFill ramp: ramp].
	gradient radial: false.
	box := costume localBounds.
	innerBox := (box insetBy: 3) translateBy: direction. "adjust for rounded corners"
	outerBox := (box expandBy: offset) translateBy: direction.
	"Background"
	(costume localAreasRemainingToFill: innerBox) do:[:r|
		aCanvas fillRectangle: r color: (ramp first value).
	].

	"Left stripe"
	shadowBox := outerBox left @ innerBox top corner: innerBox left @ innerBox bottom.
	gradient origin: shadowBox topRight.
	gradient direction: shadowBox width negated@0.
	aCanvas fillRectangle: shadowBox fillStyle: gradient.

	"Right stripe"
	shadowBox := innerBox right @ innerBox top corner: outerBox right @ innerBox bottom.
	gradient origin: shadowBox topLeft.
	gradient direction: shadowBox width@0.
	aCanvas fillRectangle: shadowBox fillStyle: gradient.

	"Top stripe"
	shadowBox := innerBox left @ outerBox top corner: innerBox right @ innerBox top.
	gradient origin: shadowBox bottomRight.
	gradient direction: 0@shadowBox height negated.
	aCanvas fillRectangle: shadowBox fillStyle: gradient.

	"Bottom stripe"
	shadowBox := innerBox left @ innerBox bottom corner: innerBox right @ outerBox bottom.
	gradient origin: shadowBox topLeft.
	gradient direction: 0@shadowBox height.
	aCanvas fillRectangle: shadowBox fillStyle: gradient.

	"Top left corner"
	gradient radial: true.
	shadowBox := outerBox topLeft rect: innerBox topLeft.
	gradient origin: shadowBox bottomRight.
	gradient direction: shadowBox width@0.
	aCanvas fillRectangle: shadowBox fillStyle: gradient.

	"Top right corner"
	shadowBox := outerBox topRight rect: innerBox topRight.
	gradient origin: shadowBox bottomLeft.
	gradient direction: shadowBox width@0.
	aCanvas fillRectangle: shadowBox fillStyle: gradient.

	"Bottom left corner"
	shadowBox := outerBox bottomLeft rect: innerBox bottomLeft.
	gradient origin: shadowBox topRight.
	gradient direction: shadowBox width@0.
	aCanvas fillRectangle: shadowBox fillStyle: gradient.

	"Bottom right corner"
	shadowBox := outerBox bottomRight rect: innerBox bottomRight.
	gradient origin: shadowBox topLeft.
	gradient direction: shadowBox width@0.
	aCanvas fillRectangle: shadowBox fillStyle: gradient.
! !

!CSoftShadowHighlight methodsFor: 'support' stamp: 'ar 2/23/2009 11:48'!
expandBounds: aRectangle
	"If the highlight draws beyound the given rectangle, 
	return the bounds including the receiver."
	self isActive ifFalse:[^aRectangle].
	costume ifNil:[^aRectangle].
	^(aRectangle expandBy: offset) translateBy: direction! !

!CSoftShadowHighlight methodsFor: 'initialize-release' stamp: 'bgf 2/24/2009 10:47'!
initialize
	super initialize.
	offset := 10.
	direction := 0@3.

	self color: (Color r: 0 g: 0 b: 0.03 alpha: 0.36)! !

!CSoftShadowHighlight methodsFor: 'accessing' stamp: 'ar 2/23/2009 10:47'!
offset
	^offset! !

!CSoftShadowHighlight methodsFor: 'accessing' stamp: 'ar 2/23/2009 11:08'!
offset: shadowOffset
	offset := shadowOffset.
	self invalidate.! !

!CSoftShadowHighlight methodsFor: 'support' stamp: 'ar 2/23/2009 10:47'!
priority
	"Return the priority for this particular highlight. Possible values are:
		< 0	- the highlight needs to be drawn *underneith* the target
			  Example: drop shadows.
		= 0	- the highlight does *NOT* need to be drawn 
			  but performs a state based modification of the target
			  Example: change of border style
		> 0	- the highlight needs to be drawn *on top* of the target
			  Example: framing highlights.
	"
	^-1! !

!CSoftShadowHighlight methodsFor: 'accessing' stamp: 'bgf 2/24/2009 00:42'!
ramp
	"Answer the ramp of the receiver"
	<bewareOf: #rampChanged>
	^self propertyValueAt: #ramp! !

!CSoftShadowHighlight methodsFor: 'accessing' stamp: 'bgf 2/24/2009 01:40'!
ramp: aValue
	"Modify the receiver's ramp.  (See also #color/color: ...  ramp must have at least one element.)"
	^self propertyValueAt: #ramp put: aValue with: #rampChanged! !

CCostumeAspect subclass: #CCostumePen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Aspects'!

!CCostumePen commentStamp: '<historical>' prior: 0!
"A pen is an object that can draw a line in the player's nearest enclosing container that allows pen trails.  Any Player in Tweak can lay down a line as it moves.  The line is usually drawn in the Project object.  A pen has a penWidth, a penColor, is up or down, and a penTrailStyle.
	If you want to draw a line, the first thing you have to do is put the pen down.  (aPlayer penDown: true).
	Styles are plain lines, arrows (lines with an arrowHead at the end of each movement), arrowheads (just arrowheads and not the lines), and dots."

### Allow Users to see the above explanation ###
CCostumePen does not accept the normal Pen commands such as go: forward: turn: etc.  Instead, every CPlayer IS a pen.  Just tell it penDown: true, and then tell it to move via forwardBy: or position:.  It will leave a trail behind it.

Caching:  A Player is born without a CCostumePen.  As soon as a Player is sent any pen message that stores, it creates a CCostumePen.  (The messages are pen:  penWidth:  penColor:  penDown:  penTrailStyle:.)

Any object that has the property #primitivePen shows pen trails.  It has a primitivePen which is a BitBlt, and its destForm has the trails.  See indicatePenTrails:.!

CCostumePen defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="width" toSet="width:" changeEvent="widthChanged">width</field>
	<field toGet="color" toSet="color:" changeEvent="colorChanged">color</field>
	<field toGet="isDown" toSet="isDown:" changeEvent="isDownChanged">isDown</field>
	<field toGet="penTrailStyle" toSet="penTrailStyle:" changeEvent="penTrailStyleChanged">penTrailStyle</field>
	<field toGet="nib" toSet="nib:" changeEvent="nibChanged">nib</field>
	<field toGet="arrowhead" toSet="arrowhead:" changeEvent="arrowheadChanged">arrowhead</field>
	<field toGet="dot" toSet="dot:" changeEvent="dotChanged">dot</field>
</fields>'!

!CCostumePen class methodsFor: 'accessing' stamp: 'ar 6/3/2005 14:02'!
defaultColor
	"DO NOT USE COLOR NAMES HERE!!!!!!"
	"See CPlayer>>penColor:"
	^Color r: 0 g: 0 b: 1.0! !

!CCostumePen class methodsFor: 'accessing' stamp: ''!
defaultWidth
	^1! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/27/2005 14:12'!
arrowhead
	"The CPolygon of the arrowhead.  Just a cache."
	<bewareOf: #arrowheadChanged>
	^self propertyValueAt: #arrowhead! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:43'!
arrowhead: aValue
	"Modify the receiver's arrowhead"
	^self propertyValueAt: #arrowhead put: aValue with: #arrowheadChanged! !

!CCostumePen methodsFor: 'drawing' stamp: 'ar 6/26/2005 00:38'!
arrowheadFrom: prevPt to: newPt using: primBlt
	"Put an arrowhead on the pen stroke from oldPt to newPt.
	(Later may want any Form as an arrowhead.)"

	| pm af  finalPt delta |
	delta := newPt - prevPt.
	delta r <= 2 "pixels" ifTrue: [^ newPt extent: 0@0].
	finalPt := newPt + (Point r: width degrees: delta degrees).	"in same direction"
	(pm := CPolygonPlayer new) vertices: (Array with: prevPt asIntegerPoint with: finalPt asIntegerPoint);
		color: color;  "not used"
		borderWidth: width; 
		borderColor: color;
		closed: false; 
		arrowStyle: #forward.
	af := pm arrowForms first.
	"render it onto the destForm"
	(CTransformCanvas on: primBlt destForm) stencil: af at: af offset + (1@1) color: color.
	^af offset + (1@1) extent: af extent! !

!CCostumePen methodsFor: 'events' stamp: 'ar 6/23/2005 15:13'!
changed
	costume signal: #penChanged.! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:18'!
color
	"Answer the color of the pen"
	<bewareOf: #colorChanged>
	^self propertyValueAt: #color! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:43'!
color: aValue
	"Set the pen color"
	self changed.
	^self propertyValueAt: #color put: aValue with: #colorChanged! !

!CCostumePen methodsFor: 'initialize' stamp: ''!
defaultColor
	^self class defaultColor! !

!CCostumePen methodsFor: 'initialize' stamp: ''!
defaultWidth
	^self class defaultWidth! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/27/2005 14:12'!
dot
	"The Form of the current dot for dotted lines.  Just a cache."
	<bewareOf: #dotChanged>
	^self propertyValueAt: #dot! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/27/2005 14:10'!
dot: aValue
	"Modify the receiver's dot"
	^self propertyValueAt: #dot put: aValue with: #dotChanged! !

!CCostumePen methodsFor: 'drawing' stamp: 'ar 6/24/2005 16:14'!
drawPenTrailFrom: oldPoint to: targetPoint using: primPen
	"Draw a pen trail for the player who owns the aspect, using its pen state (the pen is assumed to be down).  turtleTrailsForm is created on demand when the first pen is put down and removed (to save space) when turtle trails are cleared."

	| newPoint dotSize arrowLineEnd invalid r w |
	isDown ifFalse: [^nil]. 	"just checking"
	invalid := nil.
	newPoint := arrowLineEnd := targetPoint.
	primPen fillColor: color.
	w := width asInteger.
	(nib == nil or: [nib width ~= w]) ifTrue: [
		"use round nib"
		w > 0 
			ifTrue:[nib := Form dotOfSize: w]
			ifFalse:[nib := Form extent: 0@0].
	].
	primPen sourceForm: nib.
	primPen combinationRule: Form paint.
	(#(lines arrows) includes: penTrailStyle)
		ifTrue: [(nib depth = 1 and: [primPen destForm depth > 1])
					ifTrue: ["Map 1-bit source to all ones for color mask"
							primPen colorMap: (Bitmap with: 0 with: 16rFFFFFFFF)]
					ifFalse: [primPen colorMap: nil].
			penTrailStyle == #arrows ifTrue: [
				arrowLineEnd := self finalPtForArrowhead: oldPoint to: arrowLineEnd].
			primPen drawFrom: oldPoint asIntegerPoint
				to: arrowLineEnd asIntegerPoint.
			r :=  (oldPoint rect: arrowLineEnd ) truncated expandBy: w//2+1.
			invalid ifNil:[invalid := r] ifNotNil:[invalid := invalid merge: r].
	].
	((#(arrowheads arrowHeads arrows) includes: penTrailStyle) 
			and: [oldPoint ~= newPoint]) ifTrue:[
		r := self arrowheadFrom: oldPoint
			to: newPoint
			using: primPen. 	"See CPolygonPlayer arrowSpec,   5@4"
		invalid ifNil:[invalid := r] ifNotNil:[invalid := invalid merge: r].
	].
	#dots == penTrailStyle ifTrue:[
		dotSize := width*4+1. 	"= default arrow width.  later use self dotSize"
		self putDotOfDiameter: dotSize at: oldPoint using: primPen.
		self putDotOfDiameter: dotSize at: targetPoint using: primPen.
		r := (oldPoint rect: targetPoint) expandBy: dotSize // 2+1.
		invalid ifNil:[invalid := r] ifNotNil:[invalid := invalid merge: r].
	].
	^invalid! !

!CCostumePen methodsFor: 'drawing' stamp: 'tk 4/28/2005 12:01'!
finalPtForArrowhead: prevPt to: finalPt
	"There will be an arrowhead on the pen stroke from oldPt to finalPt.  Return end point reduced in length"

	| delta |
	delta := finalPt - prevPt.
	delta r <= 2 "pixels" ifTrue: [^ finalPt].
	^ finalPt - (Point r: width degrees: delta degrees "in same direction")
! !

!CCostumePen methodsFor: 'initialize' stamp: 'tk 4/26/2005 17:26'!
initialize
	color := self defaultColor.
	width := self defaultWidth.
	isDown := false.
	penTrailStyle := #lines.! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:20'!
isDown
	"Return true if the pen is down and will draw a mark"
	<bewareOf: #isDownChanged>
	^self propertyValueAt: #isDown! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:43'!
isDown: aValue
	"Tell the pen to be down or up."
	self changed.
	^self propertyValueAt: #isDown put: aValue with: #isDownChanged! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:16'!
nib
	"Answer the nib of the receiver"
	<bewareOf: #nibChanged>
	^self propertyValueAt: #nib! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:16'!
nib: aValue
	"Modify the receiver's nib"
	^self propertyValueAt: #nib put: aValue with: #nibChanged! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:16'!
penTrailStyle
	"Answer the penTrailStyle of the receiver"
	<bewareOf: #penTrailStyleChanged>
	^self propertyValueAt: #penTrailStyle! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:43'!
penTrailStyle: aValue
	"#lines #arrows #arrowheads #dots.  The styles are plain lines, arrows (lines with an arrowhead at the end of each movement), arrowheads (just arrowheads and not the lines), and dots."
	self changed.
	^ self propertyValueAt: #penTrailStyle put: aValue with: #penTrailStyleChanged.
! !

!CCostumePen methodsFor: 'drawing' stamp: 'tk 4/27/2005 15:37'!
putDotOfDiameter: aDiameter at: aPoint using: primBlt
	"Put a dot of the given size at the given point, using my colot"

	(CTransformCanvas on: primBlt destForm) 
			fillOval: (Rectangle center: aPoint extent: (aDiameter @ aDiameter))
			color: color! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:16'!
width
	"Answer the width of the receiver"
	<bewareOf: #widthChanged>
	^self propertyValueAt: #width! !

!CCostumePen methodsFor: 'accessing' stamp: 'tk 4/28/2005 16:43'!
width: aValue
	"Modify the width of the pen, a number.  Actual drawing routine may reduce it to an Integer"
	self changed.
	^self propertyValueAt: #width put: aValue with: #widthChanged! !

CCostumeAspect subclass: #CCostumeTextHolder
	instanceVariableNames: 'text paragraph editor offset color borderWidth borderColor anchorPoint inset displaying showCaret wrapContents emphasis font'
	classVariableNames: 'DefaultBorder'
	poolDictionaries: ''
	category: 'Tweak-Costume-Aspects'!

!CCostumeTextHolder commentStamp: 'ar 3/27/2004 17:43' prior: 0!
CCostumeTextHolder represents the text aspect of a costume.

Instance variables:
	text 			<Text>				The text.
	offset 			<Point>				The offset for the text
	color 			<Color>				The default color of the text.
	borderWidth 	<Number>			The border width for the text
	borderColor 		<Color>				The border color for the text.
	anchorPoint 	<Symbol>			The anchor point for the text.
	inset 			<Point>				The text's inset from the bounding rectangle.
	showCaret 		<Boolean | nil>		Whether the caret should be displayed.
	wrapContents 	<Boolean>			Whether to wrap the text or not.
	emphasis 		<Number>			The default emphasis.
	font			<Font>				The default font for the text. 
	paragraph 		<CTextParagraph>	The paragraph representation of text.
	editor 			<CTextParagraphEditor>	The editor for the text
	displaying 		<Boolean>			Whether the text is in a display operation.
!

CCostumeTextHolder defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="text" toSet="text:">text</field>
	<field instanceVariable="true" toGet="paragraph">paragraph</field>
	<field instanceVariable="true" toGet="editor" toSet="editor:">editor</field>
	<field instanceVariable="true" toGet="offset" toSet="offset:">offset</field>
	<field instanceVariable="true" toGet="color" toSet="color:">color</field>
	<field instanceVariable="true" toGet="borderWidth" toSet="borderWidth:">borderWidth</field>
	<field instanceVariable="true" toGet="borderColor" toSet="borderColor:">borderColor</field>
	<field instanceVariable="true" toGet="anchorPoint" toSet="anchorPoint:">anchorPoint</field>
	<field instanceVariable="true" toGet="inset" toSet="inset:">inset</field>
	<field instanceVariable="true">displaying</field>
	<field instanceVariable="true" toGet="showCaret" toSet="showCaret:">showCaret</field>
	<field instanceVariable="true" toGet="wrapContents" toSet="wrapContents:">wrapContents</field>
	<field instanceVariable="true" toGet="emphasis" toSet="emphasis:">emphasis</field>
	<field instanceVariable="true" toGet="font" toSet="font:">font</field>
</fields>'!

!CCostumeTextHolder class methodsFor: 'class initialization' stamp: 'ar 3/23/2004 19:46'!
initialize
	"CTextContainer initialize"
	DefaultBorder := CCostumeBorder new.! !

!CCostumeTextHolder methodsFor: 'anchoring' stamp: 'ar 3/23/2004 19:46'!
adjustTextAnchor: aCostume
	"NOTE: Embedded costumes are relocated during display phase"
	aCostume textAnchorType == #document ifTrue:[^self].
	displaying ifFalse:[self editor adjustTextAnchor: aCostume]! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
anchorPoint
	^anchorPoint! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:56'!
anchorPoint: aSymbol
	anchorPoint = aSymbol ifTrue:[^self].
	anchorPoint := aSymbol asSymbol.
	self invalidate.! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
asText
	^text! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
attributes
	^self text attributesAt: 1! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
attributes: attrs
	self text: (Text string: self text string attributes: attrs)! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:58'!
borderColor
	^borderColor! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'bf 3/30/2004 10:38'!
borderColor: aColor
	borderColor = aColor ifTrue:[^self].
	borderColor := aColor.
	self invalidate.
	^ aColor! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:59'!
borderWidth
	^borderWidth! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'bf 3/30/2004 10:40'!
borderWidth: aNumber
	| newWidth oldWidth |
	oldWidth := borderWidth.
	newWidth := (aNumber ifNil:[0]) asNumber max: 0.
	newWidth = oldWidth ifTrue:[^self].
	newWidth > oldWidth ifTrue:[self invalidate].
	borderWidth := newWidth.
	newWidth <= oldWidth ifTrue:[self invalidate].
	self invalidateLayout.
	^aNumber! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
bounds
	^0@0 extent: self paragraph extent + (inset*2)! !

!CCostumeTextHolder methodsFor: 'initialize' stamp: 'ar 3/23/2004 19:52'!
changed
	costume signal: #textChanged.
! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:57'!
color
	^color! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:58'!
color: aColor
	color = aColor ifTrue:[^self].
	color := aColor asColor.
	self invalidate.! !

!CCostumeTextHolder methodsFor: 'drawing' stamp: 'ar 3/25/2004 22:54'!
containsPoint: aPoint
	"Later, we might do a better test"
	^true! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
contents
	^self text asString! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
contents: aText
	^self text: aText! !

!CCostumeTextHolder methodsFor: 'private' stamp: 'ar 5/19/2004 14:49'!
cursorPoint
	^costume cursorPoint - self editorOffset.! !

!CCostumeTextHolder methodsFor: 'drawing' stamp: 'ar 3/23/2004 19:59'!
drawBorderedTextOn: aCanvas
	| para rect form x y bc |
	para := self paragraph.
	bc := borderColor.
	bc isTransparent ifTrue:[
		aCanvas translateBy: 1@1.
		aCanvas paragraph: para bounds: para bounds color: self color.
		aCanvas translateBy: -1@-1.
		^self.
	].
	rect := para bounds intersect: (aCanvas clipRect expandBy: 1).
	form := Form extent: rect extent depth: 8.
	(CTransformCanvas on: form) 
		translateBy: rect origin negated;
		paragraph: para bounds: para bounds color: self color.
	x := rect left + 1.
	y := rect top + 1.
	aCanvas stencil: form  at: (x+1)@(y) color: bc.
	aCanvas stencil: form  at: (x+1)@(y+1) color: bc.
	aCanvas stencil: form  at: (x)@(y+1) color: bc.
	aCanvas stencil: form  at: (x-1)@(y+1) color: bc.
	aCanvas stencil: form  at: (x-1)@(y) color: bc.
	aCanvas stencil: form  at: (x-1)@(y-1) color: bc.
	aCanvas stencil: form  at: (x)@(y-1) color: bc.
	aCanvas stencil: form  at: (x+1)@(y-1) color: bc.
	aCanvas paintImage: form at: x@y.! !

!CCostumeTextHolder methodsFor: 'drawing' stamp: 'ar 8/18/2007 22:42'!
drawOn: aCanvas in: drawingBounds
	| para box ofs |
	(text size = 0 and:[self editor showCaret not]) ifTrue:[^self].
	displaying := true.
	para := self paragraph.
	box := 0@0 extent: para extent + (inset * 2).
	ofs := (drawingBounds perform: anchorPoint) - (box perform: anchorPoint).
	ofs := ofs + offset.
	aCanvas translateBy: ofs + inset during:[:cc|
		(borderWidth > 0) ifTrue:[
			self drawBorderedTextOn: cc.
		] ifFalse:[
			cc paragraph: para bounds: para bounds color: color.
			"@@@@: Above used to be clipping but that clips the I-beam too.
			Original code was:
				cc clipBy: (0@0 extent: para extent) during:[:clip|
					clip paragraph: para bounds: para bounds color: color.
				].
			"
		].
	].
	displaying := false.
! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 4/4/2004 21:10'!
editor
	editor ifNil:[
		editor := CTextParagraphEditor new.
		editor costume: self.
		editor paragraph: self paragraph.
	].
	^editor! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 4/19/2007 14:55'!
editor: aTextParagraphEditor
	editor := aTextParagraphEditor.
	editor costume: self.
	editor paragraph: self paragraph.! !

!CCostumeTextHolder methodsFor: 'private' stamp: 'ar 3/23/2004 19:49'!
editorOffset
	| ofs |
	ofs := inset.
	costume ifNotNil:[ofs := ofs + costume border width].
	^ofs! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
emphasis
	^emphasis ifNil:[0]! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'bgf 6/22/2008 11:41'!
emphasis: emph
	| copy code attr |

	emphasis ~= emph ifTrue: [
		emphasis := emph.
		copy := self text copy.
		1 to: 3 do:[:i|
			code := 1 bitShift: i-1.
			attr := TextEmphasis new emphasisCode: code.
			copy removeAttribute: attr from: 1 to: copy size.
		].
		self text: copy.
	].! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
font
	font ifNotNil:[^font].
	(self text attributesAt: 1) do:[:each|
		each class == TextFontReference ifTrue:[^each font].
	].
	^TextStyle defaultFont
! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'bgf 11/16/2008 13:16'!
font: aFont

	(aFont = font) ifFalse: [
		font := aFont.
		text addAttribute: (TextFontReference toFont: font).
		self textChanged.
	].! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 4/4/2004 21:11'!
getEditor
	^editor! !

!CCostumeTextHolder methodsFor: 'testing' stamp: 'ar 3/23/2004 19:46'!
hasKeyboardFocus
	costume ifNil:[^false] ifNotNil:[^costume hasKeyboardFocus]! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 5/9/2005 11:20'!
height
	^costume height! !

!CCostumeTextHolder methodsFor: 'initialize' stamp: 'ar 8/20/2007 18:53'!
initialize
	displaying := false.
	color := Color black.
	inset := 3@1.
	offset := 0@0.
	wrapContents := false.
	anchorPoint := #center.
	borderWidth := 0.
	borderColor := Color transparent.
	showCaret := false.
	self text:''.! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
inset
	^inset! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'bgf 11/16/2008 13:16'!
inset: aPoint
	inset = aPoint ifFalse: [
		inset := aPoint.
		self invalidate.
		self invalidateLayout.
	].! !

!CCostumeTextHolder methodsFor: 'drawing' stamp: 'ar 3/23/2004 19:48'!
invalidate: aRectangle
	costume ifNotNil:[costume invalidate: (aRectangle translateBy: self editorOffset)].! !

!CCostumeTextHolder methodsFor: 'keyboard' stamp: 'ar 3/23/2004 19:46'!
keyboardFocusEnter
	showCaret == false ifFalse:[self invalidate: self editor selectionRect].
! !

!CCostumeTextHolder methodsFor: 'keyboard' stamp: 'ar 3/23/2004 19:46'!
keyboardFocusLeave
	showCaret == true ifFalse:[self invalidate: self editor selectionRect].
! !

!CCostumeTextHolder methodsFor: 'initialize' stamp: 'ar 6/22/2005 11:10'!
loadFrom: aTextHolder
	(aTextHolder isString or:[aTextHolder isText])
		ifTrue:[^self text: aTextHolder].
	text := aTextHolder text copy.
	offset := aTextHolder offset.
	color := aTextHolder color.
	borderWidth := aTextHolder borderWidth.
	borderColor := aTextHolder borderColor.
	anchorPoint := aTextHolder anchorPoint.
	inset := aTextHolder inset.
	showCaret := aTextHolder showCaret.
	wrapContents := aTextHolder wrapContents.
	emphasis := aTextHolder emphasis.
	font := aTextHolder font.
	self textChanged.! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
minHeight
	^0! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
minWidth
	self text isEmpty ifTrue:[^0].
	^2*(inset asPoint x) + 2! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
minimalTextExtent
	"Answer the minimal extent this text can be represented in.
	Note: For both, wrapped and non-wrapped text
	we take the current editor extent. Obviously, this is correct for wrapped
	text but also for non-wrapped since the editor has layed out the text
	in its current extent which means that it is possible to represent the
	text in these minimal bounds."
	^self paragraph minimalTextExtent + (inset * 2)! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 4/22/2005 20:18'!
modified: aBool
	costume ifNotNil:[
		costume signal: #textModified.
		costume signal: #textSelectionChanged.
	].! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
offset
	^offset! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'bgf 11/16/2008 13:17'!
offset: aPoint

	offset = aPoint ifFalse: [
		offset := aPoint.
		self invalidate.
	].! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
paragraph
	paragraph ifNil:[self updateParagraphExtent].
	^paragraph! !

!CCostumeTextHolder methodsFor: 'serializing' stamp: 'ar 3/23/2004 20:01'!
readFieldsFrom: deSerializer
	text := deSerializer readField: #text ifAbsent:[text].
	offset := deSerializer readField: #offset ifAbsent:[offset].
	color := deSerializer readField: #color ifAbsent:[color].
	borderColor := deSerializer readField: #borderColor ifAbsent:[borderColor].
	borderWidth := deSerializer readField: #borderWidth ifAbsent:[borderColor].
	anchorPoint := deSerializer readField: #anchorPoint ifAbsent:[anchorPoint].
	inset := deSerializer readField: #inset ifAbsent:[inset].
	showCaret := deSerializer readField: #showCaret ifAbsent:[showCaret].
	wrapContents := deSerializer readField: #wrapContents ifAbsent:[wrapContents].
	emphasis := deSerializer readField: #emphasis ifAbsent:[emphasis].
	font := deSerializer readField: #font ifAbsent:[font].
! !

!CCostumeTextHolder methodsFor: 'scrolling' stamp: 'ar 3/23/2004 19:47'!
scrollOffset
	^costume scrollOffset! !

!CCostumeTextHolder methodsFor: 'scrolling' stamp: 'ar 3/23/2004 19:49'!
scrollToSelection
	"Make the current selection visible"
	| rect |
	costume ifNil:[^nil].
	rect := (self editor markBlock merge: self editor pointBlock) 
		translateBy: self editorOffset.
	costume player scrollToShow: rect.! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
showCaret
	"Answer the value of the receiver's showCaret property.
	Values:
		false	-	never show the caret
		nil		-	show the caret if the receiver has the input focus
		true	-	show the caret unless nothing is selected and not input focus"
	^showCaret! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 5/19/2004 15:20'!
showCaret: aBoolOrNil
	"Set the value of the receiver's showCaret property.
	Values:
		false	-	never show the caret
		nil		-	show the caret if the receiver has the input focus
		true	-	show the caret unless nothing is selected and not input focus"
	showCaret := aBoolOrNil.
	editor ifNotNil:[self invalidate: editor selectionRect].! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
text
	^text! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 12/6/2005 15:16'!
text: aText
	| code attr newFont newEmphasis |
	text == aText ifTrue:[^aText].
	costume ifNotNil:[costume scrollOffset: 0@0].
	newFont := nil.
	newEmphasis := 0.
	aText isText ifTrue:[
		newFont := aText font.
		newEmphasis := aText emphasis.
	].
	text := aText asText.
	(newFont isNil and:[font notNil]) ifTrue:[
		text addAttribute: (TextFontReference toFont: font).
		newFont := font.
	].
	(newEmphasis = 0 and:[self emphasis ~= 0]) ifTrue:[
		1 to: 3 do:[:i|
			code := 1 bitShift: i-1.
			(self emphasis bitAnd: code) = 0 ifFalse:[
				attr := TextEmphasis new emphasisCode: code.
				text addAttribute: attr]].
		newEmphasis := emphasis.
	].
	font := newFont.
	emphasis := newEmphasis.
	self textChanged.
	^aText! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:49'!
textBounds
	^costume ifNil:[0@0 extent: 999999@999999] ifNotNil:[costume layoutBounds]! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 10/31/2004 15:21'!
textChanged
	paragraph := editor := nil.
	self updateParagraphExtent.
	costume ifNotNil:[
		self invalidate.
		self invalidateLayout.
		costume signal: #textModified.
		costume signal: #textSelectionChanged.
	].! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/24/2004 12:50'!
textSelectionChanged
	costume ifNotNil:[costume signal: #textSelectionChanged].! !

!CCostumeTextHolder methodsFor: 'private' stamp: 'ar 12/6/2005 14:42'!
updateParagraphExtent
	| rightX |
	paragraph ifNil:[
		paragraph := CTextParagraph new.
		font ifNotNil:[paragraph textStyle: font textStyle].
	].
	rightX := (self textBounds insetBy: inset) extent x.
	(self wrapContents) ifTrue:[
		paragraph
			compose: text
			style: paragraph textStyle
			from: 1
			in: (0@0 extent: rightX @ 999999999).
	] ifFalse:[
		paragraph
			compose:  text
			style: paragraph textStyle
			from: 1
			in: (0@0 extent: 999999999 @ 999999999).
		paragraph adjustRightXBy: 999999999 - paragraph width.
	].
! !

!CCostumeTextHolder methodsFor: 'testing' stamp: 'ar 3/11/2005 21:13'!
wantsCaretShowingIn: myEditor
	"Answer whether the receiver would like to have the caret showing."
	showCaret ifNotNil:[^showCaret].
	costume ifNil:[^false].
	"otherwise, always show it if I have the focus"
	"@@@@: We need #isInKeyboardFocus to allow scrollable texts to have their 'display costume' to be different from their 'focus costume'. Without the following (e.g., just using #hasKeyboardFocus) we wouldn't see the I-beam since the parent holds the focus not the child."
	(costume isInKeyboardFocus) ifTrue:[^true].
	"and then only if there is a range selected"
	^myEditor markBlock ~= myEditor pointBlock! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:46'!
wrapContents
	^wrapContents! !

!CCostumeTextHolder methodsFor: 'accessing' stamp: 'ar 3/23/2004 19:56'!
wrapContents: aBool
	wrapContents = aBool ifTrue:[^self].
	wrapContents := aBool.
	costume ifNotNil:[
		self updateParagraphExtent.
		self invalidate.
		self invalidateLayout.
	].! !

!CCostumeTextHolder methodsFor: 'serializing' stamp: 'ar 3/23/2004 20:01'!
writeFieldsOn: aSerializer
	aSerializer writeField: #text value: text.
	aSerializer writeField: #offset value: offset.
	aSerializer writeField: #color value: color.
	aSerializer writeField: #borderWidth value: borderWidth. 
	aSerializer writeField: #borderColor value: borderColor.
	aSerializer writeField: #anchorPoint value: anchorPoint.
	aSerializer writeField: #inset value: inset.
	aSerializer writeField: #showCaret value: showCaret.
	aSerializer writeField: #wrapContents value: wrapContents.
	aSerializer writeField: #emphasis value: emphasis.
	aSerializer writeField: #font value: font.! !

CCostumeAspect subclass: #CLayoutPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Layouts'!

!CLayoutPolicy commentStamp: 'ar 3/27/2004 18:02' prior: 0!
A LayoutPolicy defines how submorphs of some morph should be arranged. Subclasses of the receiver define concrete layout policies.!

CLayoutPolicy defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CLayoutPolicy methodsFor: 'accessing' stamp: 'ar 3/24/2004 03:32'!
cellPositioning
	^#center! !

!CLayoutPolicy methodsFor: 'initialize' stamp: 'ar 3/24/2004 02:19'!
changed
	^costume signal: #layoutChanged! !

!CLayoutPolicy methodsFor: 'layout' stamp: ''!
flushLayoutCache
	"Flush any cached information associated with the receiver"! !

!CLayoutPolicy methodsFor: 'accessing' stamp: 'mtf 3/10/2009 14:15'!
hAlign
	^ 0.5! !

!CLayoutPolicy methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:46'!
hResizing
	^costume hResizing! !

!CLayoutPolicy methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:46'!
hResizing: aSymbol
	^costume hResizing: aSymbol! !

!CLayoutPolicy methodsFor: 'initialize' stamp: 'ar 3/24/2004 02:45'!
invalidateLayout
	costume ifNotNil:[
		costume invalidateLayout.
		self changed.
	].! !

!CLayoutPolicy methodsFor: 'testing' stamp: ''!
isProportionalLayout
	^false! !

!CLayoutPolicy methodsFor: 'testing' stamp: 'ar 3/15/2003 17:01'!
isSimpleLayout
	^false! !

!CLayoutPolicy methodsFor: 'testing' stamp: 'ar 3/15/2003 17:01'!
isTableLayout
	^false! !

!CLayoutPolicy methodsFor: 'layout' stamp: ''!
layout: aMorph in: newBounds
	"Compute the layout for the given morph based on the new bounds"! !

!CLayoutPolicy methodsFor: 'accessing' stamp: 'ar 3/24/2004 03:42'!
layoutInset
	^costume layoutInset! !

!CLayoutPolicy methodsFor: 'accessing' stamp: 'ar 3/24/2004 03:42'!
layoutInset: newInset
	^costume layoutInset: newInset! !

!CLayoutPolicy methodsFor: 'initialize' stamp: 'ar 3/25/2004 18:03'!
loadFrom: aLayout
	"Do nothing - most layouts won't have any state"! !

!CLayoutPolicy methodsFor: 'layout' stamp: ''!
minExtentOf: aMorph in: newBounds
	"Return the minimal size aMorph's children would require given the new bounds"
	^0@0! !

!CLayoutPolicy methodsFor: 'initialize' stamp: 'ar 3/24/2004 02:19'!
releaseCachedState
	^self flushLayoutCache! !

!CLayoutPolicy methodsFor: 'accessing' stamp: 'mtf 3/10/2009 14:15'!
vAlign
	^ 0.5! !

!CLayoutPolicy methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:46'!
vResizing
	^costume vResizing! !

!CLayoutPolicy methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:46'!
vResizing: aSymbol
	^costume vResizing: aSymbol! !

!CLayoutPolicy methodsFor: 'serializing' stamp: 'ar 9/24/2003 18:04'!
writeFieldsOn: aSerializer
	self flushLayoutCache.
	super writeFieldsOn: aSerializer! !

CLayoutPolicy subclass: #CListLayout
	instanceVariableNames: 'minExtentCache fillers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Layouts'!

CListLayout defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true">minExtentCache</field>
	<field instanceVariable="true">fillers</field>
</fields>'!

!CListLayout methodsFor: 'layout' stamp: 'ar 3/21/2004 02:32'!
flushLayoutCache
	"Flush any cached information associated with the receiver"
	minExtentCache := nil.! !

!CListLayout methodsFor: 'layout' stamp: 'ar 3/21/2004 02:49'!
layout: aCostume in: newBounds
	aCostume listDirection == #topToBottom
		ifTrue:[^self layoutVertical: aCostume in: newBounds]
		ifFalse:[^self layoutHorizontal: aCostume in: newBounds]
! !

!CListLayout methodsFor: 'layout' stamp: 'ar 3/21/2004 02:57'!
layoutHorizontal: aCostume in: newBounds
	"An optimized left-to-right list layout"
	| min extraPerCell x y h w lastExtra nextExtra |
	minExtentCache ifNil:[self minExtentHorizontal: aCostume in: newBounds].
	min := minExtentCache x.
	fillers > 0 ifTrue:[extraPerCell := (newBounds width - min max: 0) / fillers asFloat].
	x := newBounds left.
	y := newBounds top.
	h := newBounds height.
	nextExtra := lastExtra := 0.
	aCostume layoutTargets do:[:cc|
		(cc hResizing == #spaceFill) ifTrue:[
			lastExtra := nextExtra.
			nextExtra := nextExtra + extraPerCell.
			w := nextExtra truncated - lastExtra truncated.
		] ifFalse:[
			w := cc bounds width.
		].
		cc bounds: (x@y extent: w@h).
		x := x + w.
	].! !

!CListLayout methodsFor: 'layout' stamp: 'ar 3/21/2004 02:58'!
layoutVertical: aCostume in: newBounds
	"An optimized left-to-right list layout"
	| min extraPerCell x y h w lastExtra nextExtra |
	minExtentCache ifNil:[self minExtentVertical: aCostume in: newBounds].
	min := minExtentCache y.
	fillers > 0 ifTrue:[extraPerCell := (newBounds height - min max: 0) / fillers asFloat].
	x := newBounds left.
	y := newBounds top.
	w := newBounds width.
	nextExtra := lastExtra := 0.
	aCostume layoutTargets do:[:cc|
		(cc vResizing == #spaceFill) ifTrue:[
			lastExtra := nextExtra.
			nextExtra := nextExtra + extraPerCell.
			h := nextExtra truncated - lastExtra truncated.
		] ifFalse:[
			h := cc bounds height.
		].
		cc bounds: (x@y extent: w@h).
		y := y + h.
	].! !

!CListLayout methodsFor: 'layout' stamp: 'ar 3/21/2004 02:57'!
minExtentHorizontal: aCostume in: newBounds
	"An optimized left-to-right list layout"
	| min |
	min := fillers := 0.
	aCostume layoutTargets do:[:cc|
		(cc hResizing == #spaceFill) 
			ifTrue:[fillers := fillers + 1]
			ifFalse:[min := min + cc width].
	].
	^minExtentCache := min @ 0! !

!CListLayout methodsFor: 'layout' stamp: 'ar 3/21/2004 02:49'!
minExtentOf: aCostume in: newBounds
	minExtentCache ifNotNil:[^minExtentCache].
	aCostume listDirection == #topToBottom
		ifTrue:[^self minExtentVertical: aCostume in: newBounds]
		ifFalse:[^self minExtentHorizontal: aCostume in: newBounds]
! !

!CListLayout methodsFor: 'layout' stamp: 'ar 3/21/2004 02:58'!
minExtentVertical: aCostume in: newBounds
	"An optimized left-to-right list layout"
	| min |
	min := fillers := 0.
	aCostume layoutTargets do:[:cc|
		(cc vResizing == #spaceFill) 
			ifTrue:[fillers := fillers + 1]
			ifFalse:[min := min + cc height]
	].
	^minExtentCache := 0@min! !

CLayoutPolicy subclass: #CProportionalLayout
	instanceVariableNames: 'minExtentCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Layouts'!

!CProportionalLayout commentStamp: 'ar 3/27/2004 18:02' prior: 0!
I represent a layout that places all children of some morph in their given LayoutFrame.!

CProportionalLayout defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true">minExtentCache</field>
</fields>'!

!CProportionalLayout methodsFor: 'layout' stamp: ''!
flushLayoutCache
	"Flush any cached information associated with the receiver"
	minExtentCache := nil.! !

!CProportionalLayout methodsFor: 'testing' stamp: ''!
isProportionalLayout
	^true! !

!CProportionalLayout methodsFor: 'layout' stamp: ''!
layout: aMorph in: newBounds
	"Compute the layout for the given morph based on the new bounds"
	aMorph layoutTargets do:[:m| m layoutProportionallyIn: newBounds].! !

!CProportionalLayout methodsFor: 'layout' stamp: ''!
minExtentOf: aMorph in: newBounds
	"Return the minimal size aMorph's children would require given the new bounds"
	| min extent frame |
	minExtentCache == nil ifFalse:[^minExtentCache].
	min := 0@0.
	aMorph layoutTargets do:[:m|
		"Map the minimal size of the child through the layout frame.
		Note: This is done here and not in the child because its specific
		for proportional layouts. Perhaps we'll generalize this for table
		layouts but I'm not sure how and when."
		extent := m minExtent.
		frame := m layoutFrame.
		frame ifNotNil:[extent := frame minExtentFrom: extent].
		min := min max: extent].
	^minExtentCache := min! !

!CProportionalLayout methodsFor: 'geometry' stamp: 'tk 5/10/2005 14:12'!
moveEdge: edgeSymbol of: aPane to: globalPoint
	"Allow the caller to change the proportion of this layout.  aPane is an element of my Player.  The user wants move one of #(left right top bottom) edge of aPane.  Find the current proportion of that edge (i.e. 0.3).  Find all elements of my Player that have 0.3 in the this axis, and change them all.  Then invalidate the layout."

	| oldPorp widthOrHeight newPorp newRect localPt fakeRect twoSides setters oldOffsets |
	oldPorp := aPane layoutFrame fractions perform: edgeSymbol.
	oldPorp = 0.0 ifTrue: [^ self].	"we don't do the outside edges"
	oldPorp = 1.0 ifTrue: [^ self].
	widthOrHeight := #(width width height height) at: 
					(#(left   right   top    bottom) indexOf: edgeSymbol).
	localPt := costume geometry globalToLocal: globalPoint.
	fakeRect := 0@0 corner: localPt.
	newPorp := (fakeRect perform: widthOrHeight) asFloat / 
					(costume player perform: widthOrHeight).
	widthOrHeight = #width
		ifTrue: [twoSides := #(left right).  setters := #(left: right:)]
		ifFalse: [twoSides := #(top bottom).  setters := #(top: bottom:)].
	costume player elements do: [:somePane |
		twoSides with: setters do: [:getter :setter |
			oldPorp = (somePane layoutFrame fractions perform: getter) ifTrue: [
				newRect := somePane layoutFrame fractions perform: setter with: newPorp.
				oldOffsets := somePane layoutFrame offsets.
				somePane layoutFrame: 
					(CLayoutFrame fractions: newRect offsets: oldOffsets)]]].! !

CLayoutPolicy subclass: #CSimpleLayout
	instanceVariableNames: 'minExtentCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Layouts'!

CSimpleLayout defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true">minExtentCache</field>
</fields>'!

!CSimpleLayout methodsFor: 'layout' stamp: 'ar 3/15/2003 17:01'!
flushLayoutCache
	"Flush any cached information associated with the receiver"
	minExtentCache := nil.! !

!CSimpleLayout methodsFor: 'testing' stamp: 'ar 3/15/2003 17:01'!
isSimpleLayout
	^true! !

!CSimpleLayout methodsFor: 'layout' stamp: 'ar 3/15/2003 17:01'!
layout: aMorph in: newBounds
	"Compute the layout for the given morph based on the new bounds"
	aMorph layoutTargets do:[:m| m layoutSimplyIn: newBounds].! !

!CSimpleLayout methodsFor: 'layout' stamp: 'ar 3/15/2003 17:02'!
minExtentOf: aMorph in: newBounds
	"Return the minimal size aMorph's children would require given the new bounds"
	| min extent |
	minExtentCache == nil ifFalse:[^minExtentCache].
	min := 0@0.
	aMorph layoutTargets do:[:m|
		extent := m minExtent.
		min := min max: extent].
	^minExtentCache := min! !

CLayoutPolicy subclass: #CTableLayout
	instanceVariableNames: 'properties minExtentCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Layouts'!

!CTableLayout commentStamp: 'ar 3/27/2004 18:02' prior: 0!
The layout process:
For computing the new layout for the children of any morph, we start with an initial rectangle which is provided as a reference.

Step 1: The first step of layout computation is to compute the minimum extent each of our children can have. The minimum extent is mapped through both the local layout frame of the morph (for relative positioning) and the global layout frame (for insets, such as cursor indication) to obtain the minimal size required for each cell.

Step 2: Based on the cell sizes, the number of cells we can put into each row and column is computed. For equal spacing, the maximum size of the cells is taken into account here.

Step 3: Based on the row/column sizes, we compute the extra space which should be added to each row/column. For 
	#leftFlush/#topFlush - we add all extra space add the end
	#rightFlush/#bottomFlush - we add all extra space at the start
	#centering - we add 1/2 of the extra space at start and end
	#justified - we distribute the space evenly between the morphs
[NOTE: If any #spaceFill morphs are encountered during this step, #justified is implied and the space is exclusively and equally distributed between those #spaceFill morphs. This is for backward compatibility and should *never* be necessary in the new regime].

Step 4: The morphs are placed in the computed cells and the extra space is distributed as necessary. Placing the submorphs is done by mapping through the global and the local layout frame as requested.

Start point:
=> bounds: new rectangle for the morph.

Compute basic arrangement of morphs:
=> For each submorph compute minExtent
	- if global layout frame inset in global layout frame
	- if local layout frame inset in local layout frame
=> Compute number of morphs per, width and height of row/column
	- if equal spacing based on max size
=> Compute extra space per row/column
	- if centering = #justified; distribute space equally
	- if centering #leftFlush/#topFlush (-1) add start extra
	- if centering #rightFlush/#bottomFlush (1) add end extra
	- if centering #centered add 1/2 extra to start/end
	<extra space must be float and rounded accordingly!!>
=> Place morphs in appropriate cells
	- if global layout frame inset in global layout frame
	- if local layout frame inset in local layout frame
	<will likely cause #layoutChanged by submorphs>

Distribute morphs in row/column:

=> Compute the max length of each row/column
!

CTableLayout defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true">properties</field>
	<field instanceVariable="true">minExtentCache</field>
</fields>'!

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:25'!
cellInset
	"Layout specific. This property specifies an extra inset for each cell in the layout."
	^properties cellInset! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:22'!
cellInset: aNumber
	"Layout specific. This property specifies an extra inset for each cell in the layout."
	properties cellInset: aNumber.
	self invalidateLayout.! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:25'!
cellPositioning
	"Layout specific. This property describes how the receiver should be layed out in its owner when the bounds of the cell assigned to the receiver do not exactly match its bounds. Possible values are:
		#topLeft, #topRight, #bottomLeft, #bottomRight, #topCenter, #leftCenter, #rightCenter, #bottomCenter, #center 
	which align the receiver's bounds with the cell at the given point."
	^properties cellPositioning! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:22'!
cellPositioning: aSymbol
	"Layout specific. This property describes how the receiver should be layed out in its owner when the bounds of the cell assigned to the receiver do not exactly match its bounds. Possible values are:
		#topLeft, #topRight, #bottomLeft, #bottomRight, #topCenter, #leftCenter, #rightCenter, #bottomCenter, #center 
	which align the receiver's bounds with the cell at the given point."
	properties cellPositioning: aSymbol.
	self invalidateLayout.! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:25'!
cellSpacing
	"Layout specific. This property describes how the cell size for each element in a list should be computed.
		#globalRect - globally equal rectangular cells
		#globalSquare - globally equal square cells
		#localRect - locally (e.g., per row/column) equal rectangular cells
		#localSquare - locally (e.g., per row/column) equal square cells
		#none - cells are sized based on available row/column constraints
	"
	^properties cellSpacing! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:22'!
cellSpacing: aSymbol
	"Layout specific. This property describes how the cell size for each element in a list should be computed.
		#globalRect - globally equal rectangular cells
		#globalSquare - globally equal square cells
		#localRect - locally (e.g., per row/column) equal rectangular cells
		#localSquare - locally (e.g., per row/column) equal square cells
		#none - cells are sized based on available row/column constraints
	"
	properties cellSpacing: aSymbol.
	self invalidateLayout.! !

!CTableLayout methodsFor: 'layout' stamp: ''!
computeCellArrangement: cellHolder in: newBounds horizontal: aBool target: aMorph
	"Compute number of cells we can put in each row/column. The returned array contains a list of all the cells we can put into the row/column at each level.
	Note: The arrangement is so that the 'x' value of each cell advances along the list direction and the 'y' value along the wrap direction. The returned arrangement has an extra cell at the start describing the width and height of the row."
	| cells wrap spacing output maxExtent n sum index max cell first last w cellMax maxCell hFill vFill inset |
	maxCell := cellHolder key.
	cells := cellHolder value.
	properties wrapDirection == #none 
		ifTrue:[wrap := SmallInteger maxVal]
		ifFalse:[wrap := aBool ifTrue:[newBounds width] ifFalse:[newBounds height].
				wrap < maxCell x ifTrue:[wrap := maxCell x]].
	spacing := properties cellSpacing.
	(spacing == #globalRect or:[spacing = #globalSquare]) ifTrue:[
		"Globally equal spacing is a very special case here, so get out fast and easy"
		^self computeGlobalCellArrangement: cells 
			in: newBounds horizontal: aBool 
			wrap: wrap spacing: spacing].
	output := (WriteStream on: Array new).
	inset := properties cellInset asPoint.
	aBool ifFalse:[inset := inset transposed].
	first := last := nil.
	maxExtent := 0@0.
	sum := 0.
	index := 1.
	n := 0.
	hFill := vFill := false.
	[index <= cells size] whileTrue:[
		w := sum.
		cell := cells at: index.
		cellMax := maxExtent max: cell cellSize. "e.g., minSize"
		(spacing == #localRect or:[spacing == #localSquare]) ifTrue:[
			"Recompute entire size of current row"
			spacing == #localSquare 
				ifTrue:[max := cellMax x max: cellMax y]
				ifFalse:[max := cellMax x].
			sum := (n + 1) * max.
		] ifFalse:[
			sum := sum + (cell cellSize x).
		].
		((sum + (n * inset x)) > wrap and:[first notNil]) ifTrue:[
			"It doesn't fit and we're not starting a new line"
			(spacing == #localSquare or:[spacing == #localRect]) ifTrue:[
				spacing == #localSquare 
					ifTrue:[maxExtent := (maxExtent x max: maxExtent y) asPoint].
				first do:[:c| c cellSize: maxExtent]].
			w := w + ((n - 1) * inset x).
			"redistribute extra space"
			first nextCell ifNotNil:[first nextCell do:[:c| c addExtraSpace: inset x@0]].
			last := CLayoutCell new.
			last cellSize: w @ (maxExtent y).
			last hSpaceFill: hFill.
			last vSpaceFill: vFill.
			last nextCell: first.
			output position = 0 ifFalse:[last addExtraSpace: 0@inset y].
			output nextPut: last.
			first := nil.
			maxExtent := 0@0.
			sum := 0.
			n := 0.
			hFill := vFill := false.
		] ifFalse:[
			"It did fit; use next item from input"
			first ifNil:[first := last := cell] ifNotNil:[last nextCell: cell. last := cell].
			index := index+1.
			n := n + 1.
			maxExtent := cellMax.
			hFill := hFill or:[cell hSpaceFill].
			vFill := vFill or:[cell vSpaceFill].
		].
	].
	first ifNotNil:[
		last := CLayoutCell new.
		sum := sum + ((n - 1) * inset x).
		first nextCell ifNotNil:[first nextCell do:[:c| c addExtraSpace: inset x@0]].
		last cellSize: sum @ maxExtent y.
		last hSpaceFill: hFill.
		last vSpaceFill: vFill.
		last nextCell: first.
		output position = 0 ifFalse:[last addExtraSpace: 0@inset y].
		output nextPut: last].
	output := output contents.
	properties listSpacing == #equal ifTrue:[
		"Make all the heights equal"
		max := output inject: 0 into:[:size :c| size max: c cellSize y].
		output do:[:c| c cellSize: c cellSize x @ max].
	].
	^output! !

!CTableLayout methodsFor: 'layout' stamp: 'ar 3/24/2004 02:31'!
computeCellSizes: aMorph in: newBounds horizontal: aBool
	"Step 1: Compute the minimum extent for all the children of aMorph"
	| cells cell size block maxCell minSize maxSize |
	cells := WriteStream on: (Array new: aMorph layoutTargets size).
	minSize := properties minCellSize asPoint.
	maxSize := properties maxCellSize asPoint.
	aBool ifTrue:[
		minSize := minSize transposed.
		maxSize := maxSize transposed].
	maxCell := 0@0.
	block := [:m|
			size := m minExtent asIntegerPoint.
			cell := CLayoutCell new target: m.
			aBool ifTrue:[
				cell hSpaceFill: m hResizing == #spaceFill.
				cell vSpaceFill: m vResizing == #spaceFill.
			] ifFalse:[
				cell hSpaceFill: m vResizing == #spaceFill.
				cell vSpaceFill: m hResizing == #spaceFill.
				size := size transposed.
			].
			size := (size min: maxSize) max: minSize.
			cell cellSize: size.
			maxCell := maxCell max: size.
			cells nextPut: cell].
	properties reverseTableCells
		ifTrue:[aMorph layoutTargets reverseDo: block]
		ifFalse:[aMorph layoutTargets do: block].
	^maxCell -> cells contents! !

!CTableLayout methodsFor: 'layout' stamp: 'ar 3/24/2004 03:30'!
computeExtraSpacing: arrangement in: newBounds horizontal: aBool target: aMorph
	"Compute the required extra spacing for laying out the cells"
	| extent extra centering n extraPerCell cell last hFill vFill max amount allow |
	"match newBounds extent with arrangement's orientation"
	extent := newBounds extent.
	aBool ifFalse:[extent := extent transposed].
	"figure out if we have any horizontal or vertical space fillers"
	hFill := vFill := false.
	max := 0@0.
	arrangement do:[:c|
		max := (max x max: c cellSize x) @ (max y + c cellSize y).
		max := max max: c cellSize.
		hFill := hFill or:[c hSpaceFill].
		vFill := vFill or:[c vSpaceFill]].
	"Take client's shrink wrap constraints into account.
	Note: these are only honored when there are no #spaceFill children,
	or when #rubberBandCells is set."
	allow := properties rubberBandCells not.
	aMorph hResizing == #shrinkWrap ifTrue:[
		aBool 
			ifTrue:[allow & hFill ifFalse:[extent := max x @ (max y max: extent y)]]
			ifFalse:[allow & vFill ifFalse:[extent := (max x max: extent x) @ max y]]].
	aMorph vResizing == #shrinkWrap ifTrue:[
		aBool 
			ifFalse:[allow & hFill ifFalse:[extent := max x @ (max y max: extent y)]]
			ifTrue:[allow & vFill ifFalse:[extent := (max x max: extent x) @ max y]]].
	"Now compute the extra v space"
	extra := extent y - (arrangement inject: 0 into:[:sum :c| sum + c cellSize y]).
	extra > 0 ifTrue:[
		"Check if we have any #spaceFillers"
		vFill ifTrue:[ "use only #spaceFillers"
			n := arrangement inject: 0 into:[:sum :c| 
				c vSpaceFill ifTrue:[sum + 1] ifFalse:[sum]].
			n isZero ifFalse:[extraPerCell := extra asFloat / n asFloat].
			extra := last := 0.
			arrangement do:[:c|
				c vSpaceFill ifTrue:[
					extra := (last := extra) + extraPerCell.
					amount := 0 @ (extra truncated - last truncated).
					c do:[:cc| cc cellSize: cc cellSize + amount]]].
		] ifFalse:[ "no #spaceFillers; distribute regularly"
			centering := properties wrapCentering.
			"centering == #topLeft ifTrue:[]." "add all extra space to the last cell; e.g., do nothing"
			centering == #bottomRight "add all extra space to the first cell"
				ifTrue:[arrangement first addExtraSpace: 0@extra].
			centering == #center "add 1/2 extra space to the first and last cell"
				ifTrue:[arrangement first addExtraSpace: 0@ (extra // 2)].
			centering == #justified "add extra space equally distributed to each cell"
				ifTrue:[	n := (arrangement size - 1) max: 1.
						extraPerCell := extra asFloat / n asFloat.
						extra := last := 0.
						arrangement do:[:c|
							c addExtraSpace: 0@(extra truncated - last truncated).
							extra := (last := extra) + extraPerCell]].
		].
	].
	"Now compute the extra space for the primary direction"
	centering := properties listCentering.
	1 to: arrangement size do:[:i|
		cell := (arrangement at: i).
		extra := extent x - cell cellSize x.
		extra > 0 ifTrue:[
			"Check if we have any #spaceFillers"
			cell hSpaceFill ifTrue:[ "use only #spaceFillers"
				cell := cell nextCell.
				n := cell inject: 0 into:[:sum :c| 
					c hSpaceFill ifTrue:[sum + 1] ifFalse:[sum]].
				n isZero ifFalse:[extraPerCell := extra asFloat / n asFloat].
				extra := last := 0.
				cell do:[:c|
					c hSpaceFill ifTrue:[
						extra := (last := extra) + (extraPerCell * 1).
						amount := extra truncated - last truncated.
						c cellSize: c cellSize + (amount@0)]].
			] ifFalse:[ "no #spaceFiller; distribute regularly"
				cell := cell nextCell.
				"centering == #topLeft ifTrue:[]" "add all extra space to the last cell; e.g., do nothing"
				centering == #bottomRight "add all extra space to the first cell"
					ifTrue:[cell addExtraSpace: extra @ 0].
				centering == #center "add 1/2 extra space to the first and last cell"
					ifTrue:[cell addExtraSpace: (extra // 2) @ 0].
				centering == #justified "add extra space equally distributed to each cell"
					ifTrue:[	n := (cell size - 1) max: 1.
							extraPerCell := extra asFloat / n asFloat.
							extra := last := 0.
							cell do:[:c|
								c addExtraSpace: (extra truncated - last truncated) @ 0.
								extra := (last := extra) + extraPerCell]].
			].
		].
	].! !

!CTableLayout methodsFor: 'layout' stamp: ''!
computeGlobalCellArrangement: cells in: newBounds horizontal: aBool wrap: wrap spacing: spacing
	"Compute number of cells we can put in each row/column. The returned array contains a list of all the cells we can put into the row/column at each level.
	Note: The arrangement is so that the 'x' value of each cell advances along the list direction and the 'y' value along the wrap direction. The returned arrangement has an extra cell at the start describing the width and height of the row."
	| output maxExtent n cell first last hFill vFill |
	output := (WriteStream on: Array new).
	first := last := nil.
	maxExtent := cells inject: 0@0 into:[:size :c| size max: c cellSize "e.g., minSize"].
	spacing == #globalSquare ifTrue:[maxExtent := (maxExtent x max: maxExtent y) asPoint].
	n := (wrap // maxExtent x) max: 1.
	hFill := vFill := false.
	1 to: cells size do:[:i|
		cell := cells at: i.
		hFill := hFill or:[cell hSpaceFill].
		vFill := vFill or:[cell vSpaceFill].
		cell cellSize: maxExtent.
		first ifNil:[first := last := cell] ifNotNil:[last nextCell: cell. last := cell].
		(i \\ n) = 0 ifTrue:[
			last := CLayoutCell new.
			last cellSize: (maxExtent x * n) @ (maxExtent y).
			last hSpaceFill: hFill.
			last vSpaceFill: vFill.
			hFill := vFill := false.
			last nextCell: first.
			output nextPut: last.
			first := nil]].
	first ifNotNil:[
		last := CLayoutCell new.
		last cellSize: (maxExtent x * n) @ (maxExtent y). self flag: #arNote."@@@: n is not correct!!"
		last nextCell: first.
		output nextPut: last].
	^output contents! !

!CTableLayout methodsFor: 'layout' stamp: ''!
flushLayoutCache
	"Flush any cached information associated with the receiver"
	minExtentCache := nil.! !

!CTableLayout methodsFor: 'initialize' stamp: 'ar 3/24/2004 03:29'!
initialize
	super initialize.
	properties := CTableLayoutProperties new initialize.! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:26'!
inset
	"Return the extra inset for layouts"
	^properties inset! !

!CTableLayout methodsFor: 'testing' stamp: ''!
isTableLayout
	^true! !

!CTableLayout methodsFor: 'layout' stamp: 'ar 3/24/2004 02:37'!
layout: aMorph in: box
	"Compute the layout for the given morph based on the new bounds"
	| cells arrangement horizontal newBounds |
	aMorph layoutTargets size = 0 ifTrue:[^self].
	newBounds := box origin asIntegerPoint corner: (box corner asIntegerPoint).
	(properties wrapDirection == #none and:[properties cellSpacing == #none]) ifTrue:[
		"get into the fast lane"
		properties listCentering == #justified ifFalse:["can't deal with that"
			properties listDirection == #leftToRight 
				ifTrue:[^self layoutLeftToRight: aMorph in: newBounds].
			properties listDirection == #topToBottom
				ifTrue:[^self layoutTopToBottom: aMorph in: newBounds].
		].
	].
	(properties listDirection == #topToBottom or:[properties listDirection == #bottomToTop])
		ifTrue:[	horizontal := false]
		ifFalse:[	horizontal := true].
	"Step 1: Compute the minimum extent for all the children of aMorph"
	cells := self computeCellSizes: aMorph 
				in: (0@0 corner: newBounds extent) 
				horizontal: horizontal.
	"Step 2: Compute the arrangement of the cells for each row and column"
	arrangement := self computeCellArrangement: cells 
						in: newBounds 
						horizontal: horizontal 
						target: aMorph.
	"Step 3: Compute the extra spacing for each cell"
	self computeExtraSpacing: arrangement 
		in: newBounds 
		horizontal: horizontal 
		target: aMorph.
	"Step 4: Place the children within the cells accordingly"
	self placeCells: arrangement 
		in: newBounds 
		horizontal: horizontal 
		target: aMorph.! !

!CTableLayout methodsFor: 'optimized' stamp: 'ar 3/24/2004 03:30'!
layoutLeftToRight: aMorph in: newBounds
	"An optimized left-to-right list layout"
	| inset n size extent width height block sum vFill posX posY extra centering extraPerCell last amount minX minY maxX maxY sizeX sizeY first cell |
	size := properties minCellSize asPoint. minX := size x. minY := size y.
	size := properties maxCellSize asPoint. maxX := size x. maxY := size y.
	inset := properties cellInset asPoint x.
	extent := newBounds extent.
	n := 0. vFill := false. sum := 0.
	width := height := 0.
	first := last := nil.
	block := [:m|
			n := n + 1.
			cell := CLayoutCell new target: m.
			(m hResizing == #spaceFill) ifTrue:[
				cell hSpaceFill: true.
				extra := 1.
				cell extraSpace: extra.
				sum := sum + extra.
			] ifFalse:[cell hSpaceFill: false].
			(m vResizing == #spaceFill) ifTrue:[vFill := true].
			size := m minExtent. sizeX := size x. sizeY := size y.
			sizeX < minX
				ifTrue:[sizeX := minX]
				ifFalse:[sizeX > maxX ifTrue:[sizeX := maxX]].
			sizeY < minY
				ifTrue:[sizeY := minY]
				ifFalse:[sizeY > maxY ifTrue:[sizeY := maxY]].
			cell cellSize: sizeX.
			last ifNil:[first := cell] ifNotNil:[last nextCell: cell].
			last := cell.
			width := width + sizeX.
			sizeY > height ifTrue:[height := sizeY].
	].
	properties reverseTableCells
		ifTrue:[aMorph layoutTargets reverseDo: block]
		ifFalse:[aMorph layoutTargets do: block].
	n > 1 ifTrue:[width := width + (n-1 * inset)].
	(aMorph hResizing == #shrinkWrap and:[properties rubberBandCells or:[sum isZero]])
		ifTrue:[extent := width @ (extent y max: height)].
	(aMorph vResizing == #shrinkWrap and:[properties rubberBandCells or:[vFill not]])
		ifTrue:[extent := (extent x max: width) @ height].
	posX := newBounds left.
	posY := newBounds top.
	"Compute extra vertical space"
	extra := extent y - height.
	extra < 0 ifTrue:[extra := 0].
	extra > 0 ifTrue:[
		vFill ifTrue:[
			height := extent y.
		] ifFalse:[
			centering := properties wrapCentering.
			centering == #bottomRight ifTrue:[posY := posY + extra].
			centering == #center ifTrue:[posY := posY + (extra // 2)]
		].
	].
	"Compute extra horizontal space"
	extra := extent x - width.
	extra < 0 ifTrue:[extra := 0].
	extraPerCell := 0.
	extra > 0 ifTrue:[
		sum isZero ifTrue:["extra space but no #spaceFillers"
			centering := properties listCentering.
			centering == #bottomRight ifTrue:[posX := posX + extra].
			centering == #center ifTrue:[posX := posX + (extra // 2)].
		] ifFalse:[extraPerCell := extra asFloat / sum asFloat].
	].
	n := 0.
	extra := last := 0.
	cell := first.
	[cell == nil] whileFalse:[
		n := n + 1.
		width := cell cellSize.
		(extraPerCell > 0 and:[cell hSpaceFill]) ifTrue:[
			extra := (last := extra) + (extraPerCell * cell extraSpace).
			amount := extra truncated - last truncated.
			width := width + amount.
		].
		cell target layoutInBounds: (posX @ posY extent: width @ height).
		posX := posX + width + inset.
		cell := cell nextCell.
	].! !

!CTableLayout methodsFor: 'optimized' stamp: 'ar 3/24/2004 03:30'!
layoutTopToBottom: aMorph in: newBounds
	"An optimized top-to-bottom list layout"
	| inset n size extent width height block sum vFill posX posY extra centering extraPerCell last amount minX minY maxX maxY sizeX sizeY first cell |
	size := properties minCellSize asPoint. minX := size x. minY := size y.
	size := properties maxCellSize asPoint. maxX := size x. maxY := size y.
	inset := properties cellInset asPoint y.
	extent := newBounds extent.
	n := 0. vFill := false. sum := 0.
	width := height := 0.
	first := last := nil.
	block := [:m|
			n := n + 1.
			cell := CLayoutCell new target: m.
			(m vResizing == #spaceFill) ifTrue:[
				cell vSpaceFill: true.
				extra := 1.
				cell extraSpace: extra.
				sum := sum + extra.
			] ifFalse:[cell vSpaceFill: false].
			(m hResizing == #spaceFill) ifTrue:[vFill := true].
			size := m minExtent. sizeX := size x. sizeY := size y.
			sizeX < minX
				ifTrue:[sizeX := minX]
				ifFalse:[sizeX > maxX ifTrue:[sizeX := maxX]].
			sizeY < minY
				ifTrue:[sizeY := minY]
				ifFalse:[sizeY > maxY ifTrue:[sizeY := maxY]].
			cell cellSize: sizeY.
			first ifNil:[first := cell] ifNotNil:[last nextCell: cell].
			last := cell.
			height := height + sizeY.
			sizeX > width ifTrue:[width := sizeX].
	].
	properties reverseTableCells
		ifTrue:[aMorph layoutTargets reverseDo: block]
		ifFalse:[aMorph layoutTargets do: block].
	n > 1 ifTrue:[height := height + (n-1 * inset)].
	(aMorph vResizing == #shrinkWrap and:[properties rubberBandCells or:[sum isZero]])
		ifTrue:[extent := (extent x max: width) @ height].
	(aMorph hResizing == #shrinkWrap and:[properties rubberBandCells or:[vFill not]])
		ifTrue:[extent := width @ (extent y max: height)].
	posX := newBounds left.
	posY := newBounds top.
	"Compute extra horizontal space"
	extra := extent x - width.
	extra < 0 ifTrue:[extra := 0].
	extra > 0 ifTrue:[
		vFill ifTrue:[
			width := extent x.
		] ifFalse:[
			centering := properties wrapCentering.
			centering == #bottomRight ifTrue:[posX := posX + extra].
			centering == #center ifTrue:[posX := posX + (extra // 2)]
		].
	].
	"Compute extra vertical space"
	extra := extent y - height.
	extra < 0 ifTrue:[extra := 0].
	extraPerCell := 0.
	extra > 0 ifTrue:[
		sum isZero ifTrue:["extra space but no #spaceFillers"
			centering := properties listCentering.
			centering == #bottomRight ifTrue:[posY := posY + extra].
			centering == #center ifTrue:[posY := posY + (extra // 2)].
		] ifFalse:[extraPerCell := extra asFloat / sum asFloat].
	].
	n := 0.
	extra := last := 0.
	cell := first.
	[cell == nil] whileFalse:[
		n := n + 1.
		height := cell cellSize.
		(extraPerCell > 0 and:[cell vSpaceFill]) ifTrue:[
			extra := (last := extra) + (extraPerCell * cell extraSpace).
			amount := extra truncated - last truncated.
			height := height + amount.
		].
		cell target layoutInBounds: (posX @ posY extent: width @ height).
		posY := posY + height + inset.
		cell := cell nextCell.
	].! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:26'!
listCentering
	"Layout specific. This property describes how the rows/columns in a list-like layout should be centered.
		#topLeft - center at start of primary direction
		#bottomRight - center at end of primary direction
		#center - center in the middle of primary direction
		#justified - insert extra space inbetween rows/columns
	"
	^properties listCentering! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:22'!
listCentering: aSymbol
	"Layout specific. This property describes how the rows/columns in a list-like layout should be centered.
		#topLeft - center at start of primary direction
		#bottomRight - center at end of primary direction
		#center - center in the middle of primary direction
		#justified - insert extra space inbetween rows/columns
	"
	properties listCentering: aSymbol.
	self invalidateLayout.! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:27'!
listDirection
	"Layout specific. This property describes the direction in which a list-like layout should be applied. Possible values are:
		#leftToRight
		#rightToLeft
		#topToBottom
		#bottomToTop
	indicating the direction in which any layout should take place"
	^properties listDirection! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:23'!
listDirection: aSymbol
	"Layout specific. This property describes the direction in which a list-like layout should be applied. Possible values are:
		#leftToRight
		#rightToLeft
		#topToBottom
		#bottomToTop
	indicating the direction in which any layout should take place"
	properties listDirection: aSymbol.
	self updateWrapDirection.
	self invalidateLayout.! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:27'!
listSpacing
	"Layout specific. This property describes how the heights for different rows in a table layout should be handled.
		#equal - all rows have the same height
		#none - all rows may have different heights
	"
	^properties listSpacing! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:23'!
listSpacing: aSymbol
	"Layout specific. This property describes how the heights for different rows in a table layout should be handled.
		#equal - all rows have the same height
		#none - all rows may have different heights
	"
	properties listSpacing: aSymbol.
	self invalidateLayout.! !

!CTableLayout methodsFor: 'initialize' stamp: 'ar 3/25/2004 18:04'!
loadFrom: aLayout
	properties := aLayout properties copy.! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:27'!
maxCellSize
	"Layout specific. This property specifies the maximum size of a table cell."
	^properties maxCellSize! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:23'!
maxCellSize: aPoint
	"Layout specific. This property specifies the maximum size of a table cell."
	properties maxCellSize: aPoint.
	self invalidateLayout.! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:27'!
minCellSize
	"Layout specific. This property specifies the minimal size of a table cell."
	^properties minCellSize! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:24'!
minCellSize: aPoint
	"Layout specific. This property specifies the minimal size of a table cell."
	properties minCellSize: aPoint.
	self invalidateLayout.! !

!CTableLayout methodsFor: 'optimized' stamp: 'ar 3/24/2004 02:31'!
minExtentHorizontal: aMorph
	"Return the minimal size aMorph's children would require given the new bounds"
	| inset n size width height minX minY maxX maxY sizeX sizeY |
	size := properties minCellSize asPoint. minX := size x. minY := size y.
	size := properties maxCellSize asPoint. maxX := size x. maxY := size y.
	inset := properties cellInset asPoint.
	n := 0.
	width := height := 0.
	aMorph layoutTargets do:[:m|
			n := n + 1.
			size := m minExtent. sizeX := size x. sizeY := size y.
			sizeX < minX
				ifTrue:[sizeX := minX]
				ifFalse:[sizeX > maxX ifTrue:[sizeX := maxX]].
			sizeY < minY
				ifTrue:[sizeY := minY]
				ifFalse:[sizeY > maxY ifTrue:[sizeY := maxY]].
			width := width + sizeX.
			sizeY > height ifTrue:[height := sizeY].
	].
	n > 1 ifTrue:[width := width + (n-1 * inset x)].
	^minExtentCache := width @ height! !

!CTableLayout methodsFor: 'layout' stamp: 'ar 3/24/2004 02:37'!
minExtentOf: aMorph in: box
	"Return the minimal size aMorph's children would require given the new bounds"
	| cells arrangement horizontal newBounds minX minY dir |
	minExtentCache == nil ifFalse:[^minExtentCache].
	aMorph layoutTargets size = 0 ifTrue:[^0@0].
	(properties wrapDirection == #none and:[properties cellSpacing == #none]) ifTrue:[
		"Get into the fast lane"
		dir := properties listDirection.
		(dir == #leftToRight or:[dir == #rightToLeft])
			ifTrue:[^self minExtentHorizontal: aMorph].
		(dir == #topToBottom or:[dir == #bottomToTop])
			ifTrue:[^self minExtentVertical: aMorph].
	].
	newBounds := box origin asIntegerPoint corner: (box corner asIntegerPoint).
	(properties listDirection == #topToBottom or:[properties listDirection == #bottomToTop])
		ifTrue:[	horizontal := false]
		ifFalse:[	horizontal := true].
	"Step 1: Compute the minimum extent for all the children of aMorph"
	cells := self computeCellSizes: aMorph 
				in: (0@0 corner: newBounds extent) 
				horizontal: horizontal.
	"Step 2: Compute the arrangement of the cells for each row and column"
	arrangement := self computeCellArrangement: cells 
						in: newBounds 
						horizontal: horizontal
						target: aMorph.
	"Step 3: Extract the minimum size out of the arrangement"
	minX := minY := 0.
	arrangement do:[:cell|
		minX := minX max: cell cellSize x + cell extraSpace x.
		minY := minY + cell cellSize y + cell extraSpace y].
	horizontal 
		ifTrue:[minExtentCache := minX@minY]
		ifFalse:[minExtentCache := minY@minX].
	^minExtentCache! !

!CTableLayout methodsFor: 'optimized' stamp: 'ar 3/24/2004 02:31'!
minExtentVertical: aMorph
	"Return the minimal size aMorph's children would require given the new bounds"
	| inset n size width height minX minY maxX maxY sizeX sizeY |
	size := properties minCellSize asPoint. minX := size x. minY := size y.
	size := properties maxCellSize asPoint. maxX := size x. maxY := size y.
	inset := properties cellInset asPoint.
	n := 0.
	width := height := 0.
	aMorph layoutTargets do:[:m|
			n := n + 1.
			size := m minExtent. sizeX := size x. sizeY := size y.
			sizeX < minX
				ifTrue:[sizeX := minX]
				ifFalse:[sizeX > maxX ifTrue:[sizeX := maxX]].
			sizeY < minY
				ifTrue:[sizeY := minY]
				ifFalse:[sizeY > maxY ifTrue:[sizeY := maxY]].
			height := height + sizeY.
			sizeX > width ifTrue:[width := sizeX].
	].
	n > 1 ifTrue:[height := height + (n-1 * inset y)].
	^minExtentCache := width @ height! !

!CTableLayout methodsFor: 'initialize' stamp: 'ar 3/24/2004 03:01'!
newListDirection: aSymbol
	| oldWrap wrapDir |
	oldWrap := self wrapDirection.
	wrapDir := self updateWrapDirection: aSymbol.
	self tweak: #listDirection to: aSymbol.
	wrapDir ifNotNil:[self tweaked: #wrapDirection from: oldWrap to: wrapDir].! !

!CTableLayout methodsFor: 'layout' stamp: ''!
placeCells: arrangement in: newBounds horizontal: aBool target: aMorph		 
	"Place the morphs within the cells accordingly"
	| xDir yDir anchor yDist place cell xDist cellRect corner inset |
	inset := properties cellInset.
	(inset isNumber and:[inset isZero]) ifTrue:[inset := nil].
	aBool ifTrue:["horizontal layout"
		properties listDirection == #rightToLeft ifTrue:[
			xDir := -1@0.
			properties wrapDirection == #bottomToTop 
				ifTrue:[yDir := 0@-1. anchor := newBounds bottomRight]
				ifFalse:[yDir := 0@1. anchor := newBounds topRight].
		] ifFalse:[
			xDir := 1@0.
			properties wrapDirection == #bottomToTop
				ifTrue:[yDir := 0@-1. anchor := newBounds bottomLeft]
				ifFalse:[yDir := 0@1. anchor := newBounds topLeft]].
	] ifFalse:["vertical layout"
		properties listDirection == #bottomToTop ifTrue:[
			xDir := 0@-1.
			properties wrapDirection == #rightToLeft
				ifTrue:[yDir := -1@0. anchor := newBounds bottomRight]
				ifFalse:[yDir := 1@0. anchor := newBounds bottomLeft]
		] ifFalse:[
			xDir := 0@1.
			properties wrapDirection == #rightToLeft
				ifTrue:[yDir := -1@0. anchor := newBounds topRight]
				ifFalse:[yDir := 1@0. anchor := newBounds topLeft]].
	].
	1 to: arrangement size do:[:i|
		cell := arrangement at: i.
		cell extraSpace ifNotNil:[anchor := anchor + (cell extraSpace y * yDir)].
		yDist := cell cellSize y * yDir. "secondary advance direction"
		place := anchor.
		cell := cell nextCell.
		[cell == nil] whileFalse:[
			cell extraSpace ifNotNil:[place := place + (cell extraSpace x * xDir)].
			xDist := cell cellSize x * xDir. "primary advance direction"
			corner := place + xDist + yDist.
			cellRect := Rectangle origin: (place min: corner) corner: (place max: corner).
			"@@@: Fix this. It's broken. :@@@"
			"inset ifNotNil:[cellRect := cellRect insetBy: inset]."
			cell target layoutInBounds: cellRect.
			place := place + xDist.
			cell := cell nextCell].
		anchor := anchor + yDist.
	].! !

!CTableLayout methodsFor: 'copying' stamp: 'ar 3/24/2004 02:57'!
postCopy
	super postCopy.
	properties := properties copy.! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:28'!
reverseTableCells
	"Layout specific. This property describes if the cells should be treated in reverse order of children."
	^properties reverseTableCells! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:24'!
reverseTableCells: aBool
	"Layout specific. This property describes if the cells should be treated in reverse order of children."
	properties reverseTableCells: aBool.
	self invalidateLayout.! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:28'!
rubberBandCells
	"Layout specific. This property describes if a parent that is #shrinkWrapped around its children should ignore any #spaceFill children. E.g., when #rubberBandCells is true, the compound layout will always stay at the smallest available size, even though some child may be able to grow."
	^properties rubberBandCells! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:24'!
rubberBandCells: aBool
	"Layout specific. This property describes if a parent that is #shrinkWrapped around its children should ignore any #spaceFill children. E.g., when #rubberBandCells is true, the compound layout will always stay at the smallest available size, even though some child may be able to grow."
	properties rubberBandCells: aBool.
	self invalidateLayout.! !

!CTableLayout methodsFor: 'private' stamp: 'ar 3/24/2004 02:23'!
updateWrapDirection
	| wrapDir |
	wrapDir := self updateWrapDirection: self listDirection.
	wrapDir ifNotNil:[self wrapDirection: wrapDir].! !

!CTableLayout methodsFor: 'private' stamp: 'ar 3/24/2004 02:23'!
updateWrapDirection: listDir
	"Answer the new wrap direction to use for the receiver if it would assume the given list direction"
	| wrapDir |
	wrapDir := self wrapDirection.
	(wrapDir == #none) ifTrue:[^nil].
	"otherwise automatically keep a valid table layout"
	(listDir == #leftToRight or:[listDir == #rightToLeft]) ifTrue:[
		wrapDir == #leftToRight ifTrue:[^#topToBottom].
		wrapDir == #rightToLeft ifTrue:[^#bottomToTop].
	] ifFalse:[
		wrapDir == #topToBottom ifTrue:[^#leftToRight].
		wrapDir == #bottomToTop ifTrue:[^#rightToLeft].
	].
	^nil! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:28'!
wrapCentering
	"Layout specific. This property describes how the rows/columns in a list-like layout should be centered.
		#topLeft - center at start of secondary direction
		#bottomRight - center at end of secondary direction
		#center - center in the middle of secondary direction
		#justified - insert extra space inbetween rows/columns
	"
	^properties wrapCentering! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:24'!
wrapCentering: aSymbol
	"Layout specific. This property describes how the rows/columns in a list-like layout should be centered.
		#topLeft - center at start of secondary direction
		#bottomRight - center at end of secondary direction
		#center - center in the middle of secondary direction
		#justified - insert extra space inbetween rows/columns
	"
	properties wrapCentering: aSymbol.
	self invalidateLayout.! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:29'!
wrapDirection
	"Layout specific. This property describes the direction along which a list-like layout should be wrapped. Possible values are:
		#leftToRight
		#rightToLeft
		#topToBottom
		#bottomToTop
		#none
	indicating in which direction wrapping should occur. This direction must be orthogonal to the list direction, that is if listDirection is #leftToRight or #rightToLeft then wrapDirection must be #topToBottom or #bottomToTop and vice versa."
	^properties wrapDirection! !

!CTableLayout methodsFor: 'accessing' stamp: 'ar 3/24/2004 02:24'!
wrapDirection: aSymbol
	"Layout specific. This property describes the direction along which a list-like layout should be wrapped. Possible values are:
		#leftToRight
		#rightToLeft
		#topToBottom
		#bottomToTop
		#none
	indicating in which direction wrapping should occur. This direction must be orthogonal to the list direction, that is if listDirection is #leftToRight or #rightToLeft then wrapDirection must be #topToBottom or #bottomToTop and vice versa."
	properties wrapDirection: aSymbol.
	self invalidateLayout.! !

CCostumeAspect subclass: #CNoBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Aspects'!

!CNoBorder commentStamp: 'ar 3/27/2004 17:32' prior: 0!
CNoBorder is a highly specialized border aspect for being able to represent "unbordered" objects more efficiently.!

CNoBorder defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CNoBorder methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:02'!
color
	| aBorder |
	(aBorder := costume border) == self 
		ifTrue:[^Color transparent] 
		ifFalse:[^aBorder color].! !

!CNoBorder methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:58'!
color: aColor
	| aBorder |
	(aBorder := costume border) == self ifFalse:[^aBorder color: aColor].
	aBorder := costume allocateBorder.
	^aBorder color: aColor! !

!CNoBorder methodsFor: 'copying' stamp: 'ar 3/25/2004 20:03'!
copy
	^CCostumeBorder new loadFrom: self! !

!CNoBorder methodsFor: 'private' stamp: 'ar 3/23/2004 17:35'!
expandBounds: box
	^box! !

!CNoBorder methodsFor: 'drawing' stamp: 'ar 12/8/2009 22:09'!
frameRectangle: aRectangle on: aCanvas
	"nothing to do"! !

!CNoBorder methodsFor: 'private' stamp: 'ar 3/23/2004 17:35'!
insetBounds: box
	^box! !

!CNoBorder methodsFor: 'testing' stamp: 'ar 3/23/2004 17:48'!
isNoBorder
	^true! !

!CNoBorder methodsFor: 'testing' stamp: 'ar 3/23/2004 17:49'!
isTranslucent
	^false! !

!CNoBorder methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:02'!
style
	| aBorder |
	(aBorder := costume border) == self 
		ifTrue:[^#none] 
		ifFalse:[^aBorder style].! !

!CNoBorder methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:58'!
style: aSymbol
	| aBorder |
	(aBorder := costume border) == self ifFalse:[^aBorder style: aSymbol].
	aSymbol == #none ifTrue:[^aSymbol].
	aBorder := costume allocateBorder.
	^aBorder style: aSymbol! !

!CNoBorder methodsFor: 'private' stamp: 'ar 3/23/2004 17:33'!
trackColorFrom: aCostume! !

!CNoBorder methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:02'!
width
	| aBorder |
	(aBorder := costume border) == self 
		ifTrue:[^0] 
		ifFalse:[^aBorder width].! !

!CNoBorder methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:58'!
width: aNumber
	| aBorder |
	(aBorder := costume border) == self ifFalse:[^aBorder width: aNumber].
	aNumber isZero ifTrue:[^aNumber].
	aBorder := costume allocateBorder.
	^aBorder width: aNumber! !

CCostumeAspect subclass: #CNoFill
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Aspects'!

!CNoFill commentStamp: 'ar 3/27/2004 17:32' prior: 0!
CNoFill is a highly specialized fill aspect for being able to represent "unfilled" objects more efficiently.!

CNoFill defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CNoFill methodsFor: 'accessing' stamp: 'ar 4/29/2005 00:04'!
alpha
	| aFill |
	(aFill := costume fill) == self 
		ifTrue:[^0.0] 
		ifFalse:[^aFill alpha].! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:56'!
alpha: aNumber
	| aFill |
	(aFill := costume fill) == self ifFalse:[^aFill alpha: aNumber].
	aNumber isZero ifTrue:[^aNumber].
	aFill := costume allocateFill.
	^aFill alpha: aNumber.! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:06'!
angle
	| aFill |
	(aFill := costume fill) == self 
		ifTrue:[^0] 
		ifFalse:[^aFill angle].! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:56'!
angle: aNumber
	| aFill |
	(aFill := costume fill) == self ifFalse:[^aFill angle: aNumber].
	aNumber isZero ifTrue:[^aNumber].
	aFill := costume allocateFill.
	^aFill angle: aNumber.! !

!CNoFill methodsFor: 'converting' stamp: 'ar 3/23/2004 17:09'!
asColor
	^Color transparent! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 4/29/2005 00:04'!
color
	| aFill |
	(aFill := costume fill) == self 
		ifTrue:[^Color transparent] 
		ifFalse:[^aFill color].! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:56'!
color: aColor
	| aFill |
	(aFill := costume fill) == self ifFalse:[^aFill color: aColor].
	aColor = Color transparent ifTrue:[^aColor].
	aFill := costume allocateFill.
	^aFill color: aColor! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/27/2004 17:32'!
colors
	| aFill |
	(aFill := costume fill) == self 
		ifTrue:[^Array with: Color white] 
		ifFalse:[^aFill colors].! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:57'!
colors: colors
	| aFill |
	(aFill := costume fill) == self ifFalse:[^aFill colors: colors].
	aFill := costume allocateFill.
	^aFill colors: colors! !

!CNoFill methodsFor: 'copying' stamp: 'ar 3/25/2004 20:03'!
copy
	^CCostumeFill new loadFrom: self! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/27/2004 17:32'!
gradientColor
	| aFill |
	(aFill := costume fill) == self 
		ifTrue:[^Color white] 
		ifFalse:[^aFill gradientColor].! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:57'!
gradientColor: aColor
	| aFill |
	(aFill := costume fill) == self ifFalse:[^aFill gradientColor: aColor].
	aFill := costume allocateFill.
	^aFill gradientColor: aColor! !

!CNoFill methodsFor: 'testing' stamp: 'ar 3/23/2004 17:08'!
isBitmapFill
	^false! !

!CNoFill methodsFor: 'testing' stamp: 'ar 3/23/2004 17:08'!
isGradientFill
	^self isSolidFill not! !

!CNoFill methodsFor: 'testing' stamp: 'ar 3/23/2004 17:53'!
isNoFill
	^true! !

!CNoFill methodsFor: 'testing' stamp: 'ar 3/23/2004 17:08'!
isOrientedFill
	^false! !

!CNoFill methodsFor: 'testing' stamp: 'ar 3/23/2004 17:08'!
isRadialFill
	^false! !

!CNoFill methodsFor: 'testing' stamp: 'ar 4/19/2005 19:07'!
isSolidFill
	^true! !

!CNoFill methodsFor: 'testing' stamp: 'ar 3/23/2004 17:08'!
isTranslucent
	^true! !

!CNoFill methodsFor: 'testing' stamp: 'ar 3/23/2004 17:08'!
isTransparent
	^true! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:07'!
offset
	| aFill |
	(aFill := costume fill) == self 
		ifTrue:[^0@0] 
		ifFalse:[^aFill offset].! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:57'!
offset: aPoint
	| aFill |
	(aFill := costume fill) == self ifFalse:[^aFill offset: aPoint].
	aFill := costume allocateFill.
	^aFill offset: aPoint! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/27/2004 17:33'!
primaryColor
	| aFill |
	(aFill := costume fill) == self 
		ifTrue:[^Color white] 
		ifFalse:[^aFill primaryColor].! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:57'!
primaryColor: aColor
	| aFill |
	(aFill := costume fill) == self ifFalse:[^aFill primaryColor: aColor].
	aFill := costume allocateFill.
	^aFill primaryColor: aColor! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/25/2004 19:56'!
style
	| aFill |
	(aFill := costume fill) == self 
		ifTrue:[^#none] 
		ifFalse:[^aFill style].! !

!CNoFill methodsFor: 'accessing' stamp: 'ar 3/23/2004 17:57'!
style: aSymbol
	| aFill |
	(aFill := costume fill) == self ifFalse:[^aFill style: aSymbol].
	aSymbol == #none ifTrue:[^aSymbol].
	aFill := costume allocateFill.
	^aFill style: aSymbol! !

CObject subclass: #CTextParagraphEditor
	instanceVariableNames: 'costume paragraph markBlock pointBlock undoStack redoStack lastUndoType findText modified emphasisHere'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Text'!

!CTextParagraphEditor commentStamp: 'ar 3/26/2004 01:18' prior: 0!
Okay, this is completely ridiculous here but I wanted to get rid of all of the messy editors in MVC and Morphic so here it is. It works, but it ain't nice, oh no. Please go ahead and rewrite it!!

Notes: The "costume" here really *ought* to be the costume not the text holder but right now that's screwed up. Most likely we really want this guy be associated with the costume so that a costume is "editable" if it has a text editor (which implies carrying a text but the text could be there anyway).!

CTextParagraphEditor defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="costume" toSet="costume:">costume</field>
	<field instanceVariable="true" toGet="paragraph" toSet="paragraph:">paragraph</field>
	<field instanceVariable="true" toGet="markBlock">markBlock</field>
	<field instanceVariable="true" toGet="pointBlock">pointBlock</field>
	<field instanceVariable="true">undoStack</field>
	<field instanceVariable="true">redoStack</field>
	<field instanceVariable="true">lastUndoType</field>
	<field instanceVariable="true">findText</field>
	<field instanceVariable="true" toGet="modified" toSet="modified:">modified</field>
	<field instanceVariable="true" toGet="emphasisHere">emphasisHere</field>
	<field virtual="true" serializable="false" toGet="textColor" toSet="textColor:">textColor</field>
	<field virtual="true" serializable="false" toGet="align" toSet="align:">align</field>
</fields>'!

!CTextParagraphEditor methodsFor: 'editor commands' stamp: ''!
addAttribute: textAttr
	"Add the given attribute to the current selection"
	self replaceSelectionWith: (self selection asText addAttribute: textAttr).! !

!CTextParagraphEditor methodsFor: 'private' stamp: 'ar 4/4/2004 21:34'!
adjustRightXBy: aValue
	^paragraph adjustRightXBy: aValue! !

!CTextParagraphEditor methodsFor: 'anchoring' stamp: ''!
adjustTextAnchor: aCostume
	"The given costume has been moved by delta; adjust its reference if necessary. The following could be optimized but using #anchor: has some advantages since it'll restore any anchor that got lost due to deleting the referencing character."
	self anchor: aCostume at: aCostume position type: aCostume textAnchorType! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: 'tak 5/9/2005 18:46'!
align
	self emphasisHere
		do: [:attr | 
			attr = TextAlignment centered
				ifTrue: [^ #centered].
			attr = TextAlignment justified
				ifTrue: [^ #justified].
			attr = TextAlignment leftFlush
				ifTrue: [^ #leftFlush].
			attr = TextAlignment rightFlush
				ifTrue: [^ #rightFlush]].
	^ #leftFlush! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: 'tak 5/10/2005 00:05'!
align: aSymbol
	"Change the alignment of the selected region to be #leftFlush, #centered, #rightFlush, or, #justified."
	| attr string left right start stop|
	(#(centered justified leftFlush rightFlush) includes: aSymbol)
		ifFalse: [^ aSymbol].
	attr := TextAlignment perform: aSymbol.
	start := markBlock stringIndex.
	stop := pointBlock stringIndex.
	string := paragraph text string.
	left := string lastIndexOf: Character cr startingAt: (start min: stop)-1 ifAbsent:[1].
	right := string indexOf: Character cr startingAt: (start max: stop) ifAbsent:[string size].
	self selectFrom: left to: right.
	self addAttribute: attr.
	self selectFrom: start to: stop.
	^ aSymbol! !

!CTextParagraphEditor methodsFor: 'anchoring' stamp: ''!
anchor: aCostume
	^self anchor: aCostume at: aCostume position! !

!CTextParagraphEditor methodsFor: 'anchoring' stamp: 'ar 3/26/2004 22:14'!
anchor: aCostume at: aPoint
	"Used to anchor a costume without knowing how exactly it should happen. We make an educated guess here based on the size and the relative position of the costume."
	"TODO: Make better guesses:
		a) When over text and having small objects use line anchoring (for bullets)
		b) If not over text or object is too large use paragraph anchoring"
	self anchor: aCostume at: aPoint type: #paragraph.
	self flag: #todo. 
! !

!CTextParagraphEditor methodsFor: 'anchoring' stamp: ''!
anchor: aCostume at: aPoint type: anchorType
	"Anchor the given costume at the provided location using the given type of anchoring"
	| start stop |
	aCostume fullBounds. "it needs to finish layout"
	lastUndoType := nil.
	start := markBlock stringIndex.
	stop := pointBlock stringIndex.
	self privateAnchor: aCostume at: aPoint type: anchorType.
	paragraph composeAll.
	costume invalidate.
	self selectFrom: start to: stop.! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: 'ar 5/5/2004 23:41'!
attributesAt: aPoint
	"Answer the attributes at the given point"
	^paragraph attributesAt: (aPoint - costume editorOffset)! !

!CTextParagraphEditor methodsFor: 'editing keys' stamp: ''!
backspace
	| type |
	type := #backspace.
	pointBlock = markBlock
		ifTrue:[self selectFrom: markBlock stringIndex to: markBlock stringIndex-1]
		ifFalse:[type := nil].
	self replaceSelectionWith: '' type: type! !

!CTextParagraphEditor methodsFor: 'editor commands' stamp: 'ar 4/4/2004 21:35'!
changeEmpasisHere: emph
	| attr |
	emphasisHere := self emphasisHere reject:[:any| any class == TextEmphasis].
	emph = 0 ifFalse:[
		attr := TextEmphasis new emphasisCode: emph.
		emphasisHere := Text addAttribute: attr toArray: self emphasisHere.
	].
	self textSelectionChanged.! !

!CTextParagraphEditor methodsFor: 'editor commands' stamp: 'ar 4/4/2004 21:35'!
changeFontHere: attr
	emphasisHere := Text addAttribute: attr toArray: self emphasisHere.
	self textSelectionChanged.! !

!CTextParagraphEditor methodsFor: 'initialize' stamp: ''!
closeUndoStack
	undoStack := OrderedCollection new.! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: ''!
costume
	^costume! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: ''!
costume: aCostume
	costume := aCostume! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: 'ar 3/13/2003 04:26'!
emphasis
	| code |
	code := 0.
	self emphasisHere do:[:attr|
		code := code bitOr: attr emphasisCode.
	].
	^code! !

!CTextParagraphEditor methodsFor: 'private' stamp: 'ar 3/13/2003 02:48'!
emphasisHere
	^emphasisHere ifNil:[#()]! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: ''!
extent
	^paragraph extent! !

!CTextParagraphEditor methodsFor: 'initialize' stamp: 'bf 3/30/2004 10:47'!
extent: anExtent
	paragraph
		compose: paragraph text
		style: paragraph textStyle
		from: 1
		in: (0@0 extent: anExtent).
	^anExtent! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: 'ar 12/6/2005 14:52'!
font
	self emphasisHere do:[:attr|
		attr class == TextFontReference ifTrue:[^attr font].
	].
	^costume font! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: 'ar 12/6/2005 14:50'!
font: aFont
	"Don't do this here but delegate to text holder"
	costume font: aFont! !

!CTextParagraphEditor methodsFor: 'editing keys' stamp: ''!
forwardDelete
	"Delete forward over the next character."
	| type |
	type := #delete.
	markBlock = pointBlock
		ifTrue:[self selectFrom: markBlock stringIndex to: markBlock stringIndex + 1]
		ifFalse:[type := nil].
	self replaceSelectionWith: '' type: type! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: 'ar 3/16/2003 21:23'!
hasKeyboardFocus
	"Return true if the receiver has the input focus"
	^costume hasKeyboardFocus! !

!CTextParagraphEditor methodsFor: 'editing keys' stamp: 'bgf 11/11/2009 17:55'!
keyStroke: evt

	self replaceSelectionWith: evt keyCharacter asString type: #keyStroke.! !

!CTextParagraphEditor methodsFor: 'private' stamp: ''!
markBlock
	^markBlock! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: ''!
minimalTextExtent
	"Return the minimal width of the text (excluding alignment!!)"
	^paragraph minimalTextWidth @ paragraph height! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: ''!
minimalTextWidth
	"Return the minimal width of the text (excluding alignment!!)"
	^paragraph minimalTextWidth! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: ''!
modified
	"Answer whether the receiver is modified"
	^modified! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: 'ar 3/13/2003 15:02'!
modified: aBool
	"Indicate whether the receiver is modified"
	costume modified: aBool.
	modified := aBool.! !

!CTextParagraphEditor methodsFor: 'mouse input' stamp: 'ar 4/7/2009 18:55'!
mouseDown: evt
	"Put the cursor at the location prompted by the user, if requested extending the selection."
	| pos textPos |
	textPos := evt position - costume editorOffset.
	lastUndoType := nil.
	pos := (paragraph characterBlockAtPoint: textPos) stringIndex.
	"extend selection for double-clicks"
	(evt nrClicks > 1)  ifTrue:[^self selectWordAt: pos].
	evt shiftPressed 
		ifTrue:[self selectFrom: markBlock stringIndex to: pos]
		ifFalse:[self selectFrom: pos to: pos].! !

!CTextParagraphEditor methodsFor: 'mouse input' stamp: 'ar 3/18/2003 15:21'!
mouseMove: evt
	"If the mouse is down select text"
	| pos textPos |
	textPos := evt position - costume editorOffset.
	lastUndoType := nil.
	pos := (paragraph characterBlockAtPoint: textPos) stringIndex.
	self selectFrom: markBlock stringIndex to: pos.! !

!CTextParagraphEditor methodsFor: 'mouse input' stamp: ''!
mouseUp: evt
	lastUndoType := nil.
	"Ignored for now"! !

!CTextParagraphEditor methodsFor: 'private' stamp: ''!
moveCaretTo: pos selecting: aBool
	"Move the caret to the given position, extending the selection if indicated"
	| newPos |
	newPos := pos min: paragraph size + 1 max: 1.
	aBool
		ifTrue:[self selectFrom: markBlock stringIndex to: newPos]
		ifFalse:[self selectFrom: newPos to: newPos].! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
moveCursorLeft
	"Select one character left"
	^self moveCaretTo: self selectionStart - 1 selecting: false! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
moveCursorRight
	"Move one character to the right"
	^self moveCaretTo: self selectionStop + 1 selecting: false! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
moveLineDown
	"Move cursor from position in current line to same position in
	next line. If next line too short, put at end."
	^self moveCaretTo: (paragraph indexOfCharacterBelow: self selectionStop) selecting: false! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
moveLineEnd
	"Move cursor end of current line. If cursor already at end of 
	line, put cursor at end of text"
	^self moveCaretTo: (paragraph lineSelectionIntervalAt: pointBlock stringIndex) last + 1 selecting: false! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
moveLineStart
	"Move cursor from position in current line to beginning of
	current line. If cursor already at beginning of line, put cursor at
	beginning of text"
	^self moveCaretTo: (paragraph lineSelectionIntervalAt: pointBlock stringIndex) first selecting: false! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
moveLineUp
	"Move one line up"
	^self moveCaretTo: (paragraph indexOfCharacterAbove: pointBlock stringIndex) selecting: false! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: 'ar 5/9/2005 11:21'!
movePageDown
	"Move cursor from position in current line to same position on
	the next page. If the line is too short, put at end."
	| block |
	block := paragraph characterBlockAtPoint: pointBlock leftCenter + (0@costume height).
	^self moveCaretTo: block stringIndex selecting: false! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: 'ar 5/9/2005 11:21'!
movePageUp
	"Move cursor from position in current line to same position on
	the prev page. If the line is too short, put at end."
	| block |
	block := paragraph characterBlockAtPoint: pointBlock leftCenter - (0@costume height).
	^self moveCaretTo: block stringIndex selecting: false! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
moveTextEnd
	"Move the cursor to the end of the text"
	^self moveCaretTo: paragraph size+1 selecting: false! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
moveTextStart
	"Move the cursor to the beginning of the text"
	^self moveCaretTo: 1 selecting: false! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
moveWordLeft
	"Move cursor left one word left"
	^self  moveCaretTo: (paragraph indexOfPreviousWord: pointBlock stringIndex-1) selecting: false.! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
moveWordRight
	"Move cursor right one word"
	^self moveCaretTo: (paragraph indexOfNextWord: self selectionStop) selecting: false! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: ''!
paragraph
	^paragraph! !

!CTextParagraphEditor methodsFor: 'initialize' stamp: 'ar 3/18/2003 12:14'!
paragraph: aTextParagraph
	paragraph := aTextParagraph.
	modified := false.
	undoStack := OrderedCollection new.
	redoStack := nil.
	markBlock := paragraph characterBlockAtIndex: 1.
	pointBlock := markBlock copy.
	self updateEmphasisHere.

	"Needed for now"
	paragraph editor: self.! !

!CTextParagraphEditor methodsFor: 'private' stamp: ''!
pointBlock
	^pointBlock! !

!CTextParagraphEditor methodsFor: 'private' stamp: ''!
prepareUndo: aText type: editingType
	| cutInterval pasteText highlightInterval lastUndo |
	"determine what to cut upon undo"
	cutInterval := Array with: self selectionStart with: self selectionStart + aText size.
	"get the text to put back in"
	pasteText := self selection.
	"determine what to select after undo"
	highlightInterval := Array with: markBlock stringIndex with: pointBlock stringIndex.
	"If keyStroke replaces selected text don't merge it"
	(editingType == #keyStroke and:[pasteText isEmpty not]) ifTrue:[lastUndoType := nil].
	(lastUndoType notNil and:[lastUndoType == editingType]) ifTrue:[
		"Try to merge current undo into last undo"
		lastUndo := undoStack last.
		editingType == #keyStroke ifTrue:[
			self assert:[pasteText isEmpty]. "after first keystroke selection must be empty"
			lastUndo at: 1 put: (Array with: lastUndo first first with: cutInterval last). "extend cut interval by one"
			^self].
		(editingType == #backspace) ifTrue:[
			lastUndo at: 1 put: cutInterval. "always empty"
			lastUndo at: 2 put: (pasteText, lastUndo second). "extend text to restore"
			lastUndo at: 3 put: (Array 
				with: lastUndo first first 
				with: cutInterval min + lastUndo second size). "and highlight"
			^self].
		(editingType == #delete) ifTrue:[
			lastUndo at: 1 put: cutInterval. "always empty"
			lastUndo at: 2 put: (lastUndo second, pasteText). "extend text to restore"
			lastUndo at: 3 put: (Array
				with: lastUndo first first
				with: cutInterval min + lastUndo second size). "and highlight"
			^self].
	].
	"Cannot merge with last undo"
	lastUndoType := editingType.
	lastUndo := {cutInterval. pasteText. highlightInterval}.
	undoStack addLast: lastUndo.
	redoStack := nil.! !

!CTextParagraphEditor methodsFor: 'private' stamp: 'mtf 6/22/2009 17:50'!
privateAnchor: aCostume at: aPoint type: anchorType
	"Anchor the given costume at the provided location using the given type of anchoring"
	| index newText block relPt |
	aCostume container == costume ifTrue:[self removeAnchor: aCostume].
	aCostume textAnchorType: nil.
	aCostume relativeTextAnchorPosition: nil.
	costume costume add: aCostume.
	aCostume textAnchorType: anchorType.
	aCostume relativeTextAnchorPosition: nil.
	relPt := aPoint - costume textBounds origin.
	"@@@@: Fix this. Embedding costumes in scrolled texts probable doesn't work without including scroll offset. :@@@@"
	index := (self paragraph characterBlockAtPoint: relPt) stringIndex.
	newText := Text 
		string: (Character value: 1) asString 
		attribute: (TextAnchor new anchoredObject: aCostume).
	anchorType == #inline ifTrue:[
		^paragraph text replaceFrom: index to: index-1 with: newText].
	anchorType == #paragraph ifTrue:[
		index := index min: paragraph size.
		index := paragraph text string lastIndexOf: Character cr startingAt: index ifAbsent:[0].
		"If there ain't no preceeding CR fall through and use #document anchoring"
		index > 0 ifTrue:[
			block := paragraph characterBlockAtIndex: index.
			aCostume relativeTextAnchorPosition: relPt x @ (relPt y - block top).
			^paragraph text replaceFrom: index+1 to: index with: newText].
	].
	"do nothing -- #document anchoring has no reference in text"! !

!CTextParagraphEditor methodsFor: 'editor commands' stamp: ''!
redo
	"Redo the last undone command"
	| stack |
	redoStack isEmptyOrNil ifTrue:[^self].
	stack := redoStack.
	redoStack := nil.
	self undoCommand: stack removeLast.
	stack isEmpty ifFalse:[redoStack := stack].! !

!CTextParagraphEditor methodsFor: 'anchoring' stamp: ''!
removeAnchor: aCostume
	| range anchor |
	anchor := TextAnchor new anchoredObject: aCostume.
	range := paragraph text find: anchor.
	range ifNotNil:[
		self replaceFrom: range first to: range last with: Text new.
	].
	aCostume textAnchorType: nil.
	aCostume relativeTextAnchorPosition: nil.! !

!CTextParagraphEditor methodsFor: 'private' stamp: 'mtf 6/23/2009 14:54'!
replaceFrom: start to: stop with: aText
	| embedded m |
	"Remember embedded costumess"
	embedded := paragraph text  embeddedCostumesFrom: start to: stop.
	"Convert those in the selection"
	aText removeAttributesThat:[:attr|
		(m := attr anchoredObject) ifNil:[false] ifNotNil:[m textAnchorType == #document]
	] replaceAttributesThat:[:attr|
		(m := attr anchoredObject) ifNil:[false] ifNotNil:[m textAnchorType ~~ #document]
	] by:[:attr| 
		m := attr anchoredObject copy.
		costume add: m.
		TextAnchor new anchoredObject: m.
	].
	paragraph replaceFrom: start to: stop with: aText.
	"Zap old costumes"
	embedded do:[:aCostume| aCostume destroy].! !

!CTextParagraphEditor methodsFor: 'selecting' stamp: ''!
replaceSelectionWith: aText
	^self replaceSelectionWith: aText allowUndo: true! !

!CTextParagraphEditor methodsFor: 'selecting' stamp: 'ar 3/13/2003 02:58'!
replaceSelectionWith: aText allowUndo: allowUndo
	(allowUndo and:[undoStack notNil]) 
		ifTrue:[self prepareUndo: aText type: nil].
	^self zapSelectionWith: aText! !

!CTextParagraphEditor methodsFor: 'private' stamp: 'ar 3/13/2003 02:53'!
replaceSelectionWith: aText type: editingType
	undoStack ifNotNil:[self prepareUndo: aText type: editingType].
	^self zapSelectionWith: aText! !

!CTextParagraphEditor methodsFor: 'selecting' stamp: 'ar 1/8/2003 22:36'!
selectAll
	self selectFrom: 1 to: paragraph text size+1! !

!CTextParagraphEditor methodsFor: 'selecting' stamp: ''!
selectAt: selectionIndex
	"Public. Used by clients"
	^self selectFrom: selectionIndex to: selectionIndex.! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
selectCursorLeft
	"Select one character left"
	^self moveCaretTo: pointBlock stringIndex - 1 selecting: true.! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
selectCursorRight
	"Select one character to the right"
	^self moveCaretTo: pointBlock stringIndex + 1 selecting: true! !

!CTextParagraphEditor methodsFor: 'editor commands' stamp: 'tk 4/7/2005 12:25'!
selectFontNamed: fontName pointSize: ptSize
	"Set the current selection to the given font name in the appropriate point size"
	| style font |
	style := TextStyle named: fontName.
	style ifNil:[^nil].
	font := style fonts detect:[:any| any pointSize = ptSize] ifNone:[nil].
	font ifNil:[^nil].
	self addAttribute: (TextFontReference toFont: font).	"change the selected text"
	^ font! !

!CTextParagraphEditor methodsFor: 'selecting' stamp: 'ar 4/4/2004 21:36'!
selectFrom: markIndex to: pointIndex
	"Select the text from markIndex to pointIndex."
	| oldRect newRect start stop |
	lastUndoType := nil. "so we need to reset"
	oldRect := self selectionRect.
	start := markIndex min: self text size + 1 max: 1.
	stop := pointIndex min: self text size + 1 max: 1.
	"Optimize search for character blocks by reusing the old mark block and testing for start=stop"
	(start = markBlock stringIndex and:[stop = pointBlock stringIndex])
		ifTrue:[^self].
	start = markBlock stringIndex 
		ifFalse:[markBlock := paragraph characterBlockAtIndex: start].
	start = stop
		ifTrue:[pointBlock := markBlock copy]
		ifFalse:[pointBlock := paragraph characterBlockAtIndex: stop].
	"Invalidate the regions that have changed"
	newRect := self selectionRect.
	costume invalidate: (oldRect merge: newRect).
	costume scrollToSelection.
	self updateEmphasisHere.
	self textSelectionChanged.! !

!CTextParagraphEditor methodsFor: 'selecting' stamp: ''!
selectLine
	| interval |
	interval := paragraph lineSelectionIntervalAt: self selectionStart.
	self selectFrom: interval first to: interval last + 1.! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
selectLineDown
	"Select one line down"
	^self moveCaretTo: (paragraph indexOfCharacterBelow: pointBlock stringIndex) selecting: true! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
selectLineEnd
	"Select up to the end of current line. If cursor already at end of 
	line, put cursor at end of text"
	^self moveCaretTo: (paragraph lineSelectionIntervalAt: pointBlock stringIndex) last + 1 selecting: true! !

!CTextParagraphEditor methodsFor: 'selecting' stamp: ''!
selectLineIfEmpty
	"If current selection is empty, select entire line"
	markBlock stringIndex = pointBlock stringIndex ifTrue:[self selectLine].! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
selectLineStart
	"Select from position in current line to beginning of
	current line. If cursor already at beginning of line, put cursor at
	beginning of text"
	^self moveCaretTo: (paragraph lineSelectionIntervalAt: self selectionStart) first selecting: true! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
selectLineUp
	"Select one line up"
	^self moveCaretTo: (paragraph indexOfCharacterAbove: pointBlock stringIndex) selecting: true! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
selectTextEnd
	"Move the cursor to the end of the text"
	^self moveCaretTo: paragraph size+1 selecting: true! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
selectTextStart
	"Select to the beginning of the text"
	^self moveCaretTo: 1 selecting: true! !

!CTextParagraphEditor methodsFor: 'selecting' stamp: ''!
selectWordAt: characterIndex
	"Select the word at the given character index"
	| interval |
	interval := paragraph wordSelectionIntervalAt: characterIndex.
	self selectFrom: interval first to: interval last+1.! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
selectWordLeft
	"Select left one word left"
	self  moveCaretTo: (paragraph indexOfPreviousWord: pointBlock stringIndex-1) selecting: true.! !

!CTextParagraphEditor methodsFor: 'cursor keys' stamp: ''!
selectWordRight
	"Select one word to the right"
	^self moveCaretTo: (paragraph indexOfNextWord: pointBlock stringIndex) selecting: true! !

!CTextParagraphEditor methodsFor: 'selecting' stamp: 'ar 3/13/2003 03:06'!
selection
	markBlock = pointBlock ifTrue:[^Text new].
	^paragraph text copyFrom: self selectionStart to: self selectionStop-1! !

!CTextParagraphEditor methodsFor: 'private' stamp: ''!
selectionRect
	"Compute selection rect"
	| rect |
	rect := markBlock merge: pointBlock.
	markBlock textLine = pointBlock textLine
		ifFalse:[rect := (rect withLeft: costume textBounds left) withWidth: costume textBounds width].
	"Something is definitely weird here with the caret handling but the following does at least work"
	^rect expandBy: 8@8! !

!CTextParagraphEditor methodsFor: 'selecting' stamp: ''!
selectionStart
	^markBlock stringIndex min: pointBlock stringIndex! !

!CTextParagraphEditor methodsFor: 'selecting' stamp: ''!
selectionStop
	^pointBlock stringIndex max: markBlock stringIndex! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: ''!
showCaret
	"Return true if the receiver should display the caret while drawing"
	markBlock ifNil:[^false].
	pointBlock ifNil:[^false].
	^costume wantsCaretShowingIn: self! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: 'ar 3/12/2004 15:55'!
showCaret: aBool
	^costume showCaret: aBool! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: ''!
text
	^paragraph text! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: 'bf 3/30/2004 11:33'!
text: newText
	"need to go through the costume here..."
	^costume text: newText.! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: 'tak 5/9/2005 18:25'!
textColor
	^ (self emphasisHere
		detect: [:attr | attr class == TextColor]
		ifNone: [^ Color black]) color! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: 'tak 5/9/2005 18:53'!
textColor: aColor 
	| aText |
	aText := self selection.
	aText
		removeAttributesSuchThat: [:a | a class == TextColor].
	aText
		addAttribute: (TextColor color: aColor).
	self replaceSelectionWith: aText.
	self selectFrom: self selectionStop - aText size to: self selectionStop.
	^ aColor
! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: ''!
textLines
	^paragraph lines! !

!CTextParagraphEditor methodsFor: 'private' stamp: 'ar 4/4/2004 21:35'!
textSelectionChanged
	self signal: #textSelectionChanged.
	costume textSelectionChanged.! !

!CTextParagraphEditor methodsFor: 'editor commands' stamp: ''!
undo
	"Undo the last command"
	| stack |
	undoStack isEmptyOrNil ifTrue:[^self].
	stack := undoStack.
	undoStack := redoStack ifNil:[OrderedCollection new].
	self undoCommand: stack removeLast.
	redoStack := undoStack.
	undoStack := stack.! !

!CTextParagraphEditor methodsFor: 'private' stamp: ''!
undoCommand: cmd
	| cutInterval pasteText highlight |
	cutInterval := cmd first.
	pasteText := cmd second.
	highlight := cmd third.
	self selectFrom: cutInterval first to: cutInterval last.
	self replaceSelectionWith: pasteText.
	self selectFrom: highlight first to: highlight last.! !

!CTextParagraphEditor methodsFor: 'private' stamp: 'ar 3/13/2003 03:11'!
updateEmphasisHere
	paragraph size = 0 ifTrue:[^self].
	emphasisHere := (paragraph text 
		attributesAt: (pointBlock stringIndex-1 max: 1) 
		forStyle: paragraph textStyle
	) select: [:att | att mayBeExtended].
! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: ''!
visibleLines
	^self visibleLinesIn: (costume textBounds)! !

!CTextParagraphEditor methodsFor: 'accessing' stamp: ''!
visibleLinesIn: box
	^paragraph lines select:[:line| 
		(line top between: box top and: box bottom) 
			and:[line bottom between: box top and: box bottom]].! !

!CTextParagraphEditor methodsFor: 'private' stamp: 'ar 3/13/2003 15:02'!
zapSelectionWith: aText
	| start stop |
	(aText isEmpty and:[markBlock = pointBlock]) ifTrue:[^self].
	start := self selectionStart.
	stop := self selectionStop-1.
	aText isString ifTrue:[
		self replaceFrom: start to: stop with: (Text string: aText emphasis: self emphasisHere).
	] ifFalse:[
		self replaceFrom: start to: stop with: aText.
	].
	"Need to recompute entirely since paragraph changes"
	markBlock := paragraph characterBlockAtIndex: start + aText size.
	pointBlock := markBlock copy.
	costume invalidate.
	costume scrollToSelection.
	self modified: true.! !

!DisplayScanner methodsFor: '*Tweak-Costume' stamp: 'ar 6/8/2003 22:14'!
privatePort: aBitBlt
	"Install the BitBlt to use"
	bitBlt := aBitBlt.
! !

!GrafPort methodsFor: '*Tweak-Costume-override' stamp: 'ar 1/23/2005 00:00'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule
	"Draw the portion of the given Form defined by sourceRect at the given point using the given BitBlt combination rule."

	self sourceForm: aForm.
	combinationRule := rule.
	self sourceRect: sourceRect.
	self destOrigin: aPoint.
	self copyBits! !

!GrafPort methodsFor: '*Tweak-Costume-override' stamp: 'ar 1/23/2005 00:00'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule alpha: sourceAlpha
	"Draw the portion of the given Form defined by sourceRect at the given point using the given BitBlt combination rule."

	self sourceForm: aForm.
	combinationRule := rule.
	self sourceRect: sourceRect.
	self destOrigin: aPoint.
	self copyBitsTranslucent: (alpha := (sourceAlpha * 255) truncated min: 255 max: 0).! !

!String methodsFor: '*Tweak-Costume-Text' stamp: 'ar 4/14/2005 22:44'!
indexOfNextWord: startPosition
	"Return the index of the word after startPosition"
	| index |
	index := startPosition.
	[(index between: 1 and: self size) and: [(self at: index) isAlphaNumeric]]
		whileTrue: [index := index + 1].
	[(index between: 1 and: self size) and: [(self at: index) isAlphaNumeric not]]
		whileTrue: [index := index + 1].
	^ index! !

!String methodsFor: '*Tweak-Costume-Text' stamp: 'ar 4/14/2005 22:45'!
indexOfPreviousWord: startPosition
	"Return the index of the word before startPosition"
	| index |
	index := startPosition.
	[(index between: 1 and: self size) and: [(self at: index) isAlphaNumeric not]]
		whileTrue: [index := index - 1].
	[(index between: 1 and: self size) and: [(self at: index) isAlphaNumeric]]
		whileTrue: [index := index - 1].
	^ index + 1! !

!String methodsFor: '*Tweak-Costume-Text' stamp: 'ar 4/14/2005 22:45'!
lineSelectionIntervalAt: textPosition
	"Return the current line around textPosition"
	| left right |
	left := textPosition.
	right := textPosition - 1.
	[left > 1 and: [(self at: (left - 1)) ~= Character cr]] whileTrue:
		[left := left - 1].
	[right < self size and: [(self at: (right + 1)) ~= Character cr]] whileTrue:
		[right := right + 1].
	^left to: (right min: self size)! !

!String methodsFor: '*Tweak-Costume-Text' stamp: 'ar 4/14/2005 22:45'!
wordSelectionIntervalAt: textPosition
	"Return the selection interval for the region at the given text position. Used for double-clicking on text."
	| here leftDelimiters rightDelimiters openDelimiter match start direction closeDelimiter stop level hereChar |
	here := textPosition.
	"if at beginning or end, select entire string"
	(here between: 2 and: self size) ifFalse:[^1 to: self size].
	leftDelimiters := '([{<''"
'.
	rightDelimiters := ')]}>''"
'.
	openDelimiter := self at: here - 1.
	match := leftDelimiters indexOf: openDelimiter.
	match > 0 ifTrue:[
		"delimiter is on left -- match to the right"
		start := here.
		direction := 1.
		here := here - 1.
		closeDelimiter := rightDelimiters at: match
	] ifFalse:[
		openDelimiter := self at: here.
		match := rightDelimiters indexOf: openDelimiter.
		match > 0 ifTrue:[
			"delimiter is on right -- match to the left"
			stop := here - 1.
			direction := -1.
			closeDelimiter := leftDelimiters at: match
		]ifFalse: [
			"no delimiters -- select a token"
			direction := -1.
		]
	].
	level := 1.
	[level > 0 and: [direction > 0
			ifTrue: [here < self size]
			ifFalse: [here > 1]]] whileTrue:[
		hereChar := self at: (here := here + direction).
		match = 0 ifTrue: [
			"token scan goes left, then right"
			hereChar tokenish ifTrue: [
				here = 1 ifTrue:[
					start := 1.
					"go right if hit string start"
					direction := 1.
				].
			] ifFalse: [
				direction < 0 ifTrue:[
					start := here + 1.
					"go right if hit non-token"
					direction := 1.
				]ifFalse: [level := 0].
			]
		] ifFalse: [
			"bracket match just counts nesting level"
			hereChar = closeDelimiter 
				ifTrue: [level := level - 1"leaving nest"]
				ifFalse: [hereChar = openDelimiter 
						ifTrue: [level := level + 1"entering deeper nest"]]].
	].
	level > 0 ifTrue: ["in case ran off string end"	here := here + direction].
	direction > 0
		ifTrue: [^start to: here - 1]
		ifFalse: [^here + 1 to: stop].! !

!DisplayScreen methodsFor: '*Tweak-Costume-override' stamp: 'ar 1/22/2005 23:58'!
actualScreenSize
	self == Display ifTrue:[^self class actualScreenSize].
	^super actualScreenSize! !

!DisplayScreen methodsFor: '*Tweak-Costume-override' stamp: 'ar 1/22/2005 23:59'!
newDepthNoRestore: pixelSize
	"Change depths.  Check if there is enough space!!  , di"
	| area need |
	pixelSize = depth ifTrue: [^ self  "no change"].
	pixelSize abs < self depth ifFalse:
		["Make sure there is enough space"
		area := Display boundingBox area. "pixels"
		self ifTweak:[] ifNot:[Smalltalk isMorphic ifFalse:
			[ScheduledControllers scheduledWindowControllers do:
				[:aController | "This should be refined..."
				aController view cacheBitsAsTwoTone ifFalse:
					[area := area + aController view windowBox area]]]].
		need := (area * (pixelSize abs - self depth) // 8)  "new bytes needed"
				+ Smalltalk lowSpaceThreshold.
		(Smalltalk garbageCollectMost <= need
			and: [Smalltalk garbageCollect <= need])
			ifTrue: [self error: 'Insufficient free space']].
	self setExtent: self extent depth: pixelSize.
	self ifTweak:[] ifNot:[Smalltalk isMorphic ifFalse: [ScheduledControllers updateGray]].
	DisplayScreen startUp! !

!DisplayScreen methodsFor: '*Tweak-Costume-override' stamp: 'ar 1/22/2005 23:59'!
restore
	self ifTweak:[^self].
	Smalltalk isMorphic
		ifTrue: [World fullRepaintNeeded]
		ifFalse: [ScheduledControllers unCacheWindows; restore].! !

!DisplayScreen methodsFor: '*Tweak-Costume-override' stamp: 'ar 1/22/2005 23:59'!
restoreAfter: aBlock
	"Evaluate the block, wait for a mouse click, and then restore the screen."

	aBlock value.
	Sensor waitButton.
	self ifTweak:[^self].
	Smalltalk isMorphic
		ifTrue: [World fullRepaintNeeded]
		ifFalse: [(ScheduledControllers restore; activeController) view emphasize]! !

!CursorWithMask methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 01:54'!
asForm
	| form |
	form := Form extent: self extent depth: 8.
	form fillShape: maskForm fillColor: Color white.
	form fillShape: self fillColor: Color black at: offset negated.
	^ form offset: self offset! !

!Point methodsFor: '*Tweak-Costume' stamp: 'ar 3/19/2003 00:11'!
boundedBy: radius
	| length |
	length := self length.
	length > radius ifTrue:[^self * (radius / length)].
	^self! !

!Point methodsFor: '*Tweak-Costume' stamp: 'ar 6/5/2003 20:49'!
fastRect: aPoint 
	"A heavily optimized version of #rect:"
	| ptX ptY rect |
	rect := Rectangle new.
	ptX := aPoint x.
	ptY := aPoint y.
	x <= ptX ifTrue:[
		y <= ptY 
			ifTrue:[^rect setOrigin: self corner: aPoint]
			ifFalse:[^rect setOrigin: x@ptY corner: ptX@x].
	] ifFalse:[
		y < ptY
			ifTrue:[^rect setOrigin: ptX@y corner: x@ptY]
			ifFalse:[^rect setOrigin: aPoint corner: self].
	].! !

!Point methodsFor: '*Tweak-Costume' stamp: 'ar 1/28/2003 03:01'!
isPowerOfTwo
	^x isPowerOfTwo and:[y isPowerOfTwo]! !

!Point methodsFor: '*Tweak-Costume' stamp: 'ar 3/19/2003 00:15'!
length
	^self r! !

!Point methodsFor: '*Tweak-Costume' stamp: 'ar 6/25/2005 19:08'!
position
	^self! !

!Point methodsFor: '*Tweak-Costume' stamp: 'ar 3/23/2003 19:48'!
rotateBy: angle
	^self rotateBy: angle about: 0@0! !

!StrikeFont methodsFor: '*Tweak-Costume' stamp: 'ar 12/12/2009 20:56'!
initializeWithMap: charMap
	"Initialize the receiver using the given charMap. The charMap is expected to be a dictionary mapping characters to forms. This method is intended to be used for special decorative fonts, like for example, window or scrollbar button decors."
	| glyphExtent xStart glyph |
	characterToGlyphMap :=  (0 to: 255) collect:[:i|i].
	xTable := Array new: 258.
	glyphExtent := charMap inject: 0@0 into:[:size :form| (size x + form width) @ (size y max: form height)].
	glyphs := Form extent: glyphExtent depth: 1.
	xStart := 0.
	maxWidth := 0.
	0 to: 255 do:[:i|
		xTable at: i+1 put: xStart.
		glyph := charMap at: (Character value: i) ifAbsent:[nil].
		glyph ifNotNil:[
			glyph displayOn: glyphs at: xStart@0 rule: Form over.
			xStart := xStart + glyph width.
			maxWidth := maxWidth max: glyph width.
		].
	].
	xTable at: 257 put: xStart.
	xTable at: 258 put: xStart.
	minAscii := 0.
	maxAscii := 255.
	strikeLength := xStart.
	ascent := glyphExtent y.
	descent := 0.
	emphasis := 0.
	pointSize := glyphExtent y.! !

!Symbol methodsFor: '*Tweak-Costume' stamp: ''!
asBorder
	^CBorder perform: self! !

!InfiniteForm methodsFor: '*Tweak-Costume' stamp: 'bf 9/2/2004 15:52'!
copy: aRect
 	"Return a new form which derives from the portion of the original form delineated by aRect."
	| newForm colors |
	patternForm isColorForm
		ifTrue: [colors := patternForm colors.
				patternForm colors: nil].
	newForm := patternForm class extent: aRect extent depth: patternForm depth.
	self displayOn: newForm at: 0@0 clippingBox: newForm boundingBox.
	colors ifNotNil: [
		patternForm colors: colors.
		newForm colors: colors copy].
	^ newForm! !

!DisplayObject methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2003 22:50'!
drawString: aString at: aPoint
	^aString displayOn: self at: aPoint! !

!TextAttribute methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 12:41'!
anchoredObject
	^nil! !

!DropEvent methodsFor: '*Tweak-Costume-override' stamp: 'ar 1/22/2005 23:59'!
transformBy: aMorphicTransform
	"Transform the receiver into a local coordinate system."
	position :=  position transformedBy: aMorphicTransform.! !

!DropEvent methodsFor: '*Tweak-Costume-override' stamp: 'ar 1/22/2005 23:59'!
translateBy: offset
	position := position + offset.! !

!DropEvent methodsFor: '*Tweak-Costume-override' stamp: 'ar 1/22/2005 23:59'!
translatedBy: delta
	"add delta to cursorPoint, and return the new event"
	^self shallowCopy translateBy: delta! !

FormCanvas subclass: #CTransformCanvas
	instanceVariableNames: 'backup transform maskCanvas forceWarp warpTransform font fontColor fontChanged lastLinePen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Support'!

!CTransformCanvas class methodsFor: 'islands' stamp: 'ar 5/20/2005 11:53'!
howToPassAsArgument
	^#passByIdentity:! !

!CTransformCanvas methodsFor: 'push/pop' stamp: 'ar 12/9/2003 17:53'!
asBackup
! !

!CTransformCanvas methodsFor: 'converting' stamp: 'ar 6/8/2003 21:19'!
asBalloonCanvas
	^(BalloonCanvas on: form) 
		setOrigin: 0@0 clipRect: port clipRect;
		transformBy: transform asMatrixTransform2x3;
		aaLevel: 4;
		yourself! !

!CTransformCanvas methodsFor: 'TODO-IGraphicsDevice' stamp: 'ar 12/9/2003 00:37'!
asCanvas
	^self! !

!CTransformCanvas methodsFor: 'accessing' stamp: 'ar 12/9/2003 00:37'!
asTransformCanvas
	^self! !

!CTransformCanvas methodsFor: 'drawing-images' stamp: 'ar 12/7/2002 22:20'!
balloonWarp: aForm transform: aTransform at: extraOffset sourceRect: sourceRect
	"Warp the given using the appropriate transform and offset."
	| engine fill globalRect tfm |
	"a workaround for balloon sometimes not rounding appropriately"
	globalRect := aTransform localBoundsToGlobal: sourceRect.
	extraOffset ifNotNil:[globalRect := globalRect translateBy: extraOffset].
	port clipBy: globalRect.
	engine := BalloonEngine new.
	engine aaLevel: 2.
	engine bitBlt: port.
	engine destOffset: extraOffset.
	engine deferred: false.
	fill := CBitmapFill form: aForm.
	fill tileFlag: false.
	fill origin: 0@0.
	fill direction: aForm width@0.
	fill normal: 0@aForm height.
	"another weirdo offset problem..."
	tfm := aTransform clone.
	tfm a13: tfm a13 - 0.2.
	tfm a23: tfm a23 - 0.2.
	engine
		drawRectangle: sourceRect
		fill: fill
		borderWidth: 0
		borderColor: nil
		transform: tfm.
	engine flush.
	port clipRect: (transform localBoundsToGlobal: clipRect).! !

!CTransformCanvas methodsFor: 'caching' stamp: 'ar 3/18/2003 23:51'!
cache: aRectangle using: aCache during: aBlock
	aCache ifNil:[^aBlock value: self].
	^aCache drawCached: aBlock on: self in: aRectangle! !

!CTransformCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 2/6/2009 17:56'!
clearRectangle: r
	"Clear the background of the given rectangle"
	| rect |
	rect := r translateBy: origin.
	self setFillColor: Color white.
	port combinationRule: Form erase.
	port fillRect: rect offset: origin
! !

!CTransformCanvas methodsFor: 'clipping' stamp: 'ar 6/25/2005 16:35'!
clipBy: aClipShape
	clipRect := clipRect intersect: aClipShape asRectangle.
	port clipBy: (transform localBoundsToGlobal: clipRect) truncated.
	(aClipShape isRectangle and:[transform isPureTranslation]) ifTrue:[^self].
	"Use a mask for clipping"
	"TODO: Need to initialize maskCanvas if not initialized"
	"TODO: Need maskCanvas to provide Form>>bitAnd!!"
	"aClipShape drawOn: maskCanvas."
	"TODO: Need to install a different form/warp in order to get masking right"! !

!CTransformCanvas methodsFor: 'clipping' stamp: ''!
clipBy: aClipShape during: aBlock
	self pushState.
	self clipBy: aClipShape.
	aBlock value: self.
	self popState.! !

!CTransformCanvas methodsFor: 'accessing' stamp: ''!
clipRect
	^clipRect! !

!CTransformCanvas methodsFor: 'transforming' stamp: ''!
copyFrom: anObject
	1 to: self class instSize do:[:i|
		self instVarAt: i put: (anObject instVarAt: i).
	].! !

!CTransformCanvas methodsFor: 'initialize' stamp: 'ar 5/22/2005 20:50'!
deferUpdates: aBool
	^form deferUpdates: aBool
! !

!CTransformCanvas methodsFor: 'as yet unclassified' stamp: 'mtf 6/23/2009 14:09'!
destForm
	"I don't understand how this works, but when using text anchoring, MultiDisplayScanner thinks I am an instance of BitBlt, and needs this. Dunno if it's an evil hack or a misnamed ivar, but whatever"

	^ self form! !

!CTransformCanvas methodsFor: 'TODO-IGraphicsDevice' stamp: 'ar 12/9/2003 00:36'!
display: anObject
	"Display the given object"
	anObject displayFrom: self.
! !

!CTransformCanvas methodsFor: 'drawing-text' stamp: 'ar 12/6/2005 14:58'!
displayString: aString from: startIndex to: stopIndex at: aPoint font: aFont kern: kernDelta
	| stringWidth stringHeight box tmpForm |
	font == aFont ifFalse:[
		font := aFont.
		fontChanged := true.
	].
	transform isPureTranslation ifTrue:[
		fontChanged ifTrue:[
			"set paint color again in case we had intermediate drawing operations"
			self setPaintColor: fontColor. 
			font installOn: port foregroundColor: fontColor backgroundColor: Color transparent.
			fontChanged := false.
		].
		font displayString: aString 
			on: port 
			from: startIndex 
			to: stopIndex 
			at: aPoint + origin
			kern: kernDelta.
		^self].


	"draw string onto temporary form"
	stringWidth := aFont widthOfString: aString from: startIndex to: stopIndex.
	stringHeight := aFont height.
	box := aPoint extent: (stringWidth @ stringHeight).
	box := box intersect: clipRect.
	tmpForm := ColorForm extent: box extent depth: 1.
	tmpForm colors: (Array with: Color transparent with: fontColor).
	tmpForm getCanvas 
		drawString: aString 
		from: startIndex 
		to: stopIndex 
		in: (aPoint - box origin extent: box extent) 
		font: font 
		color: Color black
		kern: kernDelta.
	"and blast out image"
	^self paintImage: tmpForm at: box origin! !

!CTransformCanvas methodsFor: 'drawing-text' stamp: 'tak 5/27/2005 17:51'!
displayString: aString from: startIndex to: stopIndex at: aPoint kern: kernDelta baselineY: baselineY font: aFont
	^self displayString: aString from: startIndex to: stopIndex at: aPoint font: aFont kern: kernDelta! !

!CTransformCanvas methodsFor: 'drawing-shapes' stamp: 'ar 6/9/2003 03:36'!
drawCompressedShape: aShape
	^self asBalloonCanvas drawCompressedShape: aShape! !

!CTransformCanvas methodsFor: 'drawing-lines' stamp: 'bf 9/2/2004 21:20'!
drawLineFrom: lastPt to: nextPt brush: brush
	| offset erasing |
	offset := origin.
	self setPaintColor: Color black.
	erasing := brush isColorForm and: [brush colors second isTransparent].
	erasing ifTrue: [
		brush colors at: 2 put: Color white.
		port combinationRule: Form erase].
	port sourceForm: brush; fillColor: nil;
		sourceRect: brush boundingBox;
		colorMap: (brush colormapIfNeededFor: form);
		drawFrom: (lastPt + offset) to: (nextPt + offset).
	erasing ifTrue: [brush colors at: 2 put: Color transparent] ! !

!CTransformCanvas methodsFor: 'drawing-lines' stamp: 'ar 3/27/2003 18:30'!
drawLineFrom: lastPt to: nextPt width: lineWidth color: lineColor
	^self line: lastPt to: nextPt width: lineWidth color: lineColor! !

!CTransformCanvas methodsFor: 'drawing-text' stamp: 'tak 5/27/2005 18:11'!
drawString: aString from: firstIndex to: lastIndex in: bounds font: fontOrNil color: c kern: kernDelta
	transform isPureTranslation ifTrue:[
		^super 
			drawString: aString 
			from: firstIndex 
			to: lastIndex 
			in: bounds 
			font: fontOrNil 
			color: c
			kern: kernDelta
	].
	self pushState.
	self clipBy: bounds.
	font := fontOrNil ifNil:[TextStyle defaultFont].
	font installOn: self 
		foregroundColor: (shadowColor ifNil:[c]) 
		backgroundColor: Color transparent.
	self displayString: aString
		from: firstIndex
		to: lastIndex
		at: bounds topLeft
		font: font
		kern: kernDelta.
	self popState.! !

!CTransformCanvas methodsFor: 'drawing-rectangles' stamp: ''!
fillOval: aRectangle fill: aFill border: aBorder
	"@@@@: Fix this. Remove the old interface. :@@@@"
	^self fillOval: aRectangle fillStyle: aFill borderStyle: aBorder! !

!CTransformCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 6/8/2003 20:34'!
fillRectangle: r color: c
	transform isPureTranslation ifTrue:[
		^super fillRectangle: r color: c
	].
	self balloonFillRectangle: r fillStyle: (shadowColor ifNil:[c]).
! !

!CTransformCanvas methodsFor: 'drawing-rectangles' stamp: ''!
fillRectangle: aRectangle fill: aFill border: aBorder
	"@@@@: Fix this. Remove the old interface. :@@@@"
	^self fillRectangle: aRectangle fillStyle: aFill borderStyle: aBorder! !

!CTransformCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 6/8/2003 20:31'!
fillRectangle: aRectangle fillStyle: aFillStyle
	transform isPureTranslation ifTrue:[
		^super fillRectangle: aRectangle fillStyle: aFillStyle
	].
	self balloonFillRectangle: aRectangle fillStyle: (shadowColor ifNil:[aFillStyle]).
! !

!CTransformCanvas methodsFor: 'drawing-round rects' stamp: 'ar 2/6/2005 19:08'!
fillRoundRect: aRectangle radius: cornerRadius fill: fillStyle border: borderStyle
	"Draw a rounded rectangle"
	self shadowColor ifNotNil:[
		^self fillRoundRect: aRectangle radius: cornerRadius fillStyle: shadowColor.
	].
	"see if the round rect is degenerate"
	cornerRadius asPoint <= (0@0) 
		ifTrue:[^self fillRectangle: aRectangle fill: fillStyle border: borderStyle].
	cornerRadius * 2 >= aRectangle width 
		ifTrue:[^self fillOval: aRectangle fill: fillStyle border: borderStyle].
	"Okay it's a rounded rectangle"
	fillStyle isTransparent ifFalse:["fill interior"
		| innerRect radius bw |
		innerRect := aRectangle.
		radius := cornerRadius.
		bw := borderStyle width.
		bw isZero ifFalse:[
			innerRect := innerRect insetBy: bw.
			radius := radius - bw.
		].
		self fillRoundRect: innerRect radius: radius fillStyle: fillStyle.
	].
	borderStyle width = 0 ifFalse:[
		borderStyle frameRoundRect: aRectangle radius: cornerRadius on: self.
	].! !

!CTransformCanvas methodsFor: 'drawing-round rects' stamp: 'ar 6/8/2003 19:07'!
fillRoundRect: aRectangle radius: radius fillStyle: fillStyle
	fillStyle isTransparent ifTrue:[^self].
	radius asPoint <= (0@0) 
		ifTrue:[^self fillRectangle: aRectangle fillStyle: fillStyle].
	(radius * 2) asPoint >= aRectangle extent 
		ifTrue:[^self fillOval: aRectangle fillStyle: fillStyle].
	fillStyle isSolidFill 
		ifFalse:[^self balloonFillRoundRect: aRectangle radius: radius fillStyle: fillStyle].
	self setFillColor: (shadowColor ifNil:[fillStyle asColor]).
	^port fillRoundRect: (aRectangle translateBy: origin) truncated radius: radius.
! !

!CTransformCanvas methodsFor: 'private-state' stamp: 'ar 6/9/2003 00:09'!
flushWarp
	"Warp the receiver onto aCanvas"
	| aCanvas |
	warpTransform ifNil:[^self].
	aCanvas := backup.
	maskCanvas ifNotNil:[
		"Mask out the clipping region if non-rectangular"
		maskCanvas finish.
		(BitBlt toForm: form)
			sourceForm: maskCanvas form;
			combinationRule: Form and;
			copyBits].
	aCanvas 
		privateWarp: form 
		transform: warpTransform 
		at: 0@0 
		sourceRect: form boundingBox 
		cellSize: warpTransform warpCellSize.! !

!CTransformCanvas methodsFor: 'initialize' stamp: 'ar 5/22/2005 20:50'!
forceDamageToScreen: allDamage
	form forceDamageToScreen: allDamage
! !

!CTransformCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 6/8/2003 20:49'!
frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth topLeftColor: topLeftColor bottomRightColor: bottomRightColor
	| inner bc |
	transform isPureTranslation ifTrue:[
		^super frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth topLeftColor: topLeftColor bottomRightColor: bottomRightColor.
	].
	inner := r insetBy: borderWidth.
	bc := self asBalloonCanvas.
	bc deferred: true.
	fillColor isTransparent ifFalse:[
		bc drawRectangle: inner color: fillColor borderWidth: 0 borderColor: nil.
	].

	(borderWidth > 0 and:[topLeftColor isTransparent not]) ifTrue:[	
		bc drawPolygon: {
			r topLeft.
			r topRight.
			inner topRight.
			inner topLeft.
			inner bottomLeft.
			r bottomLeft.
		} color: topLeftColor borderWidth: 0 borderColor: nil.
	].
	(borderWidth > 0 and:[bottomRightColor isTransparent not]) ifTrue:[	
		bc drawPolygon: {
			r topRight.
			r bottomRight.
			r bottomLeft.
			inner bottomLeft.
			inner bottomRight.
			inner topRight.
		} color: bottomRightColor borderWidth: 0 borderColor: nil.
	].
	bc flush.! !

!CTransformCanvas methodsFor: 'drawing-round rects' stamp: 'ar 6/8/2003 19:05'!
frameRoundRect: aRectangle radius: radius width: borderWidth color: borderColor
	"Frame a rounded rectangle with the given attributes."
	| innerRect |
	(borderWidth isZero or:[borderColor isTransparent])
		ifTrue:[^self].
	radius asPoint <= (0@0) 
		ifTrue:[^self frameRectangle: aRectangle width: borderWidth color: borderColor].
	(radius * 2) asPoint >= aRectangle extent 
		ifTrue:[^self frameOval: aRectangle width: borderWidth color: borderColor].
	"decompose inner rectangle into bezier shape"
	innerRect := aRectangle insetBy: borderWidth.
	innerRect area <= 0 
		ifTrue:[^self fillRoundRect: aRectangle radius: radius fillStyle: borderColor].
	self setFillColor: borderColor.
	port 
		frameRoundRect: (aRectangle translateBy: origin) truncated 
		radius: radius truncated 
		borderWidth: borderWidth truncated.
! !

!CTransformCanvas methodsFor: 'drawing-images' stamp: 'ar 6/8/2003 23:51'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule
	"Draw the portion of the given Form defined by sourceRect at the given point using the given BitBlt combination rule."
	"Flood this canvas with aColor wherever stencilForm has non-zero pixels"
	| fill rect |
	transform isPureTranslation ifTrue:[
		^super image: aForm at: aPoint sourceRect: sourceRect rule: rule
	].
	fill := CBitmapFill new.
	fill form: aForm.
	fill direction: sourceRect width @ 0.
	fill normal: 0 @ sourceRect height.
	fill origin: aPoint - sourceRect origin.
	rect := (aPoint extent: sourceRect extent) intersect: clipRect.
	(self asBalloonCanvas)
		drawRectangle: rect
		color: fill
		borderWidth: 0
		borderColor: nil.
! !

!CTransformCanvas methodsFor: 'drawing-text' stamp: 'ar 4/29/2009 11:41'!
installNativeFont: aFont foregroundColor: fgColor backgroundColor: bgColor
	font := aFont.
	fontColor := fgColor.
	fontChanged := true.! !

!CTransformCanvas methodsFor: 'drawing-text' stamp: 'ar 6/8/2003 22:17'!
installStrikeFont: aFont foregroundColor: fgColor backgroundColor: ignored
	font := aFont.
	fontColor := fgColor.
	fontChanged := true.! !

!CTransformCanvas methodsFor: 'drawing-text' stamp: 'ar 2/12/2004 15:58'!
installTTCFont: aFont foregroundColor: fgColor backgroundColor: ignored
	font := aFont.
	fontColor := fgColor.
	fontChanged := true.! !

!CTransformCanvas methodsFor: 'private-state' stamp: 'ar 6/8/2003 19:43'!
installWarp: localRect
	| warpForm cc |
	forceWarp ifFalse:[^self].
	"TODO: Clip localRect against re-transformed portRect to minimize space usage"
	warpForm := Form extent: localRect extent depth: 32.
	warpTransform := transform composedWithLocal: (COffsetTransform withOffset: localRect origin).
	"TODO: #setForm: needs to initialize portRect based on clipRect/transform"
	cc := shadowColor.
	self setForm: warpForm.
	shadowColor := cc.
	self translateBy: localRect origin negated.
	clipRect := localRect.! !

!CTransformCanvas methodsFor: 'testing' stamp: 'ar 12/8/2002 03:33'!
isVisible: aRectangle
	"Optimization"
	(aRectangle right) < clipRect left	ifTrue: [^ false].
	(aRectangle left) > clipRect right	ifTrue: [^ false].
	(aRectangle bottom) < clipRect top	ifTrue: [^ false].
	(aRectangle top) > clipRect bottom	ifTrue: [^ false].
	^ true! !

!CTransformCanvas methodsFor: 'drawing-lines' stamp: 'ar 2/6/2005 15:41'!
line: pt1 to: pt2 width: w color: c
	w isZero ifTrue:[^self].
	c isTransparent ifTrue:[^self].
	(lastLinePen == nil or:[lastLinePen width ~= w]) ifTrue:[
		lastLinePen := Form dotOfSize: w.
	].
	self setPaintColor: c.
	port sourceForm: lastLinePen.
	port colorMap: (Bitmap with: 0 with: 16rFFFFFFFF).
	port width: w; height: w;
		drawFrom: pt1+origin to: pt2+origin.

! !

!CTransformCanvas methodsFor: 'drawing-round rects' stamp: 'ar 6/8/2003 17:14'!
makeRoundRectShape: aRectangle radius: radius
	"decompose a rounded rectangle into bezier form"
	| ovalDiameter rectExtent segments points endPoint seg idx offset rectOffset |
	ovalDiameter := (radius * 2) asPoint min: aRectangle extent.
	(ovalDiameter x <= 0 or:[ovalDiameter y <= 0]) ifTrue:[
		"degenerates into rectangle - just hand back four lines"
		| topLeft topRight bottomLeft bottomRight |
		topLeft := aRectangle topLeft.
		topRight := aRectangle topRight.
		bottomLeft := aRectangle bottomLeft.
		bottomRight := aRectangle bottomRight.

		points := Array new: 4*3.
		points at: 1 put: topLeft.
		points at: 2 put: topLeft.
		points at: 3 put: topRight.

		points at: 4 put: topRight.
		points at: 5 put: topRight.
		points at: 6 put: bottomRight.

		points at: 7 put: bottomRight.
		points at: 8 put: bottomRight.
		points at: 9 put: bottomLeft.

		points at: 10 put: bottomLeft.
		points at: 11 put: bottomLeft.
		points at: 12 put: topLeft.
		^points
	].
	rectExtent := aRectangle extent - ovalDiameter.
	rectOffset := aRectangle origin.
	segments := Bezier2Segment makeEllipseSegments: (0@0 extent: ovalDiameter).
	"patch up the segments to include lines connecting the oval parts.
	we need: 8*3 points for the oval parts + 4*3 points for the connecting lines"
	points := Array new: 12*3.
	idx := 0.
	endPoint := segments last end + rectOffset.
	1 to: 8 by: 2 do:[:i|
		i = 1 ifTrue:[offset := rectOffset + (rectExtent x @ 0)].
		i = 3 ifTrue:[offset := rectOffset + rectExtent].
		i = 5 ifTrue:[offset := rectOffset + (0 @ rectExtent y)].
		i = 7 ifTrue:[offset := rectOffset].
		seg := segments at: i.
		"insert a line segment for the horizontal part of the round rect"
		points at: (idx := idx+1) put: endPoint.
		points at: (idx := idx+1) put: endPoint.
		points at: (idx := idx+1) put: seg start + offset.
		"now the first half-arc"
		points at: (idx := idx+1) put: seg start + offset.
		points at: (idx := idx+1) put: seg via + offset.
		points at: (idx := idx+1) put: seg end + offset.
		"the second half-arc"
		seg := segments at: i+1.
		points at: (idx := idx+1) put: seg start + offset.
		points at: (idx := idx+1) put: seg via + offset.
		points at: (idx := idx+1) put: seg end + offset.
		endPoint := seg end + offset.
	].
	^points! !

!CTransformCanvas methodsFor: 'push/pop' stamp: 'ar 12/9/2003 00:33'!
newBackup
	"Create a backup of the receiver"
	^self copy asBackup! !

!CTransformCanvas methodsFor: 'drawing-text' stamp: 'ar 3/11/2005 21:22'!
paragraph: para bounds: bounds color: c
	| scanner |
	self setPaintColor: c.
	scanner := MultiDisplayScanner new text: para text textStyle: para textStyle
		foreground: (shadowColor ifNil:[c]) background: Color transparent
		fillBlt: nil ignoreColorChanges: shadowColor notNil.
	scanner privatePort: self.
	para displayOn: self using: scanner at: bounds topLeft.! !

!CTransformCanvas methodsFor: 'push/pop' stamp: 'ar 12/9/2003 00:31'!
popState
	self restoreFrom: backup.! !

!CTransformCanvas methodsFor: 'transforming' stamp: ''!
preserveStateDuring: aBlock
	self pushState.
	aBlock value: self.
	self popState.! !

!CTransformCanvas methodsFor: 'drawing-images' stamp: 'ar 6/9/2003 00:11'!
privateWarp: aForm transform: aTransform at: extraOffset sourceRect: sourceRect cellSize: cellSize
	"Warp the given using the appropriate transform and offset."
false ifTrue:[
	^self balloonWarp: aForm transform: aTransform at: extraOffset sourceRect: sourceRect
] ifFalse:[
	^super privateWarp: aForm transform: aTransform at: extraOffset sourceRect: sourceRect cellSize: cellSize
].! !

!CTransformCanvas methodsFor: 'push/pop' stamp: 'ar 12/9/2003 17:53'!
pushState
	backup := self newBackup.
	warpTransform := nil.! !

!CTransformCanvas methodsFor: 'initialize' stamp: 'ar 6/9/2003 00:01'!
reset
	super reset.
	transform := CIdentityTransform new.
	forceWarp := true.
! !

!CTransformCanvas methodsFor: 'private-state' stamp: 'ar 6/8/2003 20:06'!
resetGrafPort
	"Private!! Create a new grafPort for a new copy."
	port := self portClass toForm: form.
	port clipRect: (transform localBoundsToGlobal: clipRect).! !

!CTransformCanvas methodsFor: 'private-state' stamp: 'ar 12/9/2003 00:31'!
restoreFrom: backup
	"Restore the receiver from the given canvas"
	self flushWarp. "flush me so pending changes take effect"
	"This should be a primitive!!"
	self copyFrom: backup! !

!CTransformCanvas methodsFor: 'rounding' stamp: 'ar 3/18/2003 23:51'!
roundCornersOf: aMorph in: bounds during: aBlock
	aMorph wantsRoundedCorners ifFalse:[^aBlock value].
	(self seesRoundedCornerOf: bounds)
		ifFalse: ["Don't bother with corner logic if the region is inside them"
				^ aBlock value].
	CCornerRounder roundCornersOf: aMorph on: self in: bounds
		displayBlock: aBlock
		borderWidth: aMorph borderWidthForRounding
		corners: aMorph roundedCorners
! !

!CTransformCanvas methodsFor: 'initialize' stamp: 'ar 12/7/2002 22:13'!
setForm: aForm
	transform ifNil:[transform := CIdentityTransform new].
	super setForm: aForm.
	port clipRect: (transform localBoundsToGlobal: clipRect).! !

!CTransformCanvas methodsFor: 'private-state' stamp: 'ar 12/7/2002 22:15'!
setOrigin: aPoint clipRect: aRectangle
	origin := aPoint.
	transform isIdentity
		ifTrue:[transform := COffsetTransform withOffset: aPoint]
		ifFalse:[transform offset: aPoint].
	clipRect := aRectangle translateBy: aPoint negated.
	port clipRect: (transform localBoundsToGlobal: clipRect).! !

!CTransformCanvas methodsFor: 'drawing-images' stamp: 'ar 6/8/2003 20:32'!
stencil: aForm at: aPoint sourceRect: sourceRect color: aColor
	"Flood this canvas with aColor wherever stencilForm has non-zero pixels"
	| stencilForm stencilColors fill rect |
	transform isPureTranslation ifTrue:[
		^super stencil: aForm at: aPoint sourceRect: sourceRect color: aColor.
	].
	stencilForm := aForm.
	stencilForm depth > 8 "ugh, oh this is going to be slowish as hell"
		ifTrue:[stencilForm := stencilForm asFormOfDepth: 8].
	"share bits"
	stencilForm := ColorForm 
		extent: stencilForm extent 
		depth: stencilForm depth 
		bits: stencilForm bits.
	stencilColors := Array new: 1 << stencilForm depth withAll: aColor.
	stencilColors at: 1 put: Color transparent.
	stencilForm colors: stencilColors.
	fill := CBitmapFill new.
	fill form: stencilForm.
	fill direction: sourceRect width @ 0.
	fill normal: 0 @ sourceRect height.
	fill origin: sourceRect origin negated.
	rect := (aPoint extent: sourceRect extent) intersect: clipRect.
	(self asBalloonCanvas)
		drawRectangle: rect
		color: fill
		borderWidth: 0
		borderColor: nil.
! !

!CTransformCanvas methodsFor: 'transforming' stamp: 'ar 1/6/2004 20:53'!
transform
	^transform! !

!CTransformCanvas methodsFor: 'transforming' stamp: 'ar 12/8/2003 22:47'!
transform: aTransform
	"Transform the receiver by the given transform.
	Do *NOT* establish warp."
	transform := aTransform.
	origin := transform offset.
	"Update clipRect based on port's information; 
	if set afterwards we may get something a little more accurate."
	clipRect := transform globalBoundsToLocal: port clipRect! !

!CTransformCanvas methodsFor: 'transforming' stamp: 'ar 1/6/2004 20:53'!
transformBy: aTransform
	"Transform the receiver by the given transform.
	Do *NOT* establish warp."
	transform := transform composedWithLocal: aTransform.
	origin := transform offset.
	"Update clipRect based on port's information; 
	if set afterwards we may get something a little more accurate."
	clipRect := transform globalBoundsToLocal: port clipRect! !

!CTransformCanvas methodsFor: 'transforming' stamp: 'ar 4/27/2005 19:09'!
transformBy: aTransform clippingTo: localRect during: aBlock
	"Transform the receiver by the given transformation and apply the given clipping rectangle.
	If non-trivial, the transformation will establish a new warp."
	self pushState.
		"Install the transformation"
		self transformBy: aTransform.
		"Install a new warp if the transform affects the mapping of localRect"
		(transform isPureTranslation)
			ifFalse:[self installWarp: localRect].
		"Install transform and clip rect"
		self clipBy: localRect.
		aBlock value: self.
	self popState.! !

!CTransformCanvas methodsFor: 'transforming' stamp: ''!
transformBy: aTransform during: aBlock
	self pushState.
	[
		self transformBy: aTransform.
		aBlock value: self.
	] ensure:[self popState].! !

!CTransformCanvas methodsFor: 'transforming' stamp: 'ar 12/7/2002 22:15'!
translateBy: offset
	offset isZero ifFalse:[self transformBy: (COffsetTransform withOffset: offset)].! !

!CTransformCanvas methodsFor: 'transforming' stamp: ''!
translateBy: delta during: aBlock
	self pushState.
	self translateBy: delta.
	aBlock value: self.
	self popState.! !

!CTransformCanvas methodsFor: 'drawing-images' stamp: ''!
warpImage: aForm transform: aTransform at: extraOffset sourceRect: sourceRect cellSize: cellSize
	"Warp the given using the appropriate transform and offset."
	| tfm |
	tfm := transform composedWithLocal: aTransform.
	^self privateWarp: aForm transform: tfm at: extraOffset sourceRect: sourceRect cellSize: cellSize! !

!FormCanvas methodsFor: '*Tweak-Costume' stamp: 'ar 6/8/2003 23:01'!
drawString: aString from: firstIndex to: lastIndex in: bounds font: fontOrNil color: c kern: kernDelta
	| font portRect |
	port colorMap: nil.
	portRect := port clipRect.
	port clipByX1: bounds left + origin x 
		y1: bounds top + origin y 
		x2: bounds right + origin x 
		y2: bounds bottom + origin y.
	font := fontOrNil ifNil: [TextStyle defaultFont].
	port combinationRule: Form paint.
	font installOn: port
		foregroundColor: (self shadowColor ifNil:[c]) 
		backgroundColor: Color transparent.
	font displayString: aString asString on: port 
		from: firstIndex to: lastIndex at: (bounds topLeft + origin) kern: kernDelta.
	port clipRect: portRect.! !

!FormCanvas methodsFor: '*Tweak-Costume-override' stamp: 'mtf 2/22/2009 12:21'!
privateWarp: aForm transform: aTransform at: extraOffset sourceRect: sourceRect cellSize: cellSize
	"Warp the given form using the appropriate transform and offset."
	| globalRect sourceQuad warp tfm |
	tfm := aTransform.
	globalRect := tfm localBoundsToGlobal: sourceRect.
	sourceQuad := tfm sourceQuadFor: globalRect.  "why not just (sourceRect innerCorners)? -bf"
	extraOffset ifNotNil:[globalRect := globalRect translateBy: extraOffset].
     warp := (WarpBlt current toForm: port destForm)
                combinationRule: Form blend;
                sourceQuad: sourceQuad destRect: globalRect;
                clipRect: port clipRect.
	warp sourceForm: aForm.
	warp cellSize: cellSize.
	cellSize = 1 ifTrue:[
		warp colorMap: (aForm colormapIfNeededFor: warp destForm).
	].
	warp warpBits! !

!Text methodsFor: '*Tweak-Costume-Text' stamp: 'ar 3/1/2005 10:57'!
allItalic
	"Force this whole text to be italic."
	string size = 0 ifTrue: [^self].
	self makeItalicFrom: 1 to: string size! !

!Text methodsFor: '*Tweak-Costume-Text' stamp: 'tk 6/22/2004 17:48'!
embeddedCostumesFrom: start to: stop
	"return the list of costumess embedded in me"
	"@@@@: Fix this. Ought to be 'embedded objects' all the way down to TextAttribute and this method should not determine whether the embedded object 'isKindOf:' something. :@@@@"
	| costumes |
	costumes := IdentitySet new.
	runs runsFrom: start to: stop do:[:attribs|
		attribs do:[:attr|
			attr anchoredObject ifNotNil:[costumes add: attr anchoredObject]]].
	^costumes select: [ :m | m isPrimitiveCostume ]! !

!Text methodsFor: '*Tweak-Costume-Text' stamp: 'ar 6/2/2004 15:23'!
emphasis
	"Answer the default emphasis set for this text or nil if none has been defined"
	| firstCode lastCode |
	self size = 0 ifTrue:[^0].
	firstCode := 0.
	(self attributesAt: 1) do:[:each| firstCode := firstCode bitOr: each emphasisCode].
	lastCode := 0.
	(self attributesAt: self size) do:[:each| lastCode := lastCode bitOr: each emphasisCode].
	^firstCode bitAnd: lastCode! !

!Text methodsFor: '*Tweak-Costume-Text' stamp: 'ar 4/6/2003 16:10'!
font
	"Answer the default font set for this text or nil if none has been defined"
	(self attributesAt: 1) do:[:each|
		each class == TextFontReference ifTrue:[^each font].
	].
	^nil! !

!Text methodsFor: '*Tweak-Costume-Text' stamp: 'ar 3/1/2005 10:57'!
makeItalicFrom: start to: stop

	^ self addAttribute: TextEmphasis italic from: start to: stop! !

!Text methodsFor: '*Tweak-Costume-Text' stamp: 'ar 3/13/2003 04:43'!
removeAttributesSuchThat: aBlock
	"Remove the attribute over the interval start to stop."
	^self removeAttributesSuchThat: aBlock from: 1 to: self size
! !

!Text methodsFor: '*Tweak-Costume-Text' stamp: 'ar 3/13/2003 04:42'!
removeAttributesSuchThat: aBlock from: start to: stop 
	"Remove the attribute over the interval start to stop."
	runs :=  runs copyReplaceFrom: start to: stop
			with: ((runs copyFrom: start to: stop)
				mapValues:
				[:attributes | attributes reject: aBlock])! !

!Cursor methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 01:54'!
asForm
	| form |
	form := Form extent: self extent depth: 8.
	form fillShape: self fillColor: Color black at: offset negated.
	^ form offset: offset! !

!Cursor methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 01:31'!
isCursor
	^true! !

!Process methodsFor: '*Tweak-Costume' stamp: 'ar 5/26/2005 19:09'!
hand
	^nil! !

!Process methodsFor: '*Tweak-Costume' stamp: 'ar 3/19/2003 22:21'!
hand: aHand
	"ignored"! !

!Process methodsFor: '*Tweak-Costume' stamp: 'ar 7/14/2003 18:46'!
world
	^ActiveWorld! !

!Process methodsFor: '*Tweak-Costume' stamp: 'ar 7/14/2003 18:53'!
world: aWorld
	"ignored"! !

!MultiDisplayScanner methodsFor: '*Tweak-Costume' stamp: 'ar 3/1/2005 14:01'!
privatePort: aBitBlt
	"Install the BitBlt to use"
	bitBlt := aBitBlt.
! !

!Canvas methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 01:16'!
draw: aCostume damageList: damageList
	| box |
	box := aCostume fullBounds.
	damageList do:[:rect|
		(box intersects: rect) ifTrue:[self clipBy: rect during:[:cc| cc draw: aCostume]].
	].! !

!Canvas methodsFor: '*Tweak-Costume' stamp: 'ar 6/5/2003 18:37'!
drawLineFrom: startPoint to: endPoint using: aBrush
	^self line: startPoint to: endPoint brushForm: aBrush! !

!Canvas methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 01:18'!
fillOval: aRectangle fillStyle: aFillStyle borderStyle: aBorderStyle
	^self fillOval: aRectangle fillStyle: aFillStyle borderWidth: aBorderStyle width borderColor: aBorderStyle color! !

!Canvas methodsFor: '*Tweak-Costume' stamp: 'ar 1/22/2005 19:38'!
fillRectangle: aRectangle fill: aFill border: aBorder
	"@@@@: Fix this. Remove the old interface. :@@@@"
	^self fillRectangle: aRectangle fillStyle: aFill borderStyle: aBorder! !

!Canvas methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 01:17'!
fullDraw: aCostume damageList: damageList
	| box |
	box := aCostume fullBounds.
	damageList do:[:rect|
		(box intersects: rect) ifTrue:[self clipBy: rect during:[:cc| cc fullDraw: aCostume]].
	].! !

!Canvas methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 01:58'!
seesRoundedCornerOf: aRectangle
	"Return true if this canvas sees any of the rounded corners of aRectangle"
	| roundRect clipRect |
	roundRect := aRectangle insetBy: CCornerRounder cornerSize.
	clipRect := self clipRect.
	"Check horizontal overlaps"
	(clipRect origin x >= roundRect origin x 
		and:[clipRect corner x <= roundRect corner x]) ifTrue:[^false].
	"Check vertical overlaps"
	(clipRect origin y >= roundRect origin y
		and:[clipRect corner y <= roundRect corner y]) ifTrue:[^false].
	^true! !

!Canvas methodsFor: '*Tweak-Costume' stamp: 'ar 1/23/2005 01:05'!
warpImage: aForm transform: aTransform sourceRect: aRectangle
	"Warp the given portion of aForm using aTransform."
	^self warpImage: aForm transform: aTransform at: 0@0 sourceRect: aRectangle cellSize: aTransform warpCellSize! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'mtf 1/19/2009 13:02'!
alignAt: position within: anotherRectangle
"Answers a new rectangle aligned within anotherRectangle. The position is a float Point specifying the alignment:
	0.0@0.0 is top-left alignment
	0.5@1.0 is bottom-center alignment"
	^ self align: (self scaledPoint: position)
		with: (anotherRectangle scaledPoint: position)! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 3/6/2004 19:44'!
asLayoutFrame
	| frame |
	frame := CLayoutFrame new.
	frame 
		leftFraction: self left; 
		rightFraction: self right; 
		topFraction: self top; 
		bottomFraction: self bottom.
	^frame! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: ''!
asRectangle
	^self! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 7/19/2003 18:04'!
bottomCenter: aPoint
	^origin corner: corner x @ aPoint y! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 1/22/2005 23:23'!
bottomCenterY
	^self top + (self height * 0.75)! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 16:53'!
bottomLeft: aPoint
	^aPoint x @ origin y corner: corner x @ aPoint y! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 16:53'!
bottomRight: aPoint
	^origin corner: aPoint! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 1/22/2005 23:23'!
centerX
	^(self left + self right) * 0.5! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 1/22/2005 23:24'!
centerY
	^(self top + self bottom) * 0.5! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 02:04'!
cornerRectsOfSize: aPoint
	"Answer an array of rectangles making up the receiver's corner of a given size"
	(aPoint x isZero or:[aPoint y isZero]) ifTrue:[^#()].
	^Array
		with: (self topLeft extent: aPoint)
		with: (self topRight - (aPoint x @ 0) extent: aPoint)
		with: (self bottomLeft - (0 @ aPoint y) extent: aPoint)
		with: (self bottomRight - aPoint extent: aPoint).! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 7/19/2003 18:05'!
leftCenter: aPoint
	^aPoint x @ origin y corner: corner! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 1/22/2005 23:24'!
leftCenterX
	^self left + (self width * 0.25)! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 6/2/2005 17:02'!
mid
	"Answer the (unrounded) center of the receiver"
	^origin + corner * 0.5! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 7/19/2003 18:05'!
rightCenter: aPoint
	^origin corner: aPoint x @ corner y! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 1/22/2005 23:24'!
rightCenterX
	^self left + (self width * 0.75)! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'mtf 1/19/2009 12:56'!
scaledPoint: aPoint
	"Return a point scaled such that 0.0@0.0 is the origin and 1.0@1.0 is the corner"
	^origin + (aPoint * self extent) asIntegerPoint
! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 7/19/2003 18:04'!
topCenter: aPoint
	^origin x @ aPoint y corner: corner! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 1/22/2005 23:24'!
topCenterY
	^ self top + (self height * 0.25)! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 16:53'!
topLeft: aPoint
	^aPoint corner: corner! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 16:53'!
topRight: aPoint
	^origin x @ aPoint y corner: aPoint x @ corner y! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: ''!
transformedBy: aTransform
	^aTransform transformRect: self! !

!Rectangle methodsFor: '*Tweak-Costume' stamp: 'ar 5/5/2004 12:38'!
wrap: aPoint
	"Return a point wrapped around the receiver if necessary"
	^origin + (aPoint - origin \\ self extent)
! !

!ColorForm methodsFor: '*Tweak-Costume' stamp: 'bf 1/26/2006 16:04'!
isOpaque
	colors ifNil: [^super isOpaque].
	^colors allSatisfy:[:each| each isOpaque].! !

Object subclass: #CBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Borders'!

!CBorder class methodsFor: 'instance creation' stamp: 'ar 12/19/2004 13:08'!
borderStyleChoices
	"Answer the superset of all supported borderStyle symbols"
	^ #(simple inset framed raised inner outer complexAltFramed complexAltInset complexAltRaised complexFramed complexInset complexRaised)! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
borderStyleForSymbol: sym
	"Answer a border style corresponding to the given symbol"
	| aSymbol |
	aSymbol := sym == #none ifTrue: [#simple] ifFalse: [sym].
	^ self perform: aSymbol! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
color: aColor width: aNumber
	^self width: aNumber color: aColor! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
complexAltFramed
	^CComplexBorder style: #complexAltFramed! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
complexAltInset
	^CComplexBorder style: #complexAltInset! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
complexAltRaised
	^CComplexBorder style: #complexAltRaised! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
complexFramed
	^CComplexBorder style: #complexFramed! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
complexInset
	^CComplexBorder style: #complexInset! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
complexRaised
	^CComplexBorder style: #complexRaised! !

!CBorder class methodsFor: 'instance creation' stamp: 'auto 6/3/2005 15:34'!
default
	^self new! !

!CBorder class methodsFor: 'instance creation' stamp: 'ar 12/19/2004 12:41'!
framed
	^CFramedBorder new! !

!CBorder class methodsFor: 'instance creation' stamp: 'ar 12/19/2004 13:09'!
inner
	^CInnerBorder new! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
inset
	^CInsetBorder new! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
none
	^self default! !

!CBorder class methodsFor: 'instance creation' stamp: 'ar 12/19/2004 13:09'!
outer
	^COuterBorder new! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
raised
	^CRaisedBorder new! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
simple
	"Answer a simple border style"
	^ CSimpleBorder new! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
width: aNumber
	^self width: aNumber color: Color black! !

!CBorder class methodsFor: 'instance creation' stamp: ''!
width: aNumber color: aColor
	^CSimpleBorder new color: aColor; width: aNumber; yourself! !

!CBorder methodsFor: 'comparing' stamp: ''!
= aCBorder
	^self species = aCBorder species
		and:[self style == aCBorder style
		and:[self width = aCBorder width
		and:[self color = aCBorder color]]].! !

!CBorder methodsFor: 'converting' stamp: ''!
asBorder
	^self! !

!CBorder methodsFor: 'accessing' stamp: ''!
baseColor
	^Color transparent! !

!CBorder methodsFor: 'accessing' stamp: ''!
baseColor: aColor
	"Ignored"! !

!CBorder methodsFor: 'accessing' stamp: ''!
color
	^Color transparent! !

!CBorder methodsFor: 'accessing' stamp: ''!
color: aColor
	"Ignored"! !

!CBorder methodsFor: 'accessing' stamp: ''!
colorsAtCorners
	^Array new: 4 withAll: self color! !

!CBorder methodsFor: 'accessing' stamp: ''!
dotOfSize: diameter forDirection: aDirection
	| form |
	form := Form extent: diameter@diameter depth: Display depth.
	form getCanvas fillOval: form boundingBox color: self color.
	^form! !

!CBorder methodsFor: 'drawing' stamp: ''!
drawLineFrom: startPoint to: stopPoint on: aCanvas
	^aCanvas line: startPoint to: stopPoint width: self width color: self color! !

!CBorder methodsFor: 'drawing' stamp: ''!
frameOval: aRectangle on: aCanvas
	"Frame the given rectangle on aCanvas"
	aCanvas frameOval: aRectangle width: self width color: self color! !

!CBorder methodsFor: 'drawing' stamp: ''!
framePolygon: vertices on: aCanvas
	"Frame the given rectangle on aCanvas"
	self framePolyline: vertices on: aCanvas.
	self drawLineFrom: vertices last to: vertices first on: aCanvas.! !

!CBorder methodsFor: 'drawing' stamp: ''!
framePolyline: vertices on: aCanvas
	"Frame the given rectangle on aCanvas"
	| prev next |
	prev := vertices at: 1.
	2 to: vertices size do:[:i|
		next := vertices at: i.
		self drawLineFrom: prev to: next on: aCanvas.
		prev := next].! !

!CBorder methodsFor: 'drawing' stamp: ''!
frameRectangle: aRectangle on: aCanvas
	"Frame the given rectangle on aCanvas"
	aCanvas frameRectangle: aRectangle width: self width color: self color! !

!CBorder methodsFor: 'drawing' stamp: 'ar 6/8/2003 16:59'!
frameRoundRect: aRectangle radius: radius on: aCanvas
	"Frame the given rectangle on aCanvas"
	aCanvas frameRoundRect: aRectangle radius: radius width: self width color: self color! !

!CBorder methodsFor: 'comparing' stamp: ''!
hash
	"hash is implemented because #= is implemented"
	^self species hash bitXor: (self width hash bitXor: self color hash)! !

!CBorder methodsFor: 'testing' stamp: ''!
isBorderStyle
	^true! !

!CBorder methodsFor: 'testing' stamp: ''!
isComplex
	^false! !

!CBorder methodsFor: 'initialize' stamp: ''!
releaseCachedState
	"Release any associated cached state"! !

!CBorder methodsFor: 'accessing' stamp: ''!
style
	^#none! !

!CBorder methodsFor: 'color tracking' stamp: ''!
trackColorFrom: aCostume
	"If necessary, update our color to reflect a change in aCostumes color"! !

!CBorder methodsFor: 'accessing' stamp: ''!
width
	^0! !

!CBorder methodsFor: 'accessing' stamp: 'bf 3/30/2004 13:51'!
width: aNumber
	"Ignored"
	^aNumber! !

!CBorder methodsFor: 'accessing' stamp: ''!
widthForRounding
	^self width! !

CBorder subclass: #CSimpleBorder
	instanceVariableNames: 'owner baseColor color width'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Borders'!

CSimpleBorder subclass: #CComplexBorder
	instanceVariableNames: 'style colors lineStyles borderForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Borders'!

!CComplexBorder class methodsFor: 'instance creation' stamp: 'bf 3/30/2004 14:44'!
style: aSymbol
	^self new style: aSymbol; yourself! !

!CComplexBorder methodsFor: 'accessing' stamp: ''!
colors
	^colors ifNil:[colors := self computeColors].! !

!CComplexBorder methodsFor: 'accessing' stamp: ''!
colorsAtCorners
	| c c14 c23 |
	c := self color.
	(style == #complexRaised) ifTrue:[
		c14 := c lighter. c23 := c darker.
		^Array with: c14 with: c with: c23 with: c].
	(style == #complexInset) ifTrue:[
		c14 := c lighter. c23 := c darker.
		^Array with: c23 with: c with: c14 with: c].
	style == #complexAltRaised ifTrue:[
		c14 := c lighter. c23 := c darker.
		^Array with: c14 with: c with: c23 with: c].
	style == #complexAltInset ifTrue:[
		c14 := c darker. c23 := c lighter.
		^Array with: c14 with: c with: c23 with: c].
	^super colorsAtCorners! !

!CComplexBorder methodsFor: 'private' stamp: ''!
colorsForDirection: direction
	"Return an array of colors describing the receiver in the given direction"
	| colorArray dT cc |
	cc := self colors.
	(direction x * direction y) <= 0 ifTrue:[
		"within up->right or down->left transition; no color blend needed"
		(direction x > 0 or:[direction y < 0]) ifTrue:["up->right"
			colorArray := cc copyFrom: 1 to: width.
		] ifFalse:["down->left"
			"colors are stored in reverse direction when following a line"
			colorArray := (cc copyFrom: width+1 to: cc size) reversed.
		].
	] ifFalse:[
		"right->down or left->up transition; need color blend"
		colorArray := Array new: width.
		dT := direction x asFloat / (direction x + direction y).
		(direction x > 0 or:[direction y >= 0]) ifTrue:["top-right"
			1 to: width do:[:i|
				colorArray at: i put: 
					((cc at: i) mixed: dT with: (cc at: cc size - i + 1))]
		] ifFalse:["bottom-left"
			1 to: width do:[:i|
				colorArray at: i put: 
					((cc at: cc size - i + 1) mixed: dT with: (cc at: i))]
		].
	].
	^colorArray! !

!CComplexBorder methodsFor: 'private' stamp: ''!
computeAltFramedColors
	| base light dark w hw colorArray param |
	base := self color asColor.
	light := Color white.
	dark := Color black.
	w := self width isPoint ifTrue:[self width x max: self width y] ifFalse:[self width].
	w := w asInteger.
	w = 1 ifTrue:[^{base mixed: 0.5 with: light. base mixed: 0.5 with: dark}].
	colorArray := Array new: w.
	hw := w // 2.
	"brighten"
	0 to: hw-1 do:[:i|
		param := 0.5 + (i asFloat / hw * 0.5).
		colorArray at: i+1 put: (base mixed: param with: dark). "brighten"
		colorArray at: w-i put: (base mixed: param with: light). "darken"
	].
	w odd ifTrue:[colorArray at: hw+1 put: base].
	^colorArray, colorArray! !

!CComplexBorder methodsFor: 'private' stamp: ''!
computeAltInsetColors
	| base light dark w colorArray param hw |
	base := self color asColor.
	light := Color white.
	dark := Color black.
	w := self width isPoint ifTrue:[self width x max: self width y] ifFalse:[self width].
	w := w asInteger.
	colorArray := Array new: w*2.
	hw := 0.5 / w.
	0 to: w-1 do:[:i|
		false
			ifTrue:[param := 0.5 + (hw * i)]
			ifFalse:[param := 0.5 + (hw * (w-i))].
		colorArray at: i+1 put: (base mixed: param with: dark). "darken"
		colorArray at: colorArray size - i put: (base mixed: param with: light). "brighten"
	].
	^colorArray! !

!CComplexBorder methodsFor: 'private' stamp: ''!
computeAltRaisedColors
	| base light dark w colorArray param hw |
	base := self color asColor.
	light := Color white.
	dark := Color black.
	w := self width isPoint ifTrue:[self width x max: self width y] ifFalse:[self width].
	w := w asInteger.
	colorArray := Array new: w*2.
	hw := 0.5 / w.
	0 to: w-1 do:[:i|
		false 
			ifTrue:[param := 0.5 + (hw * i)]
			ifFalse:[param := 0.5 + (hw * (w-i))].
		colorArray at: i+1 put: (base mixed: param with: light). "brighten"
		colorArray at: colorArray size - i put: (base mixed: param with: dark). "darken"
	].
	^colorArray! !

!CComplexBorder methodsFor: 'private' stamp: ''!
computeColors
	width = 0 ifTrue:[^colors := #()].
	style == #complexFramed ifTrue:[^self computeFramedColors].
	style == #complexAltFramed ifTrue:[^self computeAltFramedColors].
	style == #complexRaised ifTrue:[^self computeRaisedColors].
	style == #complexAltRaised ifTrue:[^self computeAltRaisedColors].
	style == #complexInset ifTrue:[^self computeInsetColors].
	style == #complexAltInset ifTrue:[^self computeAltInsetColors].
	self error:'Unknown border style: ', style printString.! !

!CComplexBorder methodsFor: 'private' stamp: ''!
computeFramedColors
	| base light dark w hw colorArray param |
	base := self color asColor.
	light := Color white.
	dark := Color black.
	w := self width isPoint ifTrue:[self width x max: self width y] ifFalse:[self width].
	w := w asInteger.
	w = 1 ifTrue:[^{base mixed: 0.5 with: light. base mixed: 0.5 with: dark}].
	colorArray := Array new: w.
	hw := w // 2.
	"brighten"
	0 to: hw-1 do:[:i|
		param := 0.5 + (i asFloat / hw * 0.5).
		colorArray at: i+1 put: (base mixed: param with: light). "brighten"
		colorArray at: w-i put: (base mixed: param with: dark). "darken"
	].
	w odd ifTrue:[colorArray at: hw+1 put: base].
	^colorArray, colorArray! !

!CComplexBorder methodsFor: 'private' stamp: ''!
computeInsetColors
	| base light dark w colorArray param hw |
	base := self color asColor.
	light := Color white.
	dark := Color black.
	w := self width isPoint ifTrue:[self width x max: self width y] ifFalse:[self width].
	w := w asInteger.
	colorArray := Array new: w*2.
	hw := 0.5 / w.
	0 to: w-1 do:[:i|
		true
			ifTrue:[param := 0.5 + (hw * i)]
			ifFalse:[param := 0.5 + (hw * (w-i))].
		colorArray at: i+1 put: (base mixed: param with: dark). "darken"
		colorArray at: colorArray size - i put: (base mixed: param with: light). "brighten"
	].
	^colorArray! !

!CComplexBorder methodsFor: 'private' stamp: ''!
computeRaisedColors
	| base light dark w colorArray param hw |
	base := self color asColor.
	light := Color white.
	dark := Color black.
	w := self width isPoint ifTrue:[self width x max: self width y] ifFalse:[self width].
	w := w asInteger.
	colorArray := Array new: w*2.
	hw := 0.5 / w.
	0 to: w-1 do:[:i|
		true 
			ifTrue:[param := 0.5 + (hw * i)]
			ifFalse:[param := 0.5 + (hw * (w-i))].
		colorArray at: i+1 put: (base mixed: param with: light). "brighten"
		colorArray at: colorArray size - i put: (base mixed: param with: dark). "darken"
	].
	^colorArray! !

!CComplexBorder methodsFor: 'drawing' stamp: 'ar 12/7/2002 22:13'!
drawLineFrom: startPoint to: stopPoint on: aCanvas
	"Here we're using the balloon engine since this is much faster than BitBlt w/ brushes."
	| delta length dir cos sin tfm w h w1 w2 h1 h2 fill |
	width isPoint ifTrue:[w := width x. h := width y] ifFalse:[w := h := width].
	w1 := w // 2.	w2 := w - w1.
	h1 := h // 2. 	h2 := h - h1.
	"Compute the rotational transform from (0@0) -> (1@0) to startPoint -> stopPoint"
	delta := stopPoint - startPoint.	length := delta r.
	length > 1.0e-10 ifTrue:[dir := delta / length] ifFalse:[dir := 1@0].
	cos := dir dotProduct: (1@0).		sin := dir crossProduct: (1@0).
	tfm := (CMatrixTransform new) a11: cos; a12: sin; a21: sin negated; a22: cos.
	"Install the start point offset"
	tfm offset: startPoint.
	"Now get the fill style appropriate for the given direction"
	fill := self fillStyleForDirection: dir.
	"And draw..."
	aCanvas asBalloonCanvas transformBy: tfm during:[:cc|
		cc drawPolygon: { 
			(0-w1) @ (0-h1). "top left"
			(length + w2) @ (0-h1). "top right"
			(length + w2) @ (h2). "bottom right"
			(0-w1) @ (h2). "bottom left"
		} fillStyle: fill.
	].! !

!CComplexBorder methodsFor: 'drawing' stamp: 'ar 12/7/2002 22:14'!
drawPolyPatchFrom: startPoint to: stopPoint on: aCanvas usingEnds: endsArray
	| cos sin tfm fill dir fsOrigin fsDirection points x y |
	dir := (stopPoint - startPoint) normalized.
	"Compute the rotational transform from (0@0) -> (1@0) to startPoint -> stopPoint"
	cos := dir dotProduct: (1@0).
	sin := dir crossProduct: (1@0).
	"Now get the fill style appropriate for the given direction"
	fill := self fillStyleForDirection: dir.
false ifTrue:[
	"Transform the fill appropriately"
	fill := fill clone.
	"Note: Code below is inlined from tfm transformPoint:/transformDirection:"
	x := fill origin x. y := fill origin y.
	fsOrigin := ((x * cos) + (y * sin) + startPoint x) @
					((y * cos) - (x * sin) + startPoint y).
	x := fill direction x. y := fill direction y.
	fsDirection := ((x * cos) + (y * sin)) @ ((y * cos) - (x * sin)).
	fill origin: fsOrigin; 
		direction: fsDirection rounded; "NOTE: This is a bug in the balloon engine!!!!!!"
		normal: nil.
	aCanvas asBalloonCanvas drawPolygon: endsArray fillStyle: fill.
] ifFalse:[
	"Transform the points rather than the fills"
	tfm := (CMatrixTransform new) a11: cos; a12: sin; a21: sin negated; a22: cos.
	"Install the start point offset"
	tfm offset: startPoint.
	points := endsArray collect:[:pt| tfm invertPoint: pt].
	aCanvas asBalloonCanvas transformBy: tfm during:[:cc|
		cc drawPolygon: points fillStyle: fill.
	].
].! !

!CComplexBorder methodsFor: 'private' stamp: 'ar 12/7/2002 22:20'!
fillStyleForDirection: direction
	"Fill the given form describing the receiver's look at a particular direction"
	| index fill dir |
	index := direction degrees truncated // 10 + 1.
	lineStyles ifNotNil:[
		fill := lineStyles at: index.
		fill ifNotNil:[^fill].
	].
	dir := Point r: 1.0 degrees: index - 1 * 10 + 5.
	fill := CGradientFill colors: (self colorsForDirection: dir).
	fill direction: 0 @ width asPoint y; radial: false.
	fill origin: ((width asPoint x // 2) @ (width asPoint y // 2)) negated.
	fill pixelRamp: (fill computePixelRampOfSize: 16).
	fill isTranslucent. "precompute"
	lineStyles ifNil:[lineStyles := Array new: 37].
	lineStyles at: index put: fill.
	^fill! !

!CComplexBorder methodsFor: 'drawing' stamp: ''!
framePolygon2: vertices on: aCanvas
	| dir1 dir2 dir3 nrm1 nrm2 nrm3 point1 point2 point3 
	 cross1 cross2 pointA pointB pointC pointD w p1 p2 p3 p4 balloon ends |
	balloon := aCanvas asBalloonCanvas.
	balloon == aCanvas ifFalse:[balloon deferred: true].
	ends := Array new: 4.
	w := width * 0.5.
	pointA := nil.
	1 to: vertices size do:[:i|
		p1 := vertices atWrap: i.
		p2 := vertices atWrap: i+1.
		p3 := vertices atWrap: i+2.
		p4 := vertices atWrap: i+3.
		dir1 := p2 - p1.
		dir2 := p3 - p2.
		dir3 := p4 - p3.
		i = 1 ifTrue:[
			"Compute the merge points of p1->p2 with p2->p3"
			cross1 := dir2 crossProduct: dir1.
			nrm1 := dir1 normalized. nrm1 := (nrm1 y * w) @ (0 - nrm1 x * w).
			nrm2 := dir2 normalized. nrm2 := (nrm2 y * w) @ (0 - nrm2 x * w).
			cross1 < 0 ifTrue:[nrm1 := nrm1 negated. nrm2 := nrm2 negated].
			point1 := (p1 x + nrm1 x) @ (p1 y + nrm1 y).
			point2 := (p2 x + nrm2 x) @ (p2 y + nrm2 y).
			pointA := self intersectFrom: point1 with: dir1 to: point2 with: dir2.
			point1 := (p1 x - nrm1 x) @ (p1 y - nrm1 y).
			point2 := (p2 x - nrm2 x) @ (p2 y - nrm2 y).
			pointB := self intersectFrom: point1 with: dir1 to: point2 with: dir2.
			pointB ifNotNil:[
				(pointB x - p2 x) abs + (pointB y - p2 y) abs > (4*w) ifTrue:[pointA := pointB := nil].
			].
		].
		"Compute the merge points of p2->p3 with p3->p4"
		cross2 := dir3 crossProduct: dir2.
		nrm2 := dir2 normalized. nrm2 := (nrm2 y * w) @ (0 - nrm2 x * w).
		nrm3 := dir3 normalized. nrm3 := (nrm3 y * w) @ (0 - nrm3 x * w).
		cross2 < 0 ifTrue:[nrm2 := nrm2 negated. nrm3 := nrm3 negated].
		point2 := (p2 x + nrm2 x) @ (p2 y + nrm2 y).
		point3 := (p3 x + nrm3 x) @ (p3 y + nrm3 y).
		pointC := self intersectFrom: point2 with: dir2 to: point3 with: dir3.
		point2 := (p2 x - nrm2 x) @ (p2 y - nrm2 y).
		point3 := (p3 x - nrm3 x) @ (p3 y - nrm3 y).
		pointD := self intersectFrom: point2 with: dir2 to: point3 with: dir3.
		pointD ifNotNil:[
			(pointD x - p3 x) abs + (pointD y - p3 y) abs > (4*w) ifTrue:[pointC := pointD := nil].
		].
		cross1 * cross2 < 0.0 ifTrue:[
			point1 := pointA.
			pointA := pointB.
			pointB := point1.
			cross1 := 0.0 - cross1].
		ends at: 1 put: pointA; at: 2 put: pointB; at: 3 put: pointD; at: 4 put: pointC.
		pointA ifNil:["degenerate and slow"
			nrm2 := dir2 normalized. nrm2 := (nrm2 y * w) @ (0 - nrm2 x * w).
			cross1 < 0 ifTrue:[nrm2 := nrm2 negated].
			point2 := (p2 x + nrm2 x) @ (p2 y + nrm2 y).
			ends at: 1 put: point2].
		pointB ifNil:["degenerate and slow"
			nrm2 := dir2 normalized. nrm2 := (nrm2 y * w) @ (0 - nrm2 x * w).
			cross1 < 0 ifTrue:[nrm2 := nrm2 negated].
			point2 := (p2 x - nrm2 x) @ (p2 y - nrm2 y).
			ends at: 2 put: point2].
		pointC ifNil:["degenerate and slow"
			nrm2 := dir2 normalized. nrm2 := (nrm2 y * w) @ (0 - nrm2 x * w).
			cross2 < 0 ifTrue:[nrm2 := nrm2 negated].
			point2 := (p3 x + nrm2 x) @ (p3 y + nrm2 y).
			ends at: 4 put: point2].
		pointD ifNil:["degenerate and slow"
			nrm2 := dir2 normalized. nrm2 := (nrm2 y * w) @ (0 - nrm2 x * w).
			cross2 < 0 ifTrue:[nrm2 := nrm2 negated].
			point2 := (p3 x - nrm2 x) @ (p3 y - nrm2 y).
			ends at: 3 put: point2].
		self drawPolyPatchFrom: p2 to: p3 on: balloon usingEnds: ends.
		pointA := pointC.
		pointB := pointD.
		cross1 := cross2.
	].
	balloon == aCanvas ifFalse:[balloon flush].! !

!CComplexBorder methodsFor: 'drawing' stamp: ''!
framePolygon: vertices on: aCanvas
	| dir1 dir2 dir3 nrm1 nrm2 nrm3 point1 point2 point3 
	 cross1 cross2 pointA pointB pointC pointD w p1 p2 p3 p4 balloon ends pointE pointF |
	balloon := aCanvas asBalloonCanvas.
	balloon == aCanvas ifFalse:[balloon deferred: true].
	ends := Array new: 6.
	w := width * 0.5.
	pointA := nil.
	1 to: vertices size do:[:i|
		p1 := vertices atWrap: i.
		p2 := vertices atWrap: i+1.
		p3 := vertices atWrap: i+2.
		p4 := vertices atWrap: i+3.
		dir1 := p2 - p1.
		dir2 := p3 - p2.
		dir3 := p4 - p3.
		(i = 1 | true) ifTrue:[
			"Compute the merge points of p1->p2 with p2->p3"
			cross1 := dir2 crossProduct: dir1.
			nrm1 := dir1 normalized. nrm1 := (nrm1 y * w) @ (0 - nrm1 x * w).
			nrm2 := dir2 normalized. nrm2 := (nrm2 y * w) @ (0 - nrm2 x * w).
			cross1 < 0 ifTrue:[nrm1 := nrm1 negated. nrm2 := nrm2 negated].
			point1 := (p1 x + nrm1 x) @ (p1 y + nrm1 y).
			point2 := (p2 x + nrm2 x) @ (p2 y + nrm2 y).
			pointA := self intersectFrom: point1 with: dir1 to: point2 with: dir2.
			point1 := (p1 x - nrm1 x) @ (p1 y - nrm1 y).
			point2 := (p2 x - nrm2 x) @ (p2 y - nrm2 y).
			pointB := point1 + dir1 + point2 * 0.5.
			pointB := p2 + ((pointB - p2) normalized * w).
			pointC := point2.
		].
		"Compute the merge points of p2->p3 with p3->p4"
		cross2 := dir3 crossProduct: dir2.
		nrm2 := dir2 normalized. nrm2 := (nrm2 y * w) @ (0 - nrm2 x * w).
		nrm3 := dir3 normalized. nrm3 := (nrm3 y * w) @ (0 - nrm3 x * w).
		cross2 < 0 ifTrue:[nrm2 := nrm2 negated. nrm3 := nrm3 negated].
		point2 := (p2 x + nrm2 x) @ (p2 y + nrm2 y).
		point3 := (p3 x + nrm3 x) @ (p3 y + nrm3 y).
		pointD := self intersectFrom: point2 with: dir2 to: point3 with: dir3.
		point2 := (p2 x - nrm2 x) @ (p2 y - nrm2 y).
		point3 := (p3 x - nrm3 x) @ (p3 y - nrm3 y).
		pointF := point2 + dir2.
		pointE := pointF + point3 * 0.5.
		pointE := p3 + ((pointE - p3) normalized * w).
		cross1 * cross2 < 0.0 ifTrue:[
			ends
				at: 1 put: pointA;
				at: 2 put: pointB;
				at: 3 put: pointC;
				at: 4 put: pointD;
				at: 5 put: pointE;
				at: 6 put: pointF.
		] ifFalse:[
			ends 
				at: 1 put: pointA; 
				at: 2 put: pointB;
				at: 3 put: pointC; 
				at: 4 put: pointF; 
				at: 5 put: pointE;
				at: 6 put: pointD.
		].
		self drawPolyPatchFrom: p2 to: p3 on: balloon usingEnds: ends.
		pointA := pointD.
		pointB := pointE.
		pointC := pointF.
		cross1 := cross2.
	].
	balloon == aCanvas ifFalse:[balloon flush].! !

!CComplexBorder methodsFor: 'drawing' stamp: ''!
frameRectangle: aRectangle on: aCanvas
	"Note: This uses BitBlt since it's roughly a factor of two faster for rectangles"
	| w h r topLeft topRight bottomLeft rectWidth rectHeight |
	self colors ifNil:[^super frameRectangle: aRectangle on: aCanvas].
	topLeft := aRectangle topLeft.
	bottomLeft := aRectangle bottomLeft.
	topRight := aRectangle topRight.
	rectWidth := topRight x - topLeft x.
	rectHeight := bottomLeft y - topLeft y.
	w := self width.
	w isPoint ifTrue:[h := w y. w := w x] ifFalse:[h := w].
	1 to: h do:[:i| "top/bottom"
		r := (topLeft + (i-1)) extent: (rectWidth - (i-1*2))@1. "top"
		aCanvas fillRectangle: r color: (colors at: i).
		r := (bottomLeft + (i @ (0-i))) extent: (rectWidth - (i-1*2) - 1)@1. "bottom"
		aCanvas fillRectangle: r color: (colors at: colors size - i + 1).
	].
	1 to: w do:[:i| "left/right"
		r := (topLeft + (i-1)) extent: 1@(rectHeight - (i-1*2)). "left"
		aCanvas fillRectangle: r color: (colors at: i).
		r := topRight + ((0-i)@i) extent: 1@(rectHeight - (i-1*2) - 1). "right"
		aCanvas fillRectangle: r color: (colors at: colors size - i + 1).
	].! !

!CComplexBorder methodsFor: 'private' stamp: ''!
intersectFrom: startPt with: startDir to: endPt with: endDir
	"Compute the intersection of two lines. Return nil if either
		* the intersection does not exist, or
		* the intersection is 'before' startPt, or
		* the intersection is 'after' endPt
	"
	| det deltaPt alpha beta |
	det := (startDir x * endDir y) - (startDir y * endDir x).
	det = 0.0 ifTrue:[^nil]. "There's no solution for it"
	deltaPt := endPt - startPt.
	alpha := (deltaPt x * endDir y) - (deltaPt y * endDir x).
	beta := (deltaPt x * startDir y) - (deltaPt y * startDir x).
	alpha := alpha / det.
	beta := beta / det.
	alpha < 0 ifTrue:[^nil].
	beta > 1.0 ifTrue:[^nil].
	"And compute intersection"
	^(startPt x + (alpha * startDir x)) @ (startPt y + (alpha * startDir y))! !

!CComplexBorder methodsFor: 'testing' stamp: ''!
isComplex
	^true! !

!CComplexBorder methodsFor: 'initialize' stamp: ''!
releaseCachedState
	colors := nil.
	lineStyles := nil.! !

!CComplexBorder methodsFor: 'accessing' stamp: ''!
style
	^style! !

!CComplexBorder methodsFor: 'accessing' stamp: 'bf 3/30/2004 10:39'!
style: newStyle
	style == newStyle ifTrue:[^self].
	style := newStyle.
	self releaseCachedState.
	^ newStyle! !

!CComplexBorder methodsFor: 'color tracking' stamp: ''!
trackColorFrom: aCostume
	baseColor ifNil:[self color: aCostume raisedColor].! !

!CComplexBorder methodsFor: 'accessing' stamp: ''!
widthForRounding
	^0! !

CSimpleBorder subclass: #CFramedBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Borders'!

!CFramedBorder methodsFor: 'accessing' stamp: 'ar 12/19/2004 12:33'!
bottomRightColor
	^color alphaMixed: 0.5 with: Color black! !

!CFramedBorder methodsFor: 'accessing' stamp: 'ar 12/19/2004 12:41'!
colorsAtCorners
	| c c14 c23 |
	c := self color.
	c14 := c lighter. c23 := c darker.
	^Array with: c14 with: c23 with: c23 with: c14! !

!CFramedBorder methodsFor: 'drawing' stamp: 'ar 12/19/2004 12:35'!
frameRectangle: aRectangle on: aCanvas
	| cc tl br |
	cc := self color.
	tl := self topLeftColor.
	br := self bottomRightColor.
	self width < 2 ifTrue:[
		^aCanvas frameAndFillRectangle: aRectangle
			fillColor: Color transparent
			borderWidth: self width
			borderColor: cc.
	].
	self width > 2 ifTrue:[
		aCanvas frameAndFillRectangle: (aRectangle insetBy: 1)
			fillColor: Color transparent
			borderWidth: self width-2
			borderColor: cc.
	].
	aCanvas frameAndFillRectangle: aRectangle 
			fillColor: Color transparent 
			borderWidth: 1
			topLeftColor: tl
			bottomRightColor: br.

	aCanvas frameAndFillRectangle: (aRectangle insetBy: self width-1)
			fillColor: Color transparent 
			borderWidth: 1
			topLeftColor: br
			bottomRightColor: tl.
! !

!CFramedBorder methodsFor: 'accessing' stamp: 'ar 12/19/2004 12:41'!
style
	^#framed! !

!CFramedBorder methodsFor: 'accessing' stamp: 'ar 12/19/2004 12:44'!
topLeftColor
	^self color alphaMixed: 0.5 with: Color white! !

!CFramedBorder methodsFor: 'drawing' stamp: 'ar 12/19/2004 12:45'!
trackColorFrom: aCostume
	baseColor ifNil:[self color: aCostume raisedColor].! !

CSimpleBorder subclass: #CInnerBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Borders'!

!CInnerBorder methodsFor: 'all' stamp: 'ar 12/19/2004 13:08'!
frameRectangle: aRectangle on: aCanvas
	self width < 1 ifTrue:[^self].
	^aCanvas frameAndFillRectangle: (aRectangle insetBy: self width-1)
			fillColor: Color transparent
			borderWidth: 1
			borderColor: self color.! !

!CInnerBorder methodsFor: 'all' stamp: 'ar 12/19/2004 13:09'!
style
	^#inner! !

!CInnerBorder methodsFor: 'all' stamp: 'ar 12/19/2004 13:08'!
trackColorFrom: aCostume
	baseColor ifNil:[self color: aCostume raisedColor].! !

CSimpleBorder subclass: #CInsetBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Borders'!

!CInsetBorder methodsFor: 'accessing' stamp: 'bgf 2/1/2009 11:03'!
bottomRightColor
	^color alphaMixed: 0.5 with: (Color gray:0.98)! !

!CInsetBorder methodsFor: 'accessing' stamp: 'bgf 2/1/2009 10:59'!
colorsAtCorners
	| c c14 c23 |
	c := self color.
	c14 := (self bottomRightColor). 
	c23 := (self topLeftColor).
	^Array with: c23 
			with: (c alphaMixed: 0.8 with: Color gray) 
			with: c14 
			with: (c alphaMixed: 0.8 with: Color gray).! !

!CInsetBorder methodsFor: 'drawing' stamp: 'ar 12/19/2004 12:22'!
frameRectangle: aRectangle on: aCanvas
	| cc tl br |
	cc := self color.
	tl := self topLeftColor.
	br := self bottomRightColor.
	aCanvas frameAndFillRectangle: aRectangle
		fillColor: Color transparent
		borderWidth: self width-1
		borderColor: cc.
	aCanvas frameAndFillRectangle: (aRectangle insetBy: width-1)
			fillColor: Color transparent 
			borderWidth: 1
			topLeftColor: tl
			bottomRightColor: br.
! !

!CInsetBorder methodsFor: 'accessing' stamp: ''!
style
	^#inset! !

!CInsetBorder methodsFor: 'accessing' stamp: 'bgf 2/1/2009 11:03'!
topLeftColor
	^color alphaMixed: 0.6 with: Color black! !

!CInsetBorder methodsFor: 'color tracking' stamp: ''!
trackColorFrom: aCostume
	baseColor ifNil:[self color: aCostume insetColor].! !

CSimpleBorder subclass: #COuterBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Borders'!

!COuterBorder methodsFor: 'all' stamp: 'ar 12/19/2004 13:15'!
frameRectangle: aRectangle on: aCanvas
	self width < 1 ifTrue:[^self].
	^aCanvas frameAndFillRectangle: aRectangle
			fillColor: Color transparent
			borderWidth: 1
			borderColor: self color.! !

!COuterBorder methodsFor: 'all' stamp: 'ar 12/19/2004 13:09'!
style
	^#inner! !

!COuterBorder methodsFor: 'all' stamp: 'ar 12/19/2004 13:09'!
trackColorFrom: aCostume
	baseColor ifNil:[self color: aCostume raisedColor].! !

CSimpleBorder subclass: #CRaisedBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Borders'!

!CRaisedBorder methodsFor: 'accessing' stamp: 'ar 12/19/2004 12:18'!
bottomRightColor
	^color alphaMixed: 0.5 with: Color black! !

!CRaisedBorder methodsFor: 'accessing' stamp: ''!
colorsAtCorners
	| c c14 c23 |
	c := self color.
	c14 := c lighter. c23 := c darker.
	^Array with: c14 with: c23 with: c23 with: c14! !

!CRaisedBorder methodsFor: 'drawing' stamp: 'ar 12/19/2004 12:21'!
frameRectangle: aRectangle on: aCanvas
	| cc tl br |
	cc := self color.
	tl := self topLeftColor.
	br := self bottomRightColor.
	aCanvas frameAndFillRectangle: (aRectangle insetBy: 1)
		fillColor: Color transparent
		borderWidth: self width-1
		borderColor: cc.
	aCanvas frameAndFillRectangle: aRectangle 
			fillColor: Color transparent 
			borderWidth: 1
			topLeftColor: tl
			bottomRightColor: br.
! !

!CRaisedBorder methodsFor: 'accessing' stamp: ''!
style
	^#raised! !

!CRaisedBorder methodsFor: 'accessing' stamp: 'ar 12/19/2004 12:18'!
topLeftColor
	^color alphaMixed: 0.5 with: Color white! !

!CRaisedBorder methodsFor: 'color tracking' stamp: ''!
trackColorFrom: aCostume
	baseColor ifNil:[self color: aCostume raisedColor].! !

!CSimpleBorder methodsFor: 'accessing' stamp: ''!
baseColor
	^baseColor ifNil:[Color transparent]! !

!CSimpleBorder methodsFor: 'accessing' stamp: 'ar 1/8/2003 18:24'!
baseColor: aColor
	| cc |
	cc := aColor isTransparent ifTrue:[nil] ifFalse:[aColor].
	baseColor = cc ifTrue:[^self].
	baseColor := cc.
	self releaseCachedState.
	self color: cc.
	owner ifNotNil:[owner invalidate].! !

!CSimpleBorder methodsFor: 'accessing' stamp: ''!
bottomRightColor
	^self color! !

!CSimpleBorder methodsFor: 'accessing' stamp: ''!
color
	^color ifNil:[Color transparent]! !

!CSimpleBorder methodsFor: 'accessing' stamp: 'ar 1/8/2003 18:22'!
color: aColor
	color = aColor ifTrue:[^self].
	color := aColor.
	self releaseCachedState.
	owner ifNotNil:[owner invalidate].! !

!CSimpleBorder methodsFor: 'drawing' stamp: ''!
drawLineFrom: startPoint to: stopPoint on: aCanvas
	| lineColor |
	(stopPoint truncated quadrantOf: startPoint truncated) > 2
		ifTrue: [lineColor := self topLeftColor]
		ifFalse: [lineColor := self bottomRightColor].
	aCanvas line: startPoint to: stopPoint width: self width color: lineColor.! !

!CSimpleBorder methodsFor: 'drawing' stamp: ''!
frameRectangle: aRectangle on: aCanvas
	aCanvas frameAndFillRectangle: aRectangle
		fillColor: Color transparent
		borderWidth: self width
		topLeftColor: self topLeftColor
		bottomRightColor: self bottomRightColor.! !

!CSimpleBorder methodsFor: 'accessing' stamp: 'ar 1/8/2003 18:22'!
owner
	^owner! !

!CSimpleBorder methodsFor: 'accessing' stamp: 'ar 1/8/2003 18:22'!
owner: newOwner
	"associate a new owner with this texture"
	owner == newOwner ifTrue:[^self].
	owner ifNotNil:[owner border: nil].
	owner := newOwner.
	owner ifNotNil:[owner border: self].! !

!CSimpleBorder methodsFor: 'accessing' stamp: ''!
style
	^#simple! !

!CSimpleBorder methodsFor: 'accessing' stamp: ''!
topLeftColor
	^self color! !

!CSimpleBorder methodsFor: 'accessing' stamp: ''!
width
	^width! !

!CSimpleBorder methodsFor: 'accessing' stamp: 'bf 3/30/2004 10:46'!
width: aNumber
	width = aNumber ifTrue:[^self].
	owner ifNotNil:[owner invalidate].
	width := aNumber truncated max: (width isPoint ifTrue:[0@0] ifFalse:[0]).
	self releaseCachedState.
	owner ifNotNil:[owner invalidate; invalidateLayout].
	^aNumber! !

Object subclass: #CCanvasCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Support'!

CCanvasCache subclass: #CFormCache
	instanceVariableNames: 'valid form damageRecorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Support'!

!CFormCache class methodsFor: 'instance creation' stamp: 'ar 1/30/2005 11:50'!
new
	^self basicNew initialize! !

!CFormCache methodsFor: 'accessing' stamp: 'ar 1/28/2003 00:26'!
damageRecorder
	^damageRecorder! !

!CFormCache methodsFor: 'drawing' stamp: 'ar 12/14/2009 19:27'!
drawCached: aBlock on: aCanvas in: bounds
	(valid and:[form notNil and:[form extent = bounds extent and:[form depth = aCanvas depth]]])
		ifTrue:[^aCanvas translucentImage: form at: bounds origin].
	(form == nil or:[form extent ~= bounds extent or:[form depth ~= aCanvas depth]]) ifTrue:[
		form := nil.
		form := Form extent: bounds extent depth: 32.
		damageRecorder doFullRepaint.
	].
	self repairDamage: bounds using: aBlock.
	valid := true.
	aCanvas translucentImage: form at: bounds origin.! !

!CFormCache methodsFor: 'accessing' stamp: ''!
form
	^form! !

!CFormCache methodsFor: 'accessing' stamp: 'ar 1/28/2003 00:31'!
form: aForm
	form := aForm.
	damageRecorder doFullRepaint.! !

!CFormCache methodsFor: 'initialize' stamp: 'ar 1/28/2003 02:03'!
initialize
	valid := false.
	damageRecorder := CDamageRecorder new.
	damageRecorder doFullRepaint.! !

!CFormCache methodsFor: 'invalidating' stamp: 'ar 8/17/2003 19:16'!
invalidate: aRectangle
	damageRecorder invalidate: aRectangle.
	valid := false.! !

!CFormCache methodsFor: 'accessing' stamp: ''!
isValid
	^valid! !

!CFormCache methodsFor: 'accessing' stamp: ''!
isValid: aBool
	valid := aBool! !

!CFormCache methodsFor: 'initialize' stamp: ''!
release
	"Flush the cache"
	form := nil.! !

!CFormCache methodsFor: 'drawing' stamp: 'ar 1/28/2003 04:03'!
repairDamage: bounds using: drawingBlock
	| myCanvas rectList validList rectToFill |
	damageRecorder updateIsNeeded ifFalse:[^#()].
	myCanvas := CTransformCanvas on: form.
	myCanvas transformBy: (COffsetTransform withOffset: bounds origin negated).
	rectList := damageRecorder invalidRectsFullBounds: bounds.
	"sort by areas to draw largest portions first"
	rectList := rectList asArray sort:[:r1 :r2| r1 area > r2 area].
	damageRecorder reset.
	validList := OrderedCollection new: rectList size.
	rectToFill := nil.
	rectList do: [:dirtyRect |
		dirtyRect allAreasOutsideList: validList do:[:r| 
			rectToFill 
				ifNil:[rectToFill := r copy]
				ifNotNil:[rectToFill := rectToFill quickMerge: r].
			validList add: r]].
	rectToFill ifNotNil:[
		validList do:[:rect|
			myCanvas clipBy: rect during:[:cc| 
				cc fillColor: Color transparent.
				drawingBlock value: cc].
		].
	].
	myCanvas finish.
	^validList! !

!CFormCache methodsFor: 'copying' stamp: 'tk 2/18/2005 15:16'!
veryDeepInner: deepCopier
	"Must actually copy the form, because it is written into many times.  In Morphic, Forms are immutable, but not in Tweak."

| ff |
super veryDeepInner: deepCopier.
valid := valid veryDeepCopyWith: deepCopier.

form ifNotNil: [
	ff := form.
	form := form deepCopy.		"really duplicate it"
	deepCopier references at: ff put: form.
	deepCopier newGuys add: form].

damageRecorder := damageRecorder veryDeepCopyWith: deepCopier.
 ! !

Object subclass: #CClipboard
	instanceVariableNames: 'contents'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Tweak-Costume-Support'!

!CClipboard class methodsFor: 'accessing' stamp: 'yo 8/11/2003 22:43'!
clearInterpreters

	self allInstances do: [:each | each clearInterpreter].
! !

!CClipboard class methodsFor: 'accessing' stamp: 'ar 12/17/2002 15:28'!
clipboardAt: formatName
	^self default clipboardAt: formatName! !

!CClipboard class methodsFor: 'accessing' stamp: 'ar 12/17/2002 15:29'!
clipboardAt: formatName put: bytes
	^self default clipboardAt: formatName put: bytes! !

!CClipboard class methodsFor: 'accessing' stamp: 'ar 12/17/2002 15:15'!
clipboardClear
	^self default clipboardClear! !

!CClipboard class methodsFor: 'accessing' stamp: 'ar 12/17/2002 15:15'!
clipboardFormats
	^self default clipboardFormats! !

!CClipboard class methodsFor: 'accessing' stamp: 'ar 12/17/2002 15:14'!
clipboardText "Clipboard clipboardText"
	^self default clipboardText.! !

!CClipboard class methodsFor: 'accessing' stamp: ''!
clipboardText: aText				 
	^self default clipboardText: aText! !

!CClipboard class methodsFor: 'accessing' stamp: ''!
default
	^Default ifNil:[Default := self new].! !

!CClipboard class methodsFor: 'accessing' stamp: ''!
default: aClipboard
	"So that clients can switch between different default clipboards"
	Default := aClipboard.! !

!CClipboard class methodsFor: 'class initialization' stamp: 'mtf 1/4/2011 12:44'!
initialize
	"CClipboard initialize"
	Smalltalk addToStartUpList: self! !

!CClipboard class methodsFor: 'instance creation' stamp: 'ar 1/30/2005 11:49'!
new
	^self basicNew initialize.! !

!CClipboard class methodsFor: 'class initialization' stamp: 'yo 12/29/2003 01:03'!
startUp

	self clearInterpreters.
! !

!CClipboard methodsFor: 'accessing' stamp: 'yo 8/11/2003 19:07'!
clearInterpreter

	interpreter := nil.
! !

!CClipboard methodsFor: 'accessing' stamp: 'ar 6/3/2007 18:41'!
clipboardAt: formatName
	"Answer the clipboard contents for the given format name."
	| data s |
	data := self primitiveClipboardAt: formatName.
	data ifNil:[data := self contentsAt: formatName].
	formatName = 'Squeak Text' ifTrue:[
		s := Preferences usePrimitiveClipboard ifTrue: [self primitiveClipboardText] ifFalse: [''].
		s := s utf8ToSqueak.
		data ifNil:[^s].
		(s isEmpty or: [s = data asString])
			ifTrue: [^ data]
			ifFalse: [^ s asText]
	].
	^data! !

!CClipboard methodsFor: 'accessing' stamp: 'ar 6/3/2007 18:42'!
clipboardAt: formatName put: bytes
	"Set the contents of the clipboard for the specified format name"
	| encoded |
	self primitiveClipboardAt: formatName put: bytes.
	self contentsAt: formatName put: bytes.
	(formatName = 'Squeak Text' and: [Preferences usePrimitiveClipboard]) ifTrue:[
		encoded := bytes asString squeakToUtf8.
		self primitiveClipboardAt: formatName put: encoded.
		self primitiveClipboardText: encoded.
	].
! !

!CClipboard methodsFor: 'initialize' stamp: 'jcg 5/4/2007 19:01'!
clipboardClear
	contents := OrderedCollection new.
	Preferences usePrimitiveClipboard ifTrue: [
		self primitiveClipboardClear.
		self primitiveClipboardText: ''.
	]! !

!CClipboard methodsFor: 'accessing' stamp: 'ar 12/17/2002 15:35'!
clipboardFormats
	| index format |
	^Array streamContents:[:s|
		self primitiveClipboardPresent ifTrue:[
			index := 0.
			[format := self primitiveClipboardFormat: (index := index+1).
			format == nil] whileFalse:[s nextPut: format].
		] ifFalse:[
			contents do:[:assoc| s nextPut: assoc key].
		].
	].! !

!CClipboard methodsFor: 'accessing' stamp: 'edc 5/8/2007 17:04'!
clipboardText
	"Return the text currently in the clipboard. If the system clipboard is empty, or if it differs from the Smalltalk clipboard text, use the Smalltalk clipboard. This is done since (a) the Mac clipboard gives up on very large chunks of text and (b) since not all platforms support the notion of a clipboard."

	| string decodedString |
	string := self primitiveClipboardText withSqueakLineEndings.
	(string isEmpty
			or: [string = contents asString])
		ifTrue: [^ contents].
	decodedString := self interpreter fromSystemClipboard: string.
	^ decodedString = contents asString 
		ifTrue: [contents]
		ifFalse: [decodedString asText].
! !

!CClipboard methodsFor: 'accessing' stamp: 'mtf 1/4/2011 12:37'!
clipboardText: text 

	| string |
	string := text asString.
	contents := text asText.
	string := self interpreter toSystemClipboard: string.
	self primitiveClipboardText: string.
! !

!CClipboard methodsFor: 'private' stamp: 'ar 12/17/2002 15:37'!
contentsAt: format
	^(contents detect:[:any| any key = format] ifNone:[^nil]) value! !

!CClipboard methodsFor: 'private' stamp: 'ar 12/17/2002 15:37'!
contentsAt: format put: value
	contents add: format->value! !

!CClipboard methodsFor: 'initialize' stamp: 'ar 11/18/2004 19:13'!
initialize
	contents := OrderedCollection new.! !

!CClipboard methodsFor: 'accessing' stamp: 'yo 8/11/2003 18:23'!
interpreter

	interpreter ifNil: [self setInterpreter].
	^ interpreter.
! !

!CClipboard methodsFor: 'primitives' stamp: 'ar 12/17/2002 15:23'!
primitiveClipboardAt: formatName
	"Answer the contents of the OS clipboard with the given format name"
	<primitive: 'primitiveClipboardAt' module: 'ClipboardPlugin'>
	^nil! !

!CClipboard methodsFor: 'primitives' stamp: 'ar 12/17/2002 15:23'!
primitiveClipboardAt: formatName put: bytes
	"Set the contents of the OS clipboard with the given format name"
	<primitive: 'primitiveClipboardPut' module: 'ClipboardPlugin'>
	^nil! !

!CClipboard methodsFor: 'primitives' stamp: 'ar 12/17/2002 15:26'!
primitiveClipboardChanged
	"Answer whether the contents of the OS clipboard has changed.
	If supported, the primitive will answer true if the contents changed
	since the LAST TIME THIS PRIMITIVE WAS INVOKED."
	<primitive: 'primitiveClipboardChanged' module: 'ClipboardPlugin'>
	^false "if not supported assume no changes"! !

!CClipboard methodsFor: 'primitives' stamp: 'ar 12/17/2002 15:26'!
primitiveClipboardClear
	"Primitive. Clear the OS clipboard."
	<primitive: 'primitiveClipboardClear' module: 'ClipboardPlugin'>
	^nil! !

!CClipboard methodsFor: 'primitives' stamp: 'ar 12/17/2002 15:26'!
primitiveClipboardFormat: index
	"Answer a textual representation of the clipboard format with the given index 
	(starting at one)."
	<primitive: 'primitiveClipboardFormat' module: 'ClipboardPlugin'>
	^nil! !

!CClipboard methodsFor: 'primitives' stamp: 'ar 12/17/2002 15:34'!
primitiveClipboardPresent
	"Answer whether primitive support for clipboard exchange with the OS exists"
	<primitive: 'primitiveClipboardPresent' module: 'ClipboardPlugin'>
	^false! !

!CClipboard methodsFor: 'private' stamp: 'ar 7/25/2003 23:40'!
primitiveClipboardText
	"Get the current clipboard text. Return the empty string if the primitive fails."
	<primitive: 141>
	^ ''! !

!CClipboard methodsFor: 'private' stamp: 'ar 12/17/2002 15:33'!
primitiveClipboardText: aString
	"Set the current clipboard text to the given string."
	<primitive: 141>
	"don't fail if the primitive is not implemented"! !

!CClipboard methodsFor: 'accessing' stamp: 'mir 7/20/2004 15:44'!
setInterpreter

	interpreter := LanguageEnvironment defaultClipboardInterpreter.
	interpreter ifNil: [
		"Should never be reached, but just in case."
		interpreter := NoConversionClipboardInterpreter new].
! !

Object subclass: #CCornerRounder
	instanceVariableNames: 'cornerMasks cornerOverlays underBits'
	classVariableNames: 'CR0 CR1 CR2'
	poolDictionaries: ''
	category: 'Tweak-Costume-Support'!

!CCornerRounder class methodsFor: 'all' stamp: 'ar 12/8/2002 01:57'!
cornerSize
	"Return the size of a rounded corner"
	^6@6! !

!CCornerRounder class methodsFor: 'all' stamp: 'ar 12/8/2002 02:06'!
initialize  "CCornerRounder initialize"

	CR0 := CR1 := self new
		masterMask:
			(Form extent: 6@6
				fromArray: #(2r1e26 2r111e26 2r1111e26 2r11111e26 2r11111e26 2r111111e26)
				offset: 0@0)
		masterOverlay:
			(Form extent: 6@6
				fromArray: #(2r1e26 2r110e26 2r1000e26 2r10000e26 2r10000e26 2r100000e26)
				offset: 0@0).
	CR2 := self new
		masterMask:
			(Form extent: 6@6
				fromArray: #(2r1e26 2r111e26 2r1111e26 2r11111e26 2r11111e26 2r111111e26)
				offset: 0@0)
		masterOverlay:
			(Form extent: 6@6
				fromArray: #(2r1e26 2r111e26 2r1111e26 2r11100e26 2r11000e26 2r111000e26)
				offset: 0@0).

! !

!CCornerRounder class methodsFor: 'all' stamp: 'ar 12/8/2002 01:57'!
rectWithinCornersOf: aRectangle
	"Return a single sub-rectangle that lies entirely inside corners
	that are made by me.
	Used to identify large regions of window that do not need to be redrawn."
	aRectangle height >= aRectangle width
		ifTrue:[^ aRectangle insetBy: 0@6]
		ifFalse:[^ aRectangle insetBy: 6@0]
! !

!CCornerRounder class methodsFor: 'all' stamp: 'ar 12/8/2002 01:56'!
roundCornersOf: aMorph on: aCanvas in: bounds displayBlock: displayBlock borderWidth: w corners: aList

	| rounder |
	rounder := CR0.
	w = 1 ifTrue: [rounder := CR1].
	w = 2 ifTrue: [rounder := CR2].
	rounder := rounder copy.
	rounder saveBitsUnderCornersOf: aMorph on: aCanvas in: bounds corners: aList.
	displayBlock value.
	rounder tweakCornersOf: aMorph on: aCanvas in: bounds borderWidth: w corners: aList! !

!CCornerRounder methodsFor: 'all' stamp: 'ar 12/8/2002 01:56'!
masterMask: maskForm masterOverlay: overlayForm

	cornerMasks := #(none left pi right) collect:
		[:dir | (maskForm rotateBy: dir centerAt: 0@0) offset: 0@0].
	cornerOverlays := #(none left pi right) collect:
		[:dir | (overlayForm rotateBy: dir centerAt: 0@0) offset: 0@0].
! !

!CCornerRounder methodsFor: 'all' stamp: 'ar 12/8/2002 01:56'!
saveBitsUnderCornersOf: aMorph on: aCanvas in: bounds corners: cornerList

	| offset corner mask form corners rect |
	underBits := Array new: 4.
	corners := bounds corners.
	cornerList do:[:i|
		mask := cornerMasks at: i.
		corner := corners at: i.
		i = 1 ifTrue: [offset := 0@0].
		i = 2 ifTrue: [offset := 0@mask height negated].
		i = 3 ifTrue: [offset := mask extent negated].
		i = 4 ifTrue: [offset := mask width negated@0].
		rect := corner + offset extent: mask extent.
		(aCanvas isVisible: rect) ifTrue:[
			form := aCanvas contentsOfArea: rect.
			form copyBits: form boundingBox from: mask at: 0@0 clippingBox: form boundingBox rule: Form and fillColor: nil map: (Bitmap with: 16rFFFFFFFF with: 0).
			underBits at: i put: form]].
! !

!CCornerRounder methodsFor: 'all' stamp: 'bgf 2/3/2009 20:16'!
tweakCornersOf: aCostume on: aCanvas in: bounds borderWidth: w corners: cornerList
	"This variant has a cornerList argument, to allow some corners to be rounded and others not"
	| offset corner saveBits fourColors mask outBits shadowColor corners |
	shadowColor := aCanvas shadowColor.
	aCanvas shadowColor: nil. "for tweaking it's essential"
	w > 0 ifTrue:[
			fourColors := shadowColor 
				ifNil:[aCostume border colorsAtCorners]
				ifNotNil:[Array new: 4 withAll: shadowColor]].
	mask := Form extent: cornerMasks first extent depth: aCanvas depth.
	corners := bounds corners.
	cornerList do:[:i|
		corner := corners at: i.
		saveBits := underBits at: i.
		saveBits ifNotNil:[
			i = 1 ifTrue: [offset := 0@0].
			i = 2 ifTrue: [offset := 0@saveBits height negated].
			i = 3 ifTrue: [offset := saveBits extent negated].
			i = 4 ifTrue: [offset := saveBits width negated@0].

			"Mask out corner area (painting saveBits won't clear if transparent)."
			mask copyBits: mask boundingBox from: (cornerMasks at: i) at: 0@0 clippingBox: mask boundingBox rule: Form over fillColor: nil map: (Bitmap with: 0 with: 16rFFFFFFFF).
			outBits := aCanvas contentsOfArea: (corner + offset extent: mask extent).
			mask displayOn: outBits at: 0@0 rule: Form and.
			"Paint back corner bits."
			saveBits displayOn: outBits at: 0@0 rule: Form paint.
			"Paint back corner bits."
			aCanvas drawImage: outBits at: corner + offset.
			w > 0 ifTrue:[
				"Paint over with border if any.  
				 Stenciling here amplifies the translucency, so use only part of it	
		 		 (1/3 gives about optical consistency with the straight-lines of the border.)
				 But if the whole player has more translucency, must honor that."
				| a |
				a := ((fourColors at: i) alpha).
				a := (1.0 - (1.0-a/3.0)) min: (aCostume player fillAlpha).
				aCanvas stencil: (cornerOverlays at: i) at: corner + offset
						 color: ((fourColors at: i) alpha: a)]
		]].
	aCanvas shadowColor: shadowColor. "restore shadow color"
! !

Object subclass: #CDamageRecorder
	instanceVariableNames: 'invalidRects totalRepaint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Support'!

!CDamageRecorder class methodsFor: 'instance creation' stamp: 'ar 1/30/2005 11:49'!
new
	^self basicNew reset! !

!CDamageRecorder methodsFor: 'recording' stamp: 'ar 8/17/2003 19:10'!
areaMerged: rect1 with: rect2
	"very much unoptimized"
	^(rect1 merge: rect2) area
	! !

!CDamageRecorder methodsFor: 'recording' stamp: ''!
doFullRepaint
	"Record that a full redisplay is needed. No further damage rectangles will be recorded until after the next reset."
	^ totalRepaint := true.! !

!CDamageRecorder methodsFor: 'testing' stamp: ''!
hasDamageInRect: aRectangle
	"Answer if there is any pending damage in the rectangle"
	totalRepaint ifTrue:[^true]. "oh yes"
	1 to: invalidRects size do:[:i|
		((invalidRects at: i) intersects: aRectangle) ifTrue:[^true].
	].
	^false! !

!CDamageRecorder methodsFor: 'recording' stamp: ''!
invalidRectsFullBounds: aRectangle
	"Return a collection of damaged rectangles for the given canvas. If a total repaint has been requested, return the given rectangle."
	totalRepaint
		ifTrue: [^ Array with: aRectangle]
		ifFalse: [^ invalidRects copy].! !

!CDamageRecorder methodsFor: 'recording' stamp: ''!
invalidate
	"Record that a full redisplay is needed. No further damage rectangles will be recorded until after the next reset."
	^ totalRepaint := true.! !

!CDamageRecorder methodsFor: 'recording' stamp: 'ar 8/17/2003 20:01'!
invalidate: newRect
	"Record the given rectangle in my damage list, a list of rectangular areas of the display that should be redraw on the next display cycle."
	"Details: Damaged rectangles are often identical or overlap significantly. In these cases, we merge them to reduce the number of damage rectangles that must be processed when the display is updated. Moreover, above a certain threshold, we ignore the individual rectangles completely, and simply do a complete repaint on the next cycle."
	| mergeRect a |
true ifTrue:[^self recordInvalidRect2: newRect].
	totalRepaint ifTrue: [^ self].  "planning full repaint; don't bother collecting damage"
	invalidRects do:
		[:rect |
		((a := (rect intersect: newRect) area) > 40
			and: ["Avoid combining a vertical and horizontal rects.
				  Can make a big diff and we only test when likely."
				  a > (newRect area // 4) or: [a > (rect area // 4)]])
			ifTrue:
			["merge rectangle in place (see note below) if there is significant overlap"
			rect setOrigin: (rect origin min: newRect origin) truncated
				corner: (rect corner max: newRect corner) truncated.
			^ self]].
	invalidRects size >= 15 ifTrue:
		["if there are too many separate areas, merge them all"
		mergeRect := Rectangle merging: invalidRects.
		self reset.
		invalidRects addLast: mergeRect].
	"add the given rectangle to the damage list"
	"Note: We make a deep copy of all rectangles added to the damage list,
		since rectangles in this list may be extended in place."
	invalidRects addLast:
		(newRect topLeft truncated corner: newRect bottomRight truncated).! !

!CDamageRecorder methodsFor: 'recording' stamp: 'ar 8/17/2003 19:10'!
recordInvalidRect2: aRectangle
	"Record the given rectangle in my damage list, a list of rectangular areas of the display that should be redraw on the next display cycle."
	"Details: Damaged rectangles are often identical or overlap significantly. In these cases, we merge them to reduce the number of damage rectangles that must be processed when the display is updated."

	| rectToMerge matchIndex acceptingRect |
	totalRepaint ifTrue: [^ self].  "planning full repaint; don't bother collecting damage"
	"if the new rectangle is contained by any existing damage, ignore it"
	invalidRects do: [:rect |
		(rect containsRect: aRectangle) ifTrue: [^self]].

	"Add the new rectangle as new damage if there is no existing damage that it would profitable to merge it with. Note the arbitrary parameter (10000) which should model the overhead of starting another rectangle and of maintaining this rectangle until drawing time. If an old rectangle swallows the new one and is thus changed, remove it and try to merge it with the other oldies."
	rectToMerge := aRectangle.
	[matchIndex := invalidRects findFirst: [:r | (self areaMerged: r with: rectToMerge) <= (r area + rectToMerge area + 10000)].
	(matchIndex = 0)] whileFalse: [acceptingRect := (invalidRects at: matchIndex).
			acceptingRect setOrigin: (acceptingRect origin min: rectToMerge origin) truncated
				corner: (acceptingRect corner max: rectToMerge corner) truncated.
			invalidRects removeAt: matchIndex.
			rectToMerge := acceptingRect.].
	
	"Eventually some rectangle will not want to match with any other remaining damage (this may be because it's now empty). Add it (back?) to the list."
	"Note: We make a deep copy of all rectangles added to the damage list,
	 since rectangles in this list may be extended in place."
	invalidRects addLast: (rectToMerge topLeft truncated corner: rectToMerge bottomRight truncated).

! !

!CDamageRecorder methodsFor: 'recording' stamp: 'ar 8/17/2003 19:55'!
recordInvalidRect: aRectangle
	"Record the given rectangle in my damage list, a list of rectangular areas of the display that should be redraw on the next display cycle."
	"Details: Damaged rectangles are often identical or overlap significantly. In these cases, we merge them to reduce the number of damage rectangles that must be processed when the display is updated. Moreover, above a certain threshold, we ignore the individual rectangles completely, and simply do a complete repaint on the next cycle."
	| mergeRect a newRect |
	totalRepaint ifTrue: [^ self].  "planning full repaint; don't bother collecting damage"
	newRect := aRectangle origin truncated corner: aRectangle corner ceiling.
	invalidRects do:[:rect |
		((a := (rect intersect: newRect) area) > 400
			and: ["Avoid combining a vertical and horizontal rects.
				  Can make a big diff and we only test when likely."
				  a > (newRect area // 4) or: [a > (rect area // 4)]])
			ifTrue:
			["merge rectangle in place (see note below) if there is significant overlap"
			rect setOrigin: (rect origin min: newRect origin)
				corner: (rect corner max: newRect corner).
			^ self]].
true ifTrue:[
	invalidRects size >= 100 ifTrue:
		["if there are too many separate areas, merge them all"
		mergeRect := Rectangle merging: invalidRects.
		self reset.
		invalidRects addLast: mergeRect].
].
	"add the given rectangle to the damage list"
	"Note: We make a deep copy of all rectangles added to the damage list,
		since rectangles in this list may be extended in place."
	invalidRects addLast:
		(newRect topLeft corner: newRect bottomRight).! !

!CDamageRecorder methodsFor: 'initialization' stamp: ''!
reset
	"Clear the damage list."
	invalidRects := OrderedCollection new: 15.
	totalRepaint := false! !

!CDamageRecorder methodsFor: 'testing' stamp: ''!
updateIsNeeded
	"Return true if the display needs to be updated."
	^ totalRepaint or: [invalidRects size > 0]! !

Object subclass: #CDisplayTransform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Transforms'!

!CDisplayTransform commentStamp: 'ar 3/27/2004 17:58' prior: 0!
This class represents a base for generic transformations of 2D points between different coordinate systems (including scaling and rotation). The transformations map objects between one coordinate system and another where it is assumed that a nested hierarchy of transformations can be defined.

It is assumed that transformations deal with Integer points. All transformations should return Integer coordinates (even though float points may be passed in as argument).

Compositions of transformations MUST work in the following order. A 'global' transformation (the argument in #composedWithGlobal:) is defined as a transformation that takes place between the receiver (the 'local') transformation and any 'global' point computations, whereas a 'local' transformation (e.g., the argument in #composedWithLocal:) takes place between the receiver ('global') and any 'local' points. For the transformation methods this means that combining a global and a local transformation will result in the following order:

		globalPointToLocal: globalPoint
			"globalPoint -> globalTransform -> localTransform -> locaPoint"
			^localTransform globalPointToLocal:
				(globalTransform globalPointToLocal: globalPoint)

		localPointToGlobal: localPoint
			"localPoint -> localTransform -> globalTransform -> globalPoint"
			^globalTransform localPointToGlobal:
				(localTransform localPointToGlobal: localPoint)

!

!CDisplayTransform class methodsFor: 'islands' stamp: 'ar 5/28/2005 23:19'!
howToPassAsArgument
	^#passByClone:! !

!CDisplayTransform class methodsFor: 'instance creation' stamp: ''!
identity
	^self new setIdentity! !

!CDisplayTransform methodsFor: 'converting' stamp: ''!
asMatrixTransform2x3
	"Represent the receiver as a 2x3 matrix transformation"
	^self subclassResponsibility! !

!CDisplayTransform methodsFor: 'composing' stamp: ''!
composedWithGlobal: aTransformation
	"Return the composition of the receiver and the global transformation passed in.
	A 'global' transformation is defined as a transformation that takes place
	between the receiver (the 'local') transformation and any 'global' point
	computations, e.g., for the methods
		globalPointToLocal: globalPoint
			globalPoint -> globalTransform -> localTransform -> locaPoint
		localPointToGlobal: localPoint
			localPoint -> localTransform -> globalTransform -> globalPoint
		"
	^aTransformation composedWithLocal: self! !

!CDisplayTransform methodsFor: 'composing' stamp: ''!
composedWithLocal: aTransformation
	"Return the composition of the receiver and the local transformation passed in.
	A 'local' transformation is defined as a transformation that takes place
	between the receiver (the 'global') transformation and any 'local' point
	computations, e.g., for the methods
		globalPointToLocal: globalPoint
			globalPoint -> globalTransform -> localTransform -> locaPoint
		localPointToGlobal: localPoint
			localPoint -> localTransform -> globalTransform -> globalPoint
		"
	self isIdentity ifTrue:[^ aTransformation].
	aTransformation isIdentity ifTrue:[^ self].
	^self asMatrixTransform2x3 composedWithLocal: aTransformation asMatrixTransform2x3! !

!CDisplayTransform methodsFor: 'transforming rects' stamp: ''!
globalBoundsToLocal: aRectangle
	"Transform aRectangle from global coordinates into local coordinates"
	^Rectangle encompassing: (self globalPointsToLocal: aRectangle corners)! !

!CDisplayTransform methodsFor: 'transforming points' stamp: ''!
globalPointToLocal: aPoint
	"Transform aPoint from global coordinates into local coordinates"
	^self subclassResponsibility! !

!CDisplayTransform methodsFor: 'transforming points' stamp: ''!
globalPointsToLocal: inArray
	"Transform all the points of inArray from global into local coordinates"
	^inArray collect:[:pt| self globalPointToLocal: pt]! !

!CDisplayTransform methodsFor: 'accessing' stamp: ''!
inverseTransformation
	"Return the inverse transformation of the receiver"
	^self subclassResponsibility! !

!CDisplayTransform methodsFor: 'transforming points' stamp: ''!
invertBoundsRect: aRectangle
	"Return a rectangle whose coordinates have been transformed
	from local back to global coordinates."
	^self subclassResponsibility! !

!CDisplayTransform methodsFor: 'transforming' stamp: ''!
invertPoint: aPoint
	^self globalPointToLocal: aPoint! !

!CDisplayTransform methodsFor: 'transforming' stamp: ''!
invertRect: aRectangle
	^self globalBoundsToLocal: aRectangle! !

!CDisplayTransform methodsFor: 'testing' stamp: ''!
isIdentity
	"Return true if the receiver is the identity transform; that is, if applying to a point returns the point itself."
	^self subclassResponsibility! !

!CDisplayTransform methodsFor: 'testing' stamp: ''!
isMatrixTransform2x3
	"Return true if the receiver is 2x3 matrix transformation"
	^false! !

!CDisplayTransform methodsFor: 'testing' stamp: ''!
isNoRotationWithin: bounds
	"Return true if the receiver has no rotation within the given bounds"
	| p0 p1 p2 |
	p0 := self localPointToGlobal: bounds topLeft.
	p1 := self localPointToGlobal: bounds topRight.
	p0 y truncated = p1 y truncated ifFalse:[^false].
	p0 x <= p1 x ifFalse:[^false].
	p2 := self localPointToGlobal: bounds bottomLeft.
	p0 x truncated = p2 x truncated ifFalse:[^false].
	p0 y <= p1 y ifFalse:[^false].
	^true! !

!CDisplayTransform methodsFor: 'testing' stamp: 'ar 4/18/2005 20:08'!
isNoTransformWithin: aRectangle
	"Return true if the receiver represents no transformation within the given bounding rectangle. This method basically determines if the receiver should be seen as a pure translation for the purposes of drawing in the given rectangle."
	^true "only implementor is CMatrixTransform"! !

!CDisplayTransform methodsFor: 'testing' stamp: ''!
isPureTranslation
	"Return true if the receiver specifies no rotation or scaling."
	^self subclassResponsibility! !

!CDisplayTransform methodsFor: 'transforming rects' stamp: ''!
localBoundsToGlobal: aRectangle
	"Transform aRectangle from local coordinates into global coordinates"
	^Rectangle encompassing: (self localPointsToGlobal: aRectangle corners)! !

!CDisplayTransform methodsFor: 'transforming points' stamp: ''!
localPointToGlobal: aPoint
	"Transform aPoint from local coordinates into global coordinates"
	^self subclassResponsibility! !

!CDisplayTransform methodsFor: 'transforming points' stamp: ''!
localPointsToGlobal: inArray
	"Transform all the points of inArray from local into global coordinates"
	^inArray collect:[:pt| self localPointToGlobal: pt]! !

!CDisplayTransform methodsFor: 'initialize' stamp: ''!
setIdentity
	"Initialize the receiver to the identity transformation (e.g., not affecting points)"
	^self subclassResponsibility! !

!CDisplayTransform methodsFor: 'transforming rects' stamp: ''!
sourceQuadFor: aRectangle
	^ aRectangle innerCorners collect: 
		[:p | self globalPointToLocal: p]! !

!CDisplayTransform methodsFor: 'transforming' stamp: ''!
transformPoint: aPoint
	^self localPointToGlobal: aPoint! !

!CDisplayTransform methodsFor: 'transforming' stamp: ''!
transformRect: aRectangle
	^self localBoundsToGlobal: aRectangle! !

!CDisplayTransform methodsFor: 'transforming' stamp: ''!
transformedBy: aTransform
	^self composedWithGlobal: aTransform! !

!CDisplayTransform methodsFor: 'accessing' stamp: 'ar 6/9/2003 00:07'!
warpCellSize
	^1! !

CDisplayTransform subclass: #CIdentityTransform
	instanceVariableNames: ''
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Tweak-Costume-Transforms'!

!CIdentityTransform commentStamp: 'ar 3/27/2004 17:59' prior: 0!
I am the identity transform. And because I am I can do a whole lot of optimizations.!

!CIdentityTransform class methodsFor: 'class initialization' stamp: ''!
initialize
	"CIdentityTransform initialize"
	Default := self basicNew.! !

!CIdentityTransform class methodsFor: 'instance creation' stamp: ''!
new
	"There can be only one"
	^Default! !

!CIdentityTransform methodsFor: 'accessing' stamp: ''!
angle
	^ 0.0! !

!CIdentityTransform methodsFor: 'converting' stamp: ''!
asMatrixTransform2x3
	"Represent the receiver as a 2x3 matrix transformation"
	^CMatrixTransform identity! !

!CIdentityTransform methodsFor: 'composing' stamp: ''!
composedWith: aTransform
	^aTransform! !

!CIdentityTransform methodsFor: 'composing' stamp: ''!
composedWithGlobal: aTransformation
	^aTransformation! !

!CIdentityTransform methodsFor: 'composing' stamp: ''!
composedWithLocal: aTransformation
	^aTransformation! !

!CIdentityTransform methodsFor: 'transforming rects' stamp: ''!
globalBoundsToLocal: aRectangle
	"Transform aRectangle from global coordinates into local coordinates"
	^aRectangle! !

!CIdentityTransform methodsFor: 'transforming points' stamp: ''!
globalPointToLocal: aPoint
	"Transform aPoint from global coordinates into local coordinates"
	^aPoint! !

!CIdentityTransform methodsFor: 'transforming points' stamp: ''!
globalPointsToLocal: inArray
	"Transform all the points of inArray from global into local coordinates"
	^inArray! !

!CIdentityTransform methodsFor: 'accessing' stamp: ''!
inverseTransformation
	"Return the inverse transformation of the receiver"
	^self! !

!CIdentityTransform methodsFor: 'transforming points' stamp: ''!
invertBoundsRect: aRectangle
	"Return a rectangle whose coordinates have been transformed
	from local back to global coordinates. Since I am the identity matrix
	no transformation is made."
	^aRectangle! !

!CIdentityTransform methodsFor: 'transforming points' stamp: 'ar 6/26/2005 14:07'!
invertDirection: aPoint
	^aPoint
! !

!CIdentityTransform methodsFor: 'testing' stamp: ''!
isIdentity
	"Return true if the receiver is the identity transform; that is, if applying to a point returns the point itself."
	^true! !

!CIdentityTransform methodsFor: 'testing' stamp: ''!
isPureTranslation
	"Return true if the receiver specifies no rotation or scaling."
	^true! !

!CIdentityTransform methodsFor: 'transforming rects' stamp: ''!
localBoundsToGlobal: aRectangle
	"Transform aRectangle from local coordinates into global coordinates"
	^aRectangle! !

!CIdentityTransform methodsFor: 'transforming points' stamp: ''!
localPointToGlobal: aPoint
	"Transform aPoint from local coordinates into global coordinates"
	^aPoint! !

!CIdentityTransform methodsFor: 'transforming points' stamp: ''!
localPointsToGlobal: inArray
	"Transform all the points of inArray from local into global coordinates"
	^inArray! !

!CIdentityTransform methodsFor: 'accessing' stamp: ''!
offset
	^0@0! !

!CIdentityTransform methodsFor: 'initialize' stamp: ''!
setIdentity
	"I *am* the identity transform"
	^self! !

!CIdentityTransform methodsFor: 'transforming rects' stamp: ''!
sourceQuadFor: aRectangle
	^ aRectangle innerCorners! !

!CIdentityTransform methodsFor: 'transforming points' stamp: 'ar 4/19/2005 00:15'!
transformDirection: aPoint
	^aPoint
! !

CDisplayTransform variableWordSubclass: #CMatrixTransform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Transforms'!

!CMatrixTransform commentStamp: 'ar 3/27/2004 17:59' prior: 0!
This class represents a transformation for points, that is a combination of scale, offset, and rotation. It is implemented as a 2x3 matrix containing the transformation from the local coordinate system in the global coordinate system. Thus, transforming points from local to global coordinates is fast and cheap whereas transformations from global to local coordinate systems are relatively expensive.

Implementation Note: It is assumed that the transformation deals with Integer points. All transformations will return Integer coordinates (even though float points may be passed in here).!

!CMatrixTransform class methodsFor: 'instance creation' stamp: ''!
fromRemoteCanvasEncoding: encoded
	"CDisplayTransform fromRemoteCanvasEncoding:  'Matrix,1065353216,0,1137541120,0,1065353216,1131610112,'"
	| nums transform encodedNums |
	"split the numbers up"
	encodedNums := encoded findTokens: ','.
	"remove the initial 'Matrix' specification"
	encodedNums := encodedNums asOrderedCollection.
	encodedNums removeFirst.
	"parse the numbers"
	nums := encodedNums collect: [ :enum |
		Integer readFromString: enum ].
	"create an instance"
	transform := self new.
	"plug in the numbers"
	nums doWithIndex: [ :num :i |
		transform basicAt: i put: num ].
	^transform! !

!CMatrixTransform class methodsFor: 'instance creation' stamp: ''!
identity
	^self new setScale: 1.0! !

!CMatrixTransform class methodsFor: 'class initialization' stamp: 'bf 9/14/2004 15:03'!
initialize
	"register myself with DataStream"

	DataStream initialize! !

!CMatrixTransform class methodsFor: 'instance creation' stamp: ''!
localRect: localBounds toGlobal: globalBounds
	^self transformFromLocal: localBounds toGlobal: globalBounds! !

!CMatrixTransform class methodsFor: 'instance creation' stamp: ''!
new
	^self new: 6! !

!CMatrixTransform class methodsFor: 'instance creation' stamp: ''!
newFromStream: s
	"Only meant for my subclasses that are raw bits and word-like.  For quick unpack form the disk."
	self isPointers | self isWords not ifTrue: [^ super newFromStream: s].
		"super may cause an error, but will not be called."
	^ s nextWordsInto: (self new: 6)! !

!CMatrixTransform class methodsFor: 'instance creation' stamp: 'ar 6/2/2005 17:02'!
transformFromLocal: localBounds toGlobal: globalBounds
	^((self withOffset: (globalBounds mid)) composedWithLocal:
		(self withScale: (globalBounds extent / localBounds extent) asFloatPoint))
			composedWithLocal: (self withOffset: localBounds mid negated)
"
	^(self identity)
		setScale: (globalBounds extent / localBounds extent) asFloatPoint;
		setOffset: localBounds mid negated asFloatPoint;
		composedWithGlobal:(self withOffset: globalBounds mid asFloatPoint)
"! !

!CMatrixTransform class methodsFor: 'instance creation' stamp: ''!
withAngle: angle
	^self new setAngle: angle! !

!CMatrixTransform class methodsFor: 'instance creation' stamp: ''!
withOffset: aPoint
	^self identity setOffset: aPoint! !

!CMatrixTransform class methodsFor: 'instance creation' stamp: ''!
withRotation: angle
	^self new setAngle: angle! !

!CMatrixTransform class methodsFor: 'instance creation' stamp: ''!
withScale: aPoint
	^self new setScale: aPoint! !

!CMatrixTransform methodsFor: 'comparing' stamp: ''!
= aMatrixTransform2x3	 
	| length |
	<primitive: 'primitiveEqual' module: 'FloatArrayPlugin'>
	self class = aMatrixTransform2x3 class ifFalse: [^ false].
	length := self size.
	length = aMatrixTransform2x3 size ifFalse: [^ false].
	1 to: self size do: [:i | (self at: i)
			= (aMatrixTransform2x3 at: i) ifFalse: [^ false]].
	^ true! !

!CMatrixTransform methodsFor: 'element access' stamp: ''!
a11
	^self at: 1! !

!CMatrixTransform methodsFor: 'element access' stamp: ''!
a11: value
	 self at: 1 put: value! !

!CMatrixTransform methodsFor: 'element access' stamp: ''!
a12
	^self at: 2! !

!CMatrixTransform methodsFor: 'element access' stamp: ''!
a12: value
	 self at: 2 put: value! !

!CMatrixTransform methodsFor: 'element access' stamp: ''!
a13
	^self at: 3! !

!CMatrixTransform methodsFor: 'element access' stamp: ''!
a13: value
	 self at: 3 put: value! !

!CMatrixTransform methodsFor: 'element access' stamp: ''!
a21
	 ^self at: 4! !

!CMatrixTransform methodsFor: 'element access' stamp: ''!
a21: value
	 self at: 4 put: value! !

!CMatrixTransform methodsFor: 'element access' stamp: ''!
a22
	 ^self at: 5! !

!CMatrixTransform methodsFor: 'element access' stamp: ''!
a22: value
	 self at: 5 put: value! !

!CMatrixTransform methodsFor: 'element access' stamp: ''!
a23
	 ^self at: 6! !

!CMatrixTransform methodsFor: 'element access' stamp: ''!
a23: value
	 self at: 6 put: value! !

!CMatrixTransform methodsFor: 'converting' stamp: ''!
asMatrixTransform2x3
	^self! !

!CMatrixTransform methodsFor: 'accessing' stamp: ''!
at: index
	<primitive: 'primitiveAt' module: 'FloatArrayPlugin'>
	^Float fromIEEE32Bit: (self basicAt: index)! !

!CMatrixTransform methodsFor: 'accessing' stamp: ''!
at: index put: value
	<primitive: 'primitiveAtPut' module: 'FloatArrayPlugin'>
	value isFloat 
		ifTrue:[self basicAt: index put: value asIEEE32BitWord]
		ifFalse:[self at: index put: value asFloat].
	^value! !

!CMatrixTransform methodsFor: 'composing' stamp: ''!
composedWithLocal: aTransformation
	"Return the composition of the receiver and the local transformation passed in"
	^self composedWithLocal: aTransformation asMatrixTransform2x3 into: self class new! !

!CMatrixTransform methodsFor: 'composing' stamp: ''!
composedWithLocal: aTransformation into: result
	"Return the composition of the receiver and the local transformation passed in.
	Store the composed matrix into result."
	| a11 a12 a13 a21 a22 a23 b11 b12 b13 b21 b22 b23 matrix |
	<primitive: 'primitiveComposeMatrix' module: 'Matrix2x3Plugin'>
	matrix := aTransformation asMatrixTransform2x3.
	a11 := self a11.		b11 := matrix a11.
	a12 := self a12.		b12 := matrix a12.
	a13 := self a13.		b13 := matrix a13.
	a21 := self a21.		b21 := matrix a21.
	a22 := self a22.		b22 := matrix a22.
	a23 := self a23.		b23 := matrix a23.
	result a11: (a11 * b11) + (a12 * b21).
	result a12: (a11 * b12) + (a12 * b22).
	result a13: a13 + (a11 * b13) + (a12 * b23).
	result a21: (a21 * b11) + (a22 * b21).
	result a22: (a21 * b12) + (a22 * b22).
	result a23: a23 + (a21 * b13) + (a22 * b23).
	^result! !

!CMatrixTransform methodsFor: 'encoding' stamp: ''!
encodeForRemoteCanvas
	"encode this transform into a string for use by a RemoteCanvas"
	^String streamContents: [ :str |
		str nextPutAll: 'Matrix,'.
		1 to: 6 do: [ :i |
			str print: (self basicAt: i).
			str nextPut: $, ].
	]! !

!CMatrixTransform methodsFor: 'printing' stamp: ''!
encodePostscriptOn: aStream
	aStream writeMatrix:self.! !

!CMatrixTransform methodsFor: 'transforming rects' stamp: ''!
globalBounds: srcRect toLocal: dstRect
	"Transform aRectangle from global coordinates into local coordinates"
	<primitive: 'primitiveInvertRectInto' module: 'Matrix2x3Plugin'>
	^super globalBoundsToLocal: srcRect! !

!CMatrixTransform methodsFor: 'transforming rects' stamp: ''!
globalBoundsToLocal: aRectangle
	"Transform aRectangle from global coordinates into local coordinates"
	^self globalBounds: aRectangle toLocal: Rectangle new! !

!CMatrixTransform methodsFor: 'transforming points' stamp: ''!
globalPointToLocal: aPoint
	"Transform aPoint from global coordinates into local coordinates"
	<primitive: 'primitiveInvertPoint' module: 'Matrix2x3Plugin'>
	^(self invertPoint: aPoint) rounded! !

!CMatrixTransform methodsFor: 'comparing' stamp: ''!
hash
	| result |
	<primitive: 'primitiveHashArray' module: 'FloatArrayPlugin'>
	result := 0.
	1 to: self size do:[:i| result := result + (self basicAt: i) ].
	^result bitAnd: 16r1FFFFFFF! !

!CMatrixTransform methodsFor: 'accessing' stamp: ''!
inverseTransformation
	"Return the inverse transformation of the receiver.
	The inverse transformation is computed by first calculating
	the inverse offset and then computing transformations
	for the two identity vectors (1@0) and (0@1)"
	| r1 r2 r3 m |
	r3 := self invertPoint: 0@0.
	r1 := (self invertPoint: 1@0) - r3.
	r2 := (self invertPoint: 0@1) - r3.
	m := self species new.
	m
		a11: r1 x; a12: r2 x; a13: r3 x;
		a21: r1 y; a22: r2 y; a23: r3 y.
	^m! !

!CMatrixTransform methodsFor: 'transforming points' stamp: 'ar 6/26/2005 14:08'!
invertDirection: aPoint
	"Transform aPoint from global coordinates into local coordinates"
	| x y a11 a12 a21 a22 det detX detY |
	x := aPoint x asFloat.
	y := aPoint y asFloat.
	a11 := self a11.	a12 := self a12.
	a21 := self a21.	a22 := self a22.
	det := (a11 * a22) - (a12 * a21).
	det = 0.0 ifTrue:[^0@0]. "So we have at least a valid result"
	det := 1.0 / det.
	detX := (x * a22) - (a12 * y).
	detY := (a11 * y) - (x * a21).
	^(detX * det) @ (detY * det)! !

!CMatrixTransform methodsFor: 'transforming points' stamp: ''!
invertPoint: aPoint
	"Transform aPoint from global coordinates into local coordinates"
	| x y det a11 a12 a21 a22 detX detY |
	x := aPoint x asFloat - (self a13).
	y := aPoint y asFloat - (self a23).
	a11 := self a11.	a12 := self a12.
	a21 := self a21.	a22 := self a22.
	det := (a11 * a22) - (a12 * a21).
	det = 0.0 ifTrue:[^0@0]. "So we have at least a valid result"
	det := 1.0 / det.
	detX := (x * a22) - (a12 * y).
	detY := (a11 * y) - (x * a21).
	^(detX * det) @ (detY * det)! !

!CMatrixTransform methodsFor: 'testing' stamp: ''!
isIdentity
	"Return true if the receiver is the identity transform; that is, if applying to a point returns the point itself."
	<primitive: 'primitiveIsIdentity' module: 'Matrix2x3Plugin'>
	^self isPureTranslation and:[self a13 = 0.0 and:[self a23 = 0.0]]! !

!CMatrixTransform methodsFor: 'testing' stamp: ''!
isMatrixTransform2x3
	"Return true if the receiver is 2x3 matrix transformation"
	^true! !

!CMatrixTransform methodsFor: 'testing' stamp: 'ar 4/18/2005 20:08'!
isNoTransformWithin: aRectangle
	"Return true if the receiver represents no transformation within the given bounding rectangle. This method basically determines if the receiver should be seen as a pure translation for the purposes of drawing in the given rectangle."
	| dy py dx px |
	"Right and down vectors straight from matrix:
		vRight := self a11 @ self a21.
		vDown := self a12 @ self a22.
	See if vRight gets into another pixel if scaled by width"
	dy := self a21 * aRectangle width.
	py := self a23 + aRectangle left.
	py truncated = (py + dy) truncated ifFalse:[^false].
	"And the same for the down vector"
	dx := self a21 * aRectangle height.
	px := self a23 + aRectangle top.
	px truncated = (px + dx) truncated ifFalse:[^false].
	^true
! !

!CMatrixTransform methodsFor: 'testing' stamp: 'bf 7/22/2005 15:37'!
isPureTranslation
	"Return true if the receiver specifies no rotation or scaling."
	<primitive: 'primitiveIsPureTranslation' module: 'Matrix2x3Plugin'>
	^self a11 = 1.0 and:[self a12 = 0.0 and:[self a21 = 0.0 and:[self a22 = 1.0]]]! !

!CMatrixTransform methodsFor: 'transforming rects' stamp: 'ar 6/22/2003 20:07'!
localBounds: srcRect toGlobal: dstRect
	"Transform aRectangle from local coordinates into global coordinates"
	"<primitive: 'primitiveTransformRectInto' module: 'Matrix2x3Plugin'>"
	^super localBoundsToGlobal: srcRect! !

!CMatrixTransform methodsFor: 'transforming rects' stamp: ''!
localBoundsToGlobal: aRectangle
	"Transform aRectangle from local coordinates into global coordinates"
	^self localBounds: aRectangle toGlobal: Rectangle new! !

!CMatrixTransform methodsFor: 'transforming points' stamp: 'ar 2/7/2005 00:16'!
localPointToGlobal: aPoint
	"Transform aPoint from local coordinates into global coordinates"
	"<primitive: 'primitiveTransformPoint' module: 'Matrix2x3Plugin'>"
	^(self transformPoint: aPoint) rounded! !

!CMatrixTransform methodsFor: 'accessing' stamp: ''!
offset
	^self a13 @ self a23! !

!CMatrixTransform methodsFor: 'accessing' stamp: ''!
offset: aPoint
	self a13: aPoint x asFloat.
	self a23: aPoint y asFloat.! !

!CMatrixTransform methodsFor: 'printing' stamp: ''!
printOn: aStream
	aStream 
		nextPutAll: self class name;
		nextPut: $(;
		cr; print: self a11; tab; print: self a12; tab; print: self a13;
		cr; print: self a21; tab; print: self a22; tab; print: self a23;
		cr; nextPut:$).! !

!CMatrixTransform methodsFor: 'accessing' stamp: 'ar 3/18/2003 23:29'!
scale
	| a11 a12 a21 a22 |
	a11 := self a11.
	a12 := self a12.
	a21 := self a21.
	a22 := self a22.
	^((a11*a11) + (a12*a12)) sqrt @ ((a21 * a21) + (a22 * a22)) sqrt! !

!CMatrixTransform methodsFor: 'serializing' stamp: 'ar 11/19/2003 19:19'!
serializeOn: aSerializer
	^aSerializer writeBitsArray: self! !

!CMatrixTransform methodsFor: 'private' stamp: ''!
setAngle: angle
	"Set the raw rotation angle in the receiver"
	| rad s c |
	rad := angle degreesToRadians.
	s := rad sin.
	c := rad cos.
	self a11: c.
	self a12: s negated.
	self a21: s.
	self a22: c.! !

!CMatrixTransform methodsFor: 'initialize' stamp: ''!
setIdentiy
	"Initialize the receiver to the identity transformation (e.g., not affecting points)"
	self
		a11: 1.0; a12: 0.0; a13: 0.0;
		a21: 0.0; a22: 1.0; a23: 0.0.! !

!CMatrixTransform methodsFor: 'private' stamp: ''!
setOffset: aPoint
	"Set the raw offset in the receiver"
	| pt |
	pt := aPoint asPoint.
	self a13: pt x asFloat.
	self a23: pt y asFloat.! !

!CMatrixTransform methodsFor: 'private' stamp: ''!
setScale: aPoint
	"Set the raw scale in the receiver"
	| pt |
	pt := aPoint asPoint.
	self a11: pt x asFloat.
	self a22: pt y asFloat.! !

!CMatrixTransform methodsFor: 'transforming points' stamp: 'ar 6/2/2005 17:05'!
sourceQuadFor: aRectangle
	^ aRectangle innerCorners collect: 
		[:p | (self invertPoint: p) truncated]! !

!CMatrixTransform methodsFor: 'transforming points' stamp: ''!
transformDirection: aPoint
	"Transform aPoint from local coordinates into global coordinates"
	| x y |
	x := (aPoint x * self a11) + (aPoint y * self a12).
	y := (aPoint x * self a21) + (aPoint y * self a22).
	^x @ y! !

!CMatrixTransform methodsFor: 'transforming points' stamp: ''!
transformPoint: aPoint
	"Transform aPoint from local coordinates into global coordinates"
	| x y |
	x := (aPoint x * self a11) + (aPoint y * self a12) + self a13.
	y := (aPoint x * self a21) + (aPoint y * self a22) + self a23.
	^x @ y! !

!CMatrixTransform methodsFor: 'accessing' stamp: 'ar 6/9/2003 00:07'!
warpCellSize
	| a11 a12 a21 a22 |
	a11 := self a11.
	a12 := self a12.
	a21 := self a21.
	a22 := self a22.
	((a11*a11) + (a12*a12)) < 1.01 ifTrue:[^2].
	((a21 * a21) + (a22 * a22)) < 1.01 ifTrue:[^2].
	(a12 - a21) abs < 0.01
		ifTrue:[^1]
		ifFalse:[^2]! !

!CMatrixTransform methodsFor: 'objects from disk' stamp: ''!
writeOn: aStream
	aStream nextWordsPutAll: self.! !

CDisplayTransform subclass: #COffsetTransform
	instanceVariableNames: 'offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Transforms'!

!COffsetTransform commentStamp: 'ar 3/27/2004 18:00' prior: 0!
COffsetTransform is a very specialized kind of transformation which optimizes for the specific case of only having to deal with translation (which is very common).!

!COffsetTransform class methodsFor: 'instance creation' stamp: ''!
offset: aPoint
	^self new offset: aPoint! !

!COffsetTransform class methodsFor: 'instance creation' stamp: ''!
withOffset: aPoint
	^self new offset: aPoint! !

!COffsetTransform methodsFor: 'comparing' stamp: ''!
= aTransform
	^aTransform isPureTranslation and:[self offset = aTransform offset]! !

!COffsetTransform methodsFor: 'converting' stamp: ''!
asMatrixTransform2x3
	^CMatrixTransform withOffset: offset! !

!COffsetTransform methodsFor: 'composing' stamp: ''!
composedWithLocal: aTransform
	aTransform isPureTranslation
		ifTrue:[^self clone offset: (offset + aTransform offset)].
	^self asMatrixTransform2x3 composedWithLocal: aTransform! !

!COffsetTransform methodsFor: 'transforming' stamp: ''!
globalBoundsToLocal: aRectangle
	^aRectangle translateBy: offset negated! !

!COffsetTransform methodsFor: 'transforming' stamp: ''!
globalPointToLocal: aPoint
	^aPoint - offset! !

!COffsetTransform methodsFor: 'comparing' stamp: ''!
hash
	^offset hash! !

!COffsetTransform methodsFor: 'accessing' stamp: ''!
inverseTransformation
	"Return the inverse transformation of the receiver."
	^self clone offset: offset negated! !

!COffsetTransform methodsFor: 'transforming' stamp: 'ar 6/26/2005 14:07'!
invertDirection: aPoint
	^aPoint! !

!COffsetTransform methodsFor: 'testing' stamp: ''!
isIdentity
	^offset isZero! !

!COffsetTransform methodsFor: 'testing' stamp: ''!
isNoRotationWithin: bounds
	^true! !

!COffsetTransform methodsFor: 'testing' stamp: ''!
isNoTransformWithin: aRectangle
	^true! !

!COffsetTransform methodsFor: 'testing' stamp: ''!
isPureTranslation
	^true! !

!COffsetTransform methodsFor: 'transforming' stamp: ''!
localBoundsToGlobal: aRectangle
	^aRectangle translateBy: offset! !

!COffsetTransform methodsFor: 'transforming' stamp: ''!
localPointToGlobal: aPoint
	^offset + aPoint! !

!COffsetTransform methodsFor: 'accessing' stamp: ''!
offset
	^offset! !

!COffsetTransform methodsFor: 'accessing' stamp: ''!
offset: aPoint
	offset := aPoint! !

!COffsetTransform methodsFor: 'printing' stamp: 'bf 4/3/2004 00:50'!
printOn: aStream
	aStream 
		nextPutAll: self class name;
		nextPut: $(;
		print: offset;
		nextPut:$).! !

!COffsetTransform methodsFor: 'accessing' stamp: ''!
scale
	^1@1! !

!COffsetTransform methodsFor: 'initialize' stamp: ''!
setIdentity
	offset := 0@0.! !

!COffsetTransform methodsFor: 'transforming' stamp: ''!
transformDirection: aPoint
	^aPoint! !

!COffsetTransform methodsFor: 'transforming' stamp: ''!
transformPoint: aPoint
	^offset + aPoint! !

Object subclass: #CGraphicsFill
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Fills'!

!CGraphicsFill class methodsFor: 'instance creation' stamp: 'ar 12/7/2002 21:58'!
none
	^Color transparent
! !

!CGraphicsFill class methodsFor: 'instance creation' stamp: 'ar 12/7/2002 21:58'!
solid
	^Color white
! !

!CGraphicsFill methodsFor: 'converting' stamp: 'ar 12/7/2002 21:58'!
asB3DColor
	^self asColor asB3DColor! !

!CGraphicsFill methodsFor: 'converting' stamp: ''!
asColor
	^self subclassResponsibility! !

!CGraphicsFill methodsFor: 'testing' stamp: ''!
isBitmapFill
	^false! !

!CGraphicsFill methodsFor: 'testing' stamp: ''!
isGradientFill
	^false! !

!CGraphicsFill methodsFor: 'testing' stamp: ''!
isOrientedFill
	"Return true if the receiver keeps an orientation (e.g., origin, direction, and normal)"
	^false! !

!CGraphicsFill methodsFor: 'testing' stamp: ''!
isSolidFill
	^false! !

!CGraphicsFill methodsFor: 'testing' stamp: ''!
isTranslucent
	^true "Since we don't know better"! !

!CGraphicsFill methodsFor: 'testing' stamp: ''!
isTransparent
	^false! !

!CGraphicsFill methodsFor: 'converting' stamp: ''!
mixed: fraction with: aColor
	^self asColor mixed: fraction with: aColor! !

!CGraphicsFill methodsFor: 'accessing' stamp: ''!
scaledPixelValue32
	"Return a pixel value of depth 32 for the primary color in the fill style"
	^self asColor scaledPixelValue32! !

!CGraphicsFill methodsFor: 'transforming' stamp: 'ar 4/19/2005 00:14'!
transformBy: aTransform
! !

!CGraphicsFill methodsFor: 'transforming' stamp: 'ar 4/19/2005 00:14'!
transformedBy: aTransform
	^self copy transformBy: aTransform
! !

CGraphicsFill subclass: #COrientedFill
	instanceVariableNames: 'origin direction normal frame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Fills'!

COrientedFill subclass: #CBitmapFill
	instanceVariableNames: 'form tileFlag combinationRule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Fills'!

!CBitmapFill class methodsFor: 'instance creation' stamp: ''!
form: aForm
	^self new form: aForm! !

!CBitmapFill class methodsFor: 'instance creation' stamp: ''!
fromForm: aForm
	| fs |
	fs := self form: aForm.
	fs direction: aForm width @ 0.
	fs normal: 0 @ aForm height.
	fs tileFlag: true.
	^fs! !

!CBitmapFill class methodsFor: 'instance creation' stamp: ''!
fromUser
	| fill |
	fill := self form: Form fromUser.
	fill origin: 0@0.
	fill direction: fill form width @ 0.
	fill normal: 0 @ fill form height.
	fill tileFlag: true. "So that we can fill arbitrary objects"
	^fill! !

!CBitmapFill methodsFor: 'converting' stamp: ''!
asColor
	^form colorAt: 0@0! !

!CBitmapFill methodsFor: 'accessing' stamp: 'ar 4/19/2005 00:14'!
combinationRule
	^combinationRule ifNil:[Form over]! !

!CBitmapFill methodsFor: 'accessing' stamp: 'ar 4/19/2005 00:14'!
combinationRule: rule
	combinationRule := rule! !

!CBitmapFill methodsFor: 'accessing' stamp: ''!
form
	^form! !

!CBitmapFill methodsFor: 'accessing' stamp: ''!
form: aForm
	form := aForm! !

!CBitmapFill methodsFor: 'testing' stamp: ''!
isBitmapFill
	^true! !

!CBitmapFill methodsFor: 'testing' stamp: ''!
isTiled
	"Return true if the receiver should be repeated if the fill shape is larger than the form"
	^tileFlag == true! !

!CBitmapFill methodsFor: 'testing' stamp: ''!
isTranslucent
	"Return true since the bitmap may be translucent and we don't really want to check"
	^true! !

!CBitmapFill methodsFor: 'accessing' stamp: ''!
tileFlag
	^tileFlag! !

!CBitmapFill methodsFor: 'accessing' stamp: ''!
tileFlag: aBoolean
	tileFlag := aBoolean! !

COrientedFill subclass: #CGradientFill
	instanceVariableNames: 'colorRamp pixelRamp radial isTranslucent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Fills'!

!CGradientFill class methodsFor: 'instance creation' stamp: ''!
colors: colorArray
	"Create a gradient fill style from an array of equally spaced colors"
	^self ramp: (colorArray withIndexCollect:
		[:color :index| (index-1 asFloat / (colorArray size - 1 max: 1)) -> color]).! !

!CGradientFill class methodsFor: 'instance creation' stamp: ''!
ramp: colorRamp
	^self new colorRamp: colorRamp! !

!CGradientFill class methodsFor: 'instance creation' stamp: ''!
sample
	"CGradientFill sample"
	^(self ramp: { 0.0 -> Color red. 0.5 -> Color green. 1.0 -> Color blue})
		origin: 300 @ 300;
		direction: 400@0;
		normal: 0@400;
		radial: true;
	yourself! !

!CGradientFill methodsFor: 'accessing' stamp: 'ar 3/12/2003 16:42'!
alpha
	^colorRamp first value alpha! !

!CGradientFill methodsFor: 'accessing' stamp: 'ar 3/12/2003 16:42'!
alpha: newAlpha
	colorRamp := colorRamp collect:[:each|
		each key -> (each value alpha: newAlpha).
	].
	pixelRamp := nil.
	^self! !

!CGradientFill methodsFor: 'converting' stamp: ''!
asColor
	"Guess..."
	^colorRamp first value mixed: 0.5 with: colorRamp last value! !

!CGradientFill methodsFor: 'private' stamp: ''!
checkTranslucency
	^colorRamp anySatisfy: [:any| any value isTranslucent]! !

!CGradientFill methodsFor: 'accessing' stamp: ''!
colorRamp
	^colorRamp! !

!CGradientFill methodsFor: 'accessing' stamp: ''!
colorRamp: anArray
	colorRamp := anArray.
	pixelRamp := nil.
	isTranslucent := nil.! !

!CGradientFill methodsFor: 'accessing' stamp: 'ar 12/9/2002 23:01'!
colors
	"Create a gradient fill style from an array of equally spaced colors"
	^self colorRamp collect:[:each| each value]! !

!CGradientFill methodsFor: 'accessing' stamp: ''!
colors: colorArray
	"Create a gradient fill style from an array of equally spaced colors"
	^self colorRamp: (colorArray withIndexCollect:
		[:color :index| (index-1 asFloat / (colorArray size - 1 max: 1)) -> color]).! !

!CGradientFill methodsFor: 'private' stamp: ''!
computePixelRampOfSize: length
	"Compute the pixel ramp in the receiver"
	| bits lastColor lastIndex nextIndex nextColor distance theta lastValue ramp lastWord nextWord step |
	ramp := colorRamp asSortedCollection:[:a1 :a2| a1 key < a2 key].
	bits := Bitmap new: length.
	lastColor := ramp first value.
	lastWord := lastColor pixelWordForDepth: 32.
	lastIndex := 0.
	ramp do:[:assoc|
		nextIndex := (assoc key * length) rounded.
		nextColor := assoc value.
		nextWord := nextColor pixelWordForDepth: 32.
		distance := (nextIndex - lastIndex).
		distance = 0 ifTrue:[distance := 1].
		step := 1.0 / distance asFloat.
		theta := 0.0.
		lastIndex+1 to: nextIndex do:[:i|
			theta := theta + step.
			"The following is an open-coded version of:
				color := nextColor alphaMixed: theta with: lastColor.
				bits at: i put: (color scaledPixelValue32).
			"
			bits at: i put: (self scaledAlphaMix: theta of: lastWord with: nextWord).
		].
		lastIndex := nextIndex.
		lastColor := nextColor.
		lastWord := nextWord.
	].
	lastValue := lastColor scaledPixelValue32.
	lastIndex+1 to: length do:[:i| bits at: i put: lastValue].
	^bits! !

!CGradientFill methodsFor: 'private' stamp: ''!
display
	| f ramp |
	ramp := self pixelRamp.
	f := Form extent: ramp size @ 1 depth: 32 bits: ramp.
	1 to: 100 do:[:i| f displayAt: 1@i].
	[Sensor anyButtonPressed] whileFalse.
	[Sensor anyButtonPressed] whileTrue.! !

!CGradientFill methodsFor: 'accessing' stamp: 'ar 3/11/2003 18:20'!
gradientColor
	^colorRamp last value! !

!CGradientFill methodsFor: 'accessing' stamp: 'ar 3/11/2003 18:20'!
gradientColor: aColor
	colorRamp at: colorRamp size put: colorRamp last key -> aColor.
	pixelRamp := nil.! !

!CGradientFill methodsFor: 'testing' stamp: ''!
isGradientFill
	^true! !

!CGradientFill methodsFor: 'testing' stamp: ''!
isRadialFill
	^radial == true! !

!CGradientFill methodsFor: 'testing' stamp: ''!
isSolidFill
	^false! !

!CGradientFill methodsFor: 'testing' stamp: ''!
isTranslucent
	^isTranslucent ifNil:[isTranslucent := self checkTranslucency]! !

!CGradientFill methodsFor: 'converting' stamp: ''!
mixed: fraction with: aColor
	^self copy colorRamp: (colorRamp collect:[:assoc| assoc key -> (assoc value mixed: fraction with: aColor)])! !

!CGradientFill methodsFor: 'accessing' stamp: 'ar 12/8/2002 18:54'!
pixelRamp
	| rampSize |
	pixelRamp ifNotNil:[^pixelRamp].
	frame ifNil:[^pixelRamp := self computePixelRampOfSize: 512].
	rampSize := ((frame width max: frame height) // 2 max: 4) asLargerPowerOfTwo.
	^pixelRamp := self computePixelRampOfSize: rampSize.! !

!CGradientFill methodsFor: 'accessing' stamp: ''!
pixelRamp: aBitmap
	pixelRamp := aBitmap! !

!CGradientFill methodsFor: 'accessing' stamp: 'ar 3/11/2003 18:21'!
primaryColor
	^colorRamp first value! !

!CGradientFill methodsFor: 'accessing' stamp: 'ar 3/11/2003 18:21'!
primaryColor: aColor
	colorRamp at: 1 put: colorRamp first key -> aColor.
	pixelRamp := nil.! !

!CGradientFill methodsFor: 'accessing' stamp: ''!
radial
	^radial! !

!CGradientFill methodsFor: 'accessing' stamp: ''!
radial: aBoolean
	radial := aBoolean! !

!CGradientFill methodsFor: 'private' stamp: 'ar 4/8/2004 16:52'!
scaledAlphaMix: theta of: lastWord with: nextWord
	"Open-coded version of alpha mixing two 32bit pixel words and returning the scaled pixel value."
	| word0 word1 a0 a1 alpha v0 v1 vv newValue |
	word0 := lastWord.
	word1 := nextWord.
	"note: extract alpha first so we'll be in SmallInteger range afterwards"
	a0 := word0 bitShift: -24. a1 := word1 bitShift: -24.
	alpha := a0 + (a1 - a0 * theta) truncated.
	"Now make word0 and word1 SmallIntegers"
	word0 := word0 bitAnd: 16rFFFFFF. word1 := word1 bitAnd: 16rFFFFFF.
	"Compute first component value"
	v0 := (word0 bitAnd: 255). v1 := (word1 bitAnd: 255).
	vv := (v0 + (v1 - v0 * theta) truncated) * alpha // 255.
	newValue := vv.
	"Compute second component value"
	v0 := ((word0 bitShift: -8) bitAnd: 255). v1 := ((word1 bitShift: -8) bitAnd: 255).
	vv := (v0 + (v1 - v0 * theta) truncated) * alpha // 255.
	newValue := newValue bitOr: (vv bitShift: 8).
	"Compute third component value"
	v0 := ((word0 bitShift: -16) bitAnd: 255). v1 := ((word1 bitShift: -16) bitAnd: 255).
	vv := (v0 + (v1 - v0 * theta) truncated) * alpha // 255.
	newValue := newValue bitOr: (vv bitShift: 16).
	"Return result"
	^newValue bitOr: (alpha bitShift: 24)! !

!CGradientFill methodsFor: 'private' stamp: 'ar 12/8/2002 18:53'!
updateFrame: aRectangle
	| rampSize |
	super updateFrame: aRectangle.
	pixelRamp ifNil:[^self].
	rampSize := (frame width max: frame height) // 2.
	rampSize > pixelRamp size ifTrue:[pixelRamp := nil].! !

!COrientedFill methodsFor: 'accessing' stamp: ''!
direction
	^direction ifNil:[direction := normal y @ normal x negated]! !

!COrientedFill methodsFor: 'accessing' stamp: ''!
direction: aPoint
	direction := aPoint! !

!COrientedFill methodsFor: 'accessing' stamp: ''!
frame
	^frame! !

!COrientedFill methodsFor: 'accessing' stamp: ''!
frame: aRectangle
	frame := aRectangle.! !

!COrientedFill methodsFor: 'testing' stamp: ''!
isOrientedFill
	"Return true if the receiver keeps an orientation (e.g., origin, direction, and normal)"
	^true! !

!COrientedFill methodsFor: 'accessing' stamp: ''!
normal
	^normal ifNil:[normal := direction y negated @ direction x]! !

!COrientedFill methodsFor: 'accessing' stamp: ''!
normal: aPoint
	normal := aPoint! !

!COrientedFill methodsFor: 'accessing' stamp: 'ar 3/11/2003 18:24'!
offset
	^origin! !

!COrientedFill methodsFor: 'accessing' stamp: 'ar 3/11/2003 18:24'!
offset: aPoint
	self origin: aPoint.! !

!COrientedFill methodsFor: 'accessing' stamp: 'ar 3/12/2003 20:16'!
origin
	^origin ifNil:[0@0]! !

!COrientedFill methodsFor: 'accessing' stamp: 'ar 3/12/2003 20:16'!
origin: aPoint
	origin := aPoint.! !

!COrientedFill methodsFor: 'transforming' stamp: 'ar 4/19/2005 00:15'!
transformBy: aTransform
	origin := aTransform transformPoint: self origin.
	direction := aTransform transformDirection: self direction.
	normal := aTransform transformDirection: self normal.
! !

!COrientedFill methodsFor: 'updating' stamp: ''!
updateFrame: aRectangle
	"Update the receiver to represent the same relative fill in aRectangle as previously in its frame. This message is sent by clients who wish to preserve the relative orientation (origin, length) across changes of the shape of the client."
	| oldExtent newExtent delta length |
	frame = aRectangle ifTrue:[^self].
	frame ifNil:[frame := aRectangle. ^self].
	frame = aRectangle ifTrue:[frame := aRectangle. ^self].
	"Update the origin"
	[oldExtent := frame extent.
	newExtent := aRectangle extent.
	delta := origin - frame origin.
	delta := delta asFloatPoint / oldExtent.
	delta := (delta * newExtent).
	delta := aRectangle origin + delta.
	origin = delta ifFalse:[origin := delta].
	"Update the direction, based on its angle and relative length"
	direction ifNotNil:[
		delta := (origin + direction) - frame origin.
		delta := delta asFloatPoint / oldExtent.
		delta := (delta * newExtent).
		delta := aRectangle origin + delta - origin.
		length := delta r. "This is what we want to scale the direction to"
		delta := direction normalized * length.
		delta = direction ifFalse:[direction := delta].
	].
	"Update the normal, based on its angle and relative length"
	normal ifNotNil:[
		delta := (origin + normal) - frame origin.
		delta := delta asFloatPoint / oldExtent.
		delta := (delta * newExtent).
		delta := aRectangle origin + delta - origin.
		length := delta r. "This is what we want to scale the direction to"
		delta := normal normalized * length.
		delta = normal ifFalse:[normal := delta].
	].
	frame := aRectangle.
	] on: ZeroDivide do:[:ex| ex return: ex dividend].! !

CGraphicsFill subclass: #CSolidFill
	instanceVariableNames: 'color pixelValue32'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Fills'!

!CSolidFill class methodsFor: 'instance creation' stamp: ''!
color: aColor
	^self new color: aColor! !

!CSolidFill methodsFor: 'converting' stamp: ''!
asColor
	^color! !

!CSolidFill methodsFor: 'accessing' stamp: ''!
color: aColor
	color := aColor.
	pixelValue32 := aColor scaledPixelValue32! !

!CSolidFill methodsFor: 'accessing' stamp: ''!
display
	^color display! !

!CSolidFill methodsFor: 'testing' stamp: ''!
isSolidFill
	^true! !

!CSolidFill methodsFor: 'testing' stamp: ''!
isTranslucent
	^color isTranslucent! !

!CSolidFill methodsFor: 'testing' stamp: ''!
isTransparent
	^color isTransparent! !

!CSolidFill methodsFor: 'printing' stamp: ''!
printOn: aStream
	super printOn: aStream.
	aStream nextPut:$(; print: color; nextPut:$).! !

!CSolidFill methodsFor: 'accessing' stamp: ''!
scaledPixelValue32
	"Return the alpha scaled pixel value for depth 32"
	^pixelValue32! !

!CSolidFill methodsFor: 'accessing' stamp: ''!
style
	^#solid! !

Object subclass: #CGraphicsShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-TODO'!

!CGraphicsShape commentStamp: 'ar 3/27/2004 17:53' prior: 0!
CGraphicsShape is the abstract superclass for all objects which represent the shape aspect of some costume.!

!CGraphicsShape methodsFor: 'testing' stamp: 'ar 6/8/2003 21:38'!
containsPoint: aPoint in: box
	"Answer whether the receiver contains the given point"
! !

!CGraphicsShape methodsFor: 'drawing' stamp: 'ar 6/8/2003 21:35'!
drawShapeOn: aCanvas in: drawingBounds fill: aFill border: aBorder
	"draw the receiver's shape on aCanvas"
! !

CGraphicsShape subclass: #CVectorShape
	instanceVariableNames: 'bounds compressedShape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-TODO'!

!CVectorShape commentStamp: 'ar 3/27/2004 17:54' prior: 0!
CVectorShape represents a vector graphics shape.!

!CVectorShape methodsFor: 'accessing' stamp: 'ar 6/9/2003 03:42'!
bounds
	^bounds! !

!CVectorShape methodsFor: 'accessing' stamp: 'ar 6/9/2003 03:42'!
bounds: newBounds
	bounds := newBounds! !

!CVectorShape methodsFor: 'accessing' stamp: 'ar 6/9/2003 03:34'!
compressedShape
	^compressedShape! !

!CVectorShape methodsFor: 'accessing' stamp: 'ar 6/9/2003 03:34'!
compressedShape: aShape
	compressedShape := aShape.
	bounds := aShape bounds.
! !

!CVectorShape methodsFor: 'drawing' stamp: 'ar 6/9/2003 03:55'!
drawOn: aCanvas in: drawingBounds
	aCanvas pushState.
	aCanvas transformBy: (CMatrixTransform transformFromLocal: bounds toGlobal: drawingBounds).
	aCanvas drawCompressedShape: compressedShape.
	aCanvas popState.! !

Object subclass: #CLayoutCell
	instanceVariableNames: 'target cellSize extraSpace flags nextCell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Layouts'!

!CLayoutCell commentStamp: 'ar 3/27/2004 18:02' prior: 0!
I am used in table layouts to hold temporary values while the layout is being computed.

Instance variables:
	target 		<Morph>		The morph contained in this cell
	cellSize 		<Point>		The size of the cell
	extraSpace 	<nil | Point>	Additional space to add after this cell
	nextCell 	<nil | LayoutCell>	The next cell in the arrangement.

Implementation note:
Both, cellSize and extraSpace contains points where
	x - represents the primary table direction
	y - represents the secondary table direction
!

!CLayoutCell methodsFor: 'accessing' stamp: ''!
addExtraSpace: aPoint
	extraSpace 
		ifNil:[extraSpace := aPoint]
		ifNotNil:[extraSpace := extraSpace + aPoint]! !

!CLayoutCell methodsFor: 'accessing' stamp: ''!
cellSize
	^cellSize! !

!CLayoutCell methodsFor: 'accessing' stamp: ''!
cellSize: aPoint
	cellSize := aPoint! !

!CLayoutCell methodsFor: 'collection' stamp: ''!
do: aBlock
	aBlock value: self.
	nextCell ifNotNil:[nextCell do: aBlock].! !

!CLayoutCell methodsFor: 'accessing' stamp: ''!
extraSpace
	^extraSpace ifNil:[0@0]! !

!CLayoutCell methodsFor: 'accessing' stamp: ''!
extraSpace: aPoint
	extraSpace := aPoint! !

!CLayoutCell methodsFor: 'accessing' stamp: ''!
hSpaceFill
	^flags anyMask: 1! !

!CLayoutCell methodsFor: 'accessing' stamp: ''!
hSpaceFill: aBool
	flags ifNil:[flags := 0].
	flags := aBool ifTrue:[flags bitOr: 1] ifFalse:[flags bitClear: 1].! !

!CLayoutCell methodsFor: 'collection' stamp: ''!
inject: thisValue into: binaryBlock		 
	"Accumulate a running value associated with evaluating the argument, 
	binaryBlock, with the current value of the argument, thisValue, and the 
	receiver as block arguments. For instance, to sum the numeric elements 
	of a collection, aCollection inject: 0 into: [:subTotal :next | subTotal + 
	next]."
	| nextValue |
	nextValue := thisValue.
	self do: [:each | nextValue := binaryBlock value: nextValue value: each].
	^nextValue! !

!CLayoutCell methodsFor: 'accessing' stamp: ''!
nextCell
	^nextCell! !

!CLayoutCell methodsFor: 'accessing' stamp: ''!
nextCell: aCell
	nextCell := aCell! !

!CLayoutCell methodsFor: 'collection' stamp: ''!
size
	| n cell |
	n := 0.
	cell := self.
	[cell == nil] whileFalse:[
		n := n + 1.
		cell := cell nextCell].
	^n! !

!CLayoutCell methodsFor: 'accessing' stamp: ''!
target
	^target! !

!CLayoutCell methodsFor: 'accessing' stamp: ''!
target: newTarget
	target := newTarget! !

!CLayoutCell methodsFor: 'accessing' stamp: ''!
vSpaceFill
	^flags anyMask: 2! !

!CLayoutCell methodsFor: 'accessing' stamp: ''!
vSpaceFill: aBool
	flags ifNil:[flags := 0].
	flags := aBool ifTrue:[flags bitOr: 2] ifFalse:[flags bitClear: 2].! !

Object subclass: #CLayoutFrame
	instanceVariableNames: 'leftFraction leftOffset topFraction topOffset rightFraction rightOffset bottomFraction bottomOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Layouts'!

!CLayoutFrame commentStamp: 'ar 3/27/2004 18:02' prior: 0!
I define a frame for positioning some morph in a proportional layout.

Instance variables:
	leftFraction 
	topFraction 
	rightFraction 
	bottomFraction 	<Float>		The fractional distance (between 0 and 1) to place the morph in its owner's bounds
	leftOffset 
	topOffset 
	rightOffset 
	bottomOffset 	<Integer>	Fixed pixel offset to apply after fractional positioning (e.g., "10 pixel right of the center of the owner")!

!CLayoutFrame class methodsFor: 'as yet unclassified' stamp: ''!
classVersion
	^1 "changed treatment of bottomOffset and rightOffset"! !

!CLayoutFrame class methodsFor: 'as yet unclassified' stamp: ''!
fractions: fractionsOrNil
	^self fractions: fractionsOrNil offsets: nil! !

!CLayoutFrame class methodsFor: 'as yet unclassified' stamp: ''!
fractions: fractionsOrNil offsets: offsetsOrNil
	| fractions offsets |
	fractions := fractionsOrNil ifNil: [0@0 extent: 0@0].
	offsets := offsetsOrNil ifNil: [0@0 extent: 0@0].
	^self new
		topFraction: fractions top offset: offsets top;
		leftFraction: fractions left offset: offsets left;
		bottomFraction: fractions bottom offset: offsets bottom;
		rightFraction: fractions right offset: offsets right! !

!CLayoutFrame class methodsFor: 'as yet unclassified' stamp: ''!
offsets: offsetsOrNil
	^self fractions: nil offsets: offsetsOrNil! !

!CLayoutFrame methodsFor: 'converting' stamp: 'ar 3/6/2004 19:40'!
asLayoutFrame
	^self! !

!CLayoutFrame methodsFor: 'accessing' stamp: 'ar 3/6/2004 19:40'!
bottomFraction
	^bottomFraction! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
bottomFraction: aNumber
	bottomFraction := aNumber! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
bottomFraction: aNumber offset: anInteger
	bottomFraction := aNumber.
	bottomOffset := anInteger! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
bottomOffset
	^bottomOffset! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
bottomOffset: anInteger
	bottomOffset := anInteger! !

!CLayoutFrame methodsFor: 'objects from disk' stamp: ''!
convertToCurrentVersion: varDict refStream: smartRefStrm
	| className oldClassVersion |
	"JW 2/1/2001"
	"Since class version isn't passed in varDict, look it up through smartRefSrm."
	className := varDict at: #ClassName.
	oldClassVersion := (smartRefStrm structures at: className) first.
	(oldClassVersion = 0) ifTrue: [ self negateBottomRightOffsets ].
	^super convertToCurrentVersion: varDict refStream: smartRefStrm.! !

!CLayoutFrame methodsFor: 'accessing' stamp: 'tk 5/10/2005 14:04'!
fractions
	"Return the fractions in the same format we got them in."
	^ (leftFraction @ topFraction) corner: (rightFraction @ bottomFraction)! !

!CLayoutFrame methodsFor: 'layout' stamp: ''!
layout: oldBounds in: newBounds
	"Return the proportional rectangle insetting the given bounds"
	| left right top bottom |
	leftFraction ifNotNil:[
		left := newBounds left + (newBounds width * leftFraction).
		leftOffset ifNotNil:[left := left + leftOffset]].
	rightFraction ifNotNil:[
		right := newBounds right - (newBounds width * (1.0 - rightFraction)).
		rightOffset ifNotNil:[right := right + rightOffset]].
	topFraction ifNotNil:[
		top := newBounds top + (newBounds height * topFraction).
		topOffset ifNotNil:[top := top + topOffset]].
	bottomFraction ifNotNil:[
		bottom := newBounds bottom - (newBounds height * (1.0 - bottomFraction)).
		bottomOffset ifNotNil:[bottom := bottom + bottomOffset]].
	left ifNil:[ right 
			ifNil:[left := oldBounds left. right := oldBounds right]
			ifNotNil:[left := right - oldBounds width]].
	right ifNil:[right := left + oldBounds width].
	top ifNil:[ bottom 
			ifNil:[top := oldBounds top. bottom := oldBounds bottom]
			ifNotNil:[top := bottom - oldBounds height]].
	bottom ifNil:[bottom := top + oldBounds height].
	^(left rounded @ top rounded) corner: (right rounded @ bottom rounded)! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
leftFraction
	^leftFraction! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
leftFraction: aNumber
	leftFraction := aNumber! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
leftFraction: aNumber offset: anInteger
	leftFraction := aNumber.
	leftOffset := anInteger! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
leftOffset
	^leftOffset! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
leftOffset: anInteger
	leftOffset := anInteger! !

!CLayoutFrame methodsFor: 'layout' stamp: 'ar 3/16/2003 18:45'!
minExtentFrom: minExtent
	"Return the minimal extent the given bounds can be represented in"
	| left right top bottom width height lOfs rOfs tOfs bOfs |
	width := minExtent x.
	height := minExtent y.

	lOfs := rOfs := tOfs := bOfs := 0.
	leftFraction ifNotNil:[leftOffset ifNotNil:[lOfs := leftOffset]].
	rightFraction ifNotNil:[rightOffset ifNotNil:[rOfs := rightOffset]].
	topFraction ifNotNil:[topOffset ifNotNil:[tOfs := topOffset]].
	bottomFraction ifNotNil:[bottomOffset ifNotNil:[bOfs := bottomOffset]].

	lOfs < 0 ifTrue:[width := width + lOfs].
	rOfs < 0 ifTrue:[width := width + rOfs].
	tOfs < 0 ifTrue:[height := height + tOfs].
	bOfs < 0 ifTrue:[height := height + bOfs].

	left := top := 0.0.
	right := bottom := 1.0.

	leftFraction ifNotNil:[left := leftFraction].
	rightFraction ifNotNil:[right := rightFraction].
	topFraction ifNotNil:[top := topFraction].
	bottomFraction ifNotNil:[bottom := bottomFraction].

	left = right ifFalse:[width := width / (right - left)].
	top = bottom ifFalse:[height := height / (bottom - top)].

	lOfs > 0 ifTrue:[width := width + lOfs].
	rOfs > 0 ifTrue:[width := width + rOfs].
	tOfs > 0 ifTrue:[height := height + tOfs].
	bOfs > 0 ifTrue:[height := height + bOfs].

	^width truncated @ height truncated! !

!CLayoutFrame methodsFor: 'layout' stamp: 'ar 3/16/2003 18:45'!
minExtentFromNEW: minExtent
	"Return the minimal extent the given bounds can be represented in"
	| left right top bottom width height lOfs rOfs tOfs bOfs |
	width := minExtent x.
	height := minExtent y.

	lOfs := rOfs := tOfs := bOfs := 0.
	leftFraction ifNotNil:[leftOffset ifNotNil:[lOfs := leftOffset]].
	rightFraction ifNotNil:[rightOffset ifNotNil:[rOfs := rightOffset]].
	topFraction ifNotNil:[topOffset ifNotNil:[tOfs := topOffset]].
	bottomFraction ifNotNil:[bottomOffset ifNotNil:[bOfs := bottomOffset]].

	lOfs < 0 ifTrue:[width := width + lOfs].
	rOfs < 0 ifTrue:[width := width + rOfs].
	tOfs < 0 ifTrue:[height := height + tOfs].
	bOfs < 0 ifTrue:[height := height + bOfs].

	left := top := 0.0.
	right := bottom := 1.0.

	leftFraction ifNotNil:[left := leftFraction].
	rightFraction ifNotNil:[right := rightFraction].
	topFraction ifNotNil:[top := topFraction].
	bottomFraction ifNotNil:[bottom := bottomFraction].

	left = right ifFalse:[width := width / (right - left)].
	top = bottom ifFalse:[height := height / (bottom - top)].

	lOfs > 0 ifTrue:[width := width + lOfs].
	rOfs > 0 ifTrue:[width := width + rOfs].
	tOfs > 0 ifTrue:[height := height + tOfs].
	bOfs > 0 ifTrue:[height := height + bOfs].

	^width truncated @ height truncated! !

!CLayoutFrame methodsFor: 'layout' stamp: 'ar 3/16/2003 18:32'!
minExtentFromOLD: minExtent
	"Return the minimal extent the given bounds can be represented in"
	| left right top bottom width height x y |
	left := top := 0.0.
	right := bottom := 1.0.
	width := height := 0.
	x := minExtent x.
	y := minExtent y.

	leftFraction ifNotNil:[left := leftFraction].
	rightFraction ifNotNil:[right := rightFraction].
	topFraction ifNotNil:[top := topFraction].
	bottomFraction ifNotNil:[bottom := bottomFraction].

	left = right ifFalse:[width := x / (right - left)].
	top = bottom ifFalse:[height := y / (bottom - top)].

	leftOffset ifNotNil:[width := width + leftOffset].
	rightOffset ifNotNil:[width := width + rightOffset].
	topOffset ifNotNil:[height := height + topOffset].
	bottomOffset ifNotNil:[height := height + bottomOffset].
	^width truncated @ height truncated! !

!CLayoutFrame methodsFor: 'objects from disk' stamp: ''!
negateBottomRightOffsets
	bottomOffset ifNotNil: [ bottomOffset := bottomOffset negated ].
	rightOffset ifNotNil: [ rightOffset := rightOffset negated ].! !

!CLayoutFrame methodsFor: 'accessing' stamp: 'tk 5/10/2005 14:17'!
offsets
	"Return the offsets in the same format we got them in.  Watch out for nil values."
	^ (leftOffset ifNil: [0]) @ (topOffset ifNil: [0]) corner: 
			(rightOffset ifNil: [0]) @ (bottomOffset ifNil: [0])! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
rightFraction
	^rightFraction! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
rightFraction: aNumber
	rightFraction := aNumber! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
rightFraction: aNumber offset: anInteger
	rightFraction := aNumber.
	rightOffset := anInteger! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
rightOffset
	^rightOffset! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
rightOffset: anInteger
	rightOffset := anInteger! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
topFraction
	^topFraction! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
topFraction: aNumber
	topFraction := aNumber! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
topFraction: aNumber offset: anInteger
	topFraction := aNumber.
	topOffset := anInteger! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
topOffset
	^topOffset! !

!CLayoutFrame methodsFor: 'accessing' stamp: ''!
topOffset: anInteger
	topOffset := anInteger! !

Object subclass: #CLayoutProperties
	instanceVariableNames: 'hResizing vResizing hAlign vAlign layoutInset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Layouts'!

!CLayoutProperties commentStamp: 'ar 3/27/2004 18:02' prior: 0!
This class provides a compact bit encoding for the most commonly used layout properties.!

!CLayoutProperties class methodsFor: 'instance creation' stamp: 'ar 1/30/2005 11:50'!
new
	^self basicNew initialize! !

!CLayoutProperties methodsFor: 'accessing' stamp: 'mtf 1/19/2009 11:33'!
hAlign
"Answers my horizontal alignment preference. Has no effect if hResizing is #spaceFill. This is a float between 0.0 and 1.0. The most common values are:
	0.0: align to the right of my available space.
	1.0: align to the left of my available space.
	0.5: center within my available space."

	^ hAlign! !

!CLayoutProperties methodsFor: 'accessing' stamp: 'mtf 1/19/2009 11:40'!
hAlign: aFloat
"Sets my horizontal alignment preference. Has no effect if hResizing is #spaceFill. This is a float between 0.0 and 1.0. The most common values are:
	0.0: align to the right of my available space.
	1.0: align to the left of my available space.
	0.5: center within my available space."

	hAlign := aFloat! !

!CLayoutProperties methodsFor: 'accessing' stamp: ''!
hResizing
	^hResizing! !

!CLayoutProperties methodsFor: 'accessing' stamp: ''!
hResizing: aSymbol
	hResizing := aSymbol! !

!CLayoutProperties methodsFor: 'initialize' stamp: 'ar 3/24/2004 03:41'!
initialize
	hResizing := vResizing := #rigid.
	layoutInset := 0@0.! !

!CLayoutProperties methodsFor: 'initialize' stamp: 'mtf 3/10/2009 14:51'!
initializeFrom: defaultProvider
	"Initialize the receiver from a default provider"
	self hResizing: defaultProvider hResizing.
	self vResizing: defaultProvider vResizing.! !

!CLayoutProperties methodsFor: 'accessing' stamp: 'ar 3/24/2004 03:40'!
layoutInset
	^layoutInset ifNil:[0@0]! !

!CLayoutProperties methodsFor: 'accessing' stamp: 'ar 3/24/2004 03:42'!
layoutInset: newInset
	layoutInset := newInset! !

!CLayoutProperties methodsFor: 'accessing' stamp: 'mtf 1/19/2009 12:44'!
vAlign
"Answers my vertical alignment preference. Has no effect if vResizing is #spaceFill. This is a float between 0.0 and 1.0. The most common values are:
	0.0: align to the top of my available space.
	1.0: align to the bottom of my available space.
	0.5: center within my available space."

	^ vAlign! !

!CLayoutProperties methodsFor: 'accessing' stamp: 'mtf 1/19/2009 12:44'!
vAlign: aFloat
"Sets my vertical alignment preference. Has no effect if vResizing is #spaceFill. This is a float between 0.0 and 1.0. The most common values are:
	0.0: align to the top of my available space.
	1.0: align to the bottom of my available space.
	0.5: center within my available space."

	vAlign := aFloat! !

!CLayoutProperties methodsFor: 'accessing' stamp: ''!
vResizing
	^vResizing! !

!CLayoutProperties methodsFor: 'accessing' stamp: ''!
vResizing: aSymbol
	vResizing := aSymbol! !

Object subclass: #CMouseClickState
	instanceVariableNames: 'clickClient clickState firstClickDown firstClickUp firstClickTime clickSelector dblClickSelector dblClickTime dblClickTimeoutSelector dragSelector dragThreshold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Support'!

!CMouseClickState methodsFor: 'event handling' stamp: ''!
click
	clickSelector ifNotNil: [clickClient perform: clickSelector with: firstClickDown]! !

!CMouseClickState methodsFor: 'initialize' stamp: ''!
client: aCostume click: aClickSelector dblClick: aDblClickSelector dblClickTime: timeOut dblClickTimeout: aDblClickTimeoutSelector drag: aDragSelector threshold: aNumber event: firstClickEvent
	clickClient := aCostume.
	clickSelector := aClickSelector.
	dblClickSelector := aDblClickSelector.
	dblClickTime := timeOut.
	dblClickTimeoutSelector := aDblClickTimeoutSelector.
	dragSelector := aDragSelector.
	dragThreshold := aNumber.
	firstClickDown := firstClickEvent.
	firstClickTime := firstClickEvent timeStamp.
	clickState := #firstClickDown.! !

!CMouseClickState methodsFor: 'event handling' stamp: ''!
doubleClick
	dblClickSelector ifNotNil: [clickClient perform: dblClickSelector with: firstClickDown]! !

!CMouseClickState methodsFor: 'event handling' stamp: ''!
doubleClickTimeout
	dblClickTimeoutSelector ifNotNil: [
		clickClient perform: dblClickTimeoutSelector with: firstClickDown]! !

!CMouseClickState methodsFor: 'event handling' stamp: ''!
drag: event
	dragSelector ifNotNil: [clickClient perform: dragSelector with: event]! !

!CMouseClickState methodsFor: 'event handling' stamp: ''!
handleEvent: evt from: aHand
	"Process the given mouse event to detect a click, double-click, or drag.
	Return true if the event should be processed by the sender, false if it shouldn't.
	NOTE: This method heavily relies on getting *all* mouse button events."
	| localEvt timedOut isDrag |
	timedOut := (evt timeStamp - firstClickTime) > dblClickTime.
	localEvt := evt transformedBy: clickClient globalToLocal.
	isDrag := (localEvt cursorPoint - firstClickDown cursorPoint) r > dragThreshold.
	clickState == #firstClickDown ifTrue: [
		"Careful here - if we had a slow cycle we may have a timedOut mouseUp event"
		(timedOut and:[localEvt isMouseUp not]) ifTrue:[
			"timeout before #mouseUp -> keep waiting for drag if requested"
			clickState := #firstClickTimedOut.
			dragSelector ifNil:[
				aHand resetClickState.
				self doubleClickTimeout; click "***"].
			^true].
		localEvt isMouseUp ifTrue:[
			(timedOut or:[dblClickSelector isNil]) ifTrue:[
				self click.
				aHand resetClickState.
				^true].
			"Otherwise transfer to #firstClickUp"
			firstClickUp := evt copy.
			clickState := #firstClickUp.
			"If timedOut or the client's not interested in dbl clicks get outta here"
			self click.
			aHand handleEvent: firstClickUp.
			^false].
		isDrag ifTrue:["drag start"
			self doubleClickTimeout. "***"
			aHand resetClickState.
			dragSelector "If no drag selector send #click instead"
				ifNil: [self click]
				ifNotNil: [self drag: localEvt].
			^true].
		^false].
	clickState == #firstClickTimedOut ifTrue:[
		localEvt isMouseUp ifTrue:["neither drag nor double click"
			aHand resetClickState.
			self doubleClickTimeout; click. "***"
			^true].
		isDrag ifTrue:["drag start"
			aHand resetClickState.
			self doubleClickTimeout; drag: localEvt. "***"
			^true].
		^false].
	clickState = #firstClickUp ifTrue:[
		(timedOut) ifTrue:[
			"timed out after mouseUp - send #click: and mouseUp"
			aHand resetClickState.
			self doubleClickTimeout. "***"
			^true].
		localEvt isMouseDown ifTrue:["double click"
			aHand resetClickState.
			self doubleClick.
			^false]].
	^true! !

Object subclass: #CMouseOverHandler
	instanceVariableNames: 'mouseOverList enteredList overList leftList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Support'!

!CMouseOverHandler class methodsFor: 'instance creation' stamp: 'ar 1/30/2005 11:50'!
new
	^self basicNew initialize! !

!CMouseOverHandler methodsFor: 'initialize-release' stamp: ''!
initialize
	mouseOverList := #().! !

!CMouseOverHandler methodsFor: 'accessing' stamp: ''!
mouseOverList
	^mouseOverList! !

!CMouseOverHandler methodsFor: 'event handling' stamp: 'ar 3/18/2003 13:54'!
noticeMouseOver: aCostume event: anEvent
	"Remember that the mouse is currently over some costume"
	(leftList includes: aCostume) 
		ifTrue:[leftList remove: aCostume]
		ifFalse:[enteredList nextPut: aCostume].
	overList nextPut: aCostume.! !

!CMouseOverHandler methodsFor: 'event handling' stamp: 'ar 6/28/2005 17:19'!
processMouseOver: anEvent
	"Re-establish the z-order for all costumes wrt the given event"
	| hand localEvt focus evt index |
	hand := anEvent hand.
	leftList := mouseOverList asIdentitySet.
	"Assume some coherence for the number of objects in over list"
	overList := WriteStream on: (Array new: leftList size).
	enteredList := WriteStream on: #().

	"Go looking for eventual mouse overs"
	focus := hand mouseFocus.
	evt := anEvent asMouseOver.
	hand dispatchEvent: evt.

	"Transfer everything currently below mouseFocus"
	focus ifNotNil:[
		index := mouseOverList indexOf: focus.
		index + 1 to: mouseOverList size do:[:i| 
			self noticeMouseOver: (mouseOverList at: i) event: evt.
		].
	].

	"Get out early if there's no change"
	(leftList size = 0 and:[enteredList position = 0]) 
		ifTrue:[^leftList := enteredList := overList := nil].

	"Send #mouseLeave as appropriate"
	evt := anEvent asMouseLeave.

	"Keep the order of the left costumes by recreating it from the mouseOverList"
	leftList size > 1 ifTrue:[leftList := mouseOverList select:[:m| leftList includes: m]].
	leftList do:[:m|
		m signal: #mouseOverChanged.
		localEvt := evt transformedBy: m costume globalToLocal.
		m asPrimCostume handleEvent: localEvt].

	"Send #mouseEnter as appropriate"
	evt := anEvent asMouseEnter.
	enteredList := enteredList contents.
	enteredList reverseDo:[:m|
		m signal: #mouseOverChanged.
		localEvt := evt transformedBy: m costume globalToLocal.
		m asPrimCostume handleEvent: localEvt].

	"And remember the over list"
	mouseOverList := overList contents.
	leftList := enteredList := overList := nil.! !

Object subclass: #CTableLayoutProperties
	instanceVariableNames: 'cellInset cellPositioning cellSpacing layoutInset listCentering listDirection listSpacing reverseTableCells rubberBandCells wrapCentering wrapDirection minCellSize maxCellSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Layouts'!

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
cellInset
	^cellInset! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
cellInset: aNumber
	cellInset := aNumber! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
cellPositioning
	^cellPositioning! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
cellPositioning: aSymbol
	cellPositioning := aSymbol! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
cellSpacing
	^cellSpacing! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
cellSpacing: aSymbol
	cellSpacing := aSymbol.! !

!CTableLayoutProperties methodsFor: 'testing' stamp: ''!
includesTableProperties
	^true! !

!CTableLayoutProperties methodsFor: 'initialize' stamp: 'ar 3/24/2004 03:41'!
initialize
	cellSpacing := listSpacing := wrapDirection := #none.
	cellPositioning := #center.
	listCentering := wrapCentering := #topLeft.
	listDirection := #topToBottom.
	reverseTableCells := rubberBandCells := false.
	cellInset := minCellSize := 0.
	maxCellSize := 1073741823. "SmallInteger maxVal"! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
listCentering
	^listCentering! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
listCentering: aSymbol
	listCentering := aSymbol! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
listDirection
	^listDirection! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
listDirection: aSymbol
	listDirection := aSymbol.! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
listSpacing
	^listSpacing! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
listSpacing: aSymbol
	listSpacing := aSymbol! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
maxCellSize
	^maxCellSize! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
maxCellSize: aNumber
	maxCellSize := aNumber.! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
minCellSize
	^minCellSize! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
minCellSize: aNumber
	minCellSize := aNumber.! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
reverseTableCells
	^reverseTableCells! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
reverseTableCells: aBool
	reverseTableCells := aBool! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
rubberBandCells
	^rubberBandCells! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
rubberBandCells: aBool
	rubberBandCells := aBool.! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
wrapCentering
	^wrapCentering! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
wrapCentering: aSymbol
	wrapCentering := aSymbol! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
wrapDirection
	^wrapDirection! !

!CTableLayoutProperties methodsFor: 'accessing' stamp: ''!
wrapDirection: aSymbol
	wrapDirection := aSymbol! !

Object subclass: #CTextComposer
	instanceVariableNames: 'lines maxRightX currentY scanner possibleSlide nowSliding prevIndex prevLines currCharIndex startCharIndex stopCharIndex deltaCharIndex theText theContainer isFirstLine theTextStyle defaultLineHeight actualHeight wantsColumnBreaks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Text'!

!CTextComposer class methodsFor: 'as yet unclassified' stamp: 'ar 1/9/2003 16:25'!
characterForColumnBreak

	^Character value: 12! !

!CTextComposer methodsFor: 'as yet unclassified' stamp: 'ar 1/9/2003 16:25'!
addNullLineForIndex: index
"This awful bit is to ensure that if we have scanned all the text and the last character is a CR that there is a null line at the end of lines. Sometimes this was not happening which caused anomalous selections when selecting all the text. This is implemented as a post-composition fixup because I couldn't figure out where to put it in the main logic."

	| oldLastLine r |

	oldLastLine := lines last.
	oldLastLine last - oldLastLine first >= 0 ifFalse: [^self].
	oldLastLine last = (index - 1) ifFalse: [^self].

	r := oldLastLine left @ oldLastLine bottom 
				extent: 0@(oldLastLine bottom - oldLastLine top).
	"Even though we may be below the bottom of the container,
	it is still necessary to compose the last line for consistency..."

	self addNullLineWithIndex: index andRectangle: r.
! !

!CTextComposer methodsFor: 'as yet unclassified' stamp: 'ar 1/9/2003 16:25'!
addNullLineWithIndex: index andRectangle: r

	lines addLast: (
		(
			TextLine 
				start: index 
				stop: index - 1
				internalSpaces: 0 
				paddingWidth: 0
		)
			rectangle: r;
			lineHeight: defaultLineHeight baseline: theTextStyle baseline
	)
! !

!CTextComposer methodsFor: 'as yet unclassified' stamp: 'ar 1/9/2003 16:25'!
checkIfReadyToSlide

	"Check whether we are now in sync with previously composed lines"

	(possibleSlide and: [currCharIndex > stopCharIndex]) ifFalse: [^self].

	[prevIndex < prevLines size
		and: [(prevLines at: prevIndex) first < (currCharIndex - deltaCharIndex)]]
			whileTrue: [prevIndex := prevIndex + 1].

	(prevLines at: prevIndex) first = (currCharIndex - deltaCharIndex) ifTrue: [
		"Yes -- next line will have same start as prior line."
		prevIndex := prevIndex - 1.
		possibleSlide := false.
		nowSliding := true
	] ifFalse: [
		prevIndex = prevLines size ifTrue: [
			"Weve reached the end of prevLines, so no use to keep looking for lines to slide."
			possibleSlide := false
		]
	]! !

!CTextComposer methodsFor: 'as yet unclassified' stamp: 'ar 1/9/2003 16:25'!
composeAllLines

	[currCharIndex <= theText size and: 
			[(currentY + defaultLineHeight) <= theContainer bottom]] whileTrue: [

		nowSliding ifTrue: [
			self slideOneLineDown ifNil: [^nil].
		] ifFalse: [
			self composeOneLine ifNil: [^nil].
		]
	].
! !

!CTextComposer methodsFor: 'as yet unclassified' stamp: 'ar 1/9/2003 16:25'!
composeAllRectangles: rectangles

	| charIndexBeforeLine numberOfLinesBefore reasonForStopping |

	actualHeight := defaultLineHeight.
	charIndexBeforeLine := currCharIndex.
	numberOfLinesBefore := lines size.
	reasonForStopping := self composeEachRectangleIn: rectangles.

	currentY := currentY + actualHeight.
	currentY > theContainer bottom ifTrue: [
		"Oops -- the line is really too high to fit -- back out"
		currCharIndex := charIndexBeforeLine.
		lines size - numberOfLinesBefore timesRepeat: [lines removeLast].
		^self
	].
	
	"It's OK -- the line still fits."
	maxRightX := maxRightX max: scanner rightX.
	1 to: rectangles size - 1 do: [ :i |
		"Adjust heights across rectangles if necessary"
		(lines at: lines size - rectangles size + i)
			lineHeight: lines last lineHeight
			baseline: lines last baseline
	].
	isFirstLine := false.
	reasonForStopping == #columnBreak ifTrue: [^nil].
	currCharIndex > theText size ifTrue: [
		^nil		"we are finished composing"
	].
	! !

!CTextComposer methodsFor: 'as yet unclassified' stamp: 'ar 1/9/2003 16:27'!
composeEachRectangleIn: rectangles

	| myLine lastChar |

	1 to: rectangles size do: [:i | 
		currCharIndex <= theText size ifFalse: [^false].
		myLine := scanner 
			composeFrom: currCharIndex 
			inRectangle: (rectangles at: i)				
			firstLine: isFirstLine 
			leftSide: i=1 
			rightSide: i=rectangles size.
		lines addLast: myLine.
		actualHeight := actualHeight max: myLine lineHeight.  "includes font changes"
		currCharIndex := myLine last + 1.
		lastChar := theText at: myLine last.
		lastChar = Character cr ifTrue: [^#cr].
		wantsColumnBreaks ifTrue: [
			lastChar = CTextComposer characterForColumnBreak ifTrue: [^#columnBreak].
		].
	].
	^false! !

!CTextComposer methodsFor: 'as yet unclassified' stamp: 'ar 7/22/2009 16:27'!
composeLinesFrom: argStart to: argStop delta: argDelta into: argLinesCollection priorLines: argPriorLines atY: argStartY textStyle: argTextStyle text: argText container: argContainer wantsColumnBreaks: argWantsColumnBreaks

	wantsColumnBreaks := argWantsColumnBreaks.
	lines := argLinesCollection.
	theTextStyle := argTextStyle.
	theText := argText.
	theContainer := argContainer.
	deltaCharIndex := argDelta.
	currCharIndex := startCharIndex := argStart.
	stopCharIndex := argStop.
	prevLines := argPriorLines.
	currentY := argStartY.
	maxRightX := theContainer left.
	possibleSlide := stopCharIndex < theText size and: [theContainer isMemberOf: Rectangle].
	nowSliding := false.
	prevIndex := 1.
	scanner := MultiCompositionScanner new text: theText textStyle: theTextStyle.
	scanner wantsColumnBreaks: wantsColumnBreaks.
	defaultLineHeight := scanner computeDefaultLineHeight.
	isFirstLine := true.
	self composeAllLines.
	isFirstLine ifTrue: ["No space in container or empty text"
		self 
			addNullLineWithIndex: startCharIndex
			andRectangle: (theContainer topLeft extent: 0@defaultLineHeight)
	] ifFalse: [
		self fixupLastLineIfCR
	].
	^{lines asArray. maxRightX}

! !

!CTextComposer methodsFor: 'as yet unclassified' stamp: 'ar 1/9/2003 16:25'!
composeOneLine

	| rectangles |

	rectangles := theContainer rectanglesAt: currentY height: defaultLineHeight.
	rectangles size >= 1 ifTrue: [
		(self composeAllRectangles: rectangles) ifNil: [^nil].
	] ifFalse: [
		currentY := currentY + defaultLineHeight
	].
	self checkIfReadyToSlide.! !

!CTextComposer methodsFor: 'as yet unclassified' stamp: 'ar 1/9/2003 16:25'!
fixupLastLineIfCR
"This awful bit is to ensure that if we have scanned all the text and the last character is a CR that there is a null line at the end of lines. Sometimes this was not happening which caused anomalous selections when selecting all the text. This is implemented as a post-composition fixup because I couldn't figure out where to put it in the main logic."

	(theText size > 1 and: [theText last = Character cr]) ifFalse: [^self].
	self addNullLineForIndex: theText size + 1.
! !

!CTextComposer methodsFor: 'as yet unclassified' stamp: 'ar 1/9/2003 16:27'!
slideOneLineDown

	| priorLine |

	"Having detected the end of rippling recoposition, we are only sliding old lines"
	prevIndex < prevLines size ifFalse: [
		"There are no more prevLines to slide."
		^nowSliding := possibleSlide := false
	].

	"Adjust and re-use previously composed line"
	prevIndex := prevIndex + 1.
	priorLine := (prevLines at: prevIndex)
				slideIndexBy: deltaCharIndex andMoveTopTo: currentY.
	lines addLast: priorLine.
	maxRightX := maxRightX max: (priorLine right - priorLine left - priorLine paddingWidth).
	currentY := priorLine bottom.
	currCharIndex := priorLine last + 1.
	wantsColumnBreaks ifTrue: [
		priorLine first to: priorLine last do: [ :i |
			(theText at: i) = CTextComposer characterForColumnBreak ifTrue: [
				nowSliding := possibleSlide := false.
				^nil
			].
		].
	].
! !

Object subclass: #CTextParagraph
	instanceVariableNames: 'text textStyle container lines maxRightX editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Text'!

!CTextParagraph methodsFor: 'accessing' stamp: 'mtf 12/21/2010 17:44'!
adjustRightXBy: value
	| w |
	lines do:[:tl|
		w := tl paddingWidth.
		w >= 0 ifTrue:[tl paddingWidth: ((w - value) max: 0)].
	].! !

!CTextParagraph methodsFor: 'accessing' stamp: 'ar 5/5/2004 23:40'!
attributesAt: aPoint
	"Answer the attributes at the given point"
	^text attributesAt: (self characterBlockAtPoint: aPoint) stringIndex forStyle: textStyle! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
bounds
	^container! !

!CTextParagraph methodsFor: 'display' stamp: 'bgf 8/21/2007 23:40'!
caretWidth
	^ 0 "Just a vertical bar."! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
characterBlockAtIndex: index
	"Answer a CharacterBlock for character in the text at targetIndex. The 
	coordinates in the CharacterBlock will be appropriate to the intersection 
	of the destinationForm rectangle and the compositionRectangle."
	^self characterBlockForIndex: index! !

!CTextParagraph methodsFor: 'selection' stamp: 'ar 3/1/2005 14:00'!
characterBlockAtPoint: aPoint					 
	"Answer a CharacterBlock for the character in the text at aPoint."
	| line |
	line := lines at: (self lineIndexForPoint: aPoint).
	^ (MultiCharacterBlockScanner new text: text textStyle: textStyle)
		characterBlockAtPoint: aPoint index: nil
		in: line! !

!CTextParagraph methodsFor: 'selection' stamp: 'ar 3/1/2005 14:00'!
characterBlockForIndex: index					 
	"Answer a CharacterBlock for the character in text at index."
	| line |
	line := lines at: (self lineIndexForCharacter: index).
	^ (MultiCharacterBlockScanner new text: text textStyle: textStyle)
		characterBlockAtPoint: nil index: ((index max: line first) min: text size+1)
		in: line! !

!CTextParagraph methodsFor: 'composition' stamp: ''!
compose: t style: ts from: startingIndex in: textContainer
	text := t.
	textStyle := ts.
	container := textContainer.
	self composeAll! !

!CTextParagraph methodsFor: 'composition' stamp: ''!
composeAll
	self composeLinesFrom: 1 to: text size delta: 0
		into: OrderedCollection new priorLines: Array new atY: container top! !

!CTextParagraph methodsFor: 'composition' stamp: 'ar 7/24/2003 20:44'!
composeLinesFrom: start to: stop delta: delta into: lineColl priorLines: priorLines atY: startingY
	"While the section from start to stop has changed, composition may ripple all the way to the end of the text.  However in a rectangular container, if we ever find a line beginning with the same character as before (ie corresponding to delta in the old lines), then we can just copy the old lines from there to the end of the container, with adjusted indices and y-values"
	| newResult |
	newResult := CTextComposer new
		composeLinesFrom: start 
		to: stop 
		delta: delta 
		into: lineColl 
		priorLines: priorLines
		atY: startingY
		textStyle: textStyle 
		text: text 
		container: container
		wantsColumnBreaks: false.
	lines := newResult first asArray.
	lines last last = text size ifFalse:[self error: 'Text composition error'].
	maxRightX := newResult second.
	^maxRightX! !

!CTextParagraph methodsFor: 'composition' stamp: ''!
compositionRectangle
	^ container! !

!CTextParagraph methodsFor: 'selection' stamp: ''!
containsPoint: aPoint
	^ (lines at: (self lineIndexForPoint: aPoint)) rectangle
		containsPoint: aPoint! !

!CTextParagraph methodsFor: 'display' stamp: 'ar 3/16/2003 20:57'!
displayOn: aCanvas using: displayScanner at: offset
	"Send all visible lines to the displayScanner for display"
	| visibleRectangle leftInRun line startBlock stopBlock showCaret mark point |
	showCaret := false.
	editor ifNotNil:[showCaret := editor showCaret].
	showCaret ifTrue:[
		mark := editor markBlock.
		point := editor pointBlock.
		mark stringIndex < point stringIndex 
			ifTrue:[startBlock := mark. 	stopBlock := point]
			ifFalse:[startBlock := point.	stopBlock := mark].
	].
	visibleRectangle := aCanvas clipRect.
	leftInRun := 0.
	(self lineIndexForPoint: visibleRectangle topLeft)
		to: (self lineIndexForPoint: visibleRectangle bottomRight)
		do: [:i | line := lines at: i.
			showCaret ifTrue:[self displaySelectionInLine: line from: startBlock to: stopBlock on: aCanvas].
			line first <= line last ifTrue:
				[leftInRun := displayScanner displayLine: line
								offset: offset leftInRun: leftInRun]].! !

!CTextParagraph methodsFor: 'display' stamp: 'bgf 8/21/2007 23:39'!
displaySelectionInLine: line from: startBlock to: stopBlock on: aCanvas
	| leftX rightX w caretColor |
	startBlock = stopBlock
		ifTrue: ["Only show caret on line where clicked"
					(startBlock textLine = line) ifFalse: [^ self]]
		ifFalse: ["Test entire selection before or after here"
				(stopBlock stringIndex < line first
					or: [startBlock stringIndex > (line last+1)])
					ifTrue: [^ self].  "No selection on this line"
				(stopBlock stringIndex = line first
					and: [stopBlock textLine ~= line])
					ifTrue: [^ self].  "Selection ends on line above"
				(startBlock stringIndex = (line last+1)
					and: [stopBlock textLine ~= line])
					ifTrue: [^ self]].  "Selection begins on line below"
	startBlock stringIndex < line first
		ifTrue: [leftX := line left]
		ifFalse: [leftX := startBlock left].
	(stopBlock stringIndex > (line last+1)
			or: [stopBlock stringIndex = (line last+1)
					and: [stopBlock textLine ~= line]])
		ifTrue: [rightX := line right]
		ifFalse: [rightX := stopBlock left].
	startBlock = stopBlock
		ifTrue:
		[rightX := rightX + 1.
		w := self caretWidth.
		caretColor := self insertionPointColor.
		1 to: w do:
			[:i |  "Draw caret triangles at top and bottom"
			aCanvas fillRectangle: ((leftX-w+i-1)@(line top+i-1) extent: (w-i*2+3)@1)
				color: caretColor.
			aCanvas fillRectangle: ((leftX-w+i-1)@(line bottom-i) extent: (w-i*2+3)@1)
				color: caretColor].
		aCanvas fillRectangle: (leftX@line top corner: rightX@line bottom)
				color: caretColor]
	ifFalse:
		[aCanvas fillRectangle: (leftX@line top corner: rightX@line bottom)
				color: self selectionColor]! !

!CTextParagraph methodsFor: 'accessing' stamp: 'ar 7/25/2003 11:58'!
editor
	^editor! !

!CTextParagraph methodsFor: 'accessing' stamp: 'ar 7/25/2003 11:58'!
editor: aTextEditor
	editor := aTextEditor! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
extent
	^maxRightX @ (lines last bottom - lines first top)! !

!CTextParagraph methodsFor: 'private' stamp: ''!
fastFindFirstLineSuchThat: lineBlock
	"Perform a binary search of the lines array and return the index
	of the first element for which lineBlock evaluates as true.
	This assumes the condition is one that goes from false to true for
	increasing line numbers (as, eg, yval > somey or start char > somex).
	If lineBlock is not true for any element, return size+1."
	| index low high |
	low := 1.
	high := lines size.
	[index := high + low // 2.
	low > high]
		whileFalse: 
			[(lineBlock value: (lines at: index))
				ifTrue: [high := index - 1]
				ifFalse: [low := index + 1]].
	^ low! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
height
	^(lines last bottom - lines first top)! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
indexOfCharacterAbove: index
	| block |
	block := self characterBlockAtIndex: index.
	^(self characterBlockAtPoint: block topLeft - (0@1)) stringIndex! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
indexOfCharacterBelow: index
	| block |
	block := self characterBlockAtIndex: index.
	^(self characterBlockAtPoint: block bottomLeft + (0@1)) stringIndex! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
indexOfNextWord: index
	^text string indexOfNextWord: index! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
indexOfPreviousWord: index
	^text string indexOfPreviousWord: index! !

!CTextParagraph methodsFor: 'display' stamp: 'jrd 10/17/2008 13:59'!
insertionPointColor
	^ Display depth <= 2
		ifTrue: [Color black]
		ifFalse: [
			CWidgetLibrary default insertionPointColor
		]! !

!CTextParagraph methodsFor: 'private' stamp: ''!
lineIndexForCharacter: index
	"Answer the index of the line in which to select the character at index."
	^ (self fastFindFirstLineSuchThat: [:line | line first > index]) - 1 max: 1! !

!CTextParagraph methodsFor: 'private' stamp: ''!
lineIndexForPoint: aPoint
	"Answer the index of the line in which to select the character nearest to aPoint."
	| i py |
	py := aPoint y truncated.
	"Find the first line at this y-value"
	i := (self fastFindFirstLineSuchThat: [:line | line bottom > py]) min: lines size.
	"Now find the first line at this x-value"
	[i < lines size and: [(lines at: i+1) top = (lines at: i) top
				and: [aPoint x >= (lines at: i+1) left]]]
		whileTrue: [i := i + 1].
	^ i! !

!CTextParagraph methodsFor: 'private' stamp: ''!
lineIndexOfCharacterIndex: characterIndex					 
	"Answer the line index for a given characterIndex."
	"apparently the selector changed with NewParagraph"
	^self lineIndexForCharacter: characterIndex! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
lineSelectionIntervalAt: index
	^text string lineSelectionIntervalAt: index! !

!CTextParagraph methodsFor: 'private' stamp: ''!
lines
	^ lines! !

!CTextParagraph methodsFor: 'accessing' stamp: 'ar 3/16/2003 21:11'!
minimalTextExtent
	^self minimalTextWidth @ self height! !

!CTextParagraph methodsFor: 'accessing' stamp: 'mtf 12/21/2010 18:34'!
minimalTextWidth
	^ maxRightX! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
numberOfLines
	^lines size! !

!CTextParagraph methodsFor: 'composition' stamp: 'ar 1/9/2003 16:32'!
recomposeFrom: start to: stop delta: delta
	"Recompose this paragraph.  The altered portion is between start and stop.
	Recomposition may continue to the end of the text, due to a ripple effect.
	Delta is the amount by which the current text is longer than it was
	when its current lines were composed."
	| startLine newLines rightX myLine |
	"Have to recompose line above in case a word-break was affected."
	startLine := (self lineIndexForCharacter: start) - 1 max: 1.
	[startLine > 1 and: [(lines at: startLine-1) top = (lines at: startLine) top]]
		whileTrue: [startLine := startLine - 1].  "Find leftmost of line pieces"
	newLines := OrderedCollection new: lines size + 1.
	rightX := 0.
	1 to: startLine-1 do: [:i | 
		myLine := lines at: i.
		rightX := rightX max: (myLine right - myLine left - myLine paddingWidth).
		newLines addLast: myLine].
	self composeLinesFrom: (lines at: startLine) first to: stop delta: delta
			into: newLines priorLines: lines
			atY: (lines at: startLine) top.
	maxRightX := maxRightX max: rightX.! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
replaceFrom: start to: stop with: aText
	"Edit the text, and then recompose the lines." 
	text replaceFrom: start to: stop with: aText.
	^self recomposeFrom: start to: start + aText size - 1 delta: aText size - (stop-start+1)! !

!CTextParagraph methodsFor: 'display' stamp: 'jrd 10/17/2008 13:45'!
selectionColor
	| color |
	Display depth = 1 ifTrue: [^ Color veryLightGray].
	Display depth = 2 ifTrue: [^ Color gray].
	"true ifTrue:[^(Color r: 1 g: 0.8 b: 0.45)]."
	"color := Color r: 0.4 g: 1.0 b: 0.0."
	color := CWidgetLibrary default selectionColor.
	editor ifNil:[^color].
	editor hasKeyboardFocus 
		ifTrue:[^color]
		ifFalse:[^color twiceLighter]! !

!CTextParagraph methodsFor: 'selection' stamp: ''!
selectionRectsFrom: characterBlock1 to: characterBlock2					 
	"Return an array of rectangles representing the area between the two character blocks given as arguments."
	| line1 line2 rects cb1 cb2 w |
	characterBlock1 <= characterBlock2
		ifTrue: [cb1 := characterBlock1.  cb2 := characterBlock2]
		ifFalse: [cb2 := characterBlock1.  cb1 := characterBlock2].
	cb1 = cb2 ifTrue:
		[w := self caretWidth.
		^ Array with: (cb1 topLeft - (w@0) corner: cb1 bottomLeft + ((w+1)@0))].
	line1 := self lineIndexForCharacter: cb1 stringIndex.
	line2 := self lineIndexForCharacter: cb2 stringIndex.
	line1 = line2 ifTrue:
		[^ Array with: (cb1 topLeft corner: cb2 bottomRight)].
	rects := OrderedCollection new.
	rects addLast: (cb1 topLeft corner: (lines at: line1) bottomRight).
	line1+1 to: line2-1 do: [ :i |
		| line |
		line := lines at: i.
		(line left = rects last left and: [ line right = rects last right ])
			ifTrue: [ "new line has same margins as old one -- merge them, so that the caller gets as few rectangles as possible"
					| lastRect |
					lastRect := rects removeLast.
					rects add: (lastRect bottom: line bottom) ]
			ifFalse: [ "differing margins; cannot merge"
					rects add: line rectangle ] ].
	rects addLast: ((lines at: line2) topLeft corner: cb2 bottomLeft).
	^ rects! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
setExtent: anExtent
	container := container topLeft extent: anExtent! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
size
	^text size! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
string
	^ text string! !

!CTextParagraph methodsFor: 'accessing' stamp: ''!
text
	^ text! !

!CTextParagraph methodsFor: 'accessing' stamp: 'ar 3/16/2003 21:54'!
textStyle
	^ textStyle ifNil:[TextStyle default]! !

!CTextParagraph methodsFor: 'accessing' stamp: 'ar 12/8/2003 22:29'!
textStyle: aTextStyle
	"Set the style by which the receiver should display its text."
	textStyle := aTextStyle! !

!CTextParagraph methodsFor: 'accessing' stamp: 'ar 1/8/2003 22:33'!
width
	^maxRightX! !

!CTextParagraph methodsFor: 'accessing' stamp: 'ar 1/8/2003 22:33'!
wordSelectionIntervalAt: index
	^text string wordSelectionIntervalAt: index! !

Object subclass: #HaloFont
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Support'!

!HaloFont class methodsFor: 'glyphs' stamp: 'ar 12/8/2002 16:28'!
glyphs
	^#(
		('collapse.gif' 'R0lGODlhCgAMAIAAAAAAAf///ywAAAAACgAMAAACFoyPqQYN6OJp8NEa7rQPu71FHfMtSgEA
Ow==')
		('drag.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACGoyPB4sL9hKczoU4lcR3N69pFRNx38Uo
qZQUADs=')
		('debug.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACFYyPGQCa7BCUstUzK8t6R+N9YcR9BQA7')
		('grab.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACGowNcIvNoU6Ub06mYtoaempdCbZczilx
5rMUADs=')
		('help.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACF4wDCceqjNZJTRoKa5424/2B3UZyZQQV
ADs=')
		('menu.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACF4yPCMurzR4EKgV6pssWG+1dnQRZ5pkU
ADs=')
		('paint.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACGIyPB5C521R4EU7W8M3aIu8pXcWEnxkZ
BQA7')
		('pooh.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACGoyPB4sL5qJTjzEqX9M3xQRJXqYF5GSi
HwgWADs=')
		('rotate.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACGIwNcIvsv5JUjDZFbcg53u1VkwaVIJQw
BQA7')
		('recolor.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACGYyPqaAHzxCEbUZp3nI3u9Bd3Qc2oGam
RgEAOw==')
		('scale.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACGYyPqQntAVA8cRoLM5X6cuw82AKGz4Km
QQEAOw==')
		('tile.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACFoyPqcsBD6OJFEyb3lXaVXh9WEOWSQEA
Ow==')
		('dup.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACF4yPqQjtChhkLgZrsNXy1g5eUIUt5lIA
ADs=')
		('viewer.gif' 'R0lGODlhDgAMAIAAAAAAAf///ywAAAAADgAMAAACG4yPqYvgr2B47oB5aZ5Gy41RnZVBVeIx
6soyBQA7')
		('dismiss.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACF4yPqQmA/WBoLtLK6JpaXXl0nQFy23kW
ADs=')
		('fontStyle.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACGoyPqQjd4cCRsCZq8LQ6P/hlnKJ1lsiE
5nIUADs=')
		('fontEmph.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACGoyPqQjt4QCMUp6WrME3v8lFm9eRowkt
qlEAADs=')
		('fontSize.gif' 'R0lGODlhDAAMAIAAAAAAAf///ywAAAAADAAMAAACFoyPecCg5t6SU7UQU75oPwZ9lTZSSQEA
Ow==')
	)
! !

!HaloFont class methodsFor: 'class initialization' stamp: 'ar 2/9/2003 16:35'!
initFont
	"HaloFont initFont"
	| form map font style files |
	files := Dictionary new.
	self glyphs do:[:spec|
		files at: spec first put: spec last base64Decoded asByteArray.
	].
	map := Dictionary new.
	#(
		( 'c'	'collapse.gif')
		( 'd'   'drag.gif')
		( 'D'	'debug.gif')
		( 'g'   'grab.gif')
		( 'h'   'help.gif')
		( 'm'   'menu.gif')
		( 'p'   'paint.gif')
		( 'P'   'pooh.gif')
		( 'r'   'rotate.gif')
		( 'R'   'recolor.gif')
		( 's'   'scale.gif')
		( 't'   'tile.gif')
		( 'u'   'dup.gif')
		( 'v'   'viewer.gif')
		( 'x'   'dismiss.gif')

		( '1'	'fontStyle.gif')
		( '2'	'fontEmph.gif')
		( '3'	'fontSize.gif')
	) do:[:spec|
		form := (Form fromBinaryStream: (ReadStream on: (files at: spec last))).
		map at: spec first first put: form.
	].
	font := StrikeFont new initializeWithMap: map.
	font name: #HaloFont.
	style := TextStyle fontArray: {font}.
	TextConstants at: #HaloFont put: style.! !

!HaloFont class methodsFor: 'class initialization' stamp: 'ar 12/12/2009 20:58'!
initialize
	"HaloFont initialize"
	(TextStyle named: 'HaloFont') ifNil:[self initFont].! !

Object subclass: #WindowFont
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Costume-Support'!

!WindowFont class methodsFor: 'class initialization' stamp: 'ar 3/10/2003 05:33'!
glyphForms
	"WindowFont glyphForms"
	| form data |
	^self glyphs collect:[:spec|
		data := spec last base64Decoded asByteArray.
		form := (Form fromBinaryStream: (ReadStream on: data)).
		spec first -> form
	].
! !

!WindowFont class methodsFor: 'glyphs' stamp: 'jl 5/23/2005 17:41'!
glyphs
	^#(
		('cross.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACGAyCaQanfWCSSNIJnWL65W01mBZ23LIt
BQA7')
		('miniCross.gif'
 'R0lGODlhCwALALMAAAAAAP//////////////////////////////////////////////////
/////////yH5BAEAAA8ALAAAAAALAAsAAAQW8MlJq50AYL115l12feMHSiS5rVfbRgA7')
		('miniCross2.gif'  'R0lGODlhCwALALMAAAAAAP///////wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAACH5BAEAAAIALAAAAAALAAsAAAQTUMhJq70YTG01v18nhFuJnSgWAQA7')
		('downArrow.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACFIyPqQbbABN8kdUw8bVZdbeE4lEAADs=')
		('upArrow.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACEoyPqQprABecidIXcbvHSgcqBQA7')
		('leftArrow.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACFIwfgAu91tSLL7l5K61W6ox501EAADs=')
		('rightArrow.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACFIxhqcDqjFyCcrYaqNTv9vhhWVUAADs=')
		('underScore.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACDYyPqcvtDx+YlJqKYQEAOw==')
		('plus.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACEIyPqQp77QJMoNqJMIuSe1UAOw==')
		('minus.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACDIyPqcvtBqIEr9q7CgA7')
		('circle.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACF4yPCLvJf1hsgU5jMdBuVytpjzeFyRkU
ADs=')
		('bullet.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACGIyPCLsJfl5gRj7W7MSzbqp93hg5XIIa
BQA7')
		('checkMark.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACFIyPqWvAAdyRMCIbact6WtY9IlIAADs=')
		('expand.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACGYSDaJvN0AKEalGXbt7x6sooUicdURlm
RgEAOw==')
		('collapse.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACGkQceQvo1lyKatZLa4RZ9btojXWMY2iG
3lEAADs=')
		('subMenu.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACEoyPCanLBuILUbJqEX515juFBQA7')
		('target.gif' 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACF4wDeWvAm9yT6DjaUGTx8pqFnPKIE2kU
ADs=')
		('miniUpArrow.gif'
'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACEIyPqQprABecadp6mtu8uwIAOw==')
		('miniDownArrow.gif'
'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACEIyPqcttcCACtMpoV23X+VMAOw==')
		('miniLeftArrow.gif'
 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACD4yPqQprABdsbDp743W8FwA7')
		('miniRightArrow.gif'
 'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACEYyPqQprAF2AbdGaqI0Oy58UADs=')
		('miniPlayFwd.gif' 
'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACEoyPCanLBuILUbJqEX515juFBQA7') 
		('miniPlayBack.gif' 
'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACE4yPaaAH3B5McroaZQt6v72ASgEAOw==') 
		('miniPlayPause.gif' 
'R0lGODlhCwALAIAAAAAAAP///ywAAAAACwALAAACFIyPqQfA/qIMDVVzMaSbT68t4lgAADs=')
		('miniUpDown.gif' 
'R0lGODdhCwALAIAAAAAAAP///ywAAAAACwALAAACEYyPGaAH355MsrZbJ8oR4nsVADs=')
		('arrowLeft.gif'
 'R0lGODlhCwALALMAAAAAAP//////////////////////////////////////////////////
//////i/JCH5BAEAAA8ALAAAAAALAAsAAAQZMMgJppWgXhz01VlGbeDWjZ8FhqlHuqQVAQA7')
		('arrowRight.gif'
 'R0lGODlhCwALALMAAAAAAP//////////////////////////////////////////////////
/////////yH5BAEAAA8ALAAAAAALAAsAAAQa8MkHpp2gXkxvzpIWbqJoaeYYfqrXbVR6bhEA
Ow==')
		('arrowUp.gif'
 'R0lGODlhCwALALMAAAAAAP//////////////////////////////////////////////////
/////////yH5BAEAAA8ALAAAAAALAAsAAAQZ8MlJ6wN2Ymz5rZ7khdoFnNo5liBLqWhmRQA7')
		('arrowDown.gif'
 'R0lGODlhCwALALMAAAAAAP//////////////////////////////////////////////////
/////////yH5BAEAAA8ALAAAAAALAAsAAAQZ8MlJKbi3PjB59VuHiRlodV8qmSh7arAUAQA7')
		('arrowUpDown.gif' 'R0lGODdhCwALAIAAAAAAAP///ywAAAAACwALAAACFIwNpwi50eKK9ND78q0MKz81GbIUADs=')

		('centered.gif' 'R0lGODlhCwALAIAAAAAAAP///yH5BAUUAAEALAAAAAALAAsAAAIVTIAJxt16TnLUqFkdXDC/
u3jMJiEFADs=')
		('leftFlush.gif' 'R0lGODlhCwALAIAAAAAAAP///yH5BAUUAAEALAAAAAALAAsAAAIURIBpwe1slHw0ykWfvTif
c3kayBUAOw==')
		('justified.gif' 'R0lGODlhCwALAIAAAAAAAP///yH5BAUUAAEALAAAAAALAAsAAAIXhB2Hwe2oQJKuznOXbVDN
/XgRyEmjUQAAOw==')
		('rightFlush.gif' 'R0lGODlhCwALAIAAAAAAAP///yH5BAUUAAEALAAAAAALAAsAAAIVTIAJZ+2mInv0xLVqu2nq
fXkahxwFADs=')

	)
! !

!WindowFont class methodsFor: 'class initialization' stamp: 'ar 4/5/2006 21:18'!
initFont
	"WindowFont initFont"
	| form map font style files |
	files := Dictionary new.
	self glyphs do:[:spec|
		files at: spec first put: spec last base64Decoded asByteArray.
	].
	map := Dictionary new.
	#(
		( 'X'	'cross.gif')
		( 'x'	'miniCross.gif')
		( 'v'	'downArrow.gif')
		( '^'	'upArrow.gif')
		( '<'	'leftArrow.gif')
		( '>'	'rightArrow.gif')
		( '_'	'underScore.gif')
		( '+'	'plus.gif')
		( '-'	'minus.gif')
		( 'O'	'circle.gif')
		( 'o'	'bullet.gif')
		( 'V'	'checkMark.gif')
		( 'E'   'expand.gif')
		( 'C'   'collapse.gif')
		( 's'   'subMenu.gif')
		( 'T'	'target.gif')
		"--"
		('l'	'miniLeftArrow.gif')
		('r'	'miniRightArrow.gif')
		('u'	'miniUpArrow.gif')
		('d'	'miniDownArrow.gif')
		('w' 'miniUpDown.gif')
		"--"
		('L' 'arrowLeft.gif')
		('R' 'arrowRight.gif')
		('U' 'arrowUp.gif')
		('D' 'arrowDown.gif')
		('W' 'arrowUpDown.gif')
		"--"
		('f' 'miniPlayFwd.gif')
		('b' 'miniPlayBack.gif')
		('p' 'miniPlayPause.gif')
		"--"
		('[' 'leftFlush.gif')
		(']' 'rightFlush.gif')
		('=' 'justified.gif')
		(':' 'centered.gif')
	) do:[:spec|
		form := (Form fromBinaryStream: (ReadStream on: (files at: spec last))).
		map at: spec first first put: form.
	].

	form := Form extent: 11@11 depth: 1.
	form getCanvas frameOval: (1@1 extent: 9@9) width: 1 color: Color black.
	map at: $q put: form.

	form := Form extent: 11@11 depth: 1.
	form getCanvas frameOval: (1@1 extent: 9@9) width: 1 color: Color black.
	form getCanvas fillOval: (3@3 extent: 5@5) color: Color black.
	map at: $Q put: form.

	font := StrikeFont new initializeWithMap: map.
	font name: #WindowFont.
	style := TextStyle fontArray: {font}.
	TextConstants at: #WindowFont put: style.! !

!WindowFont class methodsFor: 'class initialization' stamp: 'sn 3/2/2013 12:46'!
initialize
	"WindowFont initialize"
	self flag: #'1'. "Increase this flag if you need to have WindowFont newly initialized"
	self initFont. "force recreation when loading"
! !

!TextAnchor methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 12:42'!
anchoredObject
	^anchoredMorph! !

!TextAnchor methodsFor: '*Tweak-Costume' stamp: 'ar 12/8/2002 12:42'!
anchoredObject: aCostume
	anchoredMorph := aCostume! !
CSoftShadowHighlight initialize!
CCostumeTextHolder initialize!
CClipboard initialize!
CCornerRounder initialize!
CIdentityTransform initialize!
CMatrixTransform initialize!
HaloFont initialize!
WindowFont initialize!
